#ifndef _PA_MP3_H_
#define _PA_MP3_H_

/** @addtogroup SoundAS Sound and MP3 functions
 *  Functions to play sounds and mp3s.
 *  @{
 */

/** \brief Initializes AS_Lib for sound playback only.
	\param mode parameter passed to AS_Init()
*/
extern inline void PA_InitASLibForSounds(int mode)
{
	AS_Init(mode);
	AS_SetDefaultSettings(AS_PCM_8BIT, 11025, AS_SURROUND);
}

/** \brief Initializes AS_Lib for mp3 playback. You have to use a proper Makefile for this to work.
	\param mode parameter passed to AS_Init()
*/
extern inline void PA_InitASLibForMP3(int mode)
{
	IPC_Sound->mp3.helixbuffer = (u32)malloc(24000);
	PA_VBLFunctionInit(AS_SoundVBL);
	PA_InitASLibForSounds(mode);
}

/** @} */ // end of SoundAS

#endif
