#ifndef CHRLIBH
#define CHRLIBH

#include <PA9.h>
#include "big52uni16.h"
#include "Ming9c_bin.h"

typedef enum {UTF,UTF8,BIG5,GBK,JIS} Lid; 
typedef enum {Deg0,Deg90,Deg180,Deg270} ChrRot;
typedef enum {NONE,	HOLLOW,SHADOW,	BACKGROUND2} Fx;
typedef enum {NO,YES} ABLE;

typedef struct
{
   s32 x;
   s32 y;
} POINT;


typedef struct
{
   POINT Start;
   POINT End;
} BLOCK;


typedef struct
{
  u16* Name;
  u8   semiWOffset;
  u8   semiHOffset;
  u8   semiWidth;
  u8   semiHeight;
  u8   WOffset;
  u8   HOffset;
  u8   Width;
  u8   Height;
  u8   Dummy[2]; 
  u32* Index;
  u8*  Data;
  const u8*  Ptr;
} Font;

typedef struct
{
	u16   Color;
	u16   BgColor;
	u8    Align;
	u8    Rotate;     //[0]:0;[1]:90;[2]:180;[3]:270;
	u8    Fx;         //[0]:None;[1]:?r;[2]:v;[3]:?;
	u8    CutChar;		//[0]:No;[1]:Yes;
	u8    W_Space;
	u8    H_Space; 
	Font* FONT;
} CharStat;

extern Font  fontMing9C;
extern const CharStat CS;
extern char U[255];
extern char N[255]; 

char*  U2A(char* Ui);
u32    UTFLen(char* Str);
u8     IsFullChar(char* Text);
u8     FontInit(Font* FONT,const u8* ptr);
u8     ToUTF(char* Chr,u16* UTF16, const u16* Table, Lid LID);
u32    UTF2Utf8(u16* Uni,u8* Utf);
u32    UTF82UTF(char* U8,u16* U);
u32    len(char* Str);
u16    WordWidth(int* Word, CharStat *CStat, Lid Lang);
void   SwitchNewLine(CharStat *Status, BLOCK* CharArea, s16 Origin, u8 Height);
bool   CheckBound(BLOCK* PrintArea, BLOCK *CharArea,CharStat* CStat);
void   GetCharArea(CharStat* Status, BLOCK* PrintArea , BLOCK* CharArea, s16 Origin, u8 Width, u8 Height);
u32    iPrint( u16 x, u16 y,u16 x2, u16 y2, char* Str, CharStat* Status, bool screenUp,u32 Num, Lid Lang);
void 	 iDrawChar(u16* Uni,bool screenUp,CharStat* CS, BLOCK CharArea);
u32 Sim16cText(u8 Screen, u16 x, u16 y, u16 x2, u16 y2, char* Str, u16 Color, Lid Lang, u8 degree);
void   DrawPoint(u8 Screen,s32 X,s32 Y, u16 Color); 
#endif 
