/*
    DSCompress v1.0a
    Author: carpman <carpman@voidptr.org>
    http://voidptr.org

    Copyright 2007 Daniel Jackson 

    This file is part of DSCompress.

    DSCompress is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    DSCOmpress is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __linkedlist_h__
#define __linkedlist_h__

#ifndef NULL
#define NULL 0
#endif

typedef struct {
  void *previous;
  void *next;
  void *data;
  long dataSize;
} ctLListElement;

typedef struct {
  ctLListElement *headElement;
  ctLListElement *endJump;
  long elementCount;
} ctLList;

typedef struct {
  ctLList *list;
  ctLListElement *currentElement;
} ctLListIterator;

ctLList *newLList(void);
void freeLList(ctLList *list);
void appendLListElement(ctLList *list, void *data, long dataSize);
void insertLListElement(ctLList *list, long index, void *data, long dataSize);
void removeLListElement(ctLList *list, long index);
long getLListSize(ctLList *list);
void *getLListElement(ctLList *list, long index, long *dataSize);
ctLListIterator *getLListIterator(ctLList *list);
void freeLListIterator(ctLListIterator *iterator);
void *nextLListIterator(ctLListIterator *iterator, long *dataSize);
int haveNextLListIterator(ctLListIterator *iterator);
void resetLListIterator(ctLListIterator *iterator);

#endif
