#include <PA9.h>       // Include for PA_Lib
#include <fat.h>
#include "../../userConfigFunctions.h"
#include "../../misc/math.h"
#include "../../misc/misc.h"
#include "../../misc/debug.h"
#include "../../loader/loader.h"
#include "../../misc/fat.h"
#include "../../engine/engine.h"
#include "../../misc/transition.h"
#include <sys/dir.h>

#include "../../system/services/mwifi.h"
#include "../../gfx/all_gfx.h"
#include "fileExplorerText.h"
#include "../../define.h"

 

struct  itemInfo
{
	u8 PerLine;
	u8 Transition;
	u8 Animate;
	u32 Touched;
	bool TouchedNewpress;
	s8 TouchedX;
	s8 TouchedY;
	u8 AnimateWhat;
	u16 Total;
} item;

struct  fileInfo
{
	char Name[100];
	bool isFolder;
} file[200];



//0- delete
//1- copy
//2- move
struct  functionInfo
{
	u8 Function;
	u8 FunctionChanged;
	char Bin[10][30];
	u8 BinAmount;
	bool BinSelect;
	u8 BinItemSelect;
	bool BinItemToggle;
	u8 PropertySelect;
	u8 SortMode;
} fileMode;	


struct textureCollection
{
	u16 FileIcon;
	u16 FolderIcon;
	u16 BlankNdsIcon;
	u16 SaveNdsIcon;	
	u16 NdsIcon[3];
} texture;	




s8 AccellStylusX=0;
s8 AccellStylusY=0;
s16 oldStylusY=0;
s16 oldStylusX=0;
u16 modeIconAnimation=0;


struct  folderInfo
{
	struct  trimInfo
	{
		char Current[30];
		char Window[5][30];
	} Trimmed;	
	char Current[200];
	char Window[5][200];
	

	u8 OpenedWindows;

} folder;	


u8	nameTopScreenX;
u8	nameTopScreenY;

u8	typeTopScreenX;
u8	typeTopScreenY;

u8	sizeTopScreenX;
u8	sizeTopScreenY;

u8	modifiedTopScreenX;
u8	modifiedTopScreenY;
	



void deleteFile(int fileNumber)
{
   int i;
	for (i=fileNumber;i<item.Total;i++)
	{
	   file[i].isFolder= file[i+1].isFolder;
	   strncpy (file[i].Name,file[i+1].Name,200);
	   pa_3dsprites[i+100].textureID=pa_3dsprites[i+100+1].textureID;
	   pa_3dsprites[i+100].palette=pa_3dsprites[i+100+1].palette;
	}
	PA_3DSetSpriteVisible(100+item.Total-1,0);
	item.Total--;

}   

void sortFiles(u8 sortType){
   u8 temp;
   int y,i,x;
   char charTemp[256];
   switch (sortType){
      case 0:	
		   		for (y=0;y<item.Total;y++)
				      for (i=0;i<item.Total-1;i++)
				         for (x=0;x<strlen(file[i+1].Name);x++)
				         {
					         if ((file[i].Name[x] > file[i+1].Name[x] && file[i].isFolder == file[i+1].isFolder)|| PA_CompareText(file[i+1].Name,". .") ||(file[i+1].isFolder == 1 && file[i].isFolder ==0))
								{
//								   PA_Print(1,"%d %s < %d %s\n",i,file[i].Name,i+1,file[i+1].Name);
								   sprintf(charTemp,"%s",file[i+1].Name);
								   sprintf(file[i+1].Name,"%s",file[i].Name);
								   sprintf(file[i].Name,"%s",charTemp);
								   temp = file[i].isFolder;
								   file[i].isFolder = file[i+1].isFolder;
								   file[i+1].isFolder = temp;
								   break;
								}   
					         if (file[i].Name[x] < file[i+1].Name[x])
					         break;
							}			
		         	break;
      case 1:	//PA_Print(1,"Sort by CBA\n\n");
		   		for (y=0;y<item.Total;y++)
				      for (i=0;i<item.Total-1;i++)
				         for (x=0;x<strlen(file[i+1].Name);x++)
				         {
					         if ((file[i].Name[x] < file[i+1].Name[x] && file[i].isFolder == file[i+1].isFolder)|| (file[i].isFolder == 1 && file[i+1].isFolder ==0))
								{
//								   PA_Print(1,"%d %s < %d %s\n",i,file[i].Name,i+1,file[i+1].Name);
								   sprintf(charTemp,"%s",file[i+1].Name);
								   sprintf(file[i+1].Name,"%s",file[i].Name);
								   sprintf(file[i].Name,"%s",charTemp);
								   temp = file[i].isFolder;
								   file[i].isFolder = file[i+1].isFolder;
								   file[i+1].isFolder = temp;
								   break;
								}   
					         if (file[i].Name[x] > file[i+1].Name[x])
					         break;
							}			
		         	break;
		default: //PA_Print(1,"Invalid Sort");
		   		break;
	      
   }   
}   
char* getLastFolderName(char* address){
   u16 i=0,y=0;
   char *charTemp= (char*)malloc(256); 
   memset(charTemp, 0, 256);
   for (i=strlen(address); i>0; i--)
   {
      
      if (address[i] == '/' && address[i+1] != ' '&& address[i+1] != '\0') break;
   }
   i++;
   while (i<=strlen(address))
   {
      charTemp[y]=address[i];
      y++;
      i++;
//      if (address[i] == '/' || address[i+1] == ' '|| address[i+1] == '\0') 
      if (address[i] == '/' || address[i] == ' '|| address[i] == '\0') 
		{
		   break;
		}   
   }   
   charTemp[y]='\0';
	return charTemp;   
   
}   

void loadNdsIcon(int fileNumber,bool animate)
{
//   pa_3dsprites[fileNumber+100].RotY=150;
	if (animate){
		pa_3dsprites[fileNumber+100].Height=45;
		pa_3dsprites[fileNumber+100].Width=45;
	}	
//   PA_3DSetSpriteTex(fileNumber+100, texture.NdsIcon[0]);
//   PA_3DSetSpritePal(fileNumber+100,20);
   
}   

void updateIconLoad(void)
{
   int i;
   for (i=0;i<item.Total;i++)
	{   
/*   	if (pa_3dsprites[100+i].RotY>0) 
			pa_3dsprites[100+i].RotY--;
   	if (pa_3dsprites[100+i].RotY>10) 
			pa_3dsprites[100+i].RotY-=4;*/
		if (pa_3dsprites[i+100].Width > 32)
		{
			pa_3dsprites[i+100].Width--;
		}			

		if (pa_3dsprites[i+100].Height > 32)
			pa_3dsprites[i+100].Height--;  	
//		pa_3dsprites[100+i].RotX=pa_3dsprites[100+i].RotY;
	}  	
}   
void readCurrentFolder(void)
{

	
   sprintf(folder.Trimmed.Current,"%s",getLastFolderName(folder.Current));
	if (item.Total<10)
		PA_3DSetSpriteVisible(5,1);
	else
		PA_3DSetSpriteVisible(5,0);
	
	struct stat st;
	DIR_ITER* dir = diropen(folder.Current);
	int i;
	for (i=0;i<item.Total;i++)
	{
		PA_3DSetSpriteVisible(i+100,0);
		PA_3DSetSpriteY(i+100,300);
	}		
		
	if (folder.Current[strlen(folder.Current)-2] !=':')
		item.Total=1;
		else
		item.Total=0;

	if (folder.Current[strlen(folder.Current)-2] !=':')
	{
   	sprintf(file[0].Name,". .");
	   file[0].isFolder = 1;
	}   
			
	if (dir == NULL) 
	{
		ShowDialogBox(0, 0, 1,"Unable to open the directory.");
	} 
	else 
	while (dirnext(dir, file[item.Total].Name, &st) == 0) 
	{
	   if (st.st_mode & S_IFDIR)
	   {
	      if (file[item.Total].Name[0] == '_') continue;
		   file[item.Total].isFolder = 1;   
		}   
	   else
		   file[item.Total].isFolder = 0;   
	   if (!PA_CompareText(file[item.Total].Name,".") && !PA_CompareText(file[item.Total].Name,".."))item.Total++;//next line
	}
	


}


void UpdateTopScreen(int fileNumber, bool getInfo){
	PA_16cErase(1);
	PA_TextAlign(0);
	display16cText(1,nameTopScreenX,nameTopScreenY,256,nameTopScreenY,file[fileNumber].Name,ANTIALIASED_COLOR,ANTIALIASED_FONT);	
	spaceLetteringForAAText();

	if (!file[fileNumber].isFolder)
	{

		display16cText(1,typeTopScreenX,typeTopScreenY,256,typeTopScreenY,getFiletype(file[fileNumber].Name),ANTIALIASED_COLOR,ANTIALIASED_FONT);
		if (getInfo)
		{
			char charTemp[256];
		   sprintf(charTemp,"%s%s",folder.Current,file[fileNumber].Name);
/*			FILE* infoFile = fopen (file[fileNumber].Name, "rb"); //rb = read
			fseek(infoFile,0,SEEK_END);
		
			display16cText(1,sizeTopScreenX,sizeTopScreenY,256,sizeTopScreenY,convertBytesToNearest(ftell(infoFile)),ANTIALIASED_COLOR,ANTIALIASED_FONT);
			fclose(infoFile);
			display16cText(1,modifiedTopScreenX,modifiedTopScreenY,256,modifiedTopScreenY,getFileLastModified(file[fileNumber].Name/*"main.nds"*///),ANTIALIASED_COLOR,ANTIALIASED_FONT);	
		}			
		
	}		
	else
		display16cText(1,typeTopScreenX,typeTopScreenY,256,typeTopScreenY,"Folder",ANTIALIASED_COLOR,ANTIALIASED_FONT);
	PA_16cTextAlign(2);   
	spaceLetteringForDefault();

}   
			
   


int compareFileType(const char *filename,char *filetype)
{
   	   char *dotpos=strrchr(filename,'.');
	 if(NULL == dotpos)return 0;
	return 0 == strnicmp(dotpos, filetype,strlen(filetype)+1);
}

void makeText(u8 item, bool grey){
   if (16+pa_3dsprites[item].Y > 0 && 16+pa_3dsprites[item].Y  < 192){
	PA_16cTextAlign(2);
   char charTemp[256];
   memset (charTemp,0,256);
	strncpy (charTemp,file[item-100].Name,12);
	
	Filename_16cText(0,pa_3dsprites[item].X-32 > 0 ?pa_3dsprites[item].X-32 : 0,
				16+pa_3dsprites[item].Y,
				32+pa_3dsprites[item].X,
				16+pa_3dsprites[item].Y,
				charTemp,grey?9:10,1,15);
	}			
}			   
void renderFolder()
{
	sortFiles(fileMode.SortMode);
//	texture.NdsIcon[0] =  PA_3DCreateTex((void*)logo_Texture, 32, 32, TEX_256COL);	
	
	
/*	PA_Load3DSpritePal(20, // Slot
							(void*)logo_Pal); // Palette*/
							
	PA_16cErase(0);
	int i;
	for (i=0;i<item.Total;i++)
	{
		PA_3DCreateSpriteFromTex(i+100, 		
								file[i].isFolder? texture.FolderIcon: 
								compareFileType(file[i].Name,".nds")? texture.BlankNdsIcon:
							   compareFileType(file[i].Name,".sav")? texture.SaveNdsIcon:
								texture.FileIcon,
								32, 32, 				
								file[i].isFolder? 9: 
								compareFileType(file[i].Name,".nds")? 10:
							   compareFileType(file[i].Name,".sav")? 11:
								8,
								32+((i%item.PerLine)*64), 32+((i/item.PerLine)*48)); 
		PA_3DSetSpriteVisible(i+100,0);
	}			
  item.Transition=0;
  item.Animate=8;
   for (i=0;i<item.Total;i++)
   {

      if (compareFileType(file[i].Name,".nds")&& pa_3dsprites[i+100].textureID == texture.BlankNdsIcon)
      {
			loadNdsIcon(i,0);
		}			
	}			

}

int animationTime = 0;

void animateAmbience(){
	animationTime++;
	PA_3DSetSpriteRotate(0,PA_Cos(animationTime)>>2);
	PA_3DSetSpriteXY(0,(250-((animationTime/2)%200))+(PA_Cos(animationTime)>>2),((animationTime%400)-64)-(PA_Cos(animationTime*2)>>4));
	PA_3DSetSpriteWidth(0,abs(PA_Cos(animationTime)>>4)+20);
	
	PA_3DSetSpriteRotate(1,PA_Cos((animationTime+100))>>1);
	PA_3DSetSpriteXY(1,(250-(((animationTime+100)/2)%200))+(PA_Cos((animationTime+100))>>1),(((animationTime+100)%400)-64)-(PA_Cos((animationTime+100)*2)>>3));
	PA_3DSetSpriteWidth(1,abs(PA_Cos((animationTime+100))>>2)+20);
}

void animateBin(){

	if (fileMode.FunctionChanged >0)
	{		
		fileMode.FunctionChanged--;
		if (fileMode.FunctionChanged <10)PA_3DSetSpriteY(14+fileMode.Function,160-(fileMode.FunctionChanged*3));
	}			
	else
	{
		if (modeIconAnimation>0)
		{
			modeIconAnimation--;
			if  (fileMode.Function==0) PA_3DSetSpriteVisible(14+fileMode.Function,1);
			PA_3DSetSpriteX(14+fileMode.Function,228-(pa_3dsprites[14+fileMode.Function].RotZ*.2));
			PA_3DSetSpriteY(14+fileMode.Function,(160-abs(PA_Sin(modeIconAnimation*20)*(modeIconAnimation*.0005))));
		
			pa_3dsprites[14+fileMode.Function].RotZ = PA_Sin(modeIconAnimation*20)*(modeIconAnimation*.001);
			if  (fileMode.Function==0) PA_3DSetSpriteX(20,228-(pa_3dsprites[14+fileMode.Function].RotZ*.2));
			else
			{
				PA_3DSetSpriteX(20,233-(pa_3dsprites[14+fileMode.Function].RotZ*.2));
			}			
			if  (fileMode.Function!=0)
			{
			   pa_3dsprites[20].RotZ = PA_Sin(modeIconAnimation*20)*(modeIconAnimation*.001);
	
	
			}   
		}
	
	
	
		if  (pa_3dsprites[20].Width > 0 && fileMode.Function==0)
		{
		   pa_3dsprites[20].Width-=2;
		   pa_3dsprites[20].Height-=2;
			PA_3DSetSpriteVisible(20,1);
		}		
		if  (pa_3dsprites[20].Width > 32 && fileMode.Function!=0 && !fileMode.BinSelect)
		{
			PA_3DSetSpriteVisible(20,1);
			
			if (fileMode.BinAmount >1) 
				PA_3DSetSpriteY(20,155);
			else
				PA_3DSetSpriteY(20,150);
			
			PA_3DSetSpriteX(20,232);
		   pa_3dsprites[20].Width--;
		   pa_3dsprites[20].Height--;
			PA_3DSetSpriteVisible(14+fileMode.Function,0);
		}		
	}			
}   
					
					
void updateModeSelect()
{
   int i;

	if (Pad.Newpress.L || (Stylus.Newpress && fileMode.BinAmount ==0 && pa_3dsprites[20].Width != 40&& PA_3DSpriteTouched(14+fileMode.Function))) 
	{
	   fileMode.FunctionChanged = 10;
//		PA_3DSetSpriteVisible(20,0);
//clear16cZone(0,211,0,256,180);
		for (i=0;i<=fileMode.BinAmount;i++)
			PA_3DSetSpriteVisible(19+i,0);
		fileMode.BinSelect=0;
		fileMode.BinItemToggle=0;


	}   


	if ((Pad.Held.L || Stylus.Held) &&fileMode.FunctionChanged >=10)
	{
	
	   fileMode.FunctionChanged=11;
	   modeIconAnimation=0;
	   for (i=0;i<3;i++)
		   PA_3DSetSpriteVisible(14+i,1);
	
		PA_3DSetSpriteRotate(14+fileMode.Function,0);
		PA_3DSetSpriteWidthHeight(14,32,32);
		PA_3DSetSpriteXY(14,256-24,192-64);
		PA_3DSetSpriteWidthHeight(15,32,32);
		PA_3DSetSpriteXY(15,256-40,192-32);
	
		PA_3DSetSpriteWidthHeight(16,32,32);
		PA_3DSetSpriteXY(16,256-10,192-32);
	
		PA_3DSetSpriteAlpha(14,10);
		PA_3DSetSpriteAlpha(15,10);
		PA_3DSetSpriteAlpha(16,10);
		
		if (Stylus.Held) 
		{
			if (PA_3DSpriteTouched(14)) 
			{
	
			   PA_3DSetSpriteAlpha(14,20);
		   	PA_3DSetSpriteWidthHeight(14,40,40);
			 }  	
			 else
			if (PA_3DSpriteTouched(15)) 
			{
			   PA_3DSetSpriteAlpha(15,20);
		   	PA_3DSetSpriteWidthHeight(15,40,40);
			 }  	
			 else
			if (PA_3DSpriteTouched(16)) 
			{
			   PA_3DSetSpriteAlpha(16,20);
	 	   	PA_3DSetSpriteWidthHeight(16,40,40);
			 }  	
	
		}	
	
		if (Pad.Newpress.Up) fileMode.Function=0;
		if (Pad.Newpress.Left) fileMode.Function=1;
		if (Pad.Newpress.Right) fileMode.Function=2;
	}	
		
		
	
	if ((Pad.Released.L || Pad.Newpress.Up || Pad.Newpress.Left || Pad.Newpress.Right || (Stylus.Released &&(PA_3DSpriteTouched(14) || PA_3DSpriteTouched(15) || PA_3DSpriteTouched(16))) || (Stylus.Released  &&!Pad.Held.L  && !(PA_3DSpriteTouched(14) || PA_3DSpriteTouched(15) || PA_3DSpriteTouched(16)))) && (fileMode.FunctionChanged >= 10))
	{
	   if (Stylus.Released)
		  {    
			if (PA_3DSpriteTouched(14)) fileMode.Function=0; else
			if (PA_3DSpriteTouched(15)) fileMode.Function=1; else
			if (PA_3DSpriteTouched(16)) fileMode.Function=2;
		}			
	   fileMode.FunctionChanged=9;
	   modeIconAnimation=50;
	   fileMode.BinAmount=0;
	   for (i=0;i<3;i++)
		   PA_3DSetSpriteVisible(14+i,0);
	   PA_3DSetSpriteVisible(14+fileMode.Function,1);
	
	   PA_3DSetSpriteAlpha(14+fileMode.Function,20);
		PA_3DSetSpriteWidthHeight(14+fileMode.Function,64,64);
		PA_3DSetSpriteXY(14+fileMode.Function,256-28,192-32);
	
	}   
}


void makeMiscText()
{
   int i,y;
	PA_16cTextAlign(0);

	clear16cZone(0,0,2,((strlen(folder.Trimmed.Current)+1)*4)+8,10);
	if (folder.Current[strlen(folder.Current)-2] !=':')
	{	
		Filename_16cText(0,4,3,60,3,"/",1,1,12);
		Filename_16cText(0,8,3,60,3,folder.Trimmed.Current,1,1,100);

	}	
	else
	{
		Filename_16cText(0,4,3,60,3,"root",1,1,100);	   
	}   
		PA_3DSetSpriteX(3,((strlen(folder.Trimmed.Current)+1)*4)-20);
	if (fileMode.BinSelect==0 && !(72+pa_3dsprites[item.Touched].X+16 > 240 && fileMode.PropertySelect > 50 && pa_3dsprites[item.Touched].Y+16-38 <= 58))
	{

		for (i=0;i<folder.OpenedWindows;i++)
		Filename_16cText(0,212,16+(14*i),260,16+(14*i),folder.Trimmed.Window[i],1,1,100);
		
		Filename_16cText(0,212,16+(14*folder.OpenedWindows),260,16+(14*folder.OpenedWindows),"+window",1,1,100);
		switch (fileMode.SortMode){
			case 0: Filename_16cText(0,212,16+(14*(folder.OpenedWindows+1)),260,16+(14*(folder.OpenedWindows+1)),"sort ABC",1,1,100);
						break;
			case 1: Filename_16cText(0,212,16+(14*(folder.OpenedWindows+1)),260,16+(14*(folder.OpenedWindows+1)),"sort CBA",1,1,100);
						break;
			case 2: Filename_16cText(0,212,16+(14*(folder.OpenedWindows+1)),260,16+(14*(folder.OpenedWindows+1)),"sort SIZE",1,1,100);
						break;
			case 3: Filename_16cText(0,212,16+(14*(folder.OpenedWindows+1)),260,16+(14*(folder.OpenedWindows+1)),"sort NEW",1,1,100);
						break;
			case 4: Filename_16cText(0,212,16+(14*(folder.OpenedWindows+1)),260,16+(14*(folder.OpenedWindows+1)),"sort OLD",1,1,100);
						break;
			case 5: Filename_16cText(0,212,16+(14*(folder.OpenedWindows+1)),260,16+(14*(folder.OpenedWindows+1)),"sort TYPE",1,1,100);
						break;
		}			
		Filename_16cText(0,212,16+(14*(folder.OpenedWindows+2)),260,16+(14*(folder.OpenedWindows+2)),"return",1,1,100);
	}	
	else
	if (pa_3dsprites[6].Alive)	clear16cZone(0,211,0,256,180);
	for (i=0;i<=folder.OpenedWindows+2;i++)
	{
		if (fileMode.BinSelect==0 && !(72+pa_3dsprites[item.Touched].X+16 > 240 && fileMode.PropertySelect > 50 && pa_3dsprites[item.Touched].Y+16-38 <= 58))
			PA_3DSetSpriteVisible(6+i,1);
				else
			PA_3DSetSpriteVisible(6+i,0);
	}		
	
	
	char charTemp[256];
	strncpy (charTemp,"",256);
	if (fileMode.BinAmount ==1 && fileMode.Function!=0) 
	{
	   for (i=strlen(fileMode.Bin[0]);i>0;i--)
	   {
	      if (fileMode.Bin[0][i] == '/')
			    break;
		}   
		i++;
	   for (y=0;y<strlen(fileMode.Bin[0])-i;y++)
	   {
		   charTemp[y] = fileMode.Bin[0][y+i];
		   if(y == 12) break;
		}   
		PA_16cTextAlign(1);
		Filename_16cText(0,190,168,255,168,charTemp,10,1,100);
	}		
	if (fileMode.BinItemToggle && fileMode.Function!=0) 
	{
  		clear16cZone(0,190,0,260,178);
	   for (i=strlen(fileMode.Bin[fileMode.BinItemSelect]);i>0;i--)
	   {
	      if (fileMode.Bin[fileMode.BinItemSelect][i] == '/')
			    break;
		}   
		i++;
	   for (y=0;y<strlen(fileMode.Bin[fileMode.BinItemSelect])-i;y++)
	   {
		   charTemp[y] = fileMode.Bin[fileMode.BinItemSelect][y+i];
		   if(y == 12) break;
		}   
		PA_16cTextAlign(1);
		Filename_16cText(0,190,pa_3dsprites[20+fileMode.BinItemSelect].Y+16,255,pa_3dsprites[20+fileMode.BinItemSelect].Y+16,charTemp,10,1,100);
	}		
	
	if (fileMode.BinAmount >1 && fileMode.Function!=0 && !fileMode.BinItemToggle) 
	{
	   sprintf(charTemp, "%d",fileMode.BinAmount);
		PA_16cTextAlign(1);
		Filename_16cText(0,240,168,250,168,charTemp,10,1,100);
	}   

	if (fileMode.FunctionChanged >=10) 
			clear16cZone(0,240,168,255,175);
			
	PA_16cTextAlign(0);
	clear16cZone(0,211,179,256,192);
	if (pa_3dsprites[14].alpha != 10 && (pa_3dsprites[14].Alive || fileMode.Function == 0)) Filename_16cText(0,212,179,260,179,"deletefile",1,1,100); else
	if (pa_3dsprites[15].alpha != 10 && (pa_3dsprites[15].Alive || fileMode.Function == 1)) Filename_16cText(0,212,179,260,179,"copy files",1,1,100); else
	if (pa_3dsprites[16].alpha != 10 && (pa_3dsprites[16].Alive || fileMode.Function == 2)) Filename_16cText(0,212,179,260,179,"move files",1,1,100);
	
}	

void transiteIcons()
{
   int i;
	for (i=item.Transition<4?0:item.Transition-3;i<=item.Transition;i++) 
	{
	   if (!pa_3dsprites[item.Transition+100+(i*(item.PerLine-1))].Alive && item.Transition+(i*(item.PerLine-1)) < 12){
	   	PA_3DSetSpriteAlpha(item.Transition+100+(i*(item.PerLine-1)), 1);
		   PA_3DSetSpriteVisible(item.Transition+100+(i*(item.PerLine-1)),1);
		}   
	}   
	
	if (item.Animate > 0) 
		item.Animate--;
	else
	{
	   if (item.Transition < 8)
		{
		 	item.Transition++;
		 	item.Animate=8;
		} 	
		else
		{
			item.AnimateWhat=1;
			PA_16cErase(0);
		}			
	
	}  
	for (i=item.Total-1>11?11:item.Total-1;i>=0;i--)
		if (pa_3dsprites[i+100].alpha < 31)
		{
		  
			PA_16cTextAlign(2);
			if(pa_3dsprites[i+100].Width==32){

				clear16cZone(0,pa_3dsprites[i+100].X-32,
										pa_3dsprites[i+100].Y,
										32+pa_3dsprites[i+100].X,
										32+pa_3dsprites[i+100].Y);
				if (pa_3dsprites[i+100].alpha !=1)
				Filename_16cText(0,pa_3dsprites[i+100].X-32 > 0 ?pa_3dsprites[i+100].X-32 : 0,
								16+pa_3dsprites[i+100].Y,
								32+pa_3dsprites[i+100].X,
								16+pa_3dsprites[i+100].Y,
							file[i].Name,10,1,pa_3dsprites[i+100].alpha<11?pa_3dsprites[i+100].alpha:11);
			}			
	
			if( pa_3dsprites[i+100].alpha < 15)
				pa_3dsprites[i+100].alpha+=2;
			else
				pa_3dsprites[i+100].alpha++;
			
			PA_3DSetSpriteRotateXYZ(i+100,(31-pa_3dsprites[i+100].alpha)*8,(31-pa_3dsprites[i+100].alpha)*8,0);
			PA_3DSetSpriteXY(i+100,
									pa_3dsprites[i+100].Width+((i%item.PerLine)*(pa_3dsprites[i+100].Width*2))-(pa_3dsprites[i+100].Width-pa_3dsprites[i+100].alpha)+1, 
								  pa_3dsprites[i+100].Width+(((i/item.PerLine)*48)-(pa_3dsprites[i+100].Width-pa_3dsprites[i+100].alpha))+(pa_3dsprites[5].Y-25)+1);
			
		}	
		else
		if (pa_3dsprites[i+100].alpha == 31 && pa_3dsprites[i+100].Alive &&pa_3dsprites[i+100].Width==32)
		{
			PA_16cTextAlign(2);
			clear16cZone(0,pa_3dsprites[i+100].X-32,
									pa_3dsprites[i+100].Y,
									32+pa_3dsprites[i+100].X,
									32+pa_3dsprites[i+100].Y);

			Filename_16cText(0,pa_3dsprites[i+100].X-32 > 0 ?pa_3dsprites[i+100].X-32 : 0,
							16+pa_3dsprites[i+100].Y,
							32+pa_3dsprites[i+100].X,
							16+pa_3dsprites[i+100].Y,
							file[i].Name,10,1,pa_3dsprites[i+100].alpha<11?pa_3dsprites[i+100].alpha:11);
		}
		
}

void executeSelectedFunction(){
	modeIconAnimation=(abs(AccellStylusY+AccellStylusX)*.5)+50;
	AccellStylusX= 0;
	AccellStylusY=0;
	Stylus.Released=1;
	Stylus.Held=0;

	if (fileMode.Function!=0 && fileMode.BinAmount<20) 
	{
	   sprintf(fileMode.Bin[fileMode.BinAmount],"%s%s",folder.Current,file[item.Touched-100].Name);
	   
	   fileMode.BinAmount++;
	   
	   if (fileMode.BinAmount>1)
	   {
	                  
			PA_3DSetSpriteTex(20,texture.FileIcon);
			PA_3DSetSpritePal(20,8);
			
			PA_3DCreateSpriteFromTex(19+fileMode.BinAmount,texture.FileIcon,32, 32, 8,256-28,180-(32+(fileMode.BinAmount*2)));
			PA_3DSetSpritePrio(19+fileMode.BinAmount,1024-fileMode.BinAmount);

			pa_3dsprites[19+fileMode.BinAmount].Priority = 1024;
			PA_3DSetSpriteX(19+fileMode.BinAmount,233);
			PA_3DSetSpriteY(19+fileMode.BinAmount,155);
	   }   
	   else
	   {
			PA_3DSetSpriteVisible(15,0); 
			PA_3DSetSpriteVisible(16,0); 
			PA_3DSetSpriteVisible(17,0); 
			PA_3DSetSpriteVisible(20,1);
			PA_3DSetSpriteTex(20,pa_3dsprites[item.Touched].textureID);
			PA_3DSetSpritePal(20,pa_3dsprites[item.Touched].palette);
		}  
	}
 
	pa_3dsprites[20].Width=40;
	pa_3dsprites[20].Height=40;
	pa_3dsprites[20].RotX=0;
	pa_3dsprites[20].RotY=0;
	pa_3dsprites[20].RotZ=0;
}			

void loadExploreThemeResource()
{
   char* path = returnThemeResourcePath("explorer/TopScreen.jpg", 1);
   FILE* jpegFile = fopen(path,"rb");
	loadFatBgJpeg(1, jpegFile);
	fclose(jpegFile);
	free(path);
	path = returnThemeResourcePath("explorer/explorer.ini", 1);
	readINI = fopen (path, "rb"); 
	initAntiAliasedText(1,1,(bool)readIniFileInt("TopScreen_TextColor_Black"));

	nameTopScreenX = readIniFileInt("TopScreen_Text_Name_X");
	nameTopScreenY = readIniFileInt("TopScreen_Text_Name_Y");

	typeTopScreenX = readIniFileInt("TopScreen_Text_Type_X");
	typeTopScreenY = readIniFileInt("TopScreen_Text_Type_Y");

	sizeTopScreenX = readIniFileInt("TopScreen_Text_Size_X");
	sizeTopScreenY = readIniFileInt("TopScreen_Text_Size_Y");

	modifiedTopScreenX = readIniFileInt("TopScreen_Text_Modified_X");
	modifiedTopScreenY = readIniFileInt("TopScreen_Text_Modified_Y");
	
	fclose(readINI);
	free(path);
/*	PA_3DCreateSpriteFromTex(2,CreateTexFromFatBmp(returnString("fat:/_menudo/themes/%s/explorer/backgroundColor.bmp",CurrentTheme),3,1),256,256,3,256/2,192/2);
	PA_3DSetSpritePrio(2,0);
	initAmbienceFromTheme("Settings",500);*/
		
	if (textScreenColorIsBlack(1)==0) 
		setAntiAliasDepth(1, 8);	
	else
		setAntiAliasDepth(1, 8);	
}

void test3d()
{
   do
   {
      ZoomXY_3DProcess(128,0,0);  
      Soul_waitForVBL();

	}	while(!Pad.Newpress.A);
   
   
}   
void updateExplorerIconXY()
{
	if (item.Total> 9)
	{
	   int i;
		for (i=item.Total-1;i>=0;i--)
			PA_3DSetSpriteXY(i+100			,32+((i%item.PerLine)*64), 32+((i/item.PerLine)*48)+(((25-pa_3dsprites[5].Y)/3)*((item.Total-9) / item.PerLine)));
	}			
}		
void initExplorerRoundRectangle()
{
   char charTemp[256];
	int tempTex = CreateTexFromThemeResource("explorer/roundRectangle.bmp",19,1);//CreateTexFromBmp((void*)roundRectangle,19);

//	memset(charTemp, 0, 256);
	PA_3DCreateSpriteFromTex(3,tempTex,64,16, 19,((strlen(folder.Trimmed.Current)+1)*4)-24,8);
	PA_3DCreateSpriteFromTex(4,tempTex,64,16, 19,240,192-8);
	PA_3DSetSpriteHflip(4,1);
	PA_3DSetSpritePrio(4,1850);
	PA_3DSetSpritePrio(3,1850);

	PA_3DCreateSpriteFromTex(41,tempTex,64,16, 19,100,100);
	PA_3DSetSpriteWidthHeight(42,36,16);
	PA_3DCreateSpriteFromTex(42,tempTex,64,16, 19,100,116);
	PA_3DSetSpriteWidthHeight(41,48,16);
   PA_3DSetSpriteVisible(41,0);
   PA_3DSetSpriteVisible(42,0);
	//PA_3DSetSpriteAlpha(41,10);
	//PA_3DSetSpriteAlpha(42,10);
	PA_3DSetSpritePrio(41,1860);
	PA_3DSetSpritePrio(42,1860);
	int i;

	for (i=1;i<8;i++)
	{
		PA_3DCreateSpriteFromTex(5+i,tempTex,64,16, 19,240,(14*i)+8);
		PA_3DSetSpriteHflip(5+i,1);
		PA_3DSetSpriteAlpha(5+i,15);
		if (folder.OpenedWindows < i-3)
			PA_3DSetSpriteVisible(5+i,0);
	}	
}	
char* mExplore (u8 exploringGoal)
{
//	CreateTexFromBmpWithAlpha((void*)roundRectangle,19,(void*)roundRectangle);
	clearSystem();
	PA_Init3D(); // Uses Bg0, Init 3D. ..
	PA_Reset3DSprites(); // Init or Reset 3D Sprites
	
	
	PA_Init16bitBg(1, 3);
	PA_Init16cBg(1,1);


	
	
	PA_Init16cBg(0,1);
	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);						


	//item init
	item.PerLine=3;
	item.Transition=0;
	item.Animate=10;
	item.Touched=100;
	item.TouchedNewpress=0;
	item.TouchedX=0;
	item.TouchedY=0;
	item.AnimateWhat=0;	
	fileMode.Function=0;
	fileMode.BinSelect=0;
	fileMode.BinItemToggle=0;
	fileMode.PropertySelect=0;
	fileMode.SortMode=0;

//	PA_SetBgColor(1,PA_RGB(31,31,31));
	folder.OpenedWindows=1;


//	fatInitDefault(); //Initialise fat library
	


	sprintf(folder.Current,"fat:/");
	readCurrentFolder();
	initThemeTransition("explorer",1);
	loadExploreThemeResource();
	char *charTemp = (char*)malloc(256); 
	memset(charTemp, 0, 256);
	sprintf(folder.Window[0],"fat:/");
	if (folder.Window[0][strlen(folder.Window[0])-2] !=':')
   	sprintf(folder.Trimmed.Window[0],"%s",getLastFolderName(folder.Window[0]));	
   else
	   sprintf(folder.Trimmed.Window[0],"root");	
	
//	texture.FileIcon = PA_3DCreateTex((void*)fileIcon_Texture, 32, 32, TEX_256COL);	
//	sprintf(charTemp,"fat:/_menudo/themes/%s/explorer/fileIcon.bmp",CurrentTheme);
  	texture.FileIcon = CreateTexFromThemeResource("explorer/fileIcon.bmp",8,1);
	texture.FolderIcon = CreateTexFromThemeResource("explorer/folderIcon.bmp",9,1);
	texture.BlankNdsIcon = CreateTexFromThemeResource("explorer/ndsIcon.bmp",10,1);
	texture.SaveNdsIcon = CreateTexFromThemeResource("explorer/saveIcon.bmp",11,1);

	PA_3DCreateSpriteFromTex(15,CreateTexFromThemeResource("explorer/copyIcon.bmp",6,1),getRecentBmpWidth(),getRecentBmpHeight(),6,256-28,192-32);
	PA_3DCreateSpriteFromTex(16,CreateTexFromThemeResource("explorer/moveIcon.bmp",7,1),getRecentBmpWidth(),getRecentBmpHeight(),7,256-28,192-32);
	PA_3DCreateSpriteFromTex(5,CreateTexFromThemeResource("explorer/scrollBar.bmp",4,1),getRecentBmpWidth(),getRecentBmpHeight(),4,196+4,25);
	PA_3DCreateSpriteFromTex(14,CreateTexFromThemeResource("explorer/binIcon.bmp",5,1),getRecentBmpWidth(),getRecentBmpHeight(),5,256-28,192-32);
	PA_3DSetSpriteAlpha(5,10);
	
  	if (fileMode.Function!=0)PA_3DSetSpriteVisible(14,0); 
  	PA_3DSetSpriteVisible(15,0);
  	PA_3DSetSpriteVisible(16,0);
	PA_3DSetSpritePrio(14,1800);

	PA_3DSetSpriteAlpha(14,20);
	PA_3DSetSpriteAlpha(15,20);
	PA_3DSetSpriteAlpha(16,20);


/*	PA_Load3DSpritePal(8, (void*)fileIcon_Pal);
	texture.FolderIcon = PA_3DCreateTex((void*)folderIcon_Texture, 32, 32, TEX_256COL);	
	PA_Load3DSpritePal(9, (void*)folderIcon_Pal);
	texture.BlankNdsIcon = PA_3DCreateTex((void*)ndsIcon_Texture, 32, 32, TEX_256COL);	
	PA_Load3DSpritePal(10, (void*)ndsIcon_Pal);
	texture.SaveNdsIcon = PA_3DCreateTex((void*)saveIcon_Texture, 32, 32, TEX_256COL);	
	PA_Load3DSpritePal(11, (void*)saveIcon_Pal);*/


	renderFolder();


	
//	u16 tempTex = CreateTexFromBmp((void*)explorerBackground,3);
	initExplorerRoundRectangle();
	create3dBackgroundLayer(2,31,31,31); //place bg ini here
	PA_3DSetSpritePrio(2,100);


	int i,x,y;



//	PA_3DCreateSpriteFromTex(20,texture.NdsIcon[0],32, 32, 20,256-28,192-32);



								
	oldStylusY=Stylus.Y;
	oldStylusX=Stylus.X;
	UpdateTopScreen(0,1);
	if (item.Total > 199)
	ShowDialogBox(0, 0,1, "You are loading a folder that has a number of items higher than 200. \n Warning: There are known issues addressing with this number of items.");

	while(1) 
	{
	   						PA_16cErase(0);
  		updateScreenTransition();
		updateModeSelect();
		if (fileMode.BinAmount>1){
			//drag file
			if (PA_3DSpriteTouched(20) && Stylus.Newpress && !fileMode.BinSelect && pa_3dsprites[20].Width != 40 && fileMode.BinAmount>1)
			{
			   
			   item.TouchedX= Stylus.X-pa_3dsprites[20].X;
			   item.TouchedY= Stylus.Y-pa_3dsprites[20].Y;
			   for (i=0;i<=fileMode.BinAmount;i++)
				   if (pa_3dsprites[21+i].RotZ ==0)
				   	pa_3dsprites[21+i].RotZ=180+PA_RandMax(100);
				   else
					   pa_3dsprites[21+i].RotZ=pa_3dsprites[21+i].RotZ/2;
					   
			   fileMode.BinSelect=1;
//PA_16cErase(0);
			}  
			if (fileMode.BinItemToggle)
			{																	//updateSelected bin switch

				for (i=0;i<fileMode.BinAmount;i++)
					if (i!=fileMode.BinItemSelect)
					{
						PA_3DSetSpriteXY(20+i,
						233,
						170-(((150.0/fileMode.BinAmount)*(fileMode.BinAmount-i))));
						if (pa_3dsprites[20+i].RotX > -90)
						{
							if (pa_3dsprites[20+i].RotX <-80) 
								pa_3dsprites[20+i].RotX--;
							else
								pa_3dsprites[20+i].RotX-=10;
	
						}		
	
						if (pa_3dsprites[20+i].Width == 33)
						{
							PA_3DSetSpriteTex(20+i,texture.FileIcon);
							PA_3DSetSpritePal(20+i,8);
							
							pa_3dsprites[20+i].RotZ=50-PA_RandMax(100);
						}			
						if (pa_3dsprites[20+i].Width > 32)
								pa_3dsprites[20+i].Width--;
						else
							PA_3DSetSpritePrio(20+i,1024-i);
						if (pa_3dsprites[20+i].Height > 32)
								pa_3dsprites[20+i].Height--;
					}			
	
	
				if (pa_3dsprites[20+fileMode.BinItemSelect].Width < 40)
						pa_3dsprites[20+fileMode.BinItemSelect].Width++;
	
				if (pa_3dsprites[20+fileMode.BinItemSelect].Height < 40)
						pa_3dsprites[20+fileMode.BinItemSelect].Height++;
						
				if (pa_3dsprites[20+fileMode.BinItemSelect].Width == 39)
				{
					PA_3DSetSpritePrio(20+fileMode.BinItemSelect,2000);
						   for (x=strlen(fileMode.Bin[fileMode.BinItemSelect]);x>0;x--)
						   {
						      if (fileMode.Bin[fileMode.BinItemSelect][x] == '/')
								    break;
							}   
							x++;
						   for (y=0;y<strlen(fileMode.Bin[fileMode.BinItemSelect])-x;y++)
						   {
							   charTemp[y] = fileMode.Bin[fileMode.BinItemSelect][y+x];
							}   
							y=0;
						   while(1)
						   {
						      if (PA_CompareText(charTemp,file[y].Name))
						      {
						      	break;
							    }  	
							    y++;
						   }   
						PA_3DSetSpriteTex(20+fileMode.BinItemSelect, 		
												file[y].isFolder? texture.FolderIcon: 
												compareFileType(file[y].Name,".nds")? texture.BlankNdsIcon:
											   compareFileType(file[y].Name,".sav")? texture.SaveNdsIcon:
												texture.FileIcon);
						PA_3DSetSpritePal(20+fileMode.BinItemSelect, 		
												file[y].isFolder? 9: 
												compareFileType(file[y].Name,".nds")? 10:
											   compareFileType(file[y].Name,".sav")? 11:
												8); 
				}			
	
									
				PA_3DSetSpriteXY(20+fileMode.BinItemSelect,233, 170-(((150.0/fileMode.BinAmount)*(fileMode.BinAmount-fileMode.BinItemSelect))+(0)));
				if (pa_3dsprites[20+fileMode.BinItemSelect].RotZ <0)
				{
					if (pa_3dsprites[20+fileMode.BinItemSelect].RotZ >-20) 
						pa_3dsprites[20+fileMode.BinItemSelect].RotZ++;
					else
						pa_3dsprites[20+fileMode.BinItemSelect].RotZ+=10;
				}			
				if (pa_3dsprites[20+fileMode.BinItemSelect].RotZ >0)
				{
					if (pa_3dsprites[20+fileMode.BinItemSelect].RotZ <20) 
						pa_3dsprites[20+fileMode.BinItemSelect].RotZ--;
					else
						pa_3dsprites[20+fileMode.BinItemSelect].RotZ-=10;
		
				}				
				if (pa_3dsprites[20+fileMode.BinItemSelect].RotX <0)
				{
					if (pa_3dsprites[20+fileMode.BinItemSelect].RotX >-20) 
						pa_3dsprites[20+fileMode.BinItemSelect].RotX++;
					else
						pa_3dsprites[20+fileMode.BinItemSelect].RotX+=10;
				}			
				if (pa_3dsprites[20+fileMode.BinItemSelect].RotX >0)
				{
					if (pa_3dsprites[20+fileMode.BinItemSelect].RotX <20) 
						pa_3dsprites[20+fileMode.BinItemSelect].RotX--;
					else
						pa_3dsprites[20+fileMode.BinItemSelect].RotX-=10;
				}			
	//
			}			
			if (fileMode.BinSelect && Stylus.Held)
			{  
				
			   if ((155-(Stylus.Y-item.TouchedY))/1.5 >= 90)
			   {
			   	fileMode.BinItemToggle=1;
			   	
				}  	
		   if (fileMode.BinItemToggle && Stylus.Held)
		   {
	//				for (i=0;i<=fileMode.BinAmount+1;i++)
	
						if (pa_3dsprites[20+fileMode.BinItemSelect-1].Y >= Stylus.Y && fileMode.BinItemSelect >0)
						{
						   fileMode.BinItemSelect =fileMode.BinItemSelect-1;
						}   
						if (pa_3dsprites[20+fileMode.BinItemSelect+1].Y <= Stylus.Y)					
						{
						   fileMode.BinItemSelect =fileMode.BinItemSelect+1;
						}   
		
				}			
	
			   if ((155-(Stylus.Y-item.TouchedY))/1.5 < 90 && (155-(Stylus.Y-item.TouchedY))/1.5 > 0 && !fileMode.BinItemToggle)
				{ 
					PA_3DSetSpriteXY(20,233,Stylus.Y-item.TouchedY);
					PA_3DSetSpritePrio(20,2000);
					
					for (i=0;i<=fileMode.BinAmount;i++)
					{
						PA_3DSetSpriteXY((21+fileMode.BinAmount)-i, 233, 170-(((170.0-pa_3dsprites[20].Y)/fileMode.BinAmount)*(i-1)));
						PA_3DSetSpriteRotateX((21+fileMode.BinAmount)-i,abs(155.0-pa_3dsprites[20].Y)/-1.5);
					}			
					PA_3DSetSpriteRotateX(20,abs(155.0-pa_3dsprites[20].Y)/-1.5);
					PA_3DSetSpriteRotate(20,abs(155.0-pa_3dsprites[20].Y)/-1.5);
					PA_3DSetSpriteWidthHeight(20,44+(abs(155.0-pa_3dsprites[20].Y)/-10.5),
														  44+(abs(155.0-pa_3dsprites[20].Y)/-10.5));	
				}	  
				
	
				
			}   
			if (Stylus.Released && fileMode.BinSelect) 
			{
			   fileMode.BinSelect=0;
			   fileMode.BinItemToggle=0;
			   for (i=0;i<=fileMode.BinAmount;i++)  
				{
					PA_3DSetSpriteTex(20+i,texture.FileIcon);
					PA_3DSetSpritePal(20+i,8);
				}			
			   while (1)
			   {
			      
			      for (i=0;i<=fileMode.BinAmount;i++)
			      {
			         if (pa_3dsprites[20+i].Y < 150) 
							pa_3dsprites[20+i].Y+=8;
							else
						if (pa_3dsprites[20+i].Y < 160) 
							pa_3dsprites[20+i].Y++;
						if (pa_3dsprites[20+i].RotZ <0)
						{
							if (pa_3dsprites[20+i].RotZ >-20) 
								pa_3dsprites[20+i].RotZ++;
							else
								pa_3dsprites[20+i].RotZ+=10;
						}			
						if (pa_3dsprites[20+i].RotZ >0)
						{
							if (pa_3dsprites[20+i].RotZ <20) 
								pa_3dsprites[20+i].RotZ--;
							else
								pa_3dsprites[20+i].RotZ-=10;
				
						}				
						if (pa_3dsprites[20+i].RotX <0)
						{
							if (pa_3dsprites[20+i].RotX >-20) 
								pa_3dsprites[20+i].RotX++;
							else
								pa_3dsprites[20+i].RotX+=10;
						}			
						if (pa_3dsprites[20+i].RotX >0)
						{
							if (pa_3dsprites[20+i].RotX <20) 
								pa_3dsprites[20+i].RotX--;
							else
								pa_3dsprites[20+i].RotX-=10;
						}			
						if (pa_3dsprites[20+i].Height > 32)
						pa_3dsprites[20+i].Height--;
						if (pa_3dsprites[20+i].Width > 32)
						pa_3dsprites[20+i].Width--;
	
			      } 
					if (pa_3dsprites[20].Y >= 160 && pa_3dsprites[20].RotX ==0 && pa_3dsprites[20].RotZ ==0 && pa_3dsprites[20].Width <= 32) 
					break;
					animateAmbience();
			      transiteScreenAnd3DProcess();
			      Soul_waitForVBL();
			   }   
			}   
		}			


		if (PA_3DSpriteTouched(item.Touched) && Stylus.Newpress  && pa_3dsprites[item.Touched].Width < 32) 	   
		{
		   if (exploringGoal <= 1 && compareFileType(file[item.Touched-100].Name,".nds"))
		   {
		      sprintf(charTemp,"%s%s",folder.Current,file[item.Touched-100].Name);
		      if (exploringGoal == 0) menudo_runNDS(charTemp,1,0);
		      if (exploringGoal == 1) return charTemp;
		      sprintf(charTemp," ");
			}  	
		   if (file[item.Touched-100].isFolder)
		   {
				PA_ClearTextBg(1);
				if (PA_CompareText(file[item.Touched-100].Name,". ."))
				{
	
				   folder.Current[strlen(folder.Current)-1] = 0;
					for(i=strlen(folder.Current);i>0;i--)
					{
						if (folder.Current[i] == '/')
							break;
						else
							folder.Current[i]=0;
					}   
				}			
				else
				sprintf(folder.Current,"%s%s/",folder.Current,file[item.Touched-100].Name);
				readCurrentFolder();
			   renderFolder();
			   item.AnimateWhat = 0;
				PA_3DSetSpriteY(5,25);
			}			
			
		}	
		
			animateAmbience();
			animateBin();
		if (item.AnimateWhat >0){   

		if (Pad.Newpress.X) 
		{
	      for (i=0;i<item.Total;i++)
	      {

	         if (compareFileType(file[i].Name,".nds")&& pa_3dsprites[i+100].textureID == texture.BlankNdsIcon)
	         {
					loadNdsIcon(i,1);
					break;
				}			
			}			
		}			
		updateIconLoad();
		
			if (fileMode.PropertySelect <=50){
				for (i=100;i<item.Total+100;i++)
				if (PA_3DSpriteTouched(i) && Stylus.Newpress) 
				{
			   	oldStylusY=Stylus.Y;
					oldStylusX=Stylus.X;
					AccellStylusY= 0;
					AccellStylusX= 0;
					fileMode.PropertySelect =0;
				   item.AnimateWhat=2;
				   item.Touched=i;
				   UpdateTopScreen(i-100,0);
				   
				   PA_3DSetSpriteWidthHeight(item.Touched,44,44);	
				   item.TouchedX= Stylus.X-pa_3dsprites[i].X;
				   item.TouchedY= Stylus.Y-pa_3dsprites[i].Y;
			
					item.TouchedNewpress=2;
					PA_3DSetSpriteAlpha(item.Touched,31);
					break;
				}   
	
				if (PA_3DSpriteTouched(20) && fileMode.BinAmount==1 && fileMode.Function!=0 && Stylus.Newpress && pa_3dsprites[20].Width == 32) 
				{
					oldStylusY=Stylus.Y;
					oldStylusX=Stylus.X;
					AccellStylusY= 0;
					AccellStylusX= 0;
					fileMode.PropertySelect =0;
				   item.AnimateWhat=2;
				   item.Touched=20;
				   PA_3DSetSpriteWidthHeight(20,44,44);	
				   item.TouchedX= Stylus.X-pa_3dsprites[20].X;
				   item.TouchedY= Stylus.Y-pa_3dsprites[20].Y;
			
					item.TouchedNewpress=2;
	
					PA_3DSetSpriteAlpha(item.Touched,31);
				}   
			}			

			
			
			if ((Stylus.Held || (AccellStylusX!= 0 || AccellStylusY !=0)) && item.TouchedNewpress) 
			{
				PA_3DSetSpriteXY(item.Touched,Stylus.X-item.TouchedX,Stylus.Y-item.TouchedY);

			   PA_3DSetSpritePrio(item.Touched,1025);
				for (i=item.Total-1;i>=0;i--)
				{
					if (i+100!=item.Touched) 
					{
						if (file[i].isFolder) 
						{
							if (PA_3DSpriteTouched(i+100))
							{
								PA_3DSetSpriteAlpha(i+100,31);
								PA_3DSetSpriteWidthHeight(i+100,35,35);
							   if (16+pa_3dsprites[i+100].Y > 0 && 16+pa_3dsprites[i+100].Y  < 192)
								{
									PA_16cTextAlign(2);
									Filename_16cText(0,pa_3dsprites[i+100].X-32 > 0 ?pa_3dsprites[i+100].X-32 : 0,
												pa_3dsprites[item.Touched].Y-32,
												32+pa_3dsprites[i+100].X,
												pa_3dsprites[item.Touched].Y-32,
												file[i].Name,10,1,pa_3dsprites[i+100].alpha<11?pa_3dsprites[i+100].alpha:11);
								}			
							}			
							else
							{
								PA_3DSetSpriteAlpha(i+100,10);
							}			
						}			
					}			
				}			
		



		
			   if ((Stylus.X-item.TouchedX)+8 >= 32+(((item.Touched-100)%item.PerLine)*64) && 
				(Stylus.X-item.TouchedX)-8 <= 32+(((item.Touched-100)%item.PerLine)*64) && 
				(Stylus.Y-item.TouchedY)+8 >= 32+(((item.Touched-100)/item.PerLine)*48)+(((25-pa_3dsprites[5].Y)/3)*((item.Total-9) / item.PerLine)) &&
				(Stylus.Y-item.TouchedY)-8 <= 32+(((item.Touched-100)/item.PerLine)*48)+(((25-pa_3dsprites[5].Y)/3)*((item.Total-9) / item.PerLine)))
				{
				   if (fileMode.PropertySelect > 50)
					{

						PA_16cTextAlign(0);

						PA_3DSetSpriteXY(41,(Stylus.X-item.TouchedX)+24+16,(Stylus.Y-item.TouchedY)+16-30);

						Filename_16cText(0,pa_3dsprites[item.Touched].X+2+16,
												pa_3dsprites[item.Touched].Y+16-38,
												72+pa_3dsprites[item.Touched].X+32,
												pa_3dsprites[item.Touched].Y+16-38,
													"properties",1,1,15);
					   
					   PA_3DSetSpriteVisible(41,1);
					}

				}   
				if (fileMode.PropertySelect < 20)
				{

/*					clear16cZone(0,oldStylusX-32,
								oldStylusY-24,
								36+oldStylusX,
								24+oldStylusY);*/
					PA_16cTextAlign(2);


							Filename_16cText(0,pa_3dsprites[item.Touched].X-100,
											16+pa_3dsprites[item.Touched].Y < 180 ?16+pa_3dsprites[item.Touched].Y:180,
											100+pa_3dsprites[item.Touched].X,
											16+pa_3dsprites[item.Touched].Y < 180 ?16+pa_3dsprites[item.Touched].Y:180,
											file[item.Touched-100].Name,10,1,100);		

				}			
			if (Stylus.Held)
			{
				if (Stylus.Newpress)
				{
					oldStylusY=pa_3dsprites[item.Touched].Y;

					oldStylusX=pa_3dsprites[item.Touched].X;
				}			
				AccellStylusX = pa_3dsprites[item.Touched].X-oldStylusX;
				AccellStylusY = pa_3dsprites[item.Touched].Y-oldStylusY;
				
			
			}		
			else
			{
			   if ( AccellStylusX >0)
					AccellStylusX--;
			   if ( AccellStylusX <0)
					AccellStylusX++;
			   if ( AccellStylusY >0)
					AccellStylusY--;
			   if ( AccellStylusY <0)
					AccellStylusY++;
					
				if( Stylus.X > 0 && Stylus.X <256)
					Stylus.X +=AccellStylusX;
		
				if( Stylus.Y > 0 && Stylus.Y <192)
					Stylus.Y +=AccellStylusY;
		
				if( Stylus.X <= 1)
				{
					AccellStylusX= AccellStylusX*-1;
					Stylus.X = 2;
				}			
		
				if( Stylus.X >= 255)
				{
					AccellStylusX= AccellStylusX*-1;
					Stylus.X = 254;
				}			
				
				if( Stylus.Y <= 1)
				{
					AccellStylusY= AccellStylusY*-1;
					Stylus.Y = 2;
				}			
		
				if( Stylus.Y >= 191)
				{
					AccellStylusY= AccellStylusY*-1;
					Stylus.Y = 190;
				}			
					
				Stylus.Released=1;
				
				
			}		
				oldStylusY=pa_3dsprites[item.Touched].Y;
				oldStylusX=pa_3dsprites[item.Touched].X;
				
				if (Stylus.X-item.TouchedX > 224-16 && Stylus.Y-item.TouchedY > 160-16 && item.Touched != 20)
				   	if ((fileMode.Function==0 || fileMode.Function!=0) && !file[item.Touched-100].isFolder)
				   	{
							executeSelectedFunction();
							if (fileMode.Function!=1)deleteFile(item.Touched-100);
						}			

							
		
		
				
			}	
			if (!(item.TouchedNewpress))
			{
				for (i=item.Total-1;i>=0;i--)
					makeText(i+100,0);
			}			
			
			if (fileMode.PropertySelect >50)
			{
			   if (Stylus.Newpress) 
				{
					AccellStylusY= 0;
					AccellStylusX= 0;
				   fileMode.PropertySelect =0;
					Stylus.Released=1;
//					if (
				}   
			   
			}   
			if (Stylus.Released && AccellStylusX== 0 && AccellStylusY ==0 && item.TouchedNewpress && fileMode.PropertySelect <= 50)
			{
			   fileMode.PropertySelect=0;
//			   PA_3DSetSpriteVisible(42,0);
			   PA_3DSetSpriteVisible(41,0);
			   item.TouchedNewpress=0;
			   UpdateTopScreen(item.Touched-100,1);
				if (item.Touched != 20){
	//			   PA_3DSetSpriteXY(item.Touched,32+(((item.Touched-100)%item.PerLine)*64), 32+(((item.Touched-100)/item.PerLine)*48)+(((25-pa_3dsprites[5].Y)/3)*((item.Total-9) / item.PerLine)));
				   updateExplorerIconXY();
				   PA_3DSetSpritePrio(item.Touched,1024);
				   item.AnimateWhat=3;
				   PA_3DSetSpriteWidthHeight(item.Touched,20,20);
				}
				else
				{   
					PA_3DSetSpriteY(20,150);
					PA_3DSetSpriteX(20,232);
				   item.AnimateWhat=3;
				   PA_3DSetSpriteWidthHeight(20,20,20);
				}			

			}   
			if (item.AnimateWhat == 2)
			{
				if ( pa_3dsprites[item.Touched].Width > 32)
				{
				pa_3dsprites[item.Touched].Width-=1;
				pa_3dsprites[item.Touched].Height-=1;
				for (i=item.Total-1;i>=0;i--)
				if (i+100!=item.Touched)
					PA_3DSetSpriteAlpha(i+100,(pa_3dsprites[item.Touched].Height-32)+10);
				}
			
			}   
			
			if (item.AnimateWhat == 3)
			{
				if ( pa_3dsprites[item.Touched].Width < 32)
				{
				pa_3dsprites[item.Touched].Width+=1;
				pa_3dsprites[item.Touched].Height+=1;
				for (i=item.Total-1;i>=0;i--)
				PA_3DSetSpriteAlpha(i+100,pa_3dsprites[item.Touched].Height-1);
				}
			
			}   
			

		if (!item.TouchedNewpress && pa_3dsprites[item.Touched].Width == 32 && !fileMode.BinSelect){
		for (i=1;i<8;i++)
			if (PA_3DSpriteTouched(5+i) && Stylus.Newpress && pa_3dsprites[5+i].Alive)
				break;

			if (!(PA_3DSpriteTouched(5+i) && Stylus.Newpress && pa_3dsprites[5+i].Alive)){

	
			if (Stylus.Newpress || Pad.Newpress.Up || Pad.Newpress.Down){
				oldStylusY=Stylus.Y;
				oldStylusX=Stylus.X;
				pa_3dsprites[5].alpha=5;
			}	
			if (pa_3dsprites[5].alpha !=1){
				if (Stylus.Held || Pad.Held.Up || Pad.Held.Down) 
				{
		
					if (pa_3dsprites[5].alpha < 9)
					pa_3dsprites[5].alpha++;
					if (Stylus.Held)
					{
						AccellStylusY = Stylus.Y-oldStylusY;
					}	
					else		
					if (Pad.Held.Down)
					{
					   AccellStylusY = 3;
					}
					else
					if (Pad.Held.Up)
					{
					   AccellStylusY = -3;
					}					   
		
					if (pa_3dsprites[5].Y+AccellStylusY < 24 || pa_3dsprites[5].Y+AccellStylusY > 192-8)  
					AccellStylusY = 0;
					if (fileMode.FunctionChanged >=10)
						AccellStylusY = 0;

				   pa_3dsprites[5].Y+=AccellStylusY;
				   
				   
				   
					oldStylusY=Stylus.Y;
					oldStylusX=Stylus.X;
				
				
				
				
				}   
				else
				{
					   if ( AccellStylusY >0)
							AccellStylusY--;
					   if ( AccellStylusY <0)
							AccellStylusY++;
				
				
			
						if( pa_3dsprites[5].Y > 24 && pa_3dsprites[5].Y <184)
							pa_3dsprites[5].Y +=AccellStylusY;
				
					
						if( pa_3dsprites[5].Y <= 25)
						{
							AccellStylusY= AccellStylusY*-.25;
							pa_3dsprites[5].Y = 25;
						}			
				
						if( pa_3dsprites[5].Y >= 183)
						{
							AccellStylusY= AccellStylusY*-.25;
							pa_3dsprites[5].Y = 183;
						}			
					if (pa_3dsprites[5].alpha > 1)
					pa_3dsprites[5].alpha--;
				}   
				updateExplorerIconXY();

				for (i=0;i<item.Total;i++)
				PA_3DSetSpriteVisible(i+100,1);
		
				
			}	
		}		
		}	
		
		
		}	
		
		
		if (item.AnimateWhat == 0)
			transiteIcons();

		
		makeMiscText();
		for (i=1;i<8;i++)
			if (pa_3dsprites[5+i].alpha > 10)
				pa_3dsprites[5+i].alpha--;
		for (i=1;i<8;i++)
			if (PA_3DSpriteTouched(5+i) && Stylus.Newpress)
			{
				pa_3dsprites[5+i].alpha=31;
				if (i-1 <folder.OpenedWindows)
				{
					strncpy(charTemp,folder.Window[i-1],256);
					strncpy(folder.Window[i-1],folder.Current,200);
					strncpy(folder.Current,charTemp,200);
					if (folder.Window[i-1][strlen(folder.Window[i-1])-2] !=':')
				   	sprintf(folder.Trimmed.Window[i-1],"%s",getLastFolderName(folder.Window[i-1]));	
				   else
					   sprintf(folder.Trimmed.Window[i-1],"root");	
					readCurrentFolder();
				   renderFolder();
				   item.AnimateWhat = 0;
					PA_3DSetSpriteY(5,25);
				}			
				break;
			}	
			if (PA_3DSpriteTouched(5+folder.OpenedWindows+2)  && Stylus.Newpress)
			{
				if (fileMode.SortMode <1)
					fileMode.SortMode++;
					else
					fileMode.SortMode=0;
			   renderFolder();
//				clear16cZone(0,212,13+(14*(folder.OpenedWindows+1)),260,22+(14*(folder.OpenedWindows+1)));
			   item.AnimateWhat = 0;
				PA_3DSetSpriteY(5,25);
			}			
		
		if (PA_3DSpriteTouched(6+folder.OpenedWindows) && Stylus.Newpress && folder.OpenedWindows < 4)
		{
			for (i=1;i<8;i++)
					pa_3dsprites[5+i].alpha=10;
			PA_3DSetSpriteVisible(8+folder.OpenedWindows,1);
			PA_3DSetSpriteVisible(8+folder.OpenedWindows+1,1);
		   pa_3dsprites[6+folder.OpenedWindows].alpha=10;
		   pa_3dsprites[7+folder.OpenedWindows].alpha=31;
		   strncpy (charTemp,"",256);
			strncpy(folder.Window[folder.OpenedWindows],folder.Current,200);
			if (folder.Window[folder.OpenedWindows][strlen(folder.Window[folder.OpenedWindows])-2] !=':')
		   	sprintf(folder.Trimmed.Window[folder.OpenedWindows],"%s",getLastFolderName(folder.Window[folder.OpenedWindows]));	
		   else
			   sprintf(folder.Trimmed.Window[folder.OpenedWindows],"root");	
			folder.OpenedWindows++;
//			clear16cZone(0,212,0,255,120);
			makeMiscText();
			
		}			


		if ((PA_3DSpriteTouched(8+folder.OpenedWindows) && Stylus.Newpress) || Pad.Newpress.B)
		{
			initThemeTransition("explorer", 0);
			while (isScreenTransiting())
			{
				updateScreenTransition();
				updateAmbience();
				Soul_waitForVBL();
		  	}		
			return 0;	
		}			
		Soul_waitForVBL();

		transiteScreenAnd3DProcess();
	}


	
	return 0;
} // End of main()




