#include <PA9.h>       // Include for PA_Lib
#include <fat.h>
#include <sys/dir.h>
#include "game_select_animate.h" 
#include "game_select_input.h"
#include "game_select_topscreen.h"
#include "game_select_scriptengine.h"
#include "game_select_nds.h"
#include "blackSpace.h"
#include "Xmenu.h"
#include "../../system/services/mwifi.h"
#include "../../misc/misc.h"
#include "../../misc/math.h"
#include "../../misc/debug.h"
#include "../../misc/fat.h"
#include "../../misc/transition.h"
#include "../../misc/clock.h"
#include "../../loader/loader.h"
#include "../../engine/engine.h"
#include "../../userConfigFunctions.h"
#include "../../structDef.h"
#include "game_select_struct.h"

struct clockInfo
{
	textBox Text;
	spriteNoRotSet Battery;
} Clock;


typedef struct
{
	struct textInfo
	{
		textBox Title;
		textBox Description;
	}	Text;
	bool IconVisible;
	u8 IconY;
} topScreenTheme;

topScreenTheme TopScreen;
bool navigatingFolders=0;
bool horizontalNavigationControls=0;	
struct stat st;
int tempAnimVar=0;
DIR_ITER* dir;
extern u32 idleCounter;
u8 createIconCounter;

u16 ndsIconTex;
u16 folderIconTex;
extern bool customCoverDisplay;

u16 fileAmount = 0;
char gameDirectory[256];
char gameDirectory_root[100];
char gameSubDirectory[100];

int SelectMenu=0;
bool SelectSubMenu=0;

int gameSelect_counter=0;

int SubFolderAmount;
int selectedFolder=0;
extern bool heldIcon;


extern FILE* readINI;

exitGameSelect(){
	loadFatSndWav(navigation.sound.cancel);
	initThemeTransition("GameNavigate", 0);
	while (isScreenTransiting())
	{
		transiteScreenAnd3DProcess();
		updateAmbience();
		Soul_waitForVBL();
  	}		
}
void resetmSelectMemory(){
   memset (navigation.FileName,0,(100*100)-1);
   memset (navigation.Description,0,(100*3*60*sizeof(u16))-1);
	resetmSelectMemory_TopScreen();
	fileAmount = 0;
	SelectSubMenu=0;
	gameSelect_counter=0;

}   
void stringswap(char *a, char *b)
{
   char chrtemp[256];
   sprintf(chrtemp,"%s",a);
   sprintf(a,"%s",b);
   sprintf(b,"%s",chrtemp);
}
 
void folderGameSelectABCSort()
{
	int  i= 1;
	int y=0;
	while( i < fileAmount)
	{
	   for (y=0;toupper(navigation.FileName[i-1][y]) ==toupper(navigation.FileName[i][y]) && navigation.FileName[i][y] !=0;y++);
	   
		if( toupper(navigation.FileName[i-1][y]) >=toupper(navigation.FileName[i][y]))
		{
			i++;
		}		
		else
		{
			stringswap(navigation.FileName[i-1], navigation.FileName[i]);
			i--;
			if(i == 0) i = 1;
		}	
	}
}

void loadDirectory(char* Directory)
{
   startLoadScreen();
   initDebugTxt();
   int i=0;
   int x=0;
   for (x=0;Directory[x]!='\\' && Directory[x]!='/';x++);
   x++;
   while(Directory[x])
   {
      if (!((gameDirectory[i-1]=='\\' || gameDirectory[i-1]=='/') && (Directory[x] == '\\' || Directory[x] == '/')) || i==0) 
		{
			gameDirectory[i]=Directory[x];
			i++;
		}			
      x++;
   }   
   gameDirectory[i]=0;
      
	sprintf(gameDirectory,"%s",Directory);
   debugTxt("loading dir");
   debugTxt(Directory);
   resetmSelectMemory();
	dir = diropen(Directory);
	fileAmount=0;

	if (dir == NULL) 
	{
		
		loadDirectory(gameDirectory_root);
		return;
	} 
	else 
	while (dirnext(dir, navigation.FileName[fileAmount], &st) == 0) 
	{
		if (!(st.st_mode & S_IFDIR) && isFileNameNDS(navigation.FileName[fileAmount]))
		{
			navigation.FileName[fileAmount][strlen(navigation.FileName[fileAmount])-4]=0;
			navigation.isFolder[fileAmount]=0;
			fileAmount++;
		}			
	}
	debugTxt("collect dir okay ");
	sprintf(navigation.FileName[fileAmount]," ");
	if (fileAmount==0)
	{
	   sprintf(navigation.FileName[fileAmount],"No NDS Found");
		for (i=0;navigation.FileName[fileAmount][i];i++) navigation.Description[fileAmount][0][i]=navigation.FileName[fileAmount][i];
		navigation.Description[fileAmount][0][i]=0;
	}
	else   
		folderGameSelectABCSort();
	debugTxt("sort dir okay ");
	char charTemp[256];			
	chdir(Directory);
	spaceLetteringForAAText();
	PA_TextAlign(ALIGN_CENTER);

	for(i=0;i<fileAmount;i++)
	{
//		if (navigation.file[i]) fclose(navigation.file[i]);
		navigation.customIcon[i]=0;
		navigation.isFolder[i]=0;

	}   
	spaceLetteringForDefault();
	chdir("fat:/");
	debugTxt("finishedloading");
	for (i=4;i<=7;i++) PA_3DSetSpriteVisible(i,0);

	PA_3DSetSpritePrio(2, 1);
//initGameSelectSprites(0);
	
	initGameSelectSprites(0);
	stopLoadScreen();
}   
char* getNaviFolderName(int selectedFolder)
{
	struct stat st;
	char filename[256]; 
	char temp[256];
	char temp2[256];
	char temp3[256];
	sprintf(temp,"fat:/%s",gameDirectory_root);
	DIR_ITER* dir2;
	DIR_ITER* dir = diropen(temp);
	int folderCounter=0;
	bool fileFoundInsideDir=0;
	while (dirnext(dir, filename, &st) == 0) 
	{
	   //updateAmbience();
		//transiteScreenAnd3DProcess();
	   if (strcmp(filename,"..") == 0) continue;
	   if (st.st_mode & S_IFDIR) 
	   {
	   	sprintf(temp2,"fat:/%s%s/",gameDirectory_root,filename);
   		dir2 = diropen(temp2);
   		fileFoundInsideDir=0;
  			while (dirnext(dir2, temp3, &st) == 0) 
				if (!(st.st_mode & S_IFDIR) && isFileNameNDS(temp3))
				{
					fileFoundInsideDir=1;
					break;
				}			
			dirclose(dir2);
		   if (fileFoundInsideDir)
			{
			   if (selectedFolder==folderCounter) break; 
			   folderCounter++;
			}   
		}
	}   
	char * result = malloc(256); 
	sprintf(result,"%s%s/",gameDirectory_root,filename);
	return result;
}   
//extern FILE* historyFile;
struct lastFileInfo
{
	char ndsFile[80];
	char rootFolder[80];
	char subFolder[80];
	bool found;
} lastFile;

bool getLastFileInfo()
{
      if (lastFile.ndsFile[0]!=0) return 1;
		FILE * handle = fopen ("fat:/_menudo/logs/HISTORY.LASTOPENED", "rb"); //rb = read
	char charTemp[256];	
		if (handle)
		{
	
			fgets(charTemp, 256, handle);
			fclose(handle);

		int i=0;
			int x=0;
			u8 folderCounter=0;
			int folderLetterPos=0;
			int subfolderLetterPos=0;
			for(i=0;i<256;i++)
			{
			   if (charTemp[i]=='\n' || charTemp[i]=='\r' ||charTemp[i]==0) break;
			   if (folderCounter<2)
			   {
				   if (folderCounter==1) //root
				   {
				      lastFile.rootFolder[x]=charTemp[i];
				      x++;
				   }   
				   if (charTemp[i]=='/' || charTemp[i]=='\\') 
					{
					   if (folderCounter==1)
					  	lastFile.rootFolder[x]=0;
						folderLetterPos=i;
					   folderCounter++;
					   x=0;
					}   

				}
				else
				{
				   if (charTemp[i]=='/' || charTemp[i]=='\\') 
					{
						folderLetterPos=i;
						subfolderLetterPos=x;
						folderCounter++;
					}   
				   lastFile.subFolder[x] = charTemp[i];
				   x++;
				}			  	
			}
			if (folderCounter==2) memset(lastFile.subFolder,0,sizeof(lastFile.subFolder));
			int stringLength=i;
			lastFile.subFolder[subfolderLetterPos+1]=0;
			x=0;
			for(i=folderLetterPos+1;i<stringLength;i++)
			{
			   
				lastFile.ndsFile[x]=charTemp[i];
				x++;
			}			
			lastFile.ndsFile[x]=0;
			handle=fopen(charTemp,"rb");
			if(!handle)
			{
			   lastFile.found=false;
			   fclose(handle);
			   return 0;
			}   
			fclose(handle);
			   lastFile.found=true;
			return 1;
			
		}	
		return 0;		
   
}   
char* getLastNaviFolder()
{
	initDebugTxt();
	if ((!lastFile.found && lastFile.ndsFile[0]!=0) || (lastFile.ndsFile[0]==0 && !getLastFileInfo())) return NULL;

	debugTxt("comparing directory");
debugTxt(gameDirectory_root);
debugTxt(lastFile.rootFolder);
	if (stricmp(gameDirectory_root,lastFile.rootFolder)!=0)return NULL;
	debugTxt("writing directory");

   char * charTemp = malloc(100);
   memset(charTemp,0,100);
	sprintf(charTemp,"%s%s",lastFile.rootFolder,lastFile.subFolder);
	debugTxt(charTemp);
	return charTemp;
}	
void initDirectory()
{
 initDebugTxt();  
char chartemp[256];
	char* firstFolderPath=getLastNaviFolder();
	if (firstFolderPath==NULL) 
	  firstFolderPath=getNaviFolderName(0);
//	}   
	sprintf(gameDirectory,"%s",firstFolderPath);
	sprintf(chartemp,"fat:/%s",gameDirectory);
	logMessage(chartemp);


	free(firstFolderPath);
	
	sprintf(chartemp,"%s%s",lastFile.rootFolder,lastFile.subFolder);
	memset(gameSubDirectory,0,sizeof(gameSubDirectory));
	if (stricmp(chartemp,gameDirectory)==0)
	{
	   loadDirectory(chartemp);	
	   navigatingFolders=0;
		//sprintf(gameSubDirectory,"%s%s/",lastFile.rootFolder,lastFile.subFolder);
	   sprintf(gameSubDirectory,"%s",lastFile.subFolder);
	   if (gameSubDirectory[strlen(gameSubDirectory)-1]=='/' || gameSubDirectory[strlen(gameSubDirectory)-1]=='\\') gameSubDirectory[strlen(gameSubDirectory)-1]=0;

		sprintf(chartemp,"%s",lastFile.ndsFile);
	   chartemp[strlen(chartemp)-4]=0;
	   u32 i;
	   for(i=0;i<fileAmount;i++)
	   {
		   if (stricmp(chartemp,navigation.FileName[i])==0) 
	   	{
	   	   SelectMenu=i;
	   	   break;
	   	}
		}			   
		if (i<=1) SelectMenu=0; 
	   if (i>=fileAmount) SelectMenu=fileAmount;
	}   
	else
		loadFolders();
		 
		//getSelectHeader(SelectMenu);
	unloadIcons();
	cleanIcons();	
	refreshIcons();
//	TopScreenText(SelectMenu);
	

}

extern int overlayTex;

void initmSelect(char* Directory)
{
   overlayTex=-1;
	debugTxt("inasditmselect");   
//	initDebugTxt();
	debugTxt("init3d");
	init3d();
	initDebugTxt();
	debugTxt("PA_Init16bitBg");
	init16bitBg(1,2);
	initDebugTxt();

	initDebugTxt();
	initInput();
	debugTxt("initInput");
//	resetmSelectMemory();
	if (Directory[strlen(Directory)-1] == '/')
		sprintf (gameDirectory_root, "%s", Directory);
	else
		sprintf (gameDirectory_root, "%s/", Directory);		
	debugTxt(gameDirectory_root);
	initInput();
	debugTxt("get navi amount");
	SubFolderAmount=getNaviFolderAmount();
//	initInput();

	init16cBg(1, 1);
	init16cBg(0, 1);

	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);
	
	debugTxt("initWindowSystem()");

	debugTxt("CreateSpriteFromBmp");
	CreateSpriteFromBmp(2,(void*)blackSpace,1 ,128, 80);	// X, Y SPRITE CENTER !
	PA_3DSetSpriteWidthHeight(2,256,256);
	
   create3dOuterCanvasLayer(1000,31,31,31);
	PA_3DSetSpritePrio(1000,3100);
	PA_3DSetSpritePrio(1000+1,3100);	
	PA_3DSetSpritePrio(1000+2,3100);
	PA_3DSetSpritePrio(1000+3,3100);
   create3dOuterCanvasLayer(900,0,0,0);
	create3dBackgroundLayer(888,0,0,0);
	PA_3DSetSpritePrio(888,5);
	
	create3dBackgroundLayer(889,31,31,31);
	PA_3DSetSpritePrio(889,4);

   create3dOuterCanvasLayer(1000,21, 23, 28);
   create3dOuterCanvasLayer(900,21, 23, 28);
		
   create3dOuterCanvasLayer(900,0,0,0);
   create3dOuterCanvasLayer(1000,31,31,31);
   
	create3dBackgroundLayer(888,0,0,0); 
	PA_3DSetSpritePrio(888,5);
	
	create3dBackgroundLayer(889,31,31,31);
	PA_3DSetSpritePrio(889,4);
	

	PA_3DSetSpritePrio(1000,3100);
	PA_3DSetSpritePrio(1000+1,3100);	
	PA_3DSetSpritePrio(1000+2,3100);
	PA_3DSetSpritePrio(1000+3,3100);
		



	
	debugTxt("initThemeTransition()");				
	initThemeTransition("GameNavigate",1);
	initDebugTxt();
		
	initAmbienceFromTheme("GameNavigate",10);
	initDebugTxt();
	SelectMenu=0;	
	logMessage(Directory);
	clearbootupLoadScreen();	
	int i=0;
	for (i=0;i<100;i++)
	{
		PA_3DCreateSpriteFromTex(100+i,ndsIconTex,32,32, 2,(100+8)-64,i*32);
		if (SelectMenu!=i)
		{
		   pa_3dsprites[100+i].Width=16;
		   pa_3dsprites[100+i].Height=16;
		}   
	}

	gameselect_initSound();
	
   char* alphapath = returnString("fat:/_menudo/themes/%s/gamenavigate/iconMask.bmp",CurrentTheme);
	navigation.alphaTex = fopen(alphapath, "rb");
	if (navigation.alphaTex)
	{
	   char*  path = returnThemeResourcePath("filetypes/misc/folderIcon.bmp",1);
		folderIconTex = CreateTexFromFatBmpWithAlpha(path,17,alphapath); 
		if (path!=NULL) free(path);
		path = returnThemeResourcePath("filetypes/nds/defaultIcon.bmp",1);
		ndsIconTex = CreateTexFromFatBmpWithAlpha2(path,2,alphapath,true); 


		if (path!=NULL) free(path);
	  
		
	}		
	else
	{
		ndsIconTex = CreateTexFromThemeResource("filetypes/nds/defaultIcon.bmp",2,1); 
		folderIconTex= CreateTexFromThemeResource("filetypes/misc/folderIcon.bmp",17,1); 
		for(i=0;i<7;i++) 	navigation.IconTex[i] = CreateTexFromThemeResource("filetypes/nds/defaultIcon.bmp",(i%7)+10,1); 

	}
	if (alphapath!=NULL) free(alphapath);



	

	if (!isScreenTransiting()) 
	{
	   resetScreenBrightness();
	}   

	char* stringTmp = returnString("fat:/_menudo/themes/%s/gamenavigate/topscreen.jpg",CurrentTheme);
	fclose(navigation.topscreenDefault);
	navigation.topscreenDefault = fopen(stringTmp,"rb");
	if (stringTmp!=NULL) free(stringTmp);
	confirmBootupSucceeded(1);
	
	loadGameSelectScript();


	initDirectory();	

//deinitDebugTxt();
}   

	   
int getNaviFolderAmount()
{
	struct stat st;
	char temp[256]; 

	sprintf(temp,"fat:/%s",gameDirectory_root);
	DIR_ITER* dir = diropen(temp);
	int folderCounter=0;
	bool fileFoundInsideDir=0;
	while (dirnext(dir, temp, &st) == 0) 
	{
	   if (strcmp(temp,"..") == 0) continue;
	   if (st.st_mode & S_IFDIR)
		{
		   folderCounter++;
		}   
	}   
	dirclose(dir);
	return folderCounter;
}   

bool confirmDirectory()
{
   if (SelectMenu==fileAmount-1)
	{			
		return 1;
	}	

   if (SelectMenu>fileAmount-3) return 0;
   
   if (!Stylus.Held)
   {
   	if (gameSelect_counter >64)SelectMenu++;
		if (gameSelect_counter <-64)SelectMenu--;
	}		
   if (SelectMenu==fileAmount-3)
	{			
		changeDirectory("");
	}	
	else		
	if (SelectMenu<fileAmount-2)
   {
		changeDirectory(navigation.FileName[SelectMenu]);
	}
	return 0;					
}   

bool mSelect(char* Directory)
{
  resetScreenSaverCounter();
   startLoadScreen();
	char charTemp[256];
	idleCounter=0;

	initmSelect(Directory);	
//waitTillBootupIsFinished();
//startLoadScreen();

	readINI = fopen(returnString("fat:/_menudo/themes/%s/gamenavigate/interface.ini",CurrentTheme),"rb");

deinitDebugTxt();	
update_clearbootupLoadScreen();

	sprintf(TopScreen.Text.Title.format, "%s", readIniFileString("TopScreenTitleText"));
	TopScreen.Text.Title.aliasedFont = (bool)readIniFileInt("TopScreenTitleAntiAliased");
	setAntiAliasDepth(1, readIniFileInt("TopScreenTitleAntiAliasIntensity"));
	TopScreen.Text.Title.alignment = convertAlignToInt(readIniFileString("TopScreenDescriptionAlignment"));
	TopScreen.Text.Title.x1 = limitValueToScreenX(readIniFileInt("TopScreenTitleX1"));
	TopScreen.Text.Title.y1 = limitValueToScreenY(readIniFileInt("TopScreenTitleY1"));
	TopScreen.Text.Title.x2 = maxLimitValueTo(readIniFileInt("TopScreenTitleX2"),TopScreen.Text.Title.x1,256);
	TopScreen.Text.Title.y2 = maxLimitValueTo(readIniFileInt("TopScreenTitleY2"),TopScreen.Text.Title.y1,256);
	sprintf(TopScreen.Text.Description.format, "%s", readIniFileString("TopScreenDescriptionText"));
	TopScreen.Text.Description.aliasedFont = (bool)readIniFileInt("TopScreenDescriptionAntiAliased");
	TopScreen.Text.Description.alignment = convertAlignToInt(readIniFileString("TopScreenDescriptionAlignment"));
	TopScreen.Text.Description.x1 = limitValueToScreenX(readIniFileInt("TopScreenDescriptionX1"));
	TopScreen.Text.Description.y1 = limitValueToScreenY(readIniFileInt("TopScreenDescriptionY1"));
	TopScreen.Text.Description.x2 = maxLimitValueTo(readIniFileInt("TopScreenDescriptionX2"),TopScreen.Text.Description.x1,256);
	TopScreen.Text.Description.y2 = maxLimitValueTo(readIniFileInt("TopScreenDescriptionY2"),TopScreen.Text.Description.y1,256);
	horizontalNavigationControls = (bool)readIniFileInt("NavigationHorizontalControls");
	bool TopScreenTextColor = (bool)readIniFileInt("TopScreenFontBlackColor");
	initAntiAliasedText(1,1,TopScreenTextColor);
	bool BottomScreenTextColor = (bool)readIniFileInt("BottomScreenFontBlackColor");
	u8 AAdepth=readIniFileInt("BottomScreenAntiAliasIntensity");
	initAntiAliasedText(0,1,BottomScreenTextColor);
	setAntiAliasDepth(0, AAdepth);
	
	fclose(readINI);
	initWindowSystem();	


	spaceLetteringForAAText();
//  initSMF(1, "fat:/BT_Song.smf");

//char debugtxt[100];

	
	selectedFolder=0;
	int i;
customCoverDisplay=1;
	
	initTopScreen();
	   
TopScreenText(SelectMenu);
initClock("gamenavigate",11,2);
/*	setBrightness(0,25);
	setBrightness(1,25);
	transiteScreenAnd3DProcess();
	updateAmbience();
	Soul_waitForVBL();

	setBrightness(0,15);
	setBrightness(1,15);
	transiteScreenAnd3DProcess();
	updateAmbience();
	Soul_waitForVBL();
	setBrightness(0,0);
	setBrightness(1,0);*/
		  // PA_SetSpriteY(1,10,Clock.Battery.y);

		   startupPopup();
	while (1)
	{

		bootupFadeFromWhite();
		if (Pad.Newpress.R) 
		{
//		   screenshotbmp("fat:/testtest.bmp");
			toogleLights();
		}   
		
		if (Pad.Newpress.L)
		{ 
		   //if (TopScreen.IconVisible) 
			PA_SetSpriteY(1,0,205);
		   PA_SetSpriteY(1,11,205);

			if (shrinkMenu("gamenavigate","topscreen.jpg",1,10)) return 1;

//			if (shrinkMenu("topscreen",TOPscreen.Menu[getMenuSequence()],1,0)) return 1;
			TopScreenText(SelectMenu);
			initAntiAliasedText(1,1,TopScreenTextColor);
			initAntiAliasedText(0,1,BottomScreenTextColor);
			setAntiAliasDepth(0, AAdepth);

		   PA_SetSpriteY(1,10,Clock.Battery.y);
			PA_SetSpriteY(1,0,TopScreen.IconY);
		}			
		if (Pad.Newpress.X && navigatingFolders!=1)  
		{
			i = xmenu_Load16cBMPtoBG(0,(void*)Xmenu,0,0);
			Soul_waitForVBL();
		   switch(i)
		   {
		      case 2:	wifi.online=0;
		      case 1:	sprintf (charTemp,"fat0:/%s",gameDirectory);
							if (charTemp[strlen(charTemp)-2] == '/')
							{
							  charTemp[strlen(charTemp)-1]  = '\0';
							}			
							char* stringTmp = returnString("%s%s.nds",charTemp,navigation.FileName[SelectMenu]);
							menudo_prepareNDS(stringTmp,1,1);
							return 0;
							
		      case 5:	mWifi_GameInfoPage();
				         break;
		    }  	
			sprintf(charTemp,"fat:/_menudo/themes/%s/gamenavigate/topscreen.jpg",CurrentTheme);
			loadFatBg16bit(1,charTemp);
			TopScreenText(SelectMenu);
			initAntiAliasedText(1,1,TopScreenTextColor);
			initAntiAliasedText(0,1,BottomScreenTextColor);
			setAntiAliasDepth(0, AAdepth);
	
		   PA_SetSpriteY(1,10,Clock.Battery.y);
			PA_SetSpriteY(1,0,TopScreen.IconY);
		}   		

		if (Pad.Newpress.B && navigatingFolders==1)  
		{
			exitGameSelect();
	     	break;
		}   
		if (!isWindowHit())
		{
			if (getInputLeft() && navigation.isFolder[SelectMenu]) if (confirmDirectory()) { exitGameSelect(); break;}
			if ((getInputRight() && !navigation.isFolder[SelectMenu]) || (Pad.Newpress.B && navigatingFolders==0)) 	
			{
		   	loadFatSndWav(navigation.sound.cancel);
			   viewFolders();//switchFolder(1);//jumpPage(0); x
			}   
			if (getInputUp()) 	navigateDirection(1);
			if (getInputDown()) 	navigateDirection(0);	
			
		}

		if (Pad.Newpress.Y) if (stricmp(gameDirectory_root,lastFile.rootFolder)==0) initDirectory();
		
		
		if (Pad.Newpress.A || (isDoubleTapped() && heldIcon))	
		{
			loadFatSndWav(navigation.sound.confirm);
		   if (navigation.isFolder[SelectMenu])
		   {
		      if (confirmDirectory()) { exitGameSelect(); break;} 
		   }   
		   else
		   {
		      
				sprintf (charTemp,"fat0:/%s",gameDirectory);
				if (charTemp[strlen(charTemp)-2] == '/')
				{
				  charTemp[strlen(charTemp)-1]  = '\0';
				}			
				char* stringTmp = returnString("%s%s.nds",charTemp,navigation.FileName[SelectMenu]);
				menudo_prepareNDS(stringTmp,1,1);
//				closeAllFiles();
				return 0;
			}			
		}		

		
		if (heldIcon) heldIcon=0;
			 
 
	
		if (!customCoverDisplay) updateClock(11,1,2);
		updateGameSelect();
		updateWindow();		
  		updateTopScreen(SelectMenu);
  		updateScreenTransition();
		updateStylusInput();
		updateScroll();
		updateAmbience();
		
		updateIconBump();		
		transiteScreenAnd3DProcess();
		Soul_waitForVBL();
		clear16c(0);
//		AS_MP3StreamPlay("fat:/test.mp3");

		if (checkForScreenSaver())
		{

			sprintf(charTemp,"fat:/_menudo/themes/%s/gamenavigate/topscreen.jpg",CurrentTheme);
			loadFatBg16bit(1,charTemp);
 
			TopScreenText(SelectMenu);
			initAntiAliasedText(1,1,TopScreenTextColor);
			initAntiAliasedText(0,1,BottomScreenTextColor);
			setAntiAliasDepth(0, AAdepth);

		   PA_SetSpriteY(1,10,Clock.Battery.y);
			PA_SetSpriteY(1,0,TopScreen.IconY);
		}	
//		sprintf(debugtxt,"%d - %s",SubFolderAmount,gameDirectory_root);
//		PA_16cText(0,8,8,256,16,debugtxt,6,1,100);

		 
		//if (Pad.Held.Start) tempAnimVar--;
		
	}
	debugTxt("Starting close");
	initDebugTxt();
	closeAllFiles();
	debugTxt("Ending close");
	initDebugTxt();
	return 0;
} // End of main()

bool soul_fclose (FILE* file)
{
   if (file!=NULL) 
   {
		fclose(file);
		return true;
	}		
	else
		return false;
}   
void closeAllFiles()
{
//   return;
   int i=0;
   for (i=0;i<100;i++)
   {
	  if (!soul_fclose(navigation.file[i])) break;
//	  PA_WaitForVBL();
	}   
//	return;
	soul_fclose(navigation.alphaTex);
	soul_fclose(navigation.topscreenDefault);
   soul_fclose(navigation.sound.click);
   soul_fclose(navigation.sound.thud);
	soul_fclose(navigation.sound.confirm);
	soul_fclose(navigation.sound.cancel);
}	
void switchIconsTransite(bool next,bool in)
{
   if (next)
   {
	   if (in)
	   {
	
			tempAnimVar=-20;
		   while(tempAnimVar<0)
		   {
				tempAnimVar+=2;
				updateAmbience();
				updateGameSelect();
				ZoomXY_3DProcess(128,0,0);  
				Soul_waitForVBL();
				PA_16cErase(0);
				updateWindow();		
			}   
	   }   
	   else
	   {
	  	   tempAnimVar=0;
		   while(tempAnimVar<20)
		   {
		      tempAnimVar+=2;
				updateAmbience();
				updateGameSelect();
				ZoomXY_3DProcess(128,0,0);  
				Soul_waitForVBL();
				PA_16cErase(0);
				updateWindow();		
			}  	
		}
	}			
	else
	{
	   if (in)
		{
		   tempAnimVar=20;
		   while(tempAnimVar>0)
		   {
		   	tempAnimVar-=2;
				updateAmbience();
				updateGameSelect();
				ZoomXY_3DProcess(128,0,0);  
				Soul_waitForVBL();
				PA_16cErase(0);
			}
		}
		else
		{
			tempAnimVar=0;
		   while(tempAnimVar>-20)
		   {
				tempAnimVar-=2;
				updateAmbience();
				updateGameSelect();
				ZoomXY_3DProcess(128,0,0);  
				Soul_waitForVBL();
				PA_16cErase(0);
			}
		}			  						
	}   
}



void loadFolders()
{
   initDebugTxt();
   navigatingFolders=1;
   char Directory[256];
	sprintf(Directory,"fat:/%s",gameDirectory_root);
	debugTxt("Loading DIR");
	debugTxt(Directory);
   resetmSelectMemory();
	dir = diropen(Directory);
	fileAmount=0;
	
	while (dirnext(dir, navigation.FileName[fileAmount], &st) == 0) 
	{
		if (st.st_mode & S_IFDIR && navigation.FileName[fileAmount][0]!='.')
		{
			navigation.isFolder[fileAmount]=1;
			fileAmount++;
		}			
	}
 	//PA_WaitFor(Pad.Newpress.Start);
	folderGameSelectABCSort();
	sprintf (navigation.FileName[fileAmount],"Unsorted");	
	int i;
	for (i=0;navigation.FileName[fileAmount][i];i++) navigation.Description[fileAmount][0][i]=navigation.FileName[fileAmount][i];
	navigation.Description[fileAmount][0][i]=0;
	navigation.isFolder[fileAmount]=1;
	navigation.customIcon[fileAmount]=0;
  	if (navigation.file[fileAmount]) fclose(navigation.file[fileAmount]);
	fileAmount++;
	
	sprintf (navigation.FileName[fileAmount],"Recently Played");	
	for (i=0;navigation.FileName[fileAmount][i];i++) navigation.Description[fileAmount][0][i]=navigation.FileName[fileAmount][i];
	navigation.Description[fileAmount][0][i]=0;
	navigation.isFolder[fileAmount]=1;
	navigation.customIcon[fileAmount]=0;
  	if (navigation.file[fileAmount]) fclose(navigation.file[fileAmount]);
	fileAmount++;
	
	sprintf (navigation.FileName[fileAmount],"Return to Menu");	
	for (i=0;navigation.FileName[fileAmount][i];i++) navigation.Description[fileAmount][0][i]=navigation.FileName[fileAmount][i];
	navigation.Description[fileAmount][0][i]=0;
	navigation.isFolder[fileAmount]=1;
	navigation.customIcon[fileAmount]=0;
  	if (navigation.file[fileAmount]) fclose(navigation.file[fileAmount]);
	fileAmount++;
	
	SelectMenu = fileAmount-3;

	//initDebugTxt();
	debugTxt(gameSubDirectory);
	//PA_WaitFor(Pad.Newpress.Start)
	char charTemp[256];
	int x;
	for (i=0;i<fileAmount;i++)
	{
	   if (stricmp(navigation.FileName[i],gameSubDirectory)==0)	SelectMenu =  i;
		for (x=0;navigation.FileName[i][x];x++) 
			navigation.Description[i][0][x]=navigation.FileName[i][x];
		navigation.Description[i][0][x]=0;
		
		navigation.customIcon[i]=1;	  	
		navigation.isFolder[i]=1;
	}	

//	navigation.file[fileAmount-1] = returnThemeResourcePathFILE("filetypes/misc/searchIcon.bmp","rb",1);
//	navigation.file[fileAmount-2] = returnThemeResourcePathFILE("filetypes/misc/recentlyIcon.bmp","rb",1);
//	navigation.file[fileAmount-3] = returnThemeResourcePathFILE("filetypes/misc/unsortedIcon.bmp","rb",1);
		
	if (stricmp(".",gameSubDirectory)==0) SelectMenu=fileAmount-3;


	for (i=4;i<=7;i++) PA_3DSetSpriteVisible(i,0);
//	   for(i=0;i<100;i++) PA_3DSetSpriteVisible(getIconSprite(i),0);
//	   for(i=0;i<fileAmount;i++) PA_3DSetSpriteVisible(getIconSprite(i),1);

	PA_3DSetSpritePrio(2, 1);
//initGameSelectSprites(1);
	initGameSelectSprites(1);

}
void viewFolders()
{
	   PA_SetSpriteXY(1,0,0,200);
	if (gameSelect_counter >0)SelectMenu++;
	if (gameSelect_counter <0)SelectMenu--;
	switchIconsTransite(1,0);
   
   loadFolders();
//	if (SelectMenu>=fileAmount-1) SelectMenu =  fileAmount-1;
	//if (SelectMenu<0) 
	unloadIcons();
	cleanIcons();	
	refreshIcons();
	TopScreenText(SelectMenu);

   switchIconsTransite(1,1);
}   

void changeDirectory(char *dir)
{
   
	switchIconsTransite(0,0);
   navigatingFolders=0;

   char charTemp[256];
   if (dir[0]==0)
   {
      sprintf(gameSubDirectory,".");
   	sprintf(charTemp,"%s/",gameDirectory_root);
	}   
	else
	{
		sprintf(gameSubDirectory,"%s",dir);
		sprintf(charTemp,"%s%s/",gameDirectory_root,dir);
	}		
	
	loadDirectory(charTemp);
	if (fileAmount==0)
		SelectMenu=0;
	else
		SelectMenu=fileAmount-1;
	unloadIcons();
   cleanIcons();	
	refreshIcons();
	TopScreenText(SelectMenu);
	switchIconsTransite(0,1);
}

void gameselect_initSound()
{
   soul_fclose(navigation.sound.click);
   navigation.sound.click = returnThemeResourcePathFILE("gamenavigate/click.wav","rb",1);
   soul_fclose(navigation.sound.thud);
   navigation.sound.thud = returnThemeResourcePathFILE("gamenavigate/thud.wav","rb",1);
   soul_fclose(navigation.sound.confirm);
	navigation.sound.confirm = returnThemeResourcePathFILE("gamenavigate/confirm.wav","rb",1);
	soul_fclose(navigation.sound.cancel);
	navigation.sound.cancel = returnThemeResourcePathFILE("gamenavigate/cancel.wav","rb",1);
}
