#include <PA9.h>
#include "game_select_accessors.h"
#include "game_select_input.h"
#include "../../userConfigFunctions.h"
#include "game_select_struct.h"
u8 SelectOldStylusX;
u8 SelectOldStylusY;
s32 AccelerationX;
s32 AccelerationY; 
bool AccelerationEnded;
extern int gameSelect_counter;
extern int SelectMenu;
extern u16 fileAmount;
extern u16 ndsIconTex;
extern u32 idleCounter;
void cleanIcons();
void refreshIcons();

extern bool horizontalNavigationControls;	

#define StylusY_invert (isStylusInverted()?192-Stylus.Y:Stylus.Y)
#define StylusX_invert (isStylusInverted()?256-Stylus.X:Stylus.X)
#define GAMESELECT_NORMAL_ANIMATION_SPEED 8 
void initInput()
{
	AccelerationX=0;
	AccelerationY=0;
	SelectOldStylusX=0;
	SelectOldStylusY=0;
	AccelerationEnded=0;
}   
int doubleTapSelectedIcon=0; 
bool ricochetGameselect=0;
bool heldIcon=0;
extern bool overlay_Found;
extern bool overlayDuplicate_Found;
extern bool iconDuplicate_Found;
int stylusPivot=0;
bool isDoubleTapped(){
   return doubleTapSelectedIcon>0;
}   

void resetDoubleTap(){
	doubleTapSelectedIcon=getDoubleClickValue();
}
void clearDoubleTap(){
   doubleTapSelectedIcon=0;
}
void updateDoubleTap(){
   if (isDoubleTapped()) doubleTapSelectedIcon--;
}
void updateStylusInput()
{
	if (Stylus.Newpress && !isWindowHit())	
	{

		if (!horizontalNavigationControls)
			stylusPivot=StylusX_invert;
		else
			stylusPivot=StylusY_invert;
		int i;
	  for (i = fileAmount>6?((SelectMenu-3 <0?0:SelectMenu-3)-(SelectMenu+4 >fileAmount?(SelectMenu+4)-fileAmount:0)):0;   
			i < (SelectMenu+4 >fileAmount?fileAmount:SelectMenu+4)-(SelectMenu-3 <0?SelectMenu-3:0);			
			i++)
		if (PA_3DSpriteTouched(getIconSprite(i)) && pa_3dsprites[getIconSprite(i)].Alive)
		{
//		   heldIcon=1;
			heldIcon=1;
			if (SelectMenu==i)
			{
			   if (isDoubleTapped()) return;
			   resetDoubleTap();
				AccelerationEnded=1;
			}   
			else
			{
				AccelerationEnded=0;
				AccelerationY=0;
				SelectOldStylusY=getStylusY();
			}			
			int currentIcon;
			int currentOverlay;
			int currentDuplicate;
			int currentOverlayDuplicate;
			//int y,i;
		   currentIcon=getIconSprite(i);
		   currentOverlay=getOverlaySprite(i);
		   currentDuplicate=getIconDuplicateSprite(i);
		   currentOverlayDuplicate=getOverlayDuplicateSprite(i);


			while(Stylus.Held)
			{
				updateGameSelect();
				updateAmbience();
				ZoomXY_3DProcess(128,0,0);  
				Soul_waitForVBL();
			}			
			heldIcon=0;
			if (PA_3DSpriteTouched(getIconSprite(i)))
			{
		      gameSelect_counter = (SelectMenu-i)*128;
		      int y=0;
		      if (SelectMenu<i) 
					for (y=SelectMenu+1;y<=i;y++)getSelectIcon(y+(i-SelectMenu));
				else
		      if (SelectMenu >i) 
					for (y=SelectMenu-1;y>=i;y--)getSelectIcon(y+(i-SelectMenu));
			   SelectMenu= i;   
				while(gameSelect_counter!=0)
				{
				   gameSelect_counter*=.9;
					updateAmbience();
					updateGameSelect();
					ZoomXY_3DProcess(128,0,0);  
					Soul_waitForVBL();
					PA_16cErase(0);
					updateWindow();
				}			
			}
			return;
		}
		else
		{
			AccelerationEnded=0;
			AccelerationY=0;
			SelectOldStylusY=getStylusY();
		}			

		
	}		
	if (Stylus.Held && !isWindowHit())		
	{
		int i;
		if (!horizontalNavigationControls)
		{
			if (stylusPivot - StylusX_invert > 32 && navigation.isFolder[SelectMenu]) 
			{
			   confirmDirectory();
		      stylusPivot=StylusX_invert;
	   		gameSelect_counter=0;
	   		AccelerationY=0;
				TopScreenText(SelectMenu+1);

			   return;
			}   
			if (stylusPivot - StylusX_invert < -32 && !navigation.isFolder[SelectMenu])	
			{
			   viewFolders();//switchFolder(1);//jumpPage(0);
			  // switchFolder(1);
			   stylusPivot=StylusX_invert;
	   		gameSelect_counter=0;
	   		AccelerationY=0;
				TopScreenText(SelectMenu-1);
			   return;
			}   
		}			
		else
		{
			if (stylusPivot - StylusY_invert > 32&& !navigation.isFolder[SelectMenu]) 
			{
			   
			   viewFolders();
			   stylusPivot=StylusY_invert;
	   		gameSelect_counter=0;
	   		AccelerationY=0;
	   		AccelerationEnded=1;
//				TopScreenText(SelectMenu+1);

			   return;
			}   
			if (stylusPivot - StylusY_invert < -32 && navigation.isFolder[SelectMenu])	
			{
			   confirmDirectory();
			    
			   stylusPivot=StylusY_invert;
	   		gameSelect_counter=0;
	   		AccelerationY=0;
	   		AccelerationEnded=1;
//	   		TopScreenText(SelectMenu-1);
			   return;
			}   
		}	
		AccelerationY= (SelectOldStylusY-getStylusY())*(GAMESELECT_NORMAL_ANIMATION_SPEED<<2);
/*		if (gameSelect_counter+AccelerationY<0 && SelectMenu == 0) 
		{
		   AccelerationY=gameSelect_counter*-1;
		}   
		if (gameSelect_counter+AccelerationY>0 && SelectMenu ==fileAmount-1) 
		{
		   AccelerationY=gameSelect_counter*-1;
		}   */

		if (gameSelect_counter < 30 && gameSelect_counter > 20 && AccelerationY >= 0) 
		{
			gameSelect_counter++;

		}			

		if (gameSelect_counter > -30 && gameSelect_counter < -20 && AccelerationY <= 0) 
		{
			gameSelect_counter--;

		}		
			
	
	}   
	else
	{
	   if (ricochetGameselect)
	   {
		   if (SelectMenu ==0 && 0 > AccelerationY) AccelerationY*=-1;
			if (SelectMenu ==(fileAmount==0?0:fileAmount-1)  && 0 < AccelerationY) AccelerationY*=-1;
		}			
		
		
  		if (AccelerationY > 100) AccelerationY-=AccelerationY*.1;
	  		else
  		if (AccelerationY > 0) 
  		{
		   AccelerationY--;
		   if ( AccelerationY <=10)
		   {
		  		if (gameSelect_counter !=0) AccelerationY =10;
/*		  		if (gameSelect_counter+AccelerationY*.1 >=0)
			   {
			     gameSelect_counter=0;
			     AccelerationY=0;
			   }   */
//			   else
//		  		if (gameSelect_counter <=20) AccelerationY =10;
			}   
		}	  
	  	
		if (AccelerationY < -100) AccelerationY-=AccelerationY*.1;
			else
  		if (AccelerationY < 0) 
  		{
		   AccelerationY++;
		   if (AccelerationY >=-10)
		   {
		  		if (gameSelect_counter !=0) AccelerationY =-10;
/*		  		if (gameSelect_counter <=0)
			   {
			     gameSelect_counter=0;
			     AccelerationY=0;
			   }   */
//			   else
//		  		if (gameSelect_counter >=-20) AccelerationY =-10;
			}   
		}	  
		
		if (gameSelect_counter!=0)
		{
		   if (fileAmount!=0)
		   {
			   if (SelectMenu ==0)
			   {
				   if (/*-10*/0 > gameSelect_counter ) 
					{
					   gameSelect_counter=gameSelect_counter*.9;
					//if (AccelerationY > 10 && AccelerationY > 0 )	
						AccelerationY=1;
					}			
				}			
				if (SelectMenu ==fileAmount -1)
				{
					//if (AccelerationY < -10 && ) 
					if (0 < gameSelect_counter) 
					{
						AccelerationY=-1;
						gameSelect_counter=gameSelect_counter*.9;
					}			
				}			

			   if (SelectMenu <0) SelectMenu = 0;
				if (SelectMenu >fileAmount -1) SelectMenu =fileAmount -1;
			}   
			else
			{
		   	SelectMenu =0;
				AccelerationY=-1;
						gameSelect_counter=gameSelect_counter*.9;
			 }  	
		}			
		if (AccelerationY == 0)
		{
			if (AccelerationEnded == 0)
			{
//				cleanIcons();	
//				refreshIcons();
				TopScreenText(SelectMenu);
			   AccelerationEnded = 1;
			}   
		}	
	}		

	gameSelect_counter+=AccelerationY*.1;
	if (Stylus.Held && !isWindowHit())		SelectOldStylusY=getStylusY();
		

	if (Stylus.Released && !isWindowHit())	
	{
		if (gameSelect_counter <= 20 && gameSelect_counter >= -20) gameSelect_counter=0;
	}	
}
void getSelectHeader(u8 lineNumber);
void getSelectIcon(u8 lineNumber);
void TopScreenText(u8 lineNumber);
void navigateDirection(bool directionUp)
{
	if (!directionUp && 0 < SelectMenu && ((SelectMenu !=1 && gameSelect_counter !=0) || gameSelect_counter ==0))
	{
	   
		if (gameSelect_counter >0)SelectMenu++;
		if (gameSelect_counter <0)SelectMenu--;
		//if (strlen(navigation.Description[SelectMenu-1][0]) ==0)getSelectHeader(SelectMenu-1);
//		TopScreenText(SelectMenu-1);
		if (navigation.IconTex[((SelectMenu-4)%7)] != 0)
		{
			if ((SelectMenu-4)+7 > 0) 
			{
				PA_3DSetSpriteTex(getIconSprite((SelectMenu-4)+7),ndsIconTex);
				PA_3DSetSpritePal(getIconSprite((SelectMenu-4)+7),2);
			}   
		}		
		getSelectIcon(SelectMenu-4);			
		gameSelect_counter=-1;
	   idleCounter=0;
	   if (AccelerationY!=0)
	   {
		   AccelerationY = 0;
		   gameSelect_counter=0;
		   AccelerationEnded=0;
		}   
	}   

	if (directionUp && (fileAmount==0?0:fileAmount-1) > SelectMenu && ((fileAmount-2 != SelectMenu && gameSelect_counter !=0) || gameSelect_counter ==0))
	{
		if (gameSelect_counter >0)SelectMenu++;
		if (gameSelect_counter <0)SelectMenu--;
		//if (strlen(navigation.Description[SelectMenu+1][0]) ==0)getSelectHeader(SelectMenu+1);
//	   TopScreenText(SelectMenu+1);
      if (navigation.IconTex[((SelectMenu+4)%7)] != 0)
		{
			if ((SelectMenu+4)-7 > 0) 
			{
			   PA_3DSetSpriteTex(100+(SelectMenu+4)-7,ndsIconTex);
				PA_3DSetSpritePal(100+(SelectMenu+4)-7,2);
			}   
		}		
		getSelectIcon(SelectMenu+4);			
	   gameSelect_counter=1;
	   idleCounter=0;
	   if (AccelerationY!=0)
	   {
		   AccelerationY = 0;
		   gameSelect_counter=0;
		   AccelerationEnded=0;
		}   
	}   		
}   

/*void jumpPage(bool directionUp)
{
   if (directionUp)
   {
	   if ((fileAmount==0?0:fileAmount-1) > SelectMenu+5)
		SelectMenu+=5;	
		else	
		SelectMenu=(fileAmount==0?0:fileAmount-1);			
		TopScreenText(SelectMenu);	
		cleanIcons();
		refreshIcons();
	   idleCounter=0;

	}			
	else
	{
	   if (SelectMenu > 5)
		SelectMenu-=5;	
		else	
		SelectMenu=0;
	   TopScreenText(SelectMenu);

		cleanIcons();
		refreshIcons();
	   idleCounter=0;
	}		
}		
*/


int getStylusY()
{
   if (!horizontalNavigationControls)
	   return 192-StylusY_invert;
	else
	   return (!isStylusInverted()?256-Stylus.X:Stylus.X);
}   
int getStylusReverseY()
{
   if (!horizontalNavigationControls)
	   return StylusY_invert;
	else
	   return (!isStylusInverted()?256-Stylus.X:Stylus.X);;
}   
int getStylusX()
{
    if (!horizontalNavigationControls)
	   return 256-Stylus.X; 
	else
	   return 192-Stylus.Y;
}   
#define NEWPRESSHOLD_DEFAULT 20
#define NEWPRESSHOLD_REPEATER 5
u16 NewpressHold=NEWPRESSHOLD_DEFAULT;
void resetNewpressHold()
{
	NewpressHold=NEWPRESSHOLD_DEFAULT;
}   
bool checkNewpressHold()
{

   if (!(Pad.Held.Up || Pad.Held.Down || Pad.Held.Left || Pad.Held.Right)) { resetNewpressHold(); return false;}
   NewpressHold--;
   if (NewpressHold==0) 
   {
		NewpressHold = NEWPRESSHOLD_REPEATER;
		return true;
	}		
	return false;
}   

bool getInputUp()
{
    if (!horizontalNavigationControls)
      return Pad.Newpress.Up   || (Pad.Held.Up && checkNewpressHold());
	else
      return Pad.Newpress.Left || (Pad.Held.Left && checkNewpressHold());
}   
bool getInputDown()
{
    if (!horizontalNavigationControls)
      return Pad.Newpress.Down  || (Pad.Held.Down && checkNewpressHold());
	else
      return Pad.Newpress.Right || (Pad.Held.Right && checkNewpressHold());
}   
bool getInputReverseUp()
{
    if (!horizontalNavigationControls)
      return Pad.Newpress.Up    || (Pad.Held.Up && checkNewpressHold());
	else
      return Pad.Newpress.Right || (Pad.Held.Right && checkNewpressHold());
}   
bool getInputReverseDown()
{
    if (!horizontalNavigationControls)
      return Pad.Newpress.Down || (Pad.Held.Down && checkNewpressHold());
	else
      return Pad.Newpress.Left || (Pad.Held.Left && checkNewpressHold());
}   
bool getInputLeft()
{
    if (!horizontalNavigationControls)
      return Pad.Newpress.Left || (Pad.Held.Left && checkNewpressHold());
	else
      return Pad.Newpress.Up   || (Pad.Held.Up && checkNewpressHold());
}   
bool getInputRight()
{
    if (!horizontalNavigationControls)
      return Pad.Newpress.Right || (Pad.Held.Right && checkNewpressHold());
	else
      return Pad.Newpress.Down  || (Pad.Held.Down && checkNewpressHold());
}   


