#include <PA9.h>
#include "../../userConfigFunctions.h"
#include "game_select_accessors.h"
#include "../../misc/misc.h"
#include "../../misc/math.h"
#include "../../structDef.h"
#include "../../engine/engine.h"
#include "game_select_struct.h"

extern unsigned short palette[32] __attribute__ ((aligned (4)));
unsigned short palette2[32] __attribute__ ((aligned (4)));
extern unsigned char  temp_tex[512]; 
extern unsigned char  image[(32*32)]; 
extern unsigned char bmp_tex2[1024*512] __attribute__ ((aligned (4)));
extern unsigned short bmp_256Pal[256] __attribute__ ((aligned (4))); // temp pal from file	
extern u16 ndsIconTex;
extern int SelectMenu;
extern u16 fileAmount;
 
extern char gameDirectory[256];

extern u8 createIconCounter;

extern u16 folderIconTex;
extern char gameDirectory_root[100];


void unloadIcons()
{
   int i;
	for (i=0;i<fileAmount;i++)
	{
	   navigation.iconLoaded[i]=0;
	}
}	   
void cleanIcons()
{
   int i;
	for (i=0;i<fileAmount;i++)
	{
		PA_3DSetSpriteTex(getIconSprite(i),ndsIconTex);
		PA_3DSetSpritePal(getIconSprite(i),2);
	}				
}
void convertIconToTex(unsigned char outputTex[],unsigned char originaltex[], unsigned short pal[]);	
void linkNDSFile(int lineNumber)
{
//   return;
   debugTxt("linking");
   if (navigation.iconLoaded[lineNumber]) return;
   if (navigation.file[lineNumber]) fclose(navigation.file[lineNumber]);
   char charTemp[256];
   if (navigation.isFolder[lineNumber])
   {
      if (!navigation.customIcon[lineNumber]) return;
		sprintf (charTemp,"fat:/%s%s/icon.bmp",gameDirectory_root,navigation.FileName[lineNumber]);
	   debugTxt("linking file");
		navigation.file[lineNumber] = fopen(charTemp,"rb+");
		if (!navigation.file[lineNumber]) navigation.customIcon[lineNumber]=0;
		
   }
	else   
	{
	   debugTxt("linking file");
		sprintf (charTemp,"fat:/%s%s.nds",gameDirectory,navigation.FileName[lineNumber]);	
		navigation.file[lineNumber] = fopen(charTemp,"rb+");

	   char data[570];
	   int datalocation=0x68;
	   u32 newlocation=0;
	   memset(navigation.Description[lineNumber][0],0,60*sizeof(u16));
    	memset(navigation.Description[lineNumber][1],0,60*sizeof(u16));
    	memset(navigation.Description[lineNumber][2],0,60*sizeof(u16));
		if (navigation.file[lineNumber])
		{
        fseek(navigation.file[lineNumber], datalocation, SEEK_SET); // move datalocation bytes from start of file
        fread(&newlocation, sizeof(u32), 1, navigation.file[lineNumber]);		
        if (newlocation==0) return;
	      datalocation=newlocation+832; // word+832 is english title
			fseek(navigation.file[lineNumber], datalocation, SEEK_SET);
			fread(&data, 1, 560, navigation.file[lineNumber]); // read the part of the header we need

		   u16 letter=0;
	
			int lineCounter=0;
			int j=0;
			int i=0;
			for(i=0; i<256; i+=2)//+=2
			{
				letter=makeint(0,0,data[i+1],data[i],1);
				if(letter==10) 
				{
				   lineCounter++;
				   navigation.Description[lineNumber][lineCounter][j] = '\0';
				   j=0;
				}
				else
				{
				   navigation.Description[lineNumber][lineCounter][j] = letter;
				   j++;
				}			   
			}
			   navigation.Description[lineNumber][lineCounter][j] = '\0';
			   debugTxt("collecting text");
 
	    }
	}	
      debugTxt(charTemp);
    navigation.iconLoaded[lineNumber]=1;
	
}	
void getSelectIcon(int lineNumber)
{
	if (lineNumber<0 || lineNumber>=fileAmount)  return;	
   initDebugTxt();

//	if (!(pa_3dsprites[getIconSprite(lineNumber)].textureID == ndsIconTex || pa_3dsprites[getIconSprite(lineNumber)].textureID == folderIconTex)) return;
   linkNDSFile(lineNumber);


    if (navigation.file[lineNumber] && navigation.customIcon[lineNumber])
    {
       if (navigation.alphaTex)
       {
	       UpdateTexFromFatBmpWithAlphaFILE(navigation.IconTex[(lineNumber%7)]
			 											,navigation.file[lineNumber]
			 											,(lineNumber%7)+10
														,navigation.alphaTex);
	    }
		 else
		 {
	       UpdateTexFromFatBmpFILE(navigation.IconTex[(lineNumber%7)],navigation.file[lineNumber],(lineNumber%7)+10);
 		 }
		 PA_3DSetSpriteTex(getIconSprite(lineNumber),navigation.IconTex[(lineNumber%7)]);
		 PA_3DSetSpritePal(getIconSprite(lineNumber),(lineNumber%7)+10);
       return;
    }   
   debugTxt("seeking custom icon");

   char data[570];
   int datalocation=0x68;
   u32 newlocation=0;
	

	if (navigation.isFolder[lineNumber]) 
	{
		PA_3DSetSpriteTex(getIconSprite(lineNumber),folderIconTex);
		PA_3DSetSpritePal(getIconSprite(lineNumber),17);    
      return; 
	}			
   debugTxt("not folder");

    if (navigation.file[lineNumber]) {
			rewind(navigation.file[lineNumber]);
   debugTxt("rewinding");

        fseek(navigation.file[lineNumber], datalocation, SEEK_SET); // move datalocation bytes from start of file
        fread(&newlocation, sizeof(u32), 1, navigation.file[lineNumber]);
   debugTxt("reading header");

	      if (newlocation==0)
	      {
			   PA_3DSetSpriteTex(getIconSprite(lineNumber),ndsIconTex);
				PA_3DSetSpritePal(getIconSprite(lineNumber),2);
	         return;
	      }   

		
			datalocation=newlocation+544; // +544 is palette
			fseek(navigation.file[lineNumber], datalocation, SEEK_SET);
			fread(&palette, 1, 32, navigation.file[lineNumber]); // read the part of the header we need

			datalocation=newlocation+32; // +32 is icon
			fseek(navigation.file[lineNumber], datalocation, SEEK_SET);
			fread(&temp_tex, 1, 512, navigation.file[lineNumber]); // read the part of the header we need
   debugTxt("reading header");

			convertIconToTex(image,temp_tex,palette);
   debugTxt("readingicon");

			MaskTexWithFatBmpAlphaFILE(navigation.alphaTex,image, 32, 32, TEX_A3I5);
   debugTxt("masking finished");

//			flushToMemory();
	memcpy((void*)bmp_tex2, image, 32*32);	   
   debugTxt("vbl");

			PA_3DUpdateGfx(navigation.IconTex[(lineNumber%7)],(void*)bmp_tex2);	
   debugTxt("update");
	memcpy((void*)palette2, palette, 34);	   
//Soul_waitForVBL();
			PA_Load3DSpritePal((lineNumber%7)+10, (void*)palette2);
			PA_3DSetSpriteTex(getIconSprite(lineNumber),navigation.IconTex[(lineNumber%7)]);
			PA_3DSetSpritePal(getIconSprite(lineNumber),(lineNumber%7)+10);
		   debugTxt("finished");
		   initDebugTxt();
	
	    }

	
	    
}  
void refreshIcons()
{
   initDebugTxt();
   debugTxt("refreshicons");
  for (createIconCounter = fileAmount>6?((SelectMenu-3 <0?0:SelectMenu-3)-(SelectMenu+4 >fileAmount?(SelectMenu+4)-fileAmount:0)):0;   
		createIconCounter < (SelectMenu+4 >fileAmount?fileAmount:SelectMenu+4)-(SelectMenu-3 <0?SelectMenu-3:0);			
		createIconCounter++)
		{

		   getSelectIcon(createIconCounter);	
		}   
		

}
