#include <PA9.h>       // Include for PA_Lib
#include <fat.h>
#include <sys/dir.h>
#include "../../misc/misc.h"
#include "../../misc/math.h"
#include "../../misc/debug.h"
#include "../../misc/fat.h"
#include "../../misc/clock.h"
#include "../../structDef.h"
#include "../../gfx/all_gfx.h"
#include "../../engine/engine.h"
#include "../../userConfigFunctions.h"
#include "game_select_struct.h"
#include "game_select_input.h"
#include "game_select_text.h"
u16 customSmfTimer;
bool customCoverDisplay;

extern FILE* readINI;

extern char gameDirectory[100];

u8 topScreenIconImage[512];
unsigned short topScreenIconPalette[16] __attribute__ ((aligned (4)));		

int recentgameSelect_counter;
typedef struct
{
	struct textInfo
	{
		textBox Title;
		textBox Description;
	}	Text;
	bool IconVisible;
	u8 bumpStyle;
	u8 IconY;
	u8 IconX;
	u8 Angle;
	u8 speedDecrease;
	bool bumpFlip;
	bool x2Canvas;
} topScreenTheme;

topScreenTheme TopScreen;

void resetmSelectMemory_TopScreen()
{
   customSmfTimer=0;
   customCoverDisplay=1;
}   
struct clockInfo
{
	textBox Text;
	spriteNoRotSet Battery;
} Clock;
extern u16 fileAmount;
void TopScreenText(int lineNumber){

	if (lineNumber<0 || lineNumber>fileAmount) 
	return;

	char charTemp[256];
   PA_16cErase(1); 	
	updateClock(10,6,1);   
   customSmfTimer=0;
   /*
   FILE *handle;
   
	sprintf (charTemp,"filetypes/nds/covers/%s.jpeg",navigation.FileName[lineNumber]);
//return;
	char* iconPath = returnThemeResourcePath(charTemp,1);

	if (iconPath !=NULL)
	{
	   handle = fopen(iconPath, "rb");
		free(iconPath);
		if (handle)
		{
  			PA_SetSpriteY(1,0,205);
		   PA_SetSpriteY(1,10,205);
	      loadFatBg16bit(1,iconPath);			
	      fclose(handle);
			customCoverDisplay = 1;
			PA_16cErase(1);
			return; 
		}
	}	
	else
	{
	  	sprintf (charTemp,"filetypes/nds/covers/%s.jpg",navigation.FileName[lineNumber]);
		char* iconPath = returnThemeResourcePath(charTemp,1);
		if (iconPath !=NULL)
		{
		   handle = fopen(iconPath, "rb");
			free(iconPath);
			if (handle)
			{
	  			PA_SetSpriteY(1,0,205);
			   PA_SetSpriteY(1,10,205);
		      loadFatBg16bit(1,iconPath);			
		      fclose(handle);
				customCoverDisplay = 1;
				PA_16cErase(1);
				return;
			}
		}		   
	}   
*/
   if (customCoverDisplay)
   {
		customCoverDisplay = 0;
		/*
	   PA_SetSpriteY(1,10,Clock.Battery.y);
		PA_SetSpriteY(1,0,TopScreen.IconY);		*/
		//hideAll2dSprites();
   	
   	loadFatBgJpeg(1,navigation.topscreenDefault);
   }  

/*
	FILE *handle;
	sprintf (charTemp,"%s%s.jpg",gameDirectory,navigation.FileName[lineNumber]);
   handle = fopen(charTemp, "rb");
	
	   if (handle)
	   {
//	      fclose(handle);
//			PA_LoadGif(1, (void*)FAT_loadGIF(charTemp));
        	loadFatBgJpeg(1,handle);			
	      fclose(handle);
			customCoverDisplay = 1;
			return;
	
	   }   
	   else
	   {
	      fclose(handle);
			sprintf (charTemp,"%s%s.jpeg",gameDirectory,navigation.FileName[lineNumber]);
		   handle = fopen(charTemp, "rb");
		   if (handle)
		   {
		      loadFatBgJpeg(1,handle);			
		      fclose(handle);
				customCoverDisplay = 1;
				return;
		   }   
	      fclose(handle);
	      if (customCoverDisplay)
	      {
				customCoverDisplay = 0;
				
			   FILE* topBG = fopen(returnString("fat:/_menudo/themes/%s/gamenavigate/topscreen.jpg",CurrentTheme),"rb");
         	loadFatBgJpeg(1,topBG);
         	fclose(topBG);
	      }   
	   }   */
//	return;
	if (navigation.isFolder[lineNumber]) return;
   int datalocation=0x68;
    u32 newlocation=0;
    char data[570];
   
//	 sprintf (charTemp,"%s%s.nds",gameDirectory,navigation.FileName[lineNumber]);
//    handle = fopen(charTemp, "rb");
   
    if (navigation.file[lineNumber] && TopScreen.IconVisible) {

      rewind(navigation.file[lineNumber]);
      fseek(navigation.file[lineNumber], datalocation, SEEK_SET);
      fread(&newlocation, sizeof(u32), 1, navigation.file[lineNumber]);
      if (newlocation!=0)
      {
	        /* 
			datalocation=newlocation+832; // word+832 is english title
			fseek(navigation.file[lineNumber], datalocation, SEEK_SET);
			fread(&data, 1, 560, navigation.file[lineNumber]); // read the part of the header we need
			*/
			datalocation=newlocation+544; // word+544 is palette
			fseek(navigation.file[lineNumber], datalocation, SEEK_SET);
			//((PAL_SPRITE0+(0x400*1) + (0 << 5)) <- directly to pallete
			fread(PAL_SPRITE0+(0x400*1) + (0 << 5), 1, 32, navigation.file[lineNumber]); // read the part of the header we need

			//flushToMemory();
//			 PA_LoadPal16((PAL_SPRITE0+(0x400*screen)), (n_palette), palette)
//			 DMA_Copy((void*)source, (void*)((PAL_SPRITE0+(0x400*1) + (0 << 5)), 16, DMA_16NOW)
//			PA_LoadSprite16cPal(1, // Screen
//							0, // Palette number
//							(void*)topScreenIconPalette);	// Palette name
		
		
		
			datalocation=newlocation+32; // word+32 is icon
			fseek(navigation.file[lineNumber], datalocation, SEEK_SET);
			fread(&topScreenIconImage, 1, 512, navigation.file[lineNumber]); // read the part of the header we need
			PA_SetSpriteDblsize(1,0,0);
			PA_UpdateSpriteGfx(1,0,topScreenIconImage); 

		}
		else
		{
			PA_LoadSprite16cPal(1, // Screen
							0, // Palette number
							(void*)ndsIcon2d_Pal);	// Palette name
			PA_SetSpriteDblsize(1,0,0);
		   memcpy(topScreenIconImage,ndsIcon2d_Sprite,sizeof(u8)*512);
			PA_UpdateSpriteGfx(1,0,topScreenIconImage); 
		   
		}
		if (TopScreen.x2Canvas) PA_SetSpriteDblsize(1,0,1);
      PA_SetRotsetNoZoom(1,0,0);   


    }

//	return;
	PA_16cTextLetterSpacing(TopScreen.Text.Title.aliasedFont?-1:0);
	PA_TextAlign(TopScreen.Text.Title.alignment);
	u16* textstring = formatDescription(TopScreen.Text.Title.format,lineNumber);
	display16cTextUInt16(1, TopScreen.Text.Title.x1, TopScreen.Text.Title.y1, TopScreen.Text.Title.x2, TopScreen.Text.Title.y2, textstring, TopScreen.Text.Title.aliasedFont?1:3 ,TopScreen.Text.Title.aliasedFont?5:2);

	PA_16cTextLetterSpacing(TopScreen.Text.Title.aliasedFont?-1:0);
	free(textstring);

	textstring = formatDescription(TopScreen.Text.Description.format,lineNumber);
	PA_TextAlign(TopScreen.Text.Description.alignment);
	display16cTextUInt16(1, TopScreen.Text.Description.x1, TopScreen.Text.Description.y1, TopScreen.Text.Description.x2, TopScreen.Text.Description.y2, textstring, TopScreen.Text.Description.aliasedFont?1:3 ,TopScreen.Text.Description.aliasedFont?5:2);
	PA_16cTextLetterSpacing(-1);
	free(textstring);
	
	
	PA_TextAlign(0);	      
	
//   return;    
}  

extern int gameSelect_counter;
void updateTopScreen (u8 lineNumber)
{

	if (gameSelect_counter==0)  if (customSmfTimer< system.SMFCoverDelay) customSmfTimer++;
	if (customSmfTimer== system.SMFCoverDelay	)
	{

		char charTemp[256];
//		sprintf (charTemp,"%s%s.smf",gameDirectory,navigation.FileName[lineNumber]);
		sprintf(charTemp,"filetypes/nds/covers/%s.smf",navigation.FileName[lineNumber]);
	  	char* smfpath = returnThemeResourcePath(charTemp,1);
	   if (smfpath!=NULL) 
		{
	      initSMF(1, smfpath);
			free(smfpath);
			bool smfWasLoaded=0;
			s8 i=0;
			PA_SetSpriteY(1,0,205);
		   PA_SetSpriteY(1,10,205);
		   PA_16cErase(1);
			while(true)
			{
			   if (i>=-10)
			   {
					i--;
			    	setBrightness(0,i);
			   }  	
				smfWasLoaded=updateSMF();
			   if (!smfWasLoaded || (smfWasLoaded && (Pad.Newpress.Anykey|| Pad.Newpress.Y || Stylus.Held) ))
				{
				   break;
				}
				Soul_waitForVBL();   
			}		
			customCoverDisplay=1;
			TopScreenText(lineNumber);
			setBrightness(0,0);
		   PA_SetSpriteY(1,10,Clock.Battery.y);
			PA_SetSpriteY(1,0,TopScreen.IconY);
			deinitSMF();	
		}		
	   customSmfTimer=system.SMFCoverDelay+1;
	}   
   if (customCoverDisplay)
   {

	 return;  
   }   
}   



void initTopScreen()
{
	readINI = fopen(returnString("fat:/_menudo/themes/%s/gamenavigate/interface.ini",CurrentTheme),"rb");   
	PA_LoadSprite16cPal(1, 0, (void*)topScreenIconPalette);
	TopScreen.IconVisible = (bool)readIniFileInt("TopScreenIconVisible");
	TopScreen.IconY = maxLimitValueTo(readIniFileInt("TopScreenIconY"),0,256);
	TopScreen.IconX = maxLimitValueTo(readIniFileInt("TopScreenIconX"),0,256);
	if (TopScreen.IconVisible)
		PA_CreateSprite(1, 0, (void*)topScreenIconImage, OBJ_SIZE_32X32, 0, 0,TopScreen.IconX,TopScreen.IconY);
	PA_SetSpriteRotEnable(1,0, 1);
	TopScreen.Angle = readIniFileInt("TopScreenIconAngle");
	PA_SetRotsetNoZoom(1,1,TopScreen.Angle);
	TopScreen.bumpStyle = maxLimitValueTo(readIniFileInt("TopScreenIconBumpStyle"),0,5);
	TopScreen.x2Canvas = (bool)readIniFileInt("TopScreenIcon2xCanvas");
	TopScreen.speedDecrease = readIniFileInt("TopScreenIconBumpSpeedDecrease");
	TopScreen.bumpFlip = (bool)readIniFileInt("TopScreenIconBumpFlip");
	if (TopScreen.x2Canvas)
	{
	   PA_SetSpriteDblsize(1,0,1);
	   TopScreen.IconX -=16;
	   TopScreen.IconY -=16;
	}   
	
	
	fclose(readINI);
}
extern int gameSelect_counter;
extern int SelectMenu;

int recentSelectMenu;
   
void updateIconBump()
{
   
	if (!(navigation.isFolder[SelectMenu] || !TopScreen.IconVisible) )
	{
		if (!(gameSelect_counter<64 &&gameSelect_counter>-64) && (recentgameSelect_counter<64 &&recentgameSelect_counter>-64))
		{
		   if (gameSelect_counter>0)
			   TopScreenText(SelectMenu+1);
		   if (gameSelect_counter==0)
			   TopScreenText(SelectMenu);
		   if (gameSelect_counter<0)
			   TopScreenText(SelectMenu-1);
		}   
	}	
	if ((SelectMenu!=recentSelectMenu || recentgameSelect_counter==0 ) && gameSelect_counter!=0)
	{
		loadFatSndWav(navigation.sound.click);
	}   
	else
	if (SelectMenu!=recentSelectMenu )
	{
	   loadFatSndWav(navigation.sound.thud);
	}				   

	recentSelectMenu= SelectMenu;
   recentgameSelect_counter=gameSelect_counter;
   int i=gameSelect_counter/(TopScreen.speedDecrease+1);
   if (TopScreen.bumpFlip) i*=-1;
   if (i>64) i-=128;
   else
   	if (i<-64)i+=128;
	if (navigation.isFolder[SelectMenu] || !TopScreen.IconVisible) 
	{
	   PA_SetSpriteXY(1,0,0,200);
	   return;
	}   
  	PA_SetSpriteXY(1,0,TopScreen.IconX,TopScreen.IconY);
  	if (SelectMenu==0 || SelectMenu==fileAmount) return;
   switch(TopScreen.bumpStyle)
	{   
	   case 1:	PA_SetSpriteXY(1,0,TopScreen.IconX,TopScreen.IconY+(i>>1));
	      	 	break;
	   case 2:	PA_SetSpriteXY(1,0,TopScreen.IconX+(i>>1),TopScreen.IconY);
	      	 	break;
	   case 3:	PA_SetRotsetNoZoom(1,1,TopScreen.Angle+PA_Sin(i));
	      	 	break;
	   case 4:	PA_SetRotsetNoAngle(1,1,256+PA_Sin(i),256+PA_Sin(i));
	      	 	break;
   }	 	
/*   if (Pad.Held.R && Pad.Newpress.Start)
   {
      TopScreen.bumpStyle++;
      if (TopScreen.bumpStyle==4) TopScreen.bumpStyle=0;
   }   */

}   
