#include <PA9.h>
#include "types.h"
#include "../../misc/math.h"

inline int getKeyframe(int spritenumber)
{
	if(sprite[spritenumber].var2.time==sprite[spritenumber].data[sprite[spritenumber].var2.current_sprite].key_frame)
		return sprite[spritenumber].var2.current_sprite;
	else
	//if(sprite[spritenumber].var2.time==sprite[spritenumber].data[sprite[spritenumber].var2.next_sprite].key_frame)
		return sprite[spritenumber].var2.next_sprite;
}	

void setSpriteAnim(u8 spritenum, u16 time, u8 playmode,u8 nextkey,u8 currentkey)
{
  if (sprite[spritenum].var2.play_mode2==playmode)
    sprite[spritenum].var2.time =time;
	else
    sprite[spritenum].var2.play_mode2=playmode;
	sprite[spritenum].var2.next_sprite = nextkey;
	sprite[spritenum].var2.current_sprite = currentkey;
}								


void update_transpeed(u8 sprite_id,u16 current, u16 next)
{
  sprite[sprite_id].var2.trans_speed = (getNearestAngle(sprite[sprite_id].data[current].angle,sprite[sprite_id].data[next].angle)+.0)/(sprite[sprite_id].data[next].key_frame-sprite[sprite_id].data[current].key_frame);
}   

void jumpTime(u8 sprite_id,u8 mode){
   switch (mode){
      case 1:
			   sprite[sprite_id].var2.time= sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame;
				sprite[sprite_id].var2.next_sprite += 1;
				sprite[sprite_id].var2.current_sprite += 1;
				update_transpeed(sprite_id,sprite[sprite_id].var2.current_sprite, sprite[sprite_id].var2.next_sprite);
				PA_3DSetSpritePrio(sprite_id, sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].prio+1024);		
				break;
      case 2:
			   sprite[sprite_id].var2.time= sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame;
				sprite[sprite_id].var2.next_sprite -= 1;
				sprite[sprite_id].var2.current_sprite -= 1;
				update_transpeed(sprite_id,sprite[sprite_id].var2.current_sprite, sprite[sprite_id].var2.next_sprite);
				PA_3DSetSpritePrio(sprite_id, sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].prio+1024);		
				break;
	}
   
}   


void move_time(u8 sprite_id, u8 mode, u8 nextkeyframe)
{
	   if (sprite[sprite_id].var2.play_mode != mode)
	   {
		   sprite[sprite_id].var2.play_mode = mode;
		}
		else
		{
			if (sprite[sprite_id].var2.time >= sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame && mode == 1) 
			{
			   sprite[sprite_id].var2.time= sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame;
				sprite[sprite_id].var2.next_sprite += nextkeyframe;
				sprite[sprite_id].var2.current_sprite += nextkeyframe;
				update_transpeed(sprite_id,sprite[sprite_id].var2.current_sprite, sprite[sprite_id].var2.next_sprite);
				PA_3DSetSpritePrio(sprite_id, sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].prio+1024);		
				
			}
			if (sprite[sprite_id].var2.time <= sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame && mode == 2) 
			{

			   sprite[sprite_id].var2.time= sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame;
			   sprite[sprite_id].var2.next_sprite -= nextkeyframe;
			   sprite[sprite_id].var2.current_sprite -= nextkeyframe;
				update_transpeed(sprite_id,sprite[sprite_id].var2.current_sprite, sprite[sprite_id].var2.next_sprite);
				PA_3DSetSpritePrio(sprite_id, sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].prio+1024);		
			}
		}   

}   

void add_keyframe(u8 frame, u16 angle, s32 x,s32 y, u16 width, u16 height, u8 alpha, s16 pivot_x,s16 pivot_y)
{
   u8 k;
   u8 i;

if (sprite[0].data[sprite[0].var2.current_sprite].key_frame == sprite[0].var2.time || sprite[0].data[sprite[0].var2.next_sprite].key_frame == sprite[0].var2.time) return;
 		
	   	for (k = 0;k <= sprite[0].var2.last_sprite; k++)
			{
			   if (sprite[0].data[k].key_frame > frame)
			   {
				   sprite[0].var2.last_sprite++;
				   	for (i = sprite[0].var2.last_sprite; k < i; i--)
						{ 	
					   	sprite[0].data[i].key_frame = sprite[0].data[i-1].key_frame;			
					   	sprite[0].data[i].angle = sprite[0].data[i-1].angle;			
							sprite[0].data[i].x = sprite[0].data[i-1].x;
							sprite[0].data[i].y =sprite[0].data[i-1]. y;
							sprite[0].data[i].width = sprite[0].data[i-1].width;
							sprite[0].data[i].height = sprite[0].data[i-1].height;
							sprite[0].data[i].alpha = sprite[0].data[i-1].alpha;
							sprite[0].data[i].pivot_x = sprite[0].data[i-1].pivot_x;
							sprite[0].data[i].pivot_y = sprite[0].data[i-1].pivot_y;
					   }
					sprite[0].data[k].key_frame = frame;			
					sprite[0].data[k].angle = angle;
					sprite[0].data[k].x = x;
					sprite[0].data[k].y = y;
					sprite[0].data[k].width = width;
					sprite[0].data[k].height = height;
					sprite[0].data[k].alpha = alpha;
					sprite[0].data[k].pivot_x = pivot_x;
					sprite[0].data[k].pivot_y = pivot_y;
			   	break;
			   } 		
			}    
			
	   sprite[0].var2.current_sprite++;
		sprite[0].var2.next_sprite++;
		
	if (sprite[0].var2.last_sprite == k-1) 
	{

		
	   sprite[0].var2.last_sprite++;
	   sprite[0].data[k].key_frame = frame;
	}   

}   
void update_spritevars(u8 sprite_id)
{
	sprite[sprite_id].var1.pivot_x2 = PA_Cos(sprite[sprite_id].var1.pivot_angle+sprite[sprite_id].var1.angle)*(sprite[sprite_id].var1.distance);
	sprite[sprite_id].var1.pivot_y2 = PA_Sin(sprite[sprite_id].var1.pivot_angle+sprite[sprite_id].var1.angle)*sprite[sprite_id].var1.distance;
	sprite[sprite_id].var1.distance= PA_TrueDistance((sprite[sprite_id].var1.x>>8),(sprite[sprite_id].var1.y>>8),(sprite[sprite_id].var1.x>>8) + sprite[sprite_id].var1.pivot_x, (sprite[sprite_id].var1.y>>8) - sprite[sprite_id].var1.pivot_y)*-1;
	sprite[sprite_id].var1.pivot_angle= PA_GetAngle((sprite[sprite_id].var1.x>>8),(sprite[sprite_id].var1.y>>8),(sprite[sprite_id].var1.x>>8) + sprite[sprite_id].var1.pivot_x, (sprite[sprite_id].var1.y>>8) + sprite[sprite_id].var1.pivot_y);
	sprite[sprite_id].var1.angle = sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].angle + (sprite[sprite_id].var2.trans_speed * (sprite[sprite_id].var2.time-sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame));
	sprite[sprite_id].var1.x = sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].x + (((sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].x-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].x)/(sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame)) * (sprite[sprite_id].var2.time-sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame));
	sprite[sprite_id].var1.y = sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].y + (((sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].y-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].y)/(sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame)) * (sprite[sprite_id].var2.time-sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame));
	sprite[sprite_id].var1.width = sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].width + ((((sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].width-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].width)+.0)/(sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame)) * (sprite[sprite_id].var2.time-sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame));
	sprite[sprite_id].var1.height = sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].height + ((((sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].height-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].height)+.0)/(sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame)) * (sprite[sprite_id].var2.time-sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame));
	sprite[sprite_id].var1.alpha = sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].alpha + ((((sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].alpha-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].alpha)+.0)/(sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame)) * (sprite[sprite_id].var2.time-sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame));
	sprite[sprite_id].var1.pivot_x = sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].pivot_x + ((((sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].pivot_x-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].pivot_x)+.0)/(sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame)) * (sprite[sprite_id].var2.time-sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame));
	sprite[sprite_id].var1.pivot_y = sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].pivot_y + ((((sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].pivot_y-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].pivot_y)+.0)/(sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame-sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame)) * (sprite[sprite_id].var2.time-sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].key_frame));
}   

void update_spritelocation(u8 sprite_id)
{
	//PA_3DSetSpriteXY(120, sprite[sprite_id].var1.x>>8, sprite[sprite_id].var1.y>>8);
	PA_3DSetSpriteXY(sprite_id, ((sprite[sprite_id].var1.x>>8) )  + (sprite[sprite_id].var1.pivot_x2>>8), ((sprite[sprite_id].var1.y>>8)) - (sprite[sprite_id].var1.pivot_y2>>8));
	PA_3DSetSpriteWidth(sprite_id,sprite[sprite_id].var1.width);
	PA_3DSetSpriteHeight(sprite_id,sprite[sprite_id].var1.height);
	PA_3DSetSpriteRotate(sprite_id, sprite[sprite_id].var1.angle);
	if (sprite[sprite_id].var1.alpha<=1) 
		PA_3DSetSpriteVisible(sprite_id, 0);
	else 
	{
	   if (pa_3dsprites[sprite_id].textureID!=0) PA_3DSetSpriteVisible(sprite_id, 1);
	}		
	PA_3DSetSpriteAlpha(sprite_id, sprite[sprite_id].var1.alpha);      
	PA_3DSetSpritePrio(sprite_id, sprite[sprite_id].data[sprite[sprite_id].var2.current_sprite].prio+1024);		
}   


