#include <PA9.h>       // Include for PA_Lib
#include "../../engine/engine.h"
#include <fat.h>
#include <sys/dir.h>

#include "../../assignList.h"
#include "../../userConfigFunctions.h"
#include "../../gfx/all_gfx.h"
#include "../../commands/commands.h"
#include "../../loader/loader.h"
#include "../../misc/math.h"
#include "../../misc/transition.h"
#include "../../misc/misc.h"
#include "../../misc/fat.h"
#include "../../misc/debug.h" 
#include "../../misc/clock.h"

#include "../../system/services/filedetector.h"
#include "../../system/services/mwifi.h"
#include "blackSpace.h"
#include "keyframe.h"

#include "types.h"


#define HARDWARETEST
//#define DOUBLETAP_DEFAULT_DURATION 10
#define MAX_ANIM 30
#define NUMBER_OF_SPRITES 28

extern bool horizontalNavigationControls;	
extern char CurrentTheme[256];
extern char* CurrentMenuCommand;


u8 navigationSpeed = 2;
//extern bool IncompleteFiles;
//extern bool AfterSMFIntro;

extern u8 newNdsFile_WindowCounter;

extern FILE* readINI; 

extern FILE* historyFile;
extern FILE* fileChecker;


char menuSelected[6];

extern u32 idleCounter;


char* getCurrentCommand();

struct clockInfo
{
	bool MainMenuBlack;
	bool SelectMenuBlack;	
} Clock;
typedef struct
{
    char* Menu[9];
} Topscreendata;

 
Topscreendata TOPscreen;


typedef struct
{
    FILE* confirm[9];
    FILE* navigateOut[9];
    FILE* navigateIn[9];
    char startupBG[100];
} SFXdata;  // new type for ships...
 
SFXdata SFX;




//extern u8 play_mode;
//extern u8 bottommenuSelected[5];

char lastImage[40];
void loadPathImage(bool screen,char* path)
{
   if (strcmp(lastImage,path)!=0)
   {
      sprintf(lastImage,"%s",path);
      char filepath[256];
		sprintf(filepath,"fat:/_menudo/themes/%s/topscreen/%s",CurrentTheme,path);
		loadFatBg16bit(1,filepath);
	}		
}   

void LoadSpriteIngredient(u16 sprite,char* path)
{
//   return;
   char charTemp[256];
   sprintf(charTemp,"Loading %s.bmp",path);
   initDebugTxt();
   debugTxt(charTemp);
//   bool filefound=0;
   
/*   switch (system.Language)
   {
      case 1: sprintf(charTemp,"%s.cn.bmp",path);
      		  fileChecker = fopen (charTemp, "rb"); 
					if (fileChecker)
					{
					   filefound=1;
					}   
					fclose(fileChecker);
      		  break;
 	}	  */
// 	if (!filefound)
		sprintf(charTemp,"fat:/_menudo/themes/%s/mainscreen/%s.bmp",CurrentTheme,path);

	if (!CreateSpriteFromFatBmp(sprite,charTemp,sprite,128, 128,1))
	{
	   //) IncompleteFiles=1;
	   PA_3DSetSpriteVisible(sprite,0);
	   PA_3DSetSpriteTex(sprite,0);
	}   

}


void init_xmbdata()
{



	char filepath[256];
	sprintf(filepath,"fat:/_menudo/themes/%s/mainscreen/theme.recipe",CurrentTheme);

	FILE* recipeFile = fopen (filepath, "rb"); 
   debugTxt("loading recipe");
	int i,k;
	char charTemp[256];
	memset (charTemp,0,256);
	if (recipeFile)
	{
	   debugTxt("found recipe");
		for (i=0;i<30;i++)
		for (k=0;k<30;k++)
		{
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].key_frame = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].angle = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].x = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].y = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].pivot_x = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].pivot_y = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].width = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].height = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].alpha = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].prio = atoi(charTemp);
		}	
	}		
	fclose(recipeFile);
	   debugTxt("finished recipe");
//PA_WaitFor(Pad.Newpress.Start);
	LoadSpriteIngredient(0	,"1");
	LoadSpriteIngredient(1	,"2");
	LoadSpriteIngredient(2	,"3");
	LoadSpriteIngredient(3	,"4");
	LoadSpriteIngredient(4	,"5");
	LoadSpriteIngredient(5	,"a");
	LoadSpriteIngredient(6	,"b");
	LoadSpriteIngredient(7	,"c");
	LoadSpriteIngredient(8	,"d");
	LoadSpriteIngredient(9	,"e");
	LoadSpriteIngredient(10 ,"1a"); 
	LoadSpriteIngredient(11 ,"1b"); 
	LoadSpriteIngredient(12 ,"1c"); 
	LoadSpriteIngredient(13 ,"1d"); 
	LoadSpriteIngredient(14 ,"1e"); 
	LoadSpriteIngredient(15 ,"1f"); 
	LoadSpriteIngredient(16 ,"2a");
	LoadSpriteIngredient(17 ,"2b");
	LoadSpriteIngredient(18 ,"3a");
	LoadSpriteIngredient(19 ,"3b");
	LoadSpriteIngredient(20 ,"4a");
	LoadSpriteIngredient(21 ,"4b");
	LoadSpriteIngredient(22 ,"5a");
	LoadSpriteIngredient(23 ,"5b");
	LoadSpriteIngredient(24 ,"5c");
	LoadSpriteIngredient(25 ,"5d");
	LoadSpriteIngredient(26 ,"5e");
	LoadSpriteIngredient(27 ,"5f");

	create3dOuterCanvasLayer(1000,31,31,31);
   
	create3dBackgroundLayer(888,0,0,0); //place bg ini here
	PA_3DSetSpritePrio(888,5);
	
	create3dBackgroundLayer(889,31,31,31);
	PA_3DSetSpritePrio(889,4);

	
	initAmbienceFromTheme("Mainmenu",50);
	initDebugTxt();

 	for(i = 0; i < 63; i++) PA_3DSetSpritePolyID(i, i); // Set a different polyID for each sprite (0-63 values)
//	i=0; //(clear temp)

												
												


	for (k = 0; k <= NUMBER_OF_SPRITES-1; k++)
	{
		sprite[k].var2.last_sprite = 10;
		sprite[k].var2.play_mode = 1;
		sprite[k].var2.next_sprite = 1;
		sprite[k].var2.current_sprite = 0;
		sprite[k].var2.time = 0;
		if (k ==1) sprite[1].var2.time = 0;
		
		sprite[k].var1. x = 96<<8; // ship x position in 8bit fixed point
		sprite[k].var1. y = 96<<8; // Y
		sprite[k].var1. pivot_x = 0;
		sprite[k].var1. pivot_y = 0;
		sprite[k].var1. pivot_x2 = 0;
		sprite[k].var1. pivot_y2 = 0;
		sprite[k].var1. angle = 0;
		sprite[k].var1. pivot_angle = 0;
		sprite[k].var1. distance=20;
		sprite[k].var1. width = 40;
		sprite[k].var1. height = 40;
		sprite[k].var1. alpha = 31;
	
	}




	for (k = 0; k <= NUMBER_OF_SPRITES-1; k++)for (i=0;i<MAX_ANIM;i++)if (sprite[k].data[i].key_frame < sprite[k].data[i-1].key_frame) sprite[k].var2.last_sprite = i-1;

}


#define soul_free(pointer) if (pointer) free(pointer);
void closeAllResource()
{
   soul_free(TOPscreen.Menu[0]);
   soul_free(TOPscreen.Menu[1]);
   soul_free(TOPscreen.Menu[2]);
   soul_free(TOPscreen.Menu[3]);
   soul_free(TOPscreen.Menu[4]);
   soul_free(TOPscreen.Menu[5]);
   soul_free(TOPscreen.Menu[6]);
   soul_free(TOPscreen.Menu[7]);
   soul_free(TOPscreen.Menu[8]);
}

void initFileVars()
{
debugTxt("initAAtext");
//	PA_ResetSpriteSys();
	initAntiAliasedText(1,2,1);
	PA_SetSFXAlpha(1, 12, 2); 

debugTxt(CurrentTheme);

	char filepath[256];
	sprintf(filepath,"fat:/_menudo/themes/%s/topscreen/topscreen.ini",CurrentTheme);
	readINI = fopen (filepath, "rb"); 
	TOPscreen.Menu[0] = (char *)readIniFileString("Screen0");
	TOPscreen.Menu[1] = (char *)readIniFileString("Screen1");
	TOPscreen.Menu[2] = (char *)readIniFileString("Screen2");
	TOPscreen.Menu[3] = (char *)readIniFileString("Screen3");
	TOPscreen.Menu[4] = (char *)readIniFileString("Screen4");
	TOPscreen.Menu[5] = (char *)readIniFileString("Screen5");
	TOPscreen.Menu[6] = (char *)readIniFileString("Screen6");
	TOPscreen.Menu[7] = (char *)readIniFileString("Screen7");
	TOPscreen.Menu[8] = (char *)readIniFileString("Screen8");
	fclose(readINI);
	debugTxt(filepath);


	sprintf(filepath,"fat:/_menudo/themes/%s/mainscreen/topscreen.ini",CurrentTheme);

	readINI = fopen (filepath, "rb"); 
	if (readINI)
	{
		horizontalNavigationControls = !((bool)readIniFileInt("NavigationHorizontalControls"));
	}		
	else
	{
		horizontalNavigationControls = 0;
	}	
	fclose(readINI);

	debugTxt(filepath);


	sprintf(filepath,"fat:/_menudo/themes/%s/sounds/sounds.ini",CurrentTheme);


	readINI = fopen (filepath, "rb"); 
	if (readINI)
	{
		int i=0;
		char* inistring;
		char chrtemp[256];
		for (i=0;i<=8;i++)
		{
		   sprintf(chrtemp,"NavigateOut%d",i);
		   inistring = (char *)readIniFileString(chrtemp);
			if (inistring!=NULL) 
			{
				sprintf(chrtemp,"fat:/_menudo/themes/%s/sounds/%s",CurrentTheme, inistring);
				soul_fclose(SFX.navigateOut[i]);
				SFX.navigateOut[i] = fopen (chrtemp, "rb"); 
				free(inistring);
			}			
		   sprintf	(chrtemp,"NavigateIn%d",i);
		   inistring = (char *)readIniFileString(chrtemp);
			if (inistring!=NULL) 
			{
				sprintf(chrtemp,"fat:/_menudo/themes/%s/sounds/%s",CurrentTheme, inistring);
				soul_fclose(SFX.navigateIn[i]);
				SFX.navigateIn[i] = fopen (chrtemp, "rb"); 
				free(inistring);
			}			
			sprintf(chrtemp,"MenuConfirm%d",i);
		   inistring = (char *)readIniFileString(chrtemp);
			if (inistring!=NULL) 
			{
				sprintf(chrtemp,"fat:/_menudo/themes/%s/sounds/%s",CurrentTheme, inistring);
				soul_fclose(SFX.confirm[i]);
				SFX.confirm[i] = fopen (chrtemp, "rb"); 
				free(inistring);
			}			
		}		
/*	   inistring = (char *)readIniFileString("MenuStartupBG");
		if (inistring!=NULL) 
		{
			sprintf(SFX.startupBG,"fat:/_menudo/themes/%s/sounds/%s",CurrentTheme,inistring);
			free(inistring);
//			AS_SetDefaultSettings(AS_PCM_8BIT, 11025, AS_SURROUND);

//	   	AS_SetMP3Loop(1);
		}	*/
	}			
	else
	{
	   int i;
/*		for (i=0;i<=8;i++)
		{
		   fclose(SFX.navigateOut[i]);
			fclose(SFX.navigateIn[i]); 
			fclose(SFX.confirm[i]); 

		}		*/
	   sprintf(SFX.startupBG,"");
	}   
	fclose(readINI);
	debugTxt(filepath);

}	

extern bool enableDebugLog;
struct lastFileInfo
{
	char ndsFile[80];
	char rootFolder[80];
	char subFolder[80];
	bool found;
} lastFile;
bool lastMenuPositionLoaded=false;
void getLastMenu(bool fromLog)
{
   if (lastMenuPositionLoaded) return;
   lastMenuPositionLoaded=true;
   if (fromLog || !lastFile.found)
   {
		   initDebugTxt();
  		   debugTxt("getting from history");
		historyFile = fopen ("fat:/_menudo/logs/HISTORY.LASTMENU", "rb"); 	
		if (historyFile)
		{
			fread(menuSelected,6,1,historyFile);
			if (menuSelected[0]!=0) menuSelected[1] = 1;
			if (menuSelected[0]!=4) menuSelected[5] = 1;
			if (menuSelected[0] > 4) menuSelected[0] = 4;
			if (menuSelected[1] > 2) menuSelected[1] = 2;
			if (menuSelected[5] > 2) menuSelected[5] = 2;
		}		
		else
		{
			menuSelected[0]=0;
			menuSelected[1]=1;
			menuSelected[2]=0;
			menuSelected[3]=0;
			menuSelected[4]=0;
			menuSelected[5]=1;
		}		
		fclose(historyFile);
	}		
	else
	{
		menuSelected[0]=4;
		menuSelected[1]=1;
		menuSelected[2]=0;
		menuSelected[3]=0;
		menuSelected[4]=0;
		menuSelected[5]=1;
	   int i=0;
		   initDebugTxt();
  		   debugTxt("getting from history2");
  		   int x=strlen(lastFile.rootFolder)-1;
	   if (lastFile.rootFolder[x]=='\\' || lastFile.rootFolder[x]=='/')
		   lastFile.rootFolder[x]=0;
	   else
		   x=0;
	   for (i=0;i<=8;i++)
	   {
		   initDebugTxt();
  		   debugTxt(system.menuRuns[i]);
		   initDebugTxt();
  		   debugTxt(lastFile.rootFolder);
		   initDebugTxt();
			if (strcmpi(system.menuRuns[i],lastFile.rootFolder)==0)
			{
			   break;
			}   
		}		
		if (x!=0)
	   	lastFile.rootFolder[x]='/';
		convertMenuSequence(i);		
	}			
}	
int initMainMenu()
{


   
	idleCounter=0;
   int i, k;
	initThemeTransition("mainscreen", 1);


	init16bitBg(1,3);
	init16cBg(1, 2); 
	init3d();
	PA_Reset3DSprites();
	init16cBg(0, 1);


	initDebugTxt();
	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);

	initAntiAliasedText(0,1,0);
//	resetDebugCounter();

	debugTxt("initWindowSystem()");
	initWindowSystem();

	debugTxt("initFileVars();");	
	initFileVars();
		//return 0;

  	debugTxt("init_xmbdata();");	
	  init_xmbdata(); 

	
	debugTxt("historyFile");

	
	initDebugTxt();
	debugTxt("NUMBER_OF_SPRITES");
	for (k = 0; k <= NUMBER_OF_SPRITES-1; k++)
		for (i=0;i<MAX_ANIM;i++)
			if (sprite[k].data[i].key_frame < sprite[k].data[i-1].key_frame) sprite[k].var2.last_sprite = i-1;
	
	
	
//	if (IncompleteFiles) return -1;
	
	switch(menuSelected[0]){
		case 0: for (k = 0; k < 10; k++) 
					{
					   sprite[k].var2.time= 0;
						sprite[k].var2.play_mode2=0;
  						sprite[k].var2.next_sprite = 1;
						sprite[k].var2.current_sprite =0;
					}   

				 	for (k = 10; k <= 15 ; k++)
					{
			
					  	sprite[k].var2.time = (menuSelected[1]*30) ;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = menuSelected[1];
						sprite[k].var2.current_sprite =menuSelected[1]-1;
					}		
					for (k = 16; k <= 21 ; k++)
					{
						sprite[k].var2.time = 0;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 1;
						sprite[k].var2.current_sprite = 0;
					}			

					for (k = 22; k <= 27 ; k++)
					{
					  	sprite[k].var2.time = 180+(menuSelected[5]*30) ;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 10+(menuSelected[5]*2);
						sprite[k].var2.current_sprite =9+(menuSelected[5]*2);
					}	
				  break;

		case 1: for (k = 0; k < 10; k++) 
					{
					   sprite[k].var2.time= 30;
						sprite[k].var2.play_mode2=0;
  						sprite[k].var2.next_sprite = 1;
						sprite[k].var2.current_sprite =0	;
					}   
					
				 	for (k = 10; k <= 15 ; k++)
					{
			
					  	sprite[k].var2.time = 90+(menuSelected[1]*30) ;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 5+menuSelected[1];
						sprite[k].var2.current_sprite =4+menuSelected[1];
					}		
					for (k = 16; k <= 17 ; k++)
					{
						sprite[k].var2.time = 30; //60
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 1;
						sprite[k].var2.current_sprite = 0;
					}			

					for (k = 18; k <= 21 ; k++)
					{
						sprite[k].var2.time = 0;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 1;
						sprite[k].var2.current_sprite = 0;
					}			

					for (k = 22; k <= 27 ; k++)
					{
					  	sprite[k].var2.time = 180+(menuSelected[5]*30) ;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 10+(menuSelected[5]*2);
						sprite[k].var2.current_sprite =9+(menuSelected[5]*2);
					}	
				  break;
		case 2: for (k = 0; k < 10; k++) 
					{
					   sprite[k].var2.time= 60;
						sprite[k].var2.play_mode2=0;
  						sprite[k].var2.next_sprite = 2;
						sprite[k].var2.current_sprite =1	;
					}   
					
				 	for (k = 10; k <= 15 ; k++)
					{
			
					  	sprite[k].var2.time = 90+(menuSelected[5]*30) ;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 5+menuSelected[1];
						sprite[k].var2.current_sprite =4+menuSelected[1];
					}		
					for (k = 16; k <= 17 ; k++)
					{
						sprite[k].var2.time = 60; //60
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 2;
						sprite[k].var2.current_sprite = 1;
					}			

					for (k = 18; k <= 19 ; k++)
					{
						sprite[k].var2.time = 30; //60
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 1;
						sprite[k].var2.current_sprite = 0;
					}			

					for (k = 20; k <= 21 ; k++)
					{
						sprite[k].var2.time = 0;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 1;
						sprite[k].var2.current_sprite = 0;
					}			

					for (k = 22; k <= 27 ; k++)
					{
					  	sprite[k].var2.time = 180+(menuSelected[5]*30) ;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 10+(menuSelected[5]*2);
						sprite[k].var2.current_sprite =9+(menuSelected[5]*2);
					}	
				  break;
		case 3: for (k = 0; k < 10; k++) 
					{
					   sprite[k].var2.time= 90;
						sprite[k].var2.play_mode2=0;
  						sprite[k].var2.next_sprite = 3;
						sprite[k].var2.current_sprite =2	;
					}   
					
				 	for (k = 10; k <= 15 ; k++)
					{
			
					  	sprite[k].var2.time = 90+(menuSelected[1]*30) ;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 5+menuSelected[1];
						sprite[k].var2.current_sprite =4+menuSelected[1];
					}		
					for (k = 16; k <= 19 ; k++)
					{
						sprite[k].var2.time = 60; //60
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 2;
						sprite[k].var2.current_sprite = 1;
					}			

					for (k = 20; k <= 21 ; k++)
					{
						sprite[k].var2.time = 30; //60
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 1;
						sprite[k].var2.current_sprite = 0;
					}			
					for (k = 22; k <= 27 ; k++)
					{
					  	sprite[k].var2.time = 180+(menuSelected[5]*30) ;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 10+(menuSelected[5]*2);
						sprite[k].var2.current_sprite =9+(menuSelected[5]*2);
					}	
				  break;
		case 4: for (k = 0; k < 10; k++) 
					{
					   sprite[k].var2.time= 120;
						sprite[k].var2.play_mode2=0;
  						sprite[k].var2.next_sprite = 4;
						sprite[k].var2.current_sprite =3	;
					}   
				 	for (k = 10; k <= 15 ; k++)
					{
					  	sprite[k].var2.time = 90+(menuSelected[1]*30) ;//
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 5+menuSelected[1];
						sprite[k].var2.current_sprite =4+menuSelected[1];
					}		
					for (k = 16; k <= 21 ; k++)
					{
						sprite[k].var2.time = 60; //60
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 2;
						sprite[k].var2.current_sprite = 1;
					}			
					for (k = 22; k <= 27 ; k++)
					{
					  	sprite[k].var2.time = (menuSelected[5]*30) ;
						sprite[k].var2.play_mode2=0;
						sprite[k].var2.next_sprite = 1+menuSelected[5];
						sprite[k].var2.current_sprite =menuSelected[5];
					}	
				  break;		  

	}		

	initDebugTxt();
	return 0;
}   



extern bool systemBooting; 

void startupPopup()
{
	if (!systemBooting) return;

		if (system.AutoLoginWifi && !wifi.autoLoginCancelled)
		{

				PA_InitWifi(); 

			Wifi_AutoConnect(); // request connect
			int k=Wifi_AssocStatus(); // check status
			if(k==ASSOCSTATUS_ASSOCIATED) {
					initWifiService();
			   wifi.connecting = 0;
			 	}
			else
	/*		if(k==ASSOCSTATUS_CANNOTCONNECT) {
				cancellWifiConnect();
			}
			else*/
			{
			   wifi.connecting = 1;
			}   
		}		
	   systemBooting=0;
		if (wifi.online)
		{
			createWindow(0,0,WINDOW_TYPE_TEXTONLY,"Connected as",wifi.username, "");
		}		
		else
		if (wifi.autoLoginCancelled)
		{
			createWindow(0,0,WINDOW_TYPE_TEXTONLY,"Auto login cancelled","", "");
		}	
		else
		if (system.AutoLoginWifi)
		{
			if (wifi.connecting)
				createWindow(0,0,WINDOW_TYPE_TEXTONLY,"Searching for access point","", "");
			else
			{
				createWindow(0,0,WINDOW_TYPE_TEXTONLY,"Could not login to","GameNow.Asia", "");
			}	
		}		
		else
		{
		   if (!(IPC->battery >>2))
			  { 
				if (getBattery()>=2)
				{
					if ((IPC->battery >>2)) //is lite
						createWindow(0,0,WINDOW_TYPE_TEXTONLY,"Battery Low","Backlight Strength Reduced", "");
				}   
				else
				{
//					displayNewNdsWindow();
				}	
			}			
		}		

	PA_InitASLibForMP3(AS_MODE_MP3 | AS_MODE_SURROUND | AS_MODE_16CH);	// The parameter is passed to AS_Init(). Call this function only once!!!  Default settings are: AS_SetDefaultSettings(AS_PCM_8BIT, 11025, AS_SURROUND);	PA_InitASLibForMP3(AS_MODE_MP3 | AS_MODE_SURROUND | AS_MODE_16CH);	// The parameter is passed to AS_Init(). Call this function only once!!!  Default settings are: AS_SetDefaultSettings(AS_PCM_8BIT, 11025, AS_SURROUND);


}	
int runMenu(bool init)
{

	  	
   sprintf(lastImage," ");
   int k=0;
   if (init)
   {
		clearSystem();
		clearbootupLoadScreen();
		update_clearbootupLoadScreen();		
		k = initMainMenu();

		debugTxt("test1");
		initDebugTxt();
//		deinitDebugTxt();
		free3dVram();

	}			
	else
	{
		PA_SetBgPrio(1,0,0);
		PA_SetBgPrio(1,3,3);
		init16cBg(1, 2); 
		
		initFileVars();
		PA_SetBrightness(0,0);
		PA_SetBrightness(1,0);
		initAntiAliasedText(0,1,0);
		
		PA_ResetSpriteSys();
	}   
	debugTxt("test2");
	initDebugTxt();	
	loadPathImage(1,TOPscreen.Menu[getMenuSequence()]);  
	debugTxt("test3");
	initDebugTxt();
		initClock("topscreen",0,1);
	debugTxt("test4");
	initDebugTxt();
//	return 0;
	
//	createWindow(0,0,WINDOW_TYPE_TEXTONLY,"New NDS File Found","xpa-kiss", "");
//	


	if (k !=0) return k;
	k=0;
//	setBrightness(0,-31);
//	s8 FadeBrightness=-31;
	

  	navigationSpeed=getNavigateSpeed();
	
	s16 lastStylusX=0;
	s16 lastStylusY=0;
	s16 navigateStylusX=0;
	s16 navigateStylusY=0;
	s16 accellerationIsY=0;
	s16 accelleration=0;
	clearDoubleTap();
	u8 startupSoundCounter=0;
	bool loadTopScreenImg=0;
	startupPopup();

	
	if (!isScreenTransiting()) 
	{
	   resetScreenBrightness();
	}   

	debugTxt("test5");
	initDebugTxt();
	resetScreenSaverCounter();
	debugTxt("test6");
	initDebugTxt();

	while(1)  
	{
		bootupFadeFromWhite();

			
		if (startupSoundCounter<10)
		{
			startupSoundCounter++;
			if (startupSoundCounter==10)
			{

	
			}
		}			   

		


		if (Pad.Newpress.L)
		{ 
			if (shrinkMenu("topscreen",TOPscreen.Menu[getMenuSequence()],1,0))
			{
			   int i;
			   for (i=0;i<9;i++)
			   {
					soul_fclose(SFX.navigateOut[i]);
					soul_fclose(SFX.navigateIn[i]);
					soul_fclose(SFX.confirm[i]);
				}			
			   return 1;
			}   
			if (isSpriteClockLoaded())
			{
			   PA_ResetSpriteSys();
				initClock("topscreen",0,1);
			}			
			LoadDefault16c(1);
		}			
		if (!Pad.Held.L) 
		{

/*		   if (Pad.Newpress.X)
		   {
			   if (isWindowAlive())
			   {
			      killWindow();
			      if (wifi.connecting) cancellWifiConnect();
			   }   
			   display_AssignList(getMenuSequence());
		   }   */
			if (Pad.Newpress.A || (Stylus.Newpress && !isWindowHit() && isDoubleTapped()))
			{
	/*		   if (!verifyCommand(system.menuRuns[getMenuSequence()]) || Pad.Newpress.X)
			   {
				   if (isWindowAlive())
				   {
				      killWindow();
				      if (wifi.connecting) cancellWifiConnect();
				   }   
				   display_AssignList(getMenuSequence());
			   }   
			   else*/
			   {

			      PA_16cErase(0);
			      PA_16cErase(1);
			      debugTxt("killwindow");
				   if (isWindowAlive())
				   {
				      killWindow();
				      if (wifi.connecting) cancellWifiConnect();
				   }   
 		       	loadFatSndWav(SFX.confirm[getMenuSequence()]);			
					
				      debugTxt("transite");
					initThemeTransition("mainscreen", 0);
	
					while (isScreenTransiting())
	     			{
						updateScreenTransition();
						updateAmbience();
						Soul_waitForVBL();
			     	}			
				      debugTxt("history");
	         	historyFile = fopen ("fat:/_menudo/logs/HISTORY.LASTMENU", "wb"); 	
	     			fwrite(menuSelected,6,1,historyFile);
	     			fclose(historyFile);
	     			
	     			getCurrentCommand();
			 	     debugTxt(CurrentMenuCommand);
					create3dBackgroundLayer(917,0,0,0);
					PA_3DSetSpriteWidthHeight(917,1022,1022);
					PA_3DSetSpritePrio(917,3100);
					int internalAppWasOpened=-1;
					hidesprite(1, 0);
			      debugTxt("comparing");
					if (PA_CompareText (CurrentMenuCommand, "mSettings")== 1)
					{
						internalAppWasOpened = selectSettings(0);
						free(CurrentMenuCommand);  
						PA_3DSetSpriteVisible(917,0);
					}   
					if (PA_CompareText (CurrentMenuCommand, "mPda")== 1)
					{
						internalAppWasOpened = selectPDA(0);				 
						free(CurrentMenuCommand);  
						PA_3DSetSpriteVisible(917,0);
					}   
	     			if (PA_CompareText(CurrentMenuCommand,"mWireless") == 1) 
	     			{
						internalAppWasOpened = selectWireless(0);	        			 
						free(CurrentMenuCommand);  
						PA_3DSetSpriteVisible(917,0);
	     			}   
					if (PA_CompareText(CurrentMenuCommand,"mMultimedia") == 1)
					{
						internalAppWasOpened = selectMultimedia(0);
						free(CurrentMenuCommand);
						PA_3DSetSpriteVisible(917,0);
					}   
					if (PA_CompareText(CurrentMenuCommand,"gba") == 1)
					{
						internalAppWasOpened = selectGBA(0);
						free(CurrentMenuCommand);
						PA_3DSetSpriteVisible(917,0);
					}   
			      debugTxt("closing");
//	     			if (internalAppWasOpened!=0)closeAllResource();
			      debugTxt("returning");
			   	initDebugTxt();
				   return internalAppWasOpened;
				}   
			}   
		   if (Stylus.Newpress && !isWindowHit()){resetDoubleTap();}  
			if (isWindowAlive() && getWindowType() == WINDOW_TYPE_TEXTANDIMAGE)
			{
				if ((Pad.Newpress.Y ||isWindowDoubleClicked()) && stricmp(getWindowText(0),"Load Last Played Game?") == 0)
				{
					if (stricmp(getWindowText(0),"Load Last Played Game?") == 0)
					{
					   loadLastFile();
					}   			   
				}   
				else
				if (isWindowDoubleClicked())
				{
				   clearNewNDSItem(newNdsFile_WindowCounter-1);
				   menudo_runNDS(getPathOfNewNDS(newNdsFile_WindowCounter-1),1,0);
				   
				}			
			}			

									  
			if (Pad.Newpress.Y)
			{
			   if (isWindowAlive())
			   {
			      killWindow();
			      if (wifi.connecting) cancellWifiConnect();
			   }   
			   displayLastGameWindow();
			}   
			
			
			if (Stylus.Newpress && !isWindowHit()) 
			{
				lastStylusX=getStylusX();
				navigateStylusX=getStylusX();
				navigateStylusY=getStylusY();
			}			
			if (Stylus.Held && !isWindowHit()) 
			{
			   if (abs(navigateStylusX-getStylusX()) < abs(navigateStylusY-getStylusY())) 
			   {
     			   accelleration = (getStylusY()-lastStylusY)*5;
			   	accellerationIsY=1;
				}  	
			   else
			   {
				   accelleration = (getStylusX()-lastStylusX)*5;
			   	accellerationIsY=0;
				}  	
				lastStylusX=getStylusX();	
				lastStylusY=getStylusY();	
			}		
			else
			{
				if (accelleration > 10 ) accelleration-=5;  
			 	if (accelleration > 0  ) accelleration--;  
			 	if (accelleration <= 10  && accelleration > 0) accelleration=0;  
				if (accelleration < -10) accelleration+=5	;  
			 	if (accelleration >= -10  && accelleration < 0) accelleration=0;  
			 	if (accelleration < 0 ) accelleration++;
			}   
				if (getInputReverseDown() || (Stylus.Held && !isWindowHit() &&  navigateStylusY-getStylusY() < -10)  ||(!Stylus.Held && accelleration > 0 && accellerationIsY))  
				{
				   clearDoubleTap();
				   if (getInputReverseDown()) accelleration=0;
				   //Settings
			  		// MENU[1] for apps k=10 ; k<=15
					if (menuSelected[1] < 2 && menuSelected[0]==0)
					{
						loadTopScreenImg=1;
				   	if (Stylus.Held &&  !isWindowHit() && navigateStylusY-getStylusY() < -10) 
						{
						   navigateStylusX=getStylusX();
						   navigateStylusY=getStylusY();
						}
						for (k = 0; k < 10 ; k++) sprite[k].var2.time= 0;
					   if ((sprite[10].var2.play_mode2!=1) || getInputReverseDown())
					   {
						 	for (k = 10; k <= 15 ; k++)
							{
								   if (sprite[k].var2.play_mode2==1 || sprite[k].var2.time > 60)
								  	sprite[k].var2.time = (menuSelected[1])*30 ;
									sprite[k].var2.next_sprite = menuSelected[1]+1;
									sprite[k].var2.current_sprite =menuSelected[1];
	
								if (sprite[k].var2.time < sprite[k].data[sprite[k].var2.last_sprite].key_frame)
								{
									sprite[k].var2.play_mode2=1;
									move_time(k, 1,1);
								}		
						
							}		
							loadFatSndWav(SFX.navigateOut[getMenuSequence()]);			
							menuSelected[1]++;
						}			
					}		
						
					//Game
					// icons: k=22 ; k<=27
					
					if (menuSelected[5] < 2 && menuSelected[0]==4)
				   {
						loadTopScreenImg=1;
				   	if (Stylus.Held && !isWindowHit() &&  navigateStylusY-getStylusY() < -10) 
						{
						   navigateStylusX=getStylusX();
						   navigateStylusY=getStylusY();
						}
						if ((sprite[22].var2.play_mode2!=1) || getInputReverseDown())
					   {
	
						 	for (k = 22; k <= 27 ; k++)
								{
								   if (sprite[k].var2.play_mode2==1 || sprite[k].var2.time > 60)
									  	sprite[k].var2.time = (menuSelected[5])*30 ;
										sprite[k].var2.next_sprite = menuSelected[5]+1;
										sprite[k].var2.current_sprite =menuSelected[5];
									if (sprite[k].var2.time < sprite[k].data[sprite[k].var2.last_sprite].key_frame)
									{
									sprite[k].var2.play_mode2=1;
									move_time(k, 1,1);
									}		
							
								}		
						loadFatSndWav(SFX.navigateOut[getMenuSequence()]);				
						menuSelected[5]++;
						}		
					}
					if (!Stylus.Held && accelleration > 0 && !((menuSelected[1] < 2 && menuSelected[0]==0) || (menuSelected[5] < 2 && menuSelected[0]==4)))
						accelleration = 0;					

				}		
				
				if (getInputReverseUp() || (Stylus.Held&& !isWindowHit() &&  navigateStylusY-getStylusY() > 10)  ||(!Stylus.Held && accelleration < 0 && accellerationIsY)) 
				{
				   clearDoubleTap();
				   if (getInputReverseUp()) accelleration=0;


	 				if (menuSelected[1] > 0 && menuSelected[0]==0)
					{		
						loadTopScreenImg=1;
				   	if (Stylus.Held && !isWindowHit() &&  navigateStylusY-getStylusY() > 10)
						{
						   navigateStylusX=getStylusX();
						   navigateStylusY=getStylusY();
						}
					   if ((sprite[10].var2.play_mode2!=2) || getInputReverseUp())
					   {
						loadFatSndWav(SFX.navigateOut[getMenuSequence()]);
						  menuSelected[1]--;
							for (k = 0; k < 10 ; k++)
							sprite[k].var2.time= 0;
						  	for (k = 10; k <= 15 ; k++)
							{
	//						   if (sprite[k].var2.time >= 61)
							   if (sprite[k].var2.play_mode2==2 || sprite[k].var2.time > 60)
								  	sprite[k].var2.time = ((menuSelected[1]+1)*30);//-1 ;
									sprite[k].var2.next_sprite = menuSelected[1]+1;
									sprite[k].var2.current_sprite =menuSelected[1];
							   if (sprite[k].var2.time > 0)
								{   
									sprite[k].var2.play_mode2=2;
									move_time(k, 2,1);		
								}		
							}
							
						}   
			
					
					}	
					if (menuSelected[5] > 0 && menuSelected[0]==4)
				   {
						loadTopScreenImg=1;
				   	if (Stylus.Held && !isWindowHit()&&  navigateStylusY-getStylusY() > 10)
						{
						   navigateStylusX=getStylusX();
						   navigateStylusY=getStylusY();
						}
						if ((sprite[22].var2.play_mode2!=2)  || getInputReverseUp())
					   {
						loadFatSndWav(SFX.navigateOut[getMenuSequence()]);
						menuSelected[5]--;
						 	for (k = 22; k <= 27 ; k++)
								{
	//							   if (sprite[k].var2.time >= 61)
	//							  	{
							   if (sprite[k].var2.play_mode2==2 || sprite[k].var2.time > 60)
									  	sprite[k].var2.time = ((menuSelected[5]+1)*30);//-1 ;
										sprite[k].var2.next_sprite = menuSelected[5]+1;
										sprite[k].var2.current_sprite =menuSelected[5];
	//								}			
									if (sprite[k].var2.time < sprite[k].data[sprite[k].var2.last_sprite].key_frame)
									{
									sprite[k].var2.play_mode2=2;
									move_time(k, 2,1);
									}		
							
								}		
				
	
						}		
					}
					if (!Stylus.Held && accelleration < 0 && !((menuSelected[1] > 0 && menuSelected[0]==0) || (menuSelected[5] > 0 && menuSelected[0]==4)))
						accelleration = 0;
	//				menuSelected[menuSelected[0]+1]--;//size++;
					//if (!(!Stylus.Held && accelleration < 0 )) 

				}		
			
				if (getInputLeft()  || (Stylus.Held && !isWindowHit() &&  navigateStylusX-getStylusX() > 10) ||(!Stylus.Held && accelleration < 0 && !accellerationIsY)) 
				{
				   clearDoubleTap();
				   if (getInputLeft()) accelleration=0;
					loadTopScreenImg=1;
			   	if (Stylus.Held && !isWindowHit() &&  navigateStylusX-getStylusX() > 10) 
					{
					   navigateStylusX=getStylusX();
					   navigateStylusY=getStylusY();
					}   
	
					if(menuSelected[0]>0)
					{
						if (sprite[0].var2.play_mode2!=2  || getInputLeft() )
						{
			//			   if (sprite[1].var2.play_mode2==0 || sprite[1].var2.play_mode2==1)
									for (k = 0; k < 10 ; k++)
										{
											if(sprite[k].var2.time > 0)
											{
				//								if (sprite[sprite_id].var2.time >= sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame && mode == 1) 
												if (!(sprite[k].var2.play_mode2==0 || sprite[k].var2.play_mode2==1))
													jumpTime(k,2);
												sprite[k].var2.play_mode2=2;
												move_time(k, 2,1);
											}			
				
										}		
				
							   {
				
									
							   if (menuSelected[0]==1)
							   {
	
									for (k = 10; k <= 15 ; k++)
									{
	
	
										sprite[k].var2.time = 60+(menuSelected[1]*30)+(sprite[k].var2.time%30 ==0?30:sprite[k].var2.time%30);
										sprite[k].var2.play_mode2=2;
										sprite[k].var2.next_sprite = 4+(menuSelected[1]*2);
										sprite[k].var2.current_sprite =3+(menuSelected[1]*2);
									}		
				
									for (k = 16; k <= 17 ; k++)
										setSpriteAnim(k,30,2,1,0);
									for (k = 18; k <= 19 ; k++)
									   if (sprite[k].var2.play_mode2==2) sprite[k].var2.time =0;	
								}			
							   if (menuSelected[0]==2)
							   {
									for (k = 16; k <= 17 ; k++)
										setSpriteAnim(k,60,2,2,1);	
									for (k = 18; k <= 19 ; k++)
										setSpriteAnim(k,30,2,1,0);
									for (k = 20; k <= 21 ; k++)
									   if (sprite[k].var2.play_mode2==2) sprite[k].var2.time =0;	
								}			
							   if (menuSelected[0]==3)
							   {
									for (k = 18; k <= 19 ; k++)
										setSpriteAnim(k,60,2,2,1);
									for (k = 20; k <= 21 ; k++)
										setSpriteAnim(k,30,2,1,0);		
									for (k = 22; k <= 27 ; k++)
									{
										sprite[k].var2.time = 180+(menuSelected[5]*30);
									}			
								}			
							   if (menuSelected[0]==4)
							   {
						
									for (k = 20; k <= 21 ; k++)
										setSpriteAnim(k,60,2,2,1);
									for (k = 22; k <= 27 ; k++)
									{
										sprite[k].var2.time = 150+(menuSelected[5]*30)+(sprite[k].var2.time <60?0:sprite[k].var2.time%30);
	//									sprite[k].var2.time = 150+(menuSelected[5]*30)+(sprite[k].var2.time%30 ==0?30:sprite[k].var2.time%30);
	//									sprite[k].var2.time = (150+(menuSelected[5]*30))-(sprite[k].var2.time < 60?30:(30-(sprite[k].var2.time%30)));	
	//									sprite[k].var2.time = 151+(menuSelected[5]*30);
										sprite[k].var2.play_mode2=1;
										sprite[k].var2.next_sprite = 10+(menuSelected[5]*2);
										sprite[k].var2.current_sprite =9+(menuSelected[5]*2);
									}	
								}			
							loadFatSndWav(SFX.navigateOut[getMenuSequence()]);
								menuSelected[0]--;
								//if (!(!Stylus.Held && accelleration > 0)) 

							}   
						}	
					}			
					else
					if (!Stylus.Held && accelleration < 0 )
					{
					   accelleration=0;
					}   
			
				}		

				if (getInputRight()  || (Stylus.Held && !isWindowHit() &&  navigateStylusX-getStylusX() < -10) ||(!Stylus.Held && accelleration > 0 && !accellerationIsY)) 
				{
				   clearDoubleTap();
				   if (getInputRight())
					{
					   accelleration=0;
					}   
					loadTopScreenImg=1;
			   	if (Stylus.Held && !isWindowHit() &&  navigateStylusX-getStylusX() < -10) 
					{
					   navigateStylusX=getStylusX();
					   navigateStylusY=getStylusY();
					}
	
					if(menuSelected[0]<4)
					{
						if (sprite[0].var2.play_mode2!=1  || getInputRight())
						{
							for (k = 0; k < 10 ; k++)
							{
								if(sprite[k].var2.time < sprite[k].data[sprite[k].var2.last_sprite].key_frame)
								{
	//								if (sprite[sprite_id].var2.time >= sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame && mode == 1) 
									if (!(sprite[k].var2.play_mode2==0 || sprite[k].var2.play_mode2==2))
									jumpTime(k,1);
									sprite[k].var2.play_mode2=1;
									move_time(k, 1,1);
								}			
	
							}		

						   if (menuSelected[0]==0)
						   {
	
								for (k = 10; k <= 15 ; k++)
								{
									sprite[k].var2.time = (91+(menuSelected[1]*30))-(sprite[k].var2.time < 60?30:(30-(sprite[k].var2.time%30)));	
									sprite[k].var2.play_mode2=1;
									sprite[k].var2.next_sprite = 4+(menuSelected[1]*2);
									sprite[k].var2.current_sprite = 3+(menuSelected[1]*2);
								}		
								for (k = 16; k <= 17 ; k++)
									setSpriteAnim(k,0,1,1,0);
	
					
							}			
							   if (menuSelected[0]==1)
						   {

								for (k = 10; k <= 15 ; k++)
								{
										sprite[k].var2.time = (90+(menuSelected[1]*30));	
								}	
								for (k = 16; k <= 17 ; k++)
									setSpriteAnim(k,30,1,2,1);
					
								for (k = 18; k <= 19 ; k++)
									setSpriteAnim(k,0,1,1,0);
					
							}			
						   if (menuSelected[0]==2)
						   {
	
								for (k = 16; k <= 17 ; k++)
							   if (sprite[k].var2.play_mode2==1)
									sprite[k].var2.time =60;
								for (k = 18; k <= 19 ; k++)
									setSpriteAnim(k,30,1,2,1);
					
								for (k = 20; k <= 21 ; k++)
									setSpriteAnim(k,0,1,1,0);
					
							}			
					
						   if (menuSelected[0]==3)
						   {
								for (k = 18; k <= 19 ; k++)
							   if (sprite[k].var2.play_mode2==1)
									sprite[k].var2.time =60;				
								for (k = 20; k <= 21 ; k++)
									setSpriteAnim(k,30,1,2,1);
								for (k = 22; k <= 27 ; k++)
								{
//									sprite[k].var2.time = 151+30+(menuSelected[5]*30);
//									sprite[k].var2.time = 150+(menuSelected[5]*30)+(sprite[k].var2.time%30==0?30:((sprite[k].var2.time%30)));	
									sprite[k].var2.time = 150+(menuSelected[5]*30)+(sprite[k].var2.time%30==0?30:((sprite[k].var2.time%30)));	
//									sprite[k].var2.time = 60+(menuSelected[1]*30)+(sprite[k].var2.time%30 ==0?30:sprite[k].var2.time%30);

									sprite[k].var2.play_mode2=2;
									sprite[k].var2.next_sprite = 10+(menuSelected[5]*2);
									sprite[k].var2.current_sprite =9+(menuSelected[5]*2);
								}		
							}


							loadFatSndWav(SFX.navigateOut[getMenuSequence()]);

							menuSelected[0]++;


						}
					}   
					else
					if (!Stylus.Held && !isWindowHit() && accelleration > 0)
					{
					   accelleration=0;
					}   
				}			
			}			






//Bottom screen Update and Check
   
		

		for (k = 0; k <= NUMBER_OF_SPRITES-1 ; k++)
		{
			
		
			switch (sprite[k].var2.play_mode2)
			{
			   case 1:	if ((accelleration*.1)!=0 && !Stylus.Held && !isWindowHit()) 
							{
								if(sprite[k].var2.time+(accelleration*.1) < sprite[k].data[sprite[k].var2.next_sprite].key_frame)
								{
							   	if (abs(accelleration)*.1>=1) //sprite[k].var2.time+= 1;
							   	sprite[k].var2.time+= (int)(abs(accelleration)*.1);
									//sprite[k].var2.time+= abs(accelleration)*.1;
								}  	
							   else
							   { 	
								   sprite[k].var2.time = sprite[k].data[sprite[k].var2.next_sprite].key_frame;
									sprite[k].var2.play_mode2=0;
								}
								
							}   
							else
							{
							   if (sprite[k].var2.time < sprite[k].data[sprite[k].var2.next_sprite].key_frame )
							   {
								   if (navigationSpeed==1)
									{   
								   	sprite[k].var2.time+= navigationSpeed;
								   } 		
									else
									{
									   {
									      if (abs(sprite[k].data[sprite[k].var2.next_sprite].key_frame - sprite[k].var2.time) < 5)
										   	sprite[k].var2.time+= navigationSpeed*.5;
											else
										   	sprite[k].var2.time+= navigationSpeed;
					
										}   
									}			
								}			
								if(sprite[k].var2.time >= sprite[k].data[sprite[k].var2.next_sprite].key_frame) 
								{
								   sprite[k].var2.time = sprite[k].data[sprite[k].var2.next_sprite].key_frame;
								   sprite[k].var2.play_mode2=0;

								}   
								   idleCounter=0;
							}			
							break;
			   case 2: 	if ((accelleration*.1)!=0 && !Stylus.Held && !isWindowHit()) 
							{
								if(sprite[k].var2.time+(accelleration*.1) > sprite[k].data[sprite[k].var2.next_sprite-1].key_frame)
								{
							   	if (abs(accelleration)*.1>=1) //sprite[k].var2.time-= 1;
							   	sprite[k].var2.time-= (int)(abs(accelleration)*.1);
								}  	
								else
								{
								   sprite[k].var2.time = sprite[k].data[sprite[k].var2.next_sprite-1].key_frame;
									sprite[k].var2.play_mode2=0;
								}
								
							}   
							else
							{
								if(sprite[k].var2.time > sprite[k].data[sprite[k].var2.next_sprite-1].key_frame)
								{
								   if (navigationSpeed==1)
								   {
								   	sprite[k].var2.time-= navigationSpeed;
								   } 		
								   else
								   {
								      if (abs(sprite[k].data[sprite[k].var2.next_sprite].key_frame - sprite[k].var2.time) < 25)
									   	sprite[k].var2.time-= navigationSpeed;
										else
									   	sprite[k].var2.time-= navigationSpeed*.5;
									}   			   
								}			
							   if(sprite[k].var2.time <= sprite[k].data[sprite[k].var2.next_sprite-1].key_frame) 
								{
								   sprite[k].var2.time = sprite[k].data[sprite[k].var2.next_sprite-1].key_frame;
								   sprite[k].var2.play_mode2=0;

								}  
								idleCounter=0; 
							}			
							break;
			}			
			update_transpeed(k,sprite[k].var2.current_sprite, sprite[k].var2.next_sprite);
			
			update_spritevars(k);
			update_spritelocation(k);
			PA_3DSetSpritePolyID(k,k);
			PA_3DSetSpritePrio(k,1500+(k*10));
		
		}
		k = 0;
		if (!((accelleration*.1)!=0 && !Stylus.Held && !isWindowHit()))
		for (k = 0; k <= NUMBER_OF_SPRITES-1 ; k++)
			if (sprite[k].var2.play_mode2!=0) break;
	   if (loadTopScreenImg && k == NUMBER_OF_SPRITES) 
		{
		   ZoomXY_3DProcess(128,0,0);  
		   loadPathImage(1,TOPscreen.Menu[getMenuSequence()]); 
			loadFatSndWav(SFX.navigateIn[getMenuSequence()]);			
		   loadTopScreenImg=0;
		}		


		
		if (isScreenTransiting())//getScreenBrightnessValue(0)<0 && !AfterSMFIntro) 
		{
		   updateScreenTransition();   
		 //  ZoomXY_3DProcess(128+(getScreenBrightnessValue(0)*-1),0,0);
		}  	
		else
		{
			if (Pad.Newpress.R) toogleLights();
			ZoomXY_3DProcess(128,0,0);  
		}		

//	   if (Pad.Newpress.B)	createWindow(0,0,WINDOW_TYPE_TEXTONLY,"Battery Low","Backlight Strength Reduced", "");

	   

		
		updateAmbience();  //Update Ambience / Animated Background
		if (checkForScreenSaver())
		{
		   sprintf(lastImage," ");
			loadPathImage(1,TOPscreen.Menu[getMenuSequence()]);  
		}	
		Soul_waitForVBL();
		idleCounter++;
		PA_16cErase(0);
		updateClock(0,0,1);
//		updateCustomClock();
	   updateWindow();
	}  

}   


