#include <PA9.h>
#include <mikmod9.h>
#include "player_sound.h"
MODULE* module;

void MikMod9_SendCommand(u32 command)
{
	while (REG_IPC_FIFO_CR & IPC_FIFO_SEND_FULL);
	REG_IPC_FIFO_TX = command;
}

void TimerInterrupt()
{
	MikMod_Update();
	TIMER0_DATA = TIMER_FREQ_256(md_bpm * 50 / 125);
}

int initMikMod()
{
	MikMod_RegisterDriver(&drv_nds_hw);

	MikMod_RegisterAllLoaders();

	if (MikMod_Init(""))
	{
		return 0;
	}
	return 1;
}
void clearMikModMusic()
{
	Player_Stop();
	Player_Free(module);
}   

int loadMikModMusic(const void* buffer, size_t size, bool autoplay)
{
   if (!Player_Paused()) togglePlayMusic();
   clearMikModMusic();
   int maxchan=64;
   int curious=0;
	module = Player_LoadMemory(buffer, size, maxchan, curious);
	if (!module)
	{
		return 0;
	}

	TIMER0_CR = 0;
	irqSet(IRQ_TIMER0, TimerInterrupt);
	irqEnable(IRQ_TIMER0);
	TIMER0_DATA = TIMER_FREQ_256(md_bpm * 50 / 125);
	TIMER0_CR = TIMER_DIV_256 | TIMER_IRQ_REQ | TIMER_ENABLE;
	if (autoplay)
		Player_Start(module);
	return 1;
}   
int fatLoadMikModMusic(char* filepath, bool autoplay)
{
	FILE* binFile = fopen(filepath, "rb");
	u32 binSize;
	fseek (binFile, 0 , SEEK_END);
	binSize = ftell (binFile);
	rewind (binFile);
	fclose (binFile);
   clearMikModMusic();
   int maxchan=64;
   int curious=0;
	module = Player_Load(filepath,binSize,64);
	if (!module)
	{
		return 0;
	}
	TIMER0_CR = 0;
	irqSet(IRQ_TIMER0, TimerInterrupt);
	irqEnable(IRQ_TIMER0);
	TIMER0_DATA = TIMER_FREQ_256(md_bpm * 50 / 125);
	TIMER0_CR = TIMER_DIV_256 | TIMER_IRQ_REQ | TIMER_ENABLE;
	if (autoplay)
		Player_Start(module);
	return 1;
}
int getSongChannell()
{
	if (!module)
		return 0;
	return module->numchn;
}	
unsigned int getSongElapsed()
{
	if (!module)
		return 0;
	return (module->sngtime)>>10;
}
void togglePlayMusic()
{

   if (Player_Paused())
	   Player_SetVolume(128);
   else
   	Player_SetVolume(0);

	Soul_waitForVBL();
	Soul_waitForVBL();
	Soul_waitForVBL();
	Soul_waitForVBL();
   Player_TogglePause();

/*   if (Player_Active()!=0)
		Player_Stop();
	else
	while(true)
		Player_Start(module);*/
//	PA_WaitFor(Pad.Newpress.Start);

//	Player_TogglePause();
//	Voice_Mute(MUTE_INCLUSIVE,0,32);
//	else
} 		
