#include <PA9.h>
#include <mikmod9.h>
#include "player_sound.h"
#define DISPLAY_FREQUENCY_LIMIT 6
#define FALL_SPEED_COUNTER_START 60
#define FALL_SPEED_COUNTER_SPEEDUP3 40
#define FALL_SPEED_COUNTER_SPEEDUP2 30
#define FALL_SPEED_COUNTER_SPEEDUP1 20


unsigned char displayFrequency[DISPLAY_FREQUENCY_LIMIT];
unsigned char displayfallFrequency[DISPLAY_FREQUENCY_LIMIT];
unsigned char speedfallFrequency[DISPLAY_FREQUENCY_LIMIT];
bool musicFrequency_Changed[64];

void updateVisualizerVars()
{

	if (Player_Active()) 
	{
	   int i;
	   int x=0; 
	   unsigned char temp=0;
	   unsigned char channelAverage=(getSongChannell())/(DISPLAY_FREQUENCY_LIMIT);//-(getSongChannell()%DISPLAY_FREQUENCY_LIMIT));
	   unsigned char musicFrequency[64];
	   for (i=0;i<getSongChannell();i++)
	   {
	      if (Voice_GetVolume(i)==0) 
			{
  				musicFrequency[i] = 0;
	        	musicFrequency_Changed[i]=1;
			}			
			else
			{   
			   temp= ((Voice_GetFrequency(i)>>5)%32)*3;
			   if (musicFrequency[i] == temp)
			   {
			      temp=15;
			      if (temp<0) temp=0;
			   }   
	      	musicFrequency[i] = temp;
			  	musicFrequency_Changed[i]=0;
		   }  	
//        	if (musicFrequency[i]>64) musicFrequency[i]*=.5;
		}		
	   
	   for (i=0;i<DISPLAY_FREQUENCY_LIMIT;i++)
	   {
			if (channelAverage!=0)
			{
		      while (x-(i*channelAverage)<channelAverage)
		      {
		         if (musicFrequency_Changed[x])
		         {
			            displayFrequency[i]*=.9;
		         }
					else
					{
					   if (x-(i*channelAverage)==0)  displayFrequency[i]=0;   
						
			      	displayFrequency[i] += musicFrequency[x]/channelAverage;
				   }  	
			      x++;
			   }   
			}   
			else
			{
	         if (musicFrequency_Changed[i])
	         {
		         displayFrequency[i]=0;
	         }
				else
				{
					displayFrequency[i] = musicFrequency[i%getSongChannell()];
			   }  	

			}   
			if (displayfallFrequency[i]<=displayFrequency[i])
			{
			   displayfallFrequency[i] = displayFrequency[i];
			   speedfallFrequency[i]=FALL_SPEED_COUNTER_START;
			}   
			else
			{
			   if (speedfallFrequency[i]> 0) speedfallFrequency[i]--;
			   if (speedfallFrequency[i]<FALL_SPEED_COUNTER_SPEEDUP1)
			   {
				   if (displayfallFrequency[i]-5<0)
					{
					   displayfallFrequency[i]=0;
					}
					else   
				   displayfallFrequency[i]-=5;
				}
				else
			   if (speedfallFrequency[i]<FALL_SPEED_COUNTER_SPEEDUP2)
			   {
				   if (displayfallFrequency[i]-3<0)
					{
					   displayfallFrequency[i]=0;
					}
					else   
				   displayfallFrequency[i]-=3;
				}
				else
			   if (speedfallFrequency[i]<FALL_SPEED_COUNTER_SPEEDUP3) 
				{
				   displayfallFrequency[i]--;
				}
			}   
		}		
	}			
}   
void initVisualizer()
{
/*	u16 barTex = PA_3DCreateTex((void*)mollusk_Texture, 64, 64, TEX_16COL );
	PA_Load3DSpritePal(0, (void*)mollusk_Pal);
	int i;	
	for (i=0;i<DISPLAY_FREQUENCY_LIMIT*4;i++)
		PA_3DCreateSpriteFromTex(i, barTex, 	150/DISPLAY_FREQUENCY_LIMIT, 10, 	0, 	((i%DISPLAY_FREQUENCY_LIMIT)+1)*((150/DISPLAY_FREQUENCY_LIMIT)+8), 150);	
*/
//	for (i=0;i<DISPLAY_FREQUENCY_LIMIT;i++)
//		PA_3DCreateSpriteFromTex(i+DISPLAY_FREQUENCY_LIMIT, barTex, 	150/DISPLAY_FREQUENCY_LIMIT, 10, 	0, 	(i+1)*((150/DISPLAY_FREQUENCY_LIMIT)+8), 150);	
}   
void animateVisualizer()
{
	if (Player_Active()) 
	{
		int i;
	   for (i=0;i<DISPLAY_FREQUENCY_LIMIT;i++)
	   {
			pa_3dsprites[i].corner[0].y=10-displayFrequency[i];
			pa_3dsprites[i].corner[1].y=10-displayFrequency[i];
			PA_3DSetSpriteY(i+DISPLAY_FREQUENCY_LIMIT,148-displayfallFrequency[i]);
			pa_3dsprites[i+(DISPLAY_FREQUENCY_LIMIT*2)].corner[0].y=10+displayFrequency[i];
			pa_3dsprites[i+(DISPLAY_FREQUENCY_LIMIT*2)].corner[1].y=10+displayFrequency[i];
			PA_3DSetSpriteY(i+(DISPLAY_FREQUENCY_LIMIT*2),152);
			PA_3DSetSpriteAlpha(i+(DISPLAY_FREQUENCY_LIMIT*2),10);
			PA_3DSetSpriteY(i+(DISPLAY_FREQUENCY_LIMIT*3),164+displayfallFrequency[i]);
			PA_3DSetSpriteAlpha(i+(DISPLAY_FREQUENCY_LIMIT*3),10);
		}   
	}		

}   

