/*#include <PA9.h>
#include "black_background.h"
#include "visualizer1.h"
#include "../../../misc/math.h"
#include "../../../gfx/all_gfx.h"
extern int i;

struct songInfo
{
	char Title[100];
	char Artist[100];
	char Album[100];
	u8 lrcAmount;
	u8 lrcCounter;
} song;

typedef struct
{
	u32 duration;
	char line[256];
} lyricsInfo;
 
lyricsInfo lrc[100]; 

typedef struct
{
	u16 animation;
	u16 hertz;
	u8 originX;
	u8 originY;
} visualizerInfo;
 
visualizerInfo visualizer[100]; 

extern u16 TP_giftotexcolor;

extern void TP_GifToTexTransp(u16 color);

extern u16 TP_3DCreateTexFromGif(void *gif, u8 palette);

extern inline void TP_3DCreateSpriteFromGif(u16 sprite, void *gif, u8 palette, s16 x, s16 y){
   PA_3DCreateSpriteFromTex(sprite, TP_3DCreateTexFromGif(gif, palette), PA_GetGifWidth(gif), PA_GetGifHeight(gif), palette, x, y);
}   
char *getTagValue(char endcharacter, char* line)
{
   u16 i;
   u8 x;
   char *value = malloc(strlen(line)-5);
   for(x=0;x<strlen(line);x++)
   {
      if (line[x]==endcharacter)
      break;
   }   
   x++;
   
   for(i=0;(line[i+x] != ']' && line[i+x] != '\0');i++)
      value[i] = line[i+x];
//   value[i] = '\0';
   return value;
}	   
bool compareTag(char* tag, char* line)
{
   char temptag[strlen(tag)+2];
   sprintf(temptag,"[%s:",tag);
   
   u16 i=0;
   while(i!=strlen(temptag))
	{
	   if (line[i]!=temptag[i])
   	return false;
   	i++;
	}  	
	return true;
}   
bool compareNoteTag(char* line)
{
   if (line[0] == '[' &&
   	 line[3] == ':' &&
   	 line[6] == '.' &&
   	 line[9] == ']')
	return true;
	else
	return false;
}  

void mPlayer()
{

	PA_Init();
	PA_InitVBL();
	PA_Init3D();	
	PA_Reset3DSprites();
	PA_InitText(1,0);
	PA_Init16cBg(0, 1);
	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);

	PA_16cCustomFont(5, arialAA12);
	PA_16cCustomFont(7, arialAA12gray);
	PA_16cCustomFont(6, arialAA8);

	PA_LoadPal16c(PAL_BG0, arialAA12_Pal);

	PA_EnableSpecialFx(0, SFX_ALPHA, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	PA_SetSFXAlpha(0, 31, 15);

	TP_3DCreateSpriteFromGif(2, 		 		// Sprite
									(void*)black_background,  // Gif
									2	, 				// Palette number
									128, 80);	// X, Y SPRITE CENTER !
	PA_3DSetSpriteWidthHeight(2,256,256);
	PA_3DSetSpritePrio(2,100);
	TP_GifToTexTransp(PA_RGB(31,0,31));
	u16 visualizerGlow = TP_3DCreateTexFromGif((void*)visualizer1,2);
	u16 visualizerAmount=0;




	u32 timeDuration=0;
	

	FILE* testRead = fopen ("fat:/mPlayerTest.lrc", "rb"); //rb = read
	char chrTemp[256]; 
   memset(chrTemp, 0, 256);
	song.lrcAmount=0;
   while(fgets(chrTemp, 256, testRead)!=NULL)
   {	
      // Get song information
      if (compareTag("ti",chrTemp))
				sprintf(song.Title,"%s",getTagValue(':',chrTemp));
      if (compareTag("ar",chrTemp))
				sprintf(song.Artist,"%s",getTagValue(':',chrTemp));
      if (compareTag("al",chrTemp))
				sprintf(song.Album,"%s",getTagValue(':',chrTemp));
		if (compareNoteTag(chrTemp))
		{

		   sprintf(lrc[song.lrcAmount].line,"%s",getTagValue(']',chrTemp));
		   lrc[song.lrcAmount].duration = timetoMilisecs(getTagValue('[',chrTemp));
		   song.lrcAmount++;
		}			

   }  
   if (song.Title[0] == '\0')
	   sprintf(song.Title,"crappy_song.mp3");
	PA_Print(1,"Title:%s\n",song.Title); 
	PA_Print(1,"Artist:%s\n",song.Artist); 
	PA_Print(1,"Album:%s\n",song.Album); 
	PA_Print(1,"Filename: fat:/mPlayerTest.mp3\n"); 
	PA_Print(1,"Lyrics: fat:/mPlayerTest.lrc\n\n"); 	
	PA_Print(1,"Currently in development\n(October 15)\n"); 	
	fclose(testRead);
	song.lrcCounter=0;
	AS_MP3StreamPlay("fat:/mPlayerTest.mp3");
	AS_SetMP3Volume(100);
timeDuration=100;
AS_SetSoundVolume(0,100);


u8 visualizerStyle=0;
	while (1)
	{
	   if (Stylus.Newpress)
	   {
			PA_3DCreateSpriteFromTex(3+visualizerAmount,visualizerGlow,64,64,2,Stylus.X,Stylus.Y);
			visualizer[visualizerAmount].originX=Stylus.X;
			visualizer[visualizerAmount].originY=Stylus.Y;
			visualizer[visualizerAmount].animation=512-(PA_GetAngle(128,96,Stylus.X,Stylus.Y));
			visualizerAmount++;
	      
	   }
		for (i=0;i<visualizerAmount;i++)
		{   
		   switch(visualizerStyle)
		   {
				case 0:	if (visualizer[i].hertz <=10)
						   {
							   visualizer[i].hertz = PA_RandMinMax(10,64);
							}   
							   else
							{
							   PA_3DSetSpriteAlpha(3+i,(visualizer[i].hertz/2)-1);
							   visualizer[i].hertz--;
							}  
							visualizer[i].animation++;	
							if (visualizer[i].animation > 512) visualizer[i].animation = 0;
							PA_3DSetSpriteXY(3+i,128+((PA_Cos(visualizer[i].animation)>>2)/(abs(visualizer[i].originY-96)*.08)),visualizer[i].originY);
							PA_3DSetSpritePrio(3+i,(pa_3dsprites[i].Y-visualizer[i].originY)+1000);
						   PA_3DSetSpriteWidthHeight(3+i,visualizer[i].hertz+(PA_Sin(visualizer[i].animation)>>4),visualizer[i].hertz+(PA_Sin(visualizer[i].animation)>>4));
						   if (pa_3dsprites[3+i].Height > 200) 
						   {
								PA_3DSetSpriteWidthHeight(3+i,1,1);
							}
							break;
							//Under development
				case 1:	if (visualizer[i].hertz <=10)
						   {
							   visualizer[i].hertz = 256;
							}   
							   else
							{
							   PA_3DSetSpriteY(3+i,120+(PA_Sin(visualizer[i].hertz)>>2));
							   visualizer[i].hertz--;
							}  
							visualizer[i].animation++;	
							if (visualizer[i].animation > 512) visualizer[i].animation = 0;
							visualizer[i].originX=128;
							//PA_3DSetSpriteXY(3+i,visualizer[i].originX+(PA_Cos(visualizer[i].animation)>>2),120+(PA_Sin(visualizer[i].hertz)>>2));
//							PA_3DSetSpritePrio(3+i,(pa_3dsprites[i].Y-visualizer[i].originY)+1000);
						   PA_3DSetSpriteWidthHeight(3+i,10,10);
						   if (pa_3dsprites[3+i].Height > 200) 
						   {
								PA_3DSetSpriteWidthHeight(3+i,1,1);
							}
							break;
			}			
		}   
		timeDuration+=3;
		if ((timeDuration/2)+100 >= lrc[song.lrcCounter].duration && song.lrcCounter<song.lrcAmount)
		{
		   PA_16cErase(0);
		   PA_16cTextAlign(2);
			PA_16cText(0,10,(10*(song.lrcCounter%2))+150,246,(10*(song.lrcCounter%2))+150,lrc[song.lrcCounter].line,1,5,256);
			if (song.lrcCounter>0)
				PA_16cText(0,10,(10*((song.lrcCounter-1)%2))+150,246,(10*((song.lrcCounter-1)%2))+150,lrc[song.lrcCounter-1].line,1,5,256);
			++song.lrcCounter;
		}	  
		
		PA_OutputText(1,2,19,"%s     ",milisecsToTime((timeDuration/2)));
		PA_OutputText(1,2,20,"%s     ",milisecsToTime(lrc[song.lrcCounter].duration));
		PA_OutputText(1,2,21,"visualizerAmount: %d",visualizerAmount);
		PA_OutputText(1,0,22,"Touch the screen to \nplace a visualizer sprite");
		Soul_waitForVBL();
		PA_3DProcess(); 
		if (Pad.Newpress.B) return;
    }
	

}*/	
