/*


// Includes
#include <PA9.h>       // Include for PA_Lib

#include "paper.h"
#include "../../../gfx/all_gfx.h"
#include "tapWrite.h"
#include "writing.h"


void Draw16cCircle(int xCenter, int yCenter, int radius, int color){
int x = 0;
int y = radius;
int p = 3 - 2 * radius;
int i;
   while (x <= y){
      for (i=xCenter - x;i<=xCenter + x;i++)
      {
	      PA_16cPutPixel(0,i, yCenter + y, color);
			if (color == 0) PA_16cClearZone(0,i, yCenter + y,i+1, yCenter + y+1);
		}			
      for (i=xCenter - x;i<=xCenter + x;i++)
      {
	      PA_16cPutPixel(0,i, yCenter - y, color);
			if (color == 0) PA_16cClearZone(0,i, yCenter - y,i+1, (yCenter - y)+1);
		}

      for (i=xCenter - y;i<=xCenter + y;i++)   
		{
		   PA_16cPutPixel(0,i, yCenter + x, color);
			if (color == 0) PA_16cClearZone(0,i, yCenter + x,i+1, yCenter + x+1);
		}
		

      for (i=xCenter - y;i<=xCenter + y;i++)   
		{   
		   PA_16cPutPixel(0,i, yCenter - x, color);
		 		if (color == 0) PA_16cClearZone(0,i, yCenter - x,i+1, (yCenter - x)+1);
		}
      if (p < 0) p += 4 * x++ + 6;
      else p += 4 * (x++ - y--) + 10;
   }
}

void mNoteDraw16cLine(u16 x1, u16 y1, u16 x2, u16 y2, u8 color, u8 radius){
  int i,dx,dy,sdx,sdy,dxabs,dyabs,x,y,px,py;

  dx=x2-x1;    
  dy=y2-y1;    
  dxabs = dx;
  sdx = 1;
  if (dx < 0) {
	  dxabs = -dx;
	  sdx = -1;
  }
  dyabs = dy;
  sdy = 1;
  if (dy < 0) {
	  dyabs = -dy;
	  sdy = -1;
  }

  x=dyabs>>1;
  y=dxabs>>1;
  px=x1;
  py=y1;
  if (radius > 0)
	  Draw16cCircle(px, py, radius,color);
	  else
	  PA_16cPutPixel(0,px,py,color);


  if (dxabs>=dyabs) {
    for(i=0;i<dxabs;i++)  {
      y+=dyabs;
      if (y>=dxabs)  {
        y-=dxabs;
        py+=sdy;
      }
      px+=sdx;
	  if (radius > 0)
		  Draw16cCircle(px, py, radius,color);
		  else
		  PA_16cPutPixel(0,px,py,color);

    }
  }
  else {
    for(i=0;i<dyabs;i++) {
      x+=dxabs;
      if (x>=dyabs)  {
        x-=dyabs;
        px+=sdx;
      }
      py+=sdy;
	  if (radius > 0)
		  Draw16cCircle(px, py, radius,color);
		  else
		  PA_16cPutPixel(0,px,py,color);

    }
  }
}

// Function: main()
void mNote()
{
	PA_Init3D(); // Uses Bg0, Init 3D...
	PA_Reset3DSprites(); // Init or Reset 3D Sprites
	PA_Init16cBg(0,1);
	PA_SetBgPrio(0,1,0);
	PA_SetBgPrio(0,0,1);
	
	// Initialise the text system on the top screen
//	PA_InitText(1, 1);  // Initialise the text system on the top screen	
	PA_Init8bitBg(1,3);
	PA_LoadGif(	1, (void*)paper); 
						
//	PA_OutputSimpleText(1, 2, 6, " 3DSprites Example : 16bits");	
	

	s16 bgTexture = PA_3DCreateTex((void*)paper_Texture,  // Texture
									256, 192,						// Width, Height
									TEX_16BITS );				// Texture Format

	s16 dirt = PA_3DCreateTex((void*)dirtTexture_Texture,  // Texture
									16, 16,						// Width, Height
									TEX_256COL );				// Texture Format
	u16 numberOfDirt=0;
	PA_Load3DSpritePal(1, (void*)dirtTexture_Pal);

	PA_3DCreateSpriteFromTex(0,
							bgTexture,
							256,192,
							0,
							256/2, 192/2); 
	PA_3DSetSpritePrio(0,100);


	u16 oldStylusX=0;
	u16 oldStylusY=0;

	u16 touchZ1;
	u16 touchZ2;
	u16 touchX;
	u16 intPressure;
	u16 i;
	u8 distanceCounter=0;
	u16 pageTransition=0;

	AS_SetMP3Loop(true);
	AS_MP3DirectPlay((u8*)writing, (u32)writing_size);
	s16 scribbleVolume=0;
	AS_SetSoundVolume(0,scribbleVolume);
s8 FadeTransition=-31;
	while(1) {
	   if (FadeTransition<0)
		{
		   FadeTransition++;
		   PA_SetBrightness(0,FadeTransition);
		   PA_SetBrightness(1,FadeTransition);	   

		}		
	   if (FadeTransition>0)
		{
		   FadeTransition--;
		   PA_SetBrightness(0,FadeTransition-31);
		   PA_SetBrightness(1,FadeTransition-31);	   
		   if (FadeTransition==0)return;
		}		
		if (Pad.Held.A)
			pageTransition++;
	   if (Stylus.Newpress)
	   {
	      
	      AS_SoundQuickPlay(tapWrite);
	   	oldStylusX = Stylus.X;
	   	oldStylusY = Stylus.Y;
			if (Pad.Held.Left)
			{
			   for (i=1;i<=numberOfDirt;i++)
				   if (PA_3DSpriteTouched(i))	break;
				if(i==numberOfDirt+1){
					numberOfDirt++;
					PA_3DCreateSpriteFromTex(numberOfDirt,dirt,16,16,1,Stylus.X, Stylus.Y); 
					PA_3DSetSpriteWidthHeight(numberOfDirt,PA_RandMax(16),PA_RandMax(16));
				}			
			}   
			distanceCounter=0;
			
		}  
		AS_SetSoundVolume(0,scribbleVolume);
		if (scribbleVolume >0) scribbleVolume=scribbleVolume/5;
	   if (Stylus.Held && (oldStylusX != Stylus.X || oldStylusY != Stylus.Y))
	   {
	      
	      scribbleVolume=PA_TrueDistance(oldStylusX,oldStylusY,Stylus.X,Stylus.Y)*10;
	      //AS_SetSoundVolume(0,128);
	      //AS_SoundQuickPlay(scribbleWrite);
	      //AS_SoundQuickPlay(tapWrite);
			touchZ1 = IPC->touchZ1;
			touchZ2 = IPC->touchZ2;
			touchX = IPC->touchX;
	
			intPressure = ((75-(((touchX * touchZ2) / (64 * touchZ1) - touchX / 64)))/5)-1;
			if (intPressure > 10) intPressure = 0;
			if (Pad.Held.Up)
				mNoteDraw16cLine(Stylus.X,Stylus.Y,oldStylusX,oldStylusY,Pad.Held.Left ? 0 : 10,intPressure);
				else
				mNoteDraw16cLine(Stylus.X,Stylus.Y,oldStylusX,oldStylusY,Pad.Held.Left ? 0 : 10,Pad.Held.Left ? 2 : 0);


			if (Pad.Held.Left)
			{
				distanceCounter += PA_TrueDistance(oldStylusX,oldStylusY,Stylus.X,Stylus.Y);
				if (distanceCounter > 10)
				{
				   for (i=1;i<=numberOfDirt;i++)
					   if (PA_3DSpriteTouched(i))	break;
					if(i==numberOfDirt+1){
						numberOfDirt++;
						PA_3DCreateSpriteFromTex(numberOfDirt,dirt,16,16,1,Stylus.X, Stylus.Y); 
						PA_3DSetSpriteWidthHeight(numberOfDirt,PA_RandMax(16),PA_RandMax(16));
					}			
			
					distanceCounter=0;
				}   
			   for (i=1;i<=numberOfDirt;i++)
				   if (PA_3DSpriteTouched(i))
				   {
						PA_3DSetSpriteXY(i,Stylus.X, Stylus.Y); 
						PA_3DSetSpriteRotate(numberOfDirt,PA_GetAngle(oldStylusX,oldStylusY,Stylus.X,Stylus.Y));
					}			
//				pa_3dsprites[numberOfDirt].Height++;
//				pa_3dsprites[numberOfDirt].Width++;
			}   
	   	oldStylusX = Stylus.X;
	   	oldStylusY = Stylus.Y;
		}  	

		if (Pad.Newpress.Right)
			PA_16cErase(0);

		PA_3DProcess();  // Update sprites

		Soul_waitForVBL();
		if (FadeTransition<=0)
		if (Pad.Newpress.B)
			FadeTransition=31;
	}


	

} // End of main()*/
