#include <PA9.h>
 
#include "16bit.h"
struct CanvasInfo
{
   u16 X1;
   u16 Y1;
   u16 X2;
   u16 Y2;
   float thickness;
   float alpha;
   int color;
   bool screen; 
} drawCanvas;

float Float_abs(float i)
{
   if (i >0)
   return i;
   else
   return i*-1;
}   

void putPixelAlpha_16bit(u8 screen, s16 x, s16 y, u16 color, float alpha) {
//   drawCanvas.X1 = 0;
//   drawCanvas.X2 = 256;
   if (!(x>=drawCanvas.X1 && x<=drawCanvas.X2)) return;
   if (!(y>=drawCanvas.Y1 && y<=drawCanvas.Y2)) return;
   int r = getRed(color) - getRed(PA_DrawBg[screen][x + (y << 8)]);
   r = r * alpha;
   r += getRed(PA_DrawBg[screen][x + (y << 8)]);
   
   int g = getGreen(color) - getGreen(PA_DrawBg[screen][x + (y << 8)]);
   g = g * alpha;
   g += getGreen(PA_DrawBg[screen][x + (y << 8)]);
   
   int b = getBlue(color) - getBlue(PA_DrawBg[screen][x + (y << 8)]);
   b = b * alpha;
   b += getBlue(PA_DrawBg[screen][x + (y << 8)]);
   
	PA_DrawBg[screen][x + (y << 8)] = PA_RGB(r,g,b);
}
void draw16cBox(u8 screen, s16 x, s16 y, s16 x2, s16 y2, u16 color, float alpha)
{
   int i1,i2;
   for (i1=x;i1<=x2;i1++)
	   for (i2=y;i2<=y2;i2++)
		   putPixelAlpha_16bit(screen, i1, i2, color, alpha);
}   
void putCircleAlpha_16bit(int screen, int xCenter, int yCenter, float thickness, int color, float alpha)
{
	int x = 0;
	float radius = thickness;
	int y = radius;
	int p = (3 - 2) * radius;
	int i;
	   while (x <= y){
	      for (i=xCenter - x;i<=xCenter + x;i++)
		      putPixelAlpha_16bit(screen, i, yCenter + y, color,alpha);
	      for (i=xCenter - x;i<=xCenter + x;i++)
		      putPixelAlpha_16bit(screen, i, yCenter - y, color,alpha);
	
	      for (i=xCenter - y;i<=xCenter+ y;i++)
		      putPixelAlpha_16bit(screen, i, yCenter + x, color,alpha);
	
	      for (i=xCenter - y;i<=xCenter + y;i++)
		      putPixelAlpha_16bit(screen, i, yCenter - x, color,alpha);
	
	      if (p < 0) p += 4 * x++ + 6;
	      else p += 4 * (x++ - y--) + 10;
	   }

}   
void WuLine(int screen, float x1, float y1, float x2, float y2, int color,float alpha,float thickness) {
   if (alpha>1) alpha=1;
   if (thickness<=0) return;
   if (thickness!=1)
   {
		int x = 0;
		float radius = thickness;
		int y = radius;
		int p = 3 - 2 * radius;
		int i;
		   while (x <= y){
		      for (i=0 - x;i<=0 + x;i++)
		      	WuLine(screen, x1+i, y1 + y, x2+i, y2 + y, color,alpha,1);
//			      PA_16cPutPixel(screen, i, yCenter + y, color);
		
		      for (i=0 - x;i<=0 + x;i++)
		      	WuLine(screen, x1+i, y1 - y, x2+i, y2 - y, color,alpha,1);
//			      PA_16cPutPixel(screen, i, 0 - y, color);
		
		      for (i=0 - y;i<=0+ y;i++)
		      	WuLine(screen, x1+i, y1 + x, x2+i, y2 + x, color,alpha,1);
//			      PA_16cPutPixel(screen, i, yCenter + x, color);
		
		      for (i=0 - y;i<=0 + y;i++)
		      	WuLine(screen, x1+i, y1 - x, x2+i, y2 - x, color,alpha,1);
//			      PA_16cPutPixel(screen, i, yCenter - x, color);
		
		      if (p < 0) p += 4 * x++ + 6;
		      else p += 4 * (x++ - y--) + 10;
		   }

      return;
   }   
	float xd, yd, grad, b1, b2, yf;
	int ix1, ix2, iy1, iy2, y;

	
	int tmp, x;
	float ftmp;
	
	xd=x2-x1;
	yd=y2-y1;
	
	if(Float_abs(xd) >= Float_abs(yd)) {
		if(x1>x2) {
			ftmp=x1; x1=x2; x2=ftmp;
			ftmp=y1; y1=y2; y2=ftmp;
			
			xd=x2-x1; yd=y2-y1;
		}
		
		yf = y1;
		
		grad=yd/xd;
		ix1=(int)(x1);
		ix2=(int)(x2);

		for(x=ix1; x<=ix2; x++) {
			b2=yf-(0.0f+(int)(yf));
			b1=1.0f-b2;
			
			tmp=(int)(yf);


			putPixelAlpha_16bit(screen, x, tmp, color,b1*alpha);
			putPixelAlpha_16bit(screen, x, tmp+1, color,b2*alpha);
			
			yf+=grad;
		}
	} else {
	
		if(y1>y2) {
			ftmp=x1; x1=x2; x2=ftmp;
			ftmp=y1; y1=y2; y2=ftmp;
			
			xd=x2-x1;
			yd=y2-y1;
		}
		
		yf=x1;
		grad=xd/yd;
		iy1=(int)(y1);
		iy2=(int)(y2);
		
		for(y=iy1; y<=iy2; y++) {
			b2 = yf-(0.0f+(int)(yf));
			b1 = 1.0f-b2;
			
			tmp=(int)(yf);

			putPixelAlpha_16bit(screen, tmp, y, color,b1*alpha);
			putPixelAlpha_16bit(screen, tmp+1, y, color,b2*alpha);
			
			yf+=grad;			
		}
	}
}
void setDrawColor(int color)
{
   drawCanvas.color = color;   
}	   
void setDrawAlpha(float alpha)
{
   drawCanvas.alpha = alpha;
}	   
void setDrawThickness(float thickness)
{
   drawCanvas.thickness = thickness;
}	   

int getDrawColor()
{
   return drawCanvas.color;
}	   
float getDrawAlpha()
{
   return drawCanvas.alpha;
}	   
float getDrawThickness()
{
   return drawCanvas.thickness;
}	   

void initDraw(bool screen, int x1, int y1, int x2, int y2)
{
   if (x1<0) x1=0;   if (x1>255) x1=255;   
   if (x2<0) x1=0;   if (x2>255) x2=255;   
   if (y1<0) y1=0;   if (y1>191) y1=191;   
   if (y2<0) y2=0;   if (y2>191) y2=191;   
   drawCanvas.X1 = x1;
	drawCanvas.Y1 = y1;
	drawCanvas.X2 = x2;
	drawCanvas.Y2 = y2;
	drawCanvas.screen =screen;
}   
void updateDraw()
{
	if (Stylus.Held){
//		Stylus.X;
//		Stylus.Y;


		if (!Stylus.Newpress) {
		  // PA_Draw16bitLineEx(screen, x, y, PA_oldx[screen], PA_oldy[screen], color, PA_drawsize[screen]);
		  if (Stylus.Pressure<3) Stylus.Pressure = 3;
//		  if (drawCanvas.thickness)
		  WuLine(drawCanvas.screen ,Stylus.X
		  									,Stylus.Y
											,PA_oldx[drawCanvas.screen]
											,PA_oldy[drawCanvas.screen]
											,drawCanvas.color
											,drawCanvas.alpha==-1?(3/(float)Stylus.Pressure):drawCanvas.alpha
											,drawCanvas.thickness==-1?((float)(3-Stylus.Pressure)/3.0)+3:drawCanvas.thickness);
		}
		
		PA_oldx[drawCanvas.screen] = Stylus.X; 
		PA_oldy[drawCanvas.screen] = Stylus.Y;
	}
}   
void drawLetterP(bool screen, int x, int y, int color, float alpha)
{
		putPixelAlpha_16bit(screen,0+x,0+y,color,alpha);
		putPixelAlpha_16bit(screen,1+x,0+y,color,alpha);
		putPixelAlpha_16bit(screen,2+x,0+y,color,alpha);
		putPixelAlpha_16bit(screen,3+x,0+y,color,alpha);
		putPixelAlpha_16bit(screen,4+x,0+y,color,alpha);
		putPixelAlpha_16bit(screen,5+x,0+y,color,alpha);
		
		putPixelAlpha_16bit(screen,0+x,1+y,color,alpha);
		putPixelAlpha_16bit(screen,1+x,1+y,color,alpha);
		putPixelAlpha_16bit(screen,2+x,1+y,color,alpha);
		putPixelAlpha_16bit(screen,3+x,1+y,color,alpha);
		putPixelAlpha_16bit(screen,4+x,1+y,color,alpha);
		putPixelAlpha_16bit(screen,5+x,1+y,color,alpha);
		putPixelAlpha_16bit(screen,6+x,1+y,color,alpha);
		
		putPixelAlpha_16bit(screen,0+x,2+y,color,alpha);
		putPixelAlpha_16bit(screen,1+x,2+y,color,alpha);
		putPixelAlpha_16bit(screen,5+x,2+y,color,alpha);
		putPixelAlpha_16bit(screen,6+x,2+y,color,alpha);
		
		putPixelAlpha_16bit(screen,0+x,3+y,color,alpha);
		putPixelAlpha_16bit(screen,1+x,3+y,color,alpha);
		putPixelAlpha_16bit(screen,5+x,3+y,color,alpha);
		putPixelAlpha_16bit(screen,6+x,3+y,color,alpha);
		
		putPixelAlpha_16bit(screen,0+x,4+y,color,alpha);
		putPixelAlpha_16bit(screen,1+x,4+y,color,alpha);
		putPixelAlpha_16bit(screen,2+x,4+y,color,alpha);
		putPixelAlpha_16bit(screen,3+x,4+y,color,alpha);
		putPixelAlpha_16bit(screen,4+x,4+y,color,alpha);
		putPixelAlpha_16bit(screen,5+x,4+y,color,alpha);
		putPixelAlpha_16bit(screen,6+x,4+y,color,alpha);
		
		putPixelAlpha_16bit(screen,0+x,5+y,color,alpha);
		putPixelAlpha_16bit(screen,1+x,5+y,color,alpha);
		putPixelAlpha_16bit(screen,2+x,5+y,color,alpha);
		putPixelAlpha_16bit(screen,3+x,5+y,color,alpha);
		putPixelAlpha_16bit(screen,4+x,5+y,color,alpha); 
		putPixelAlpha_16bit(screen,5+x,5+y,color,alpha);
		
		putPixelAlpha_16bit(screen,0+x,6+y,color,alpha);
		putPixelAlpha_16bit(screen,1+x,6+y,color,alpha);
		
		putPixelAlpha_16bit(screen,0+x,7+y,color,alpha);
		putPixelAlpha_16bit(screen,1+x,7+y,color,alpha);
		
		putPixelAlpha_16bit(screen,0+x,8+y,color,alpha);
		putPixelAlpha_16bit(screen,1+x,8+y,color,alpha);
		
		putPixelAlpha_16bit(screen,0+x,9+y,color,alpha);
		putPixelAlpha_16bit(screen,1+x,9+y,color,alpha);
}		
