#include <PA9.h>
#include "../../misc/debug.h"
extern FILE* imgFile;

#define SHRINKEDCANVAS_WIDTH 204
#define SHRINKEDCANVAS_HEIGHT 154
char imgbuffer[256*1024];
u32 fileToBuffer(FILE * handle)
{
	fseek (handle, 0 , SEEK_END);
	u32 imgSize = ftell (handle);
	rewind (handle);
//	memcpy(	imgbuffer, 0, 256*1024);	   	   
	fread (imgbuffer, 1, imgSize, handle);	

	return imgSize;
}	

void shrinked_LoadBmpToBuffer(u16 *Buffer, s16 x, s16 y, void *bmp){

	u8 *temp = (u8*)bmp;
	BMPHeader0 *Bmpinfo0 = (BMPHeader0 *) (temp);
	BMP_Headers *Bmpinfo = (BMP_Headers*)(temp+14);
	
//	u8 *gfx = temp+54;
  u32 start = Bmpinfo0->ImageStart1 + ((Bmpinfo0->ImageStart2)<<16);
	u8 *gfx = temp+start;
	u16 *gfx2 = (u16*)(temp+start);
//	u16 *gfx2 = (u16*)(temp+54); // Pour le mode 16 bit...
	s32 r, g, b;  s16 tempx, tempy;
	s16 lx = Bmpinfo->Width;   s16 ly = Bmpinfo->Height;
	u16 Bits = Bmpinfo->BitsperPixel;
	x--;
	//Buffer = (u16*)(Buffer + ((x + (y*SWidth)) << 1)); // Position de dpart
	s32 i = 0;
	if (Bits > 16){ // Pour 24 et 32 bits
		for (tempy = ly-1; tempy > -1; tempy--){
			for (tempx = 0; tempx < lx; tempx++){
				b = (gfx[i] >> 3)&31;	i++;
				g = (gfx[i] >> 3)&31;	i++;
				r = (gfx[i] >> 3)&31;	i++;	
				if (Bits == 32) i++; // On passe le bit alpha
				//PA_Put16bitPixel(screen, x + tempx, y + tempy, PA_RGB(r, g, b));
				if ((x + tempx) >=26 && (x + tempx)<=26+SHRINKEDCANVAS_WIDTH && (y + tempy) >= 4  && (y + tempy) <= 10+SHRINKEDCANVAS_HEIGHT)
				Buffer[x + tempx + ((y + tempy) * 256)] = PA_RGB(r, g, b);
			}
			while(i&3) i++; // Padding....
		}
	}
	else if (Bits == 16){
		for (tempy = ly-1; tempy > -1; tempy--){
			for (tempx = 0; tempx < lx; tempx++){
				b = *gfx2&31;
				g = (*gfx2>>5)&31;
				r = (*gfx2>>10)&31;		
				//PA_Put16bitPixel(screen, x + tempx, y + tempy, PA_RGB(r, g, b));
				if ((x + tempx) >=26 && (x + tempx)<=26+SHRINKEDCANVAS_WIDTH && (y + tempy) >= 4  && (y + tempy) <= 10+SHRINKEDCANVAS_HEIGHT)
				Buffer[x + tempx + ((y + tempy) * 256)] = PA_RGB(r, g, b);
				gfx2++; // On passe au pixel suivant
			}
			s32 temp = (s32)gfx2;
			while(temp&3) temp++; // Padding....
			gfx2 = (u16*)temp;
		}	
	}
	if (Bits == 8) {
		// look for palette data if present //
		u8 *colormap = temp+14+Bmpinfo->SizeofHeader;
		u16 palette[256];
    s32 colors;
    if (Bmpinfo->NColors != 0) {
      colors = Bmpinfo->NColors & 0xff;
    } else {
      colors = 256;
    }
		for(i = 0; i < colors; i++) {
			b = ((colormap[(i<<2)+0])>>3)&31;
			g = ((colormap[(i<<2)+1])>>3)&31;
			r = ((colormap[(i<<2)+2])>>3)&31;
			palette[i] = PA_RGB(r, g, b);
		}
    i = 0;
		for (tempy = ly-1; tempy > -1; tempy--){
			for (tempx = 0; tempx < lx; tempx++){
				if ((x + tempx) >=26 && (x + tempx)<=26+SHRINKEDCANVAS_WIDTH && (y + tempy) >= 4  && (y + tempy) <= 10+SHRINKEDCANVAS_HEIGHT)
				Buffer[x + tempx + ((y + tempy) * 256)] =  palette[gfx[i]];
				i++;
			}
		}
	}
}


bool loadShrinkedFatBgBmp(bool screen, FILE* filename)
{
	if(filename)
	{ 
		u32 imgSize = fileToBuffer(filename);
		rewind(filename);
		fseek(filename, 18, SEEK_SET);
		u32 bmp_width2; u32 bmp_height2;
		fread(&bmp_width2, 4, 1, filename);	
		fseek(filename, 22, SEEK_SET);
		fread(&bmp_height2, 4, 1, filename);	
		
		shrinked_LoadBmpToBuffer(PA_DrawBg[screen],(27+102)-(bmp_width2/2),87-(bmp_height2/2), (void *)imgbuffer);

//		fclose (imgFile);
		return 1;
	}
	else
   {
//		fclose (imgFile);
		return 0;
	}		
	
}  
bool loadFatBgBmp(bool screen, FILE* filename)
{
      debugTxt("loadFatBgBmp");
	if(filename)
	{ 
		u32 imgSize = fileToBuffer(filename);
      debugTxt("get all");	
		rewind(filename);
		fseek(filename, 18, SEEK_SET);
		u32 bmp_width2; u32 bmp_height2;
		fread(&bmp_width2, 4, 1, filename);	
		fseek(filename, 22, SEEK_SET);
		fread(&bmp_height2, 4, 1, filename);	
      debugTxt("loadbmpex");			
		PA_LoadBmpEx(screen, 128-(bmp_width2/2),96-(bmp_height2/2),(void *)imgbuffer); 
//		fclose (imgFile);
		return 1;
	}
	else
   {
//		fclose (imgFile);
		return 0;
	}		
	
}  

bool loadFatBgBmpXY(bool screen, FILE* filename, int x, int y)
{
	if(filename)
	{ 
		fileToBuffer(filename);
		PA_LoadBmpEx(screen, x,y,(void *)imgbuffer); 

		return 1;
	}
	else
   {
//		fclose (imgFile);
		return 0;
	}		
	
}  

bool loadFatBg16bit(bool screen, char* path)
{
   initDebugTxt();
   debugTxt("loadFatBg16bit");
   int i=strlen(path);
   if  (path[i-3] == '.' &&
		 (path[i-2] == 'B' || path[i-2] == 'b') &&
		 (path[i-1] == 'B' || path[i-1] == 'm') &&
		 (path[i-0] == 'M' || path[i-0] == 'p'))
	{
   debugTxt("bmp");	   
	   loadBMPWithPath(screen,path);
	}
	else   
	{
   debugTxt("jpg");
	   loadJPEGWithPath(screen,path);
	}   
}   
bool loadFatBgJpeg(bool screen, FILE* filename)
{
//	return 0;   	
//   imgFile = fopen (filename, "rb"); //rb = read
   debugTxt("loadFatBgJpeg");
	if(filename)
	{
	   fileToBuffer(filename);
		PA_LoadJpeg(screen, (void *)imgbuffer); 
		return 1;
	}
	else
   {
//		fclose (imgFile);
		return 0;
	}		
	
}  
void loadJPEGWithPath(bool screen,char* path)
{
   debugTxt("loadJPEGWithPath");
   debugTxt(path);
	FILE* image = fopen (path, "rb"); 
	loadFatBgJpeg(screen, image);
	fclose(image);
} 
void loadBMPWithPath(bool screen,char* path)
{
	FILE* image = fopen (path, "rb"); 
	loadFatBgBmp(screen, image);
	fclose(image);
} 
void loadBMPWithPathXY(bool screen,int x,int y,char* path)
{
	FILE* image = fopen (path, "rb"); 
	loadFatBgBmpXY(screen, image,x,y);
	fclose(image);
} 
void loadBMPWithResource(bool screen,int x,int y,char* themepath)
{
	char* path = returnThemeResourcePath(themepath, 1);
	if (path!=NULL)
	{
		loadBMPWithPathXY(screen, x,y,path);
		free(path);
	}		
} 
char* FAT_loadGIF(char *filename)
{
   //return 0;
	  
   	imgFile = fopen (filename, "rb"); //rb = read
	
	if(imgFile)
	{ // Make sure there is a file to load
		// obtain file size:
		
		fseek (imgFile, 0 , SEEK_END);
		u32 imgSize = ftell (imgFile);
		rewind (imgFile);
	
		// allocate memory to store the image file
		char * buffer;
		buffer = (char*) malloc (sizeof(char)*imgSize);
		fread (buffer, 1, imgSize, imgFile);
	
		// close the file
		
//		PA_LoadGif(screen, (void *)buffer); // Show GIF on top screen
//chdir("..");
		fclose (imgFile);
		return buffer;
	}
	else

   {
		PA_Init16cBg(1, 1);
	   ShowDialogBox(1, 0, 1,"%s \n Gif could not be found",filename); Soul_waitForVBL();
		fclose (imgFile);
		return 0;
	}		
	
}  
