#include <PA9.h>

extern const unsigned short blackarialAA12_Pal[8] __attribute__ ((aligned (4)));
unsigned short pal_16c[16] __attribute__ ((aligned (4)));
unsigned short pal_16c2[16] __attribute__ ((aligned (4)));

s8 bg_16c[2];
bool active3d=0;
bool is3dActive() {return active3d ==1;}
void restart3d() {active3d=0;}
void init3d()
{
   if (!is3dActive())
   {
      active3d=1;
	   PA_Init3D();
	   PA_Reset3DSprites();
	}   
}   
s8 get16cBg(bool screen)
{
   return bg_16c[screen];
}
bool is16cActive(bool screen)
{
   return bg_16c[screen]!=-1;
}   
void restart16cBg(bool screen)
{
   bg_16c[screen]=-1;
}
void init16cBg(bool screen, u8 bg)
{
   if (get16cBg(screen)!=bg)
   {
		PA_Init16cBg(screen,bg);
		bg_16c[screen]=bg;
	}		
}	
void Load16cBMPtoBG(bool screen, void *bmp,int pos_x, int pos_y)
{
   Load16cBMPtoBGPal(screen, bmp,pos_x, pos_y,pal_16c);
}   
void Load16cBMPtoBG2(bool screen, void *bmp,int pos_x, int pos_y)
{
   Load16cBMPtoBGPal(screen, bmp,pos_x, pos_y,pal_16c2);
}   
void Load16cBMPtoBGPal(bool screen, void *bmp,int pos_x, int pos_y, unsigned short *array16c)
{
		int bmp_height;
	int bmp_width;	
	int temp=0; 
	int temp1=0; 
	int i=0;
	u16 zero = 0;
	u8 *tempbmp = (u8*)bmp;
	BMPHeader0 *Bmpinfo0 = (BMPHeader0 *) (tempbmp);
	BMP_Headers *Bmpinfo = (BMP_Headers*)(tempbmp+14);

	u8 *gfx = tempbmp+(Bmpinfo0->ImageStart1 + ((Bmpinfo0->ImageStart2)<<16));

	bmp_width = Bmpinfo->Width; 
	bmp_height = Bmpinfo->Height;
	
	u8 *colormap = tempbmp+14+Bmpinfo->SizeofHeader;

	DMA_Force(zero, array16c, (16)>>1, DMA_16NOW); // Blank out

	int magenta=-10; 
 	u16 colors = Bmpinfo->ImportantColors;
	i = 0;


	for(temp=0; temp<colors; temp++)
	{
		if(temp==16) break;
		if(PA_RGB(((colormap[(temp<<2)+2])>>3)&31, ((colormap[(temp<<2)+1])>>3)&31, ((colormap[(temp<<2)+0])>>3)&31)==PA_RGB(31,0,31))
		{
		   magenta=15-temp;
		}   
		else
		if(temp==15 && magenta!=-10	)
		{
			array16c[15-magenta]= PA_RGB(((colormap[(temp<<2)+2])>>3)&31, ((colormap[(temp<<2)+1])>>3)&31, ((colormap[(temp<<2)+0])>>3)&31);		   
		}   
		else
			array16c[15-temp]= PA_RGB(((colormap[(temp<<2)+2])>>3)&31, ((colormap[(temp<<2)+1])>>3)&31, ((colormap[(temp<<2)+0])>>3)&31);
	}   
	PA_LoadPal16c(screen? PAL_BG1 : PAL_BG0, (void*)array16c);
	//PA_WaitForVBL();	
	flushToMemory();
	for(temp=bmp_height-1; temp>=0; temp--)
		for(temp1=0; temp1<bmp_width; temp1++)
		{ 
			if (PA_16cGetPixel(screen,pos_x+temp1,pos_y+(bmp_height-temp)-1 )==0 && 15-((u32)(gfx[(temp*bmp_width)+temp1]))!=magenta)
				PA_16cPutPixel(screen,pos_x+temp1,pos_y+(bmp_height-temp)-1,
					15-((u32)(gfx[(temp*bmp_width)+temp1]))==0?
						15-magenta
					:
						15-((u32)(gfx[(temp*bmp_width)+temp1]))
					);
		}
}
int testcounter=0;
int temptext=0;
	unsigned short pal_temp[16] __attribute__ ((aligned (4)));   
	extern bool allowbootupfinish;
	extern bool bootupFadeIn;
void VBL_LoadingScreen()
{


   int i=0;
   int r,g,b,x;
   if (PA_VBLCounter[1]!=testcounter)
   {
      testcounter=PA_VBLCounter[1];
      if (bootupFadeIn)
      x=temptext;
      else
      x=(31-temptext);
      temptext++;
      if (temptext>31 || !bootupFadeIn)
      {
         temptext=0;
         if (bootupFadeIn)
	         allowbootupfinish=1;
         PA_VBLFunctionReset();
         return;
      }   

	   for (i=0;i<16;i++)
	   {
	      r=getRed(pal_16c[i])+x;
			g=getGreen(pal_16c[i])+x;
			b=getBlue(pal_16c[i])+x;
	      if (r>31)r=31; if (g>31)g=31; if (b>31)b=31;
	      if (r<0)r=0;   if (g<0) g=0;  if (b<0)b=0;
	      pal_temp[i]=PA_RGB(	(u8)r,
	      						(u8)g,
	      						(u8)b);
	   }   
	   PA_LoadPal16c(1? PAL_BG1 : PAL_BG0, (void*)pal_temp);

	   for (i=0;i<16;i++)
	   {

	      r=getRed(pal_16c2[i])+x;
			g=getGreen(pal_16c2[i])+x;
			b=getBlue(pal_16c2[i])+x;
	      if (r>31)r=31; if (g>31)g=31; if (b>31)b=31;
	      if (r<0)r=0;   if (g<0) g=0;  if (b<0)b=0;

	      pal_temp[i]=PA_RGB(	(u8)r,
	      						(u8)g,
	      						(u8)b);
	   }   
	   PA_LoadPal16c(0? PAL_BG1 : PAL_BG0, (void*)pal_temp);

	}   
}   

extern char imgbuffer[256*1024];
bool load16cBMPWithPathXY(bool screen,int x,int y,char* path)
{
	FILE* filename = fopen (path, "rb"); 

	if(filename)
	{ 

		fileToBuffer(filename);
		Load16cBMPtoBG(screen, (void *)imgbuffer,x,y);
		fclose (filename);
		return 1;
	}
	else
   {
//		fclose (imgFile);
		return 0;
	}		
	fclose(filename);
} 
void load16cBMPWithResource(bool screen,int x,int y,char* themepath)
{
	char* path = returnThemeResourcePath(themepath, 1);
	if (path!=NULL)
	{
	
		load16cBMPWithPathXY(screen, x,y,path);
		free(path);
	}		
} 
void Draw16cLine(u8 screen, u16 x1, u16 y1, u16 x2, u16 y2, u16 color)
{
  int i,dx,dy,sdx,sdy,dxabs,dyabs,x,y,px,py;

  dx=x2-x1;      /* the horizontal distance of the line */
  dy=y2-y1;      /* the vertical distance of the line */
  dxabs = dx;
  sdx = 1;
  if (dx < 0) {
	  dxabs = -dx;
	  sdx = -1;
  }
  dyabs = dy;
  sdy = 1;
  if (dy < 0) {
	  dyabs = -dy;
	  sdy = -1;
  }

  x=dyabs>>1;
  y=dxabs>>1;
  px=x1;
  py=y1;
  
PA_16cPutPixel(screen, px, py, color);


  if (dxabs>=dyabs) {
    for(i=0;i<dxabs;i++)  {
      y+=dyabs;
      if (y>=dxabs)  {
        y-=dxabs;
        py+=sdy;
      }
      px+=sdx;
      PA_16cPutPixel(screen, px, py, color);
    }
  }
  else {
    for(i=0;i<dyabs;i++) {
      x+=dxabs;
      if (x>=dyabs)  {
        x-=dyabs;
        px+=sdx;
      }
      py+=sdy;
      PA_16cPutPixel(screen, px, py, color);
    }
  }
}
void Delete16cLine(u8 screen, u16 x1, u16 y1, u16 x2, u16 y2)
{
  int i,dx,dy,sdx,sdy,dxabs,dyabs,x,y,px,py;

  dx=x2-x1;      /* the horizontal distance of the line */
  dy=y2-y1;      /* the vertical distance of the line */
  dxabs = dx;
  sdx = 1;
  if (dx < 0) {
	  dxabs = -dx;
	  sdx = -1;
  }
  dyabs = dy;
  sdy = 1;
  if (dy < 0) {
	  dyabs = -dy;
	  sdy = -1;
  }

  x=dyabs>>1;
  y=dxabs>>1;
  px=x1;
  py=y1;
  
PA_16cDeletePixel(screen, px, py);


  if (dxabs>=dyabs) {
    for(i=0;i<dxabs;i++)  {
      y+=dyabs;
      if (y>=dxabs)  {
        y-=dxabs;
        py+=sdy;
      }
      px+=sdx;
      PA_16cDeletePixel(screen, px, py);
    }
  }
  else {
    for(i=0;i<dyabs;i++) {
      x+=dxabs;
      if (x>=dyabs)  {
        x-=dyabs;
        px+=sdx;
      }
      py+=sdy;
      PA_16cDeletePixel(screen, px, py);
    }
  }
}

void fillScreen16c(bool screen,int color)
{
   int x, y;
   PA_16cErase(screen);
   for (x=0;x<256;x++)
   for (y=0;y<192;y++)   
   	PA_16cPutPixel(screen,x,y,color);
}   

void LoadDefault16c(bool screen)
{
   u8 npalette = 0;
	PA_SetBgPalCol(screen, (npalette<<4)+1, PA_RGB(31, 31, 31));
	PA_SetBgPalCol(screen, (npalette<<4)+2, PA_RGB(31, 0, 0));
	PA_SetBgPalCol(screen, (npalette<<4)+3, PA_RGB(0, 31, 0));
	PA_SetBgPalCol(screen, (npalette<<4)+4, PA_RGB(0, 0, 31));
	PA_SetBgPalCol(screen, (npalette<<4)+5, PA_RGB(31, 0, 31));
	PA_SetBgPalCol(screen, (npalette<<4)+6, PA_RGB(0, 31, 31));
	PA_SetBgPalCol(screen, (npalette<<4)+7, PA_RGB(31, 31, 0));
	PA_SetBgPalCol(screen, (npalette<<4)+8, PA_RGB(25, 25, 25));
	PA_SetBgPalCol(screen, (npalette<<4)+9, PA_RGB(20, 20, 20));
	PA_SetBgPalCol(screen, (npalette<<4)+10, PA_RGB(0, 0, 0));
}	


