#include <PA9.h>       // Include for PA_Lib
#include "shunt.h"
#include "ambience.h"
#include "../../engine/sprite/bmp3DSprite.h"
#include "../../misc/misc.h"
#include "../../misc/debug.h"
#include "../../misc/fat.h"
extern char CurrentTheme[256];
char equation[20][MAX_AMBIENCEPROPERTIES][MAX_EQUATIONLENGTH];
int ambienceTex[MAX_AMBIENCETEX];
u16 ambienceTexWidth[MAX_AMBIENCETEX];
u16 ambienceTexHeight[MAX_AMBIENCETEX];
u8  ambienceTex_Amount=0;
bool ambienceIsHidden=0;   

u32 timer_counter=0;
int ambienceSpriteStart=0;
void loadAmbienceScript(char* filename)
{
	char charTemp[256];
	FILE* testRead = fopen (filename, "rb");  
	if(testRead)
	{
	   fgets(charTemp, 256, testRead);
	   if (PA_CompareText(charTemp,"Ambience Script v.01"))
	   {
	      int x,i;
	      memset(equation,0,sizeof(equation));
			for (x=0;x<MAX_AMBIENCE;x++)
			for (i=0;i<MAX_AMBIENCEPROPERTIES;i++)
			{
			   PA_3DSetSpritePolyID(x, 30+x);
		   	fgets(equation[x][i], MAX_EQUATIONLENGTH, testRead);
			   if (equation[x][i][strlen(equation[x][i])-1]=='\n')
				equation[x][i][strlen(equation[x][i])-1]='\0';
	
			}   
		}			
	}			
	else
	{
		ShowDialogBox(1, 0,1,"%s \nScript cannot be found",filename);
	}		
	fclose(testRead);   
}   


void updateProperty(int i, int sprite,int property)
{
 
	switch (property)
	{
	   case 0: if (!isSyntaxError()) 
						pa_3dsprites[sprite].X= i; 
					else
	   		  	 pa_3dsprites[sprite].X = 0;
				  return;
		case 1: if (!isSyntaxError()) 
						pa_3dsprites[sprite].Y= i; 
					else
				  	 pa_3dsprites[sprite].Y = 0;
				  return;
		case 2: if (!isSyntaxError()) 
						pa_3dsprites[sprite].Width= i; 
					else
				  	 pa_3dsprites[sprite].Width = pa_3dsprites[sprite].ImgWidth;
				  return;
		case 3: if (!isSyntaxError()) 
						pa_3dsprites[sprite].Height= i; 
					else
				  	 pa_3dsprites[sprite].Height = pa_3dsprites[sprite].ImgHeight;
				  return;
		case 4: if (!isSyntaxError()) 
					{
						if (i>31) i=31;
						if (i<=0) 
						{
						   i=0;
						   PA_3DSetSpriteVisible(sprite,0);
						}   
						
						pa_3dsprites[sprite].alpha= i; 
					}			
					else
				  	 pa_3dsprites[sprite].alpha = 31;
				  return;
		case 5: if (!isSyntaxError()) 
						pa_3dsprites[sprite].RotZ= i; 
					else
				  	 pa_3dsprites[sprite].RotZ = 0;
				  return;

		case 6: if (!isSyntaxError()) 
						pa_3dsprites[sprite].RotX= i;
					else
				  	 pa_3dsprites[sprite].RotX = 0;
				  return;
		case 7: if (!isSyntaxError()) 
						pa_3dsprites[sprite].RotY= i; 
					else
				  	 pa_3dsprites[sprite].RotY = 0;
				  return;
		case 8: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[0].x= i; 
					else
				  	 pa_3dsprites[sprite].corner[0].x = 0;
				  return;
		case 9: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[0].y= i; 
					else
				  	 pa_3dsprites[sprite].corner[0].y = 0;
				  return;
		case 10: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[1].x= i; 
					else
				  	 pa_3dsprites[sprite].corner[1].x = 0;
				  return;
		case 11: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[1].y= i; 
					else
				   	 pa_3dsprites[sprite].corner[1].y = 0;
					return;
		case 12: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[2].x= i;
					else
				   	 pa_3dsprites[sprite].corner[2].x = 0;
					return;
		case 13: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[2].y= i; 
					else
				   	 pa_3dsprites[sprite].corner[2].y = 0;
					return;
		case 14: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[3].x= i; 
					else
				   	 pa_3dsprites[sprite].corner[3].x = 0;
					return;
		case 15: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[3].y= i; 
					else
						pa_3dsprites[sprite].corner[3].y = 0;
					return;
		case 16: if (!isSyntaxError()) 
					{
						if (i>=MAX_AMBIENCE) 
						{
						   i=PRIORITY_ONTOP;
//						   return;
						} 		
						if (i<=0) 
						{
						   i=0;
						}   
						pa_3dsprites[sprite].Priority= PRIORITY_AMBIENCESPRITE+i; 
					}			
					else
						pa_3dsprites[sprite].Priority= PRIORITY_AMBIENCESPRITE;
				  	return;
		case 17: if (!isSyntaxError()) 
					{
						if (i>=ambienceTex_Amount) i=ambienceTex_Amount-1;
						if (i<0) 
						{
						   i=0;
						}   
					}									
					else
					{
						i=0; 
					}			
					pa_3dsprites[sprite].textureID= ambienceTex[i]; 
					pa_3dsprites[sprite].ImgWidth=ambienceTexWidth[i];
					pa_3dsprites[sprite].ImgHeight=ambienceTexHeight[i];
					if(((textures[pa_3dsprites[sprite].textureID]>>26)&7) == TEX_4COL){
					   pa_3dsprites[sprite].palette = (MAX_PALLETE-i)<<1;
					}
					else{
					   pa_3dsprites[sprite].palette = (MAX_PALLETE-i); 
					}		   

				  	return;
	}
}   

void loadAmbienceTextures(char * path)
{ 

	ambienceTex_Amount=0;
	char charTemp[256];
   FILE* textureFile;  
   chdir(path);
	while(1)
	{
	   if (ambienceTex_Amount==MAX_AMBIENCETEX) break;   
		sprintf(charTemp,"tex_%02d.bmp",ambienceTex_Amount);

	   textureFile=fopen (charTemp, "rb");
	   if (textureFile)
		{
		   fclose(textureFile);
		 	ambienceTex[ambienceTex_Amount]=CreateTexFromFatBmp(charTemp,MAX_PALLETE-ambienceTex_Amount,1);
			ambienceTexWidth[ambienceTex_Amount]=getRecentBmpWidth();
			ambienceTexHeight[ambienceTex_Amount]=getRecentBmpHeight();
			ambienceTex_Amount++;
		}		
		else   
		{
		   fclose(textureFile);
		   break;
		}
//		fclose(textureFile);
	}
	chdir("fat:/");	
	if (ambienceTex_Amount==0)
	{
		ShowDialogBox(1,0,1,"No texture found in folder\n%s",path);
	   return;
	}		
}	   

void initAmbienceFromTheme(char* CurrentMenu,int spritestart)
{
	initDebugTxt();
debugTxt("Load ambience");   
   timer_counter=0;
   char varname[30];
   char charTemp[256];
debugTxt("1");   
   ambienceSpriteStart=spritestart;
   
	sprintf(charTemp,"fat:/_menudo/themes/%s/ambience/ambience.ini", CurrentTheme);
	readINI = fopen (charTemp, "rb"); 
debugTxt("2");   
	sprintf(varname,"%s_Folder",CurrentMenu);
	char* folderpath = (char *)readIniFileString(varname);
	bool usedefault=0;
	if (strcmp(CurrentMenu,"mWifi")==0 && folderpath[0]==0)
	{
	   usedefault=1;
		free(folderpath);   	   
		
		sprintf(charTemp,"fat:/_menudo/default/ambience/ambience.ini");
		readINI = fopen (charTemp, "rb"); 
		sprintf(varname,"%s_Folder",CurrentMenu);
		folderpath = (char *)readIniFileString(varname);
	}
debugTxt("4");   
	if (usedefault)
		sprintf(charTemp,"fat:/_menudo/default/ambience/%s",folderpath);
	else
		sprintf(charTemp,"fat:/_menudo/themes/%s/ambience/%s",CurrentTheme,folderpath);
	if (folderpath!=NULL) free(folderpath);   	
   
debugTxt("5");   
	char ambiencePath[strlen(charTemp)+100];
	sprintf(ambiencePath,"%s",charTemp);

	debugTxt("Loading Textures");
   loadAmbienceTextures(ambiencePath);
	
	sprintf(varname,"%s_Script",CurrentMenu);
	char * ambienceScript=readIniFileString(varname);
	sprintf(ambiencePath,"%s/%s",ambiencePath,ambienceScript);
	if (ambienceScript!=NULL) free (ambienceScript);

	fclose (readINI);
   loadAmbienceScript(ambiencePath);	

  	
  	
	PA_3DCreateSpriteFromTex(ambienceSpriteStart+0,ambienceTex[0],ambienceTexWidth[0],ambienceTexHeight[0],(MAX_PALLETE-0),0,0);
	PA_3DCreateSpriteFromTex(ambienceSpriteStart+1,ambienceTex[0],ambienceTexWidth[0],ambienceTexHeight[0],(MAX_PALLETE-0),0,0);
	PA_3DCreateSpriteFromTex(ambienceSpriteStart+2,ambienceTex[0],ambienceTexWidth[0],ambienceTexHeight[0],(MAX_PALLETE-0),0,0);
	PA_3DCreateSpriteFromTex(ambienceSpriteStart+3,ambienceTex[0],ambienceTexWidth[0],ambienceTexHeight[0],(MAX_PALLETE-0),0,0);

}	

void updateTimerCounter()
{
	timer_counter++;
	//So timer wouldnt go beyond 2000 so timer-int equations would be noticable
	if (timer_counter<0) timer_counter=0;
}	
int getTimerCounter()
{
   return timer_counter;
}   

void updateAmbience()
{
	if (!ambienceIsHidden)
	{
	   int x,i;
		for (x=0;x<MAX_AMBIENCE;x++) PA_3DSetSpriteVisible(ambienceSpriteStart+x,0);
		updateTimerCounter();
	
		for (i=0;i<MAX_AMBIENCEPROPERTIES;i++)
			for (x=0;x<MAX_AMBIENCE;x++)
			{
		   	updateProperty(readExpression(equation[x][i],0,0),x+ambienceSpriteStart,i);
			   if (!isSyntaxError() && pa_3dsprites[ambienceSpriteStart+x].alpha!=0) PA_3DSetSpriteVisible(ambienceSpriteStart+x,1);
			}  	
	}			
}   
void initAmbience(char* path, char* filename,int spritestart)
{

   timer_counter=0;
	char charTemp[256];
   ambienceSpriteStart=spritestart;
   sprintf(charTemp,"%s/%s",path,filename);
   loadAmbienceScript(charTemp);
   loadAmbienceTextures(path);
	PA_3DCreateSpriteFromTex(ambienceSpriteStart+0,ambienceTex[0],ambienceTexWidth[0],ambienceTexHeight[0],(MAX_PALLETE-0),0,0);
	PA_3DCreateSpriteFromTex(ambienceSpriteStart+1,ambienceTex[0],ambienceTexWidth[0],ambienceTexHeight[0],(MAX_PALLETE-0),0,0);
	PA_3DCreateSpriteFromTex(ambienceSpriteStart+2,ambienceTex[0],ambienceTexWidth[0],ambienceTexHeight[0],(MAX_PALLETE-0),0,0);
	PA_3DCreateSpriteFromTex(ambienceSpriteStart+3,ambienceTex[0],ambienceTexWidth[0],ambienceTexHeight[0],(MAX_PALLETE-0),0,0);
}

void hideAmbience()
{
	ambienceIsHidden = 1;
	int x;
	for (x=0;x<MAX_AMBIENCE;x++) PA_3DSetSpriteVisible(ambienceSpriteStart+x,0);
}   

void showAmbience()
{
	ambienceIsHidden = 0;
}   

void toggleAmbience()
{
   if (ambienceIsHidden)
   	showAmbience();
  	else
  		hideAmbience();
}   

