#include<PA9.h>
#include<stdlib.h>
#include<stdio.h>
#include<ctype.h>
int atoi ( const char * str );
#define MAXOPSTACK 64
#define MAXNUMSTACK 64

extern int timer_counter;
extern int gameSelect_counter;
extern int idleCounter;
extern s16 SelectMenu;
extern u16 fileAmount;
#define SCROLLVALUE_DESTINATION 128
unsigned char displayFrequency[6];//[DISPLAY_FREQUENCY_LIMIT];
unsigned char displayfallFrequency[6];//[DISPLAY_FREQUENCY_LIMIT];

bool syntaxError=0;
bool isSyntaxError()
{
   return syntaxError;
}   
int eval_abs(int a1, int a2) 
{
	if (a1<0)
		return -a1;
	else
		return a1;
}	
int randomStorage=0;
int eval_rand(int a1, int a2) 
{
   if (timer_counter % a2 ==0) randomStorage=PA_RandMax(a1);
	return randomStorage;
}

int eval_cos(int a1, int a2) 
{
	return PA_Cos(a1);
}
int eval_sin(int a1, int a2) 
{
	return PA_Sin(a1);
}	
int eval_bitshift_left(int a1, int a2) 
{
	return a1<<a2;
}	
int eval_bitshift_right(int a1, int a2) 
{
	return a1>>a2;
}	
int eval_max(int a1, int a2) 
{
	return a1 < a2? a1 : a2;
}	
int eval_min(int a1, int a2) 
{
	return a1 > a2? a1: a2;
}	
int eval_uminus(int a1, int a2) 
{
	return -a1;
}
int eval_exp(int a1, int a2)
{
	return a2<0 ? 0 : (a2==0?1:a1*eval_exp(a1, a2-1));
}
int eval_mul(int a1, int a2) 
{
	return a1*a2;
}
int eval_div(int a1, int a2) 
{
	if(!a2) {
	   syntaxError=1;
		return 0;//PA_Print(1, "ERROR: Division by zero\n");
	}
	return a1/a2;
}
int eval_mod(int a1, int a2) 
{
	if(!a2) {
	   syntaxError=1;
		return 0;//PA_Print(1, "ERROR: Division by zero\n");
	}
	return a1%a2;
}
int eval_add(int a1, int a2) 
{
	return a1+a2;
}
int eval_sub(int a1, int a2) 
{
	return a1-a2;
}



enum {ASSOC_NONE=0, ASSOC_LEFT, ASSOC_RIGHT};

struct op_s {
	char op;
	int prec;
	int assoc;
	bool unary;
	int (*eval)(int a1, int a2);
} ops[]={
	{'m', 11, ASSOC_LEFT, 0, eval_max},
	{'n', 11, ASSOC_LEFT, 0, eval_min},
	{'_', 10, ASSOC_RIGHT, 1, eval_uminus},
	{'c', 10, ASSOC_RIGHT, 1, eval_cos},
	{'s', 10, ASSOC_RIGHT, 1, eval_sin},
	{'a', 10, ASSOC_RIGHT, 1, eval_abs},
	{'r', 10, ASSOC_LEFT, 0, eval_rand},
	{'^', 9, ASSOC_RIGHT, 0, eval_exp},
	{'*', 8, ASSOC_LEFT, 0, eval_mul},
	{'/', 8, ASSOC_LEFT, 0, eval_div},
	{'%', 8, ASSOC_LEFT, 0, eval_mod},
	{'<', 6, ASSOC_LEFT, 0, eval_bitshift_left},
	{'>', 6, ASSOC_LEFT, 0, eval_bitshift_right},
	
	{'+', 5, ASSOC_LEFT, 0, eval_add},
	{'-', 5, ASSOC_LEFT, 0, eval_sub},
	{'(', 0, ASSOC_NONE, 0, NULL},
	{')', 0, ASSOC_NONE, 0, NULL}
};

struct op_s *getop(char ch)
{
	int i;
	for(i=0; i<sizeof ops/sizeof ops[0]; ++i) {
		if(ops[i].op==ch) return ops+i;
	}
	return NULL;
}


struct op_s *opstack[MAXOPSTACK];
int nopstack=0;

int numstack[MAXNUMSTACK];
int nnumstack=0;

void push_opstack(struct op_s *op)
{
	if(nopstack>MAXOPSTACK-1) {
	   syntaxError=1;
		return; //PA_Print(1, "ERROR: Operator stack overflow\n");
	}
	opstack[nopstack++]=op;
}

struct op_s *pop_opstack()
{
	if(!nopstack) {
	   syntaxError=1;
		return 0; //PA_Print(1, "ERROR: Operator stack overflow\n");
	}
	return opstack[--nopstack];
}

void push_numstack(int num)
{
	if(nnumstack>MAXNUMSTACK-1) {
		
	   syntaxError=1;
		return ; //PA_Print(1, "ERROR: Operator stack overflow\n");
	}
	numstack[nnumstack++]=num;
}

int pop_numstack()
{
	if(!nnumstack) {
	   syntaxError=1;
		return 0; //PA_Print(1, "ERROR: Operator stack overflow\n");
	}
	nnumstack--;
	return numstack[nnumstack];
	 
}



void shunt_op(struct op_s *op)
{
	struct op_s *pop;
	int n1, n2;

	if(op->op=='(') {
		push_opstack(op);
		return;

	} else if(op->op==')') {

		while(nopstack>0 && opstack[nopstack-1]->op!='(') {
			pop=pop_opstack();
			n1=pop_numstack();

			if(pop->unary) push_numstack(pop->eval(n1, 0));
			else {
				n2=pop_numstack();
			//if (numstackUsestimer_counter[1]) PA_Print(0, "x");   
				push_numstack(pop->eval(n2, n1));
			}

		}

		if(!(pop=pop_opstack()) || pop->op!='(') {
		   syntaxError=1;
			return; //PA_Print(1, "ERROR: Stack error. No matching \'(\'\n");
		}
		return;
	}

	if(op->assoc==ASSOC_RIGHT) {
	   
		while(nopstack && op->prec<opstack[nopstack-1]->prec) 
		{
			pop=pop_opstack();
			n1=pop_numstack();
			if(pop->unary) push_numstack(pop->eval(n1, 0));
			else {
				n2=pop_numstack();
				push_numstack(pop->eval(n2, n1));
			}
		}
//		PA_Print(0,"X");
	} else {
//		PA_Print(0,"y");
		while(nopstack && op->prec<=opstack[nopstack-1]->prec) {
			pop=pop_opstack();
			n1=pop_numstack();
			if(pop->unary) push_numstack(pop->eval(n1, 0));
			else {
				n2=pop_numstack();
				push_numstack(pop->eval(n2, n1));
			}
		}
	}
	push_opstack(op);
}

int n1, n2;

struct op_s startop;	/* Dummy operator to mark start */
struct op_s *op;
struct op_s *lastop;

int readExpression(char *argv, int selectGap, bool gameselect)
{
	
	if (strlen(argv)==0)
	{
		syntaxError=1;
		return 0;
	}		
	else
	{
		syntaxError=0;
	}		
	char *expr;
	char *tstart=NULL;
	struct op_s startop={'X', 0, ASSOC_NONE, 0, NULL};	

	int i;
	for (i=0;i<=nnumstack;i++)
	{
		numstack[i] = 0;
//		numstackUsestimer_counter[i] = 0;
	}			


	nopstack=0;
	nnumstack=0;



	for(expr=argv; *expr; ++expr) 
	{
		if (syntaxError) return -1;
		if(!tstart) 
		{
			if((op=getop(*expr))) 
			{
				if(lastop && (lastop==&startop || lastop->op!=')')) 
				{
					if(op->unary) 
					{ 
					   op=getop(op->op);
					}   
					else 
					if(op->op=='-') 
					{
					   op=getop('_');
					}   
					else 
					if(op->op!='(') 
					{
						//PA_Print(1, "ERROR: Illegal use of binary operator (%c)\n", op->op);
						syntaxError=1;
						return -1;
					}
				}

				shunt_op(op);

				if (syntaxError) return -1;
				lastop=op;
				continue;
			} 
			if(*expr == 'x' || *expr == 'k' || *expr == 'z')
			{
//				PA_Print(0,"x");
				tstart=expr;
			   continue;
			}
			   
			if(isdigit(*expr)) 
			{
			   tstart=expr;
			   //PA_Print(1,"%s\n",tstart);
			   continue;
			}   
			
			if(!isspace(*expr)) 
			{
			   //PA_Print(1,"1 ERROR: Syntax error\n");
			   syntaxError=1;
				return -1; 
			}
		} 
		else 
		{
			if(*tstart == 'x' && (*(tstart+1) >= '0' && *(tstart+1) <= '9')) 
			{
			   //exchange x<num> for a timer_counter

			   switch(*(tstart+1))
			   {
			      case '0': push_numstack(timer_counter);
			      			 break;
			      case '1': if ((SCROLLVALUE_DESTINATION*SelectMenu)+gameSelect_counter-selectGap==0 || !gameselect)
									push_numstack(idleCounter);
								 else
								 	push_numstack(0);
			      			 break;
			      case '2': push_numstack((SCROLLVALUE_DESTINATION*SelectMenu)+gameSelect_counter-selectGap);
			      			 break;
	      	}		 
				tstart=NULL;
				lastop=NULL;
			   continue;
			   
			}
			if(*tstart == 'k' && (*(tstart+1) >= '0' && *(tstart+1) <= '9')) 
			{
   
			   switch(*(tstart+1))
			   {
			      case '0': push_numstack(displayFrequency[0]);
			      			 break;
			      case '1': push_numstack(displayFrequency[1]);
			      			 break;
			      case '2': push_numstack(displayFrequency[2]);
			      			 break;
			      case '3': push_numstack(displayFrequency[3]);
			      			 break;
			      case '4': push_numstack(displayFrequency[4]);
			      			 break;
			      case '5': push_numstack(displayFrequency[5]);
			      			 break;
			      case '6': push_numstack((displayFrequency[0] + displayFrequency[1] + displayFrequency[2] + displayFrequency[3] + displayFrequency[4] + displayFrequency[5]) / 6);
			      			 break;
	      	}		 
				tstart=NULL;
				lastop=NULL;
			   continue;
			}
			if(*tstart == 'z' && (*(tstart+1) >= '0' && *(tstart+1) <= '9')) 
			{
			   switch(*(tstart+1))
			   {
			      case '0': push_numstack(displayfallFrequency[0]);
			      			 break;
			      case '1': push_numstack(displayfallFrequency[1]);
			      			 break;
			      case '2': push_numstack(displayfallFrequency[2]);
			      			 break;
			      case '3': push_numstack(displayfallFrequency[3]);
			      			 break;
			      case '4': push_numstack(displayfallFrequency[4]);
			      			 break;
			      case '5': push_numstack(displayfallFrequency[5]);
			      			 break;
			      case '6': push_numstack((displayfallFrequency[0] + displayfallFrequency[1] + displayfallFrequency[2] + displayfallFrequency[3] + displayfallFrequency[4] + displayfallFrequency[5]) / 6);
			      			 break;
	      	}		 
				tstart=NULL;
				lastop=NULL;
			   continue;
			}
			if(isspace(*expr)) 
			{
				push_numstack(atoi(tstart));
				tstart=NULL;
				lastop=NULL;
				continue;
			} 
			if((op=getop(*expr))) 
			{
				//PA_Print(1,"#%s\n",tstart);
				push_numstack(atoi(tstart));
				tstart=NULL;
				shunt_op(op);
				lastop=op;
				continue;
			} 
			if(!isdigit(*expr))
			{
			   syntaxError=1;
				return -1; ////PA_Print(1,"2 ERROR: Syntax error\n");
			}
		}
	}
	if (syntaxError) return -1;	
	if (tstart) push_numstack(atoi(tstart));
	if (syntaxError) return -1;

	int inttemp=0;
	while(nopstack) 
	{
   
		op=pop_opstack();
		if (op->eval ==NULL) syntaxError=1;
		if (syntaxError) return -1;
		n1=pop_numstack();
		if (syntaxError) return -1;
//		   sprintf(temp,"%c",op->op);
//		   PA_16cText(0,10*inttemp,180,200,180,temp,10,2,100);
		if(op->unary) 
		{
		      

			  inttemp++; 
		   push_numstack(op->eval(n1, 0));
		 	if (syntaxError) return -1;
		}   
		else 
		{
			n2=pop_numstack();
			if (syntaxError) return -1;
			
			push_numstack(op->eval(n2, n1));
			if (syntaxError) return -1;
		}

	}
	if(nnumstack!=1) {
	   syntaxError=1;      
		return -1;
	}
	if (syntaxError) 
		return -1;
	else
		syntaxError=0;
	return numstack[0];
}	
