/*
    DSCompress v1.0a
    Author: carpman <carpman@voidptr.org>
    http://voidptr.org

    Copyright 2007 Daniel Jackson

    This file is part of DSCompress.

    DSCompress is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    DSCOmpress is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <PA9.h>
#include <zlib.h>
#include <fat.h>
#include <sys/dir.h>

#include "linkedlist.h"

char *clearstr = "                                ";

typedef struct {
  int viewHeight;
  int yBegin;
  int currentPosition;
} suiTextList;

typedef struct {
  long maxvalue;
  long incriment;
  long value;
  int yBegin;
  int xBegin;
  char label[255];
} suiPercentProgress;

suiPercentProgress *suiNewPercentProgress(int x, int y, long maxvalue, long incriment, char *label){
  suiPercentProgress *newPercentProgress = malloc(sizeof(suiPercentProgress));

  newPercentProgress->yBegin = y;
  newPercentProgress->xBegin = x;
  newPercentProgress->maxvalue = maxvalue;
  newPercentProgress->incriment = incriment;
  newPercentProgress->value = 0;
  strcpy(newPercentProgress->label, label);

  return newPercentProgress;
}
int dsCompress(char *inputFilename, char *outputFilename){//, suiPercentProgress *progress){
  gzFile outFile = gzopen(outputFilename, "wb");
  FILE *inFile = fopen(inputFilename, "rb");
  char buffer[512];
  int readSize = 0;
  int err;

  while((readSize = fread(buffer, 1, sizeof(buffer), inFile)) > 0){
    /*advancePercentProgress(progress);
    drawPercentProgress(progress);*/
    if(gzwrite(outFile, buffer, (unsigned)readSize) != readSize){
      gzerror(outFile, &err);
      break;
    }
  }

  fclose(inFile);
  if(gzclose(outFile) == Z_OK){
    return Z_OK;
  }

  return err;
}
/*
int dsUncompress(char *inputFilename, char *outputFilename, suiPercentProgress *progress){
  gzFile inFile = gzopen(inputFilename, "rb");
  FILE *outFile = fopen(outputFilename, "wb");
  char *buffer[512];
  int writeSize = 0;

  while((writeSize = gzread(inFile, buffer, 512)) > 0){
    advancePercentProgress(progress);
    drawPercentProgress(progress);
    if(fwrite(buffer, 1, writeSize, outFile) != writeSize){
      return -1;
    }
  }

  gzclose(inFile);
  fclose(outFile);

  return 1;
}*/
/*
int main(int argc, char **argv){
 
  PA_Init();
  PA_InitVBL();

  PA_InitText(0, 0);
  PA_InitText(1, 0);

  fatInitDefault();
	  suiPercentProgress *compressionPercentage = suiNewPercentProgress(0, 4, st->st_size, 512, "Progress: ");
	  dsCompress("", "", compressionPercentage);
 
   return 0;
}*/
