#include <PA9.h>
#include "../../misc/misc.h"
#include "../../misc/transition.h"
#include "../engine.h"
#include "../../system/shrink.h"

#define refreshTextFull()																	  					\
			refreshText(screen, x1, y1,x2, y2,backdropColor, color,font,output,cursorOffset);\
		   textCursorX = PA_LetterPos.Letter[cursorOffset-1].X;						  				\
		   textCursorY = PA_LetterPos.Letter[cursorOffset-1].Y;						  				\
		   																						  					\
																													  \
			if (PA_LetterPos.Letter[cursorOffset].X == x1+5)											  \
			{																										  \
				textCursorX=x1;																				  \
				textCursorY=PA_LetterPos.Letter[cursorOffset].Y;									  \
			}																										  \
			else																									  \
			   textCursorX+=5;																				  \
			refreshKeyboardPreviewText(screen, output,cursorOffset);
bool endedWithEnter=0;
bool endedWithSave=0;

int cursorOffset=0;
char* output = NULL;

bool shrinkzoom=1;
void setKeyboardShrinkZoom(bool on)
{
   shrinkzoom=on;
}   
void setKeyboardWhiteBoardMode(bool i)
{
//   whiteBoardMode=i;
}   
void refreshText(bool screen, int x1, int y1,int x2, int y2, int backdropColor, int color,int font,char* text, int cursor)
{
   int temp1=0;
   int temp2=0;
	for (temp1=x1;temp1<x2;temp1++)
	   for (temp2=y1-2;temp2<y2+16;temp2++)
		   PA_16cDeletePixel(screen,temp1,temp2);         

		   
   PA_TextAlign(ALIGN_LEFT);
   display16cTextForKeyboard(screen,x1,y1,x2,y2,text,color,font,cursor);				   
   for (temp1=x1;temp1<x2;temp1++)
	   for (temp2=y1-2;temp2<y2+16;temp2++)
		   if(PA_16cGetPixel(screen,temp1,temp2)==0) PA_16cPutPixel(screen,temp1,temp2,backdropColor);

}
void refreshKeyboardPreviewText(bool screen, char* text, int cursor)
{
   int temp1=0;
   int temp2=0;
	for (temp1=0;temp1<160;temp1++)
	   for (temp2=6;temp2<6+76;temp2++)
		   PA_16cDeletePixel(!screen,temp1,temp2);         

   int colorBlack=PA_16cGetPixel(!screen,165,11);   
   int colorWhite=PA_16cGetPixel(!screen,181,6);   		   
   display16cTextForKeyboard(!screen,0,6,160,6+76,text,colorBlack,2,cursor);				   
	for (temp1=0;temp1<160;temp1++)
	   for (temp2=6;temp2<6+76;temp2++)
		   if(PA_16cGetPixel(!screen,temp1,temp2)==0) PA_16cPutPixel(!screen,temp1,temp2,colorWhite);

}
bool shiftOn=0;
bool capsLock=0;
u8 keyboardMode=0;
void update16cKeyboardDisplay(bool screen)
{
   PA_16cErase(!screen);
   switch(keyboardMode)
   {
	   case 0:	if (!(shiftOn || capsLock) || (shiftOn && capsLock))
					   load16cBMPWithResource(!screen,0,0,"keyboard/keyboard_lower.16c.bmp");
				   else
					   load16cBMPWithResource(!screen,0,0,"keyboard/keyboard_upper.16c.bmp");
					break;
	   case 1:	if (!(shiftOn || capsLock) || (shiftOn && capsLock))
					   load16cBMPWithResource(!screen,0,0,"keyboard/quong_lower.16c.bmp");
				   else
					   load16cBMPWithResource(!screen,0,0,"keyboard/quong_upper.16c.bmp");
					break;
	   case 2:	load16cBMPWithResource(!screen,0,0,"keyboard/graffiti.16c.bmp");
					break;
	}			
	refreshKeyboardPreviewText(screen,output,cursorOffset);
}	
void toggleCaps(bool screen)
{
   capsLock = !capsLock;
	update16cKeyboardDisplay(screen);
}   

void toggleShift(bool screen)
{
   shiftOn = !shiftOn;
	update16cKeyboardDisplay(screen);
}   


void toggleKeyboardMode(bool screen)
{
   keyboardMode++;
   if (keyboardMode>2)keyboardMode=0;
	update16cKeyboardDisplay(screen);
}   
void clearGraffiti(bool screen)
{
    screen = !screen; 
//   screen = 1-whiteBoardMode;
   int colorWhite=PA_16cGetPixel(screen,181,6);   
//   int colorBlack=PA_16cGetPixel(screen,165,11);
   int x,y;
   for (x=181;x<=181+75;x++)
   for (y=7;y<=7+74;y++)
   {
      PA_16cDeletePixel(screen,x,y);
	   PA_16cPutPixel(screen,x,y,colorWhite);
   }   
}   
void graffitiInput(bool screen)
{
   screen = !screen;
   int colorBlack=PA_16cGetPixel(screen,165,11);
   if (Stylus.Newpress)
	{
		PA_oldx[0] = Stylus.X;
		PA_oldy[0] = Stylus.Y;		
	}		   
   if (PA_StylusInZone(181,7,181+75,7+74))
   {

      Delete16cLine(screen,PA_oldx[0],PA_oldy[0],Stylus.X,Stylus.Y);
      Draw16cLine(screen,PA_oldx[0],PA_oldy[0],Stylus.X,Stylus.Y,colorBlack);

		PA_oldx[0] = Stylus.X;
		PA_oldy[0] = Stylus.Y; 
   }   
   
}   
#define assignKeyInZone(x1,y1,x2,y2,letter) if (PA_StylusInZone(x1,y1,x2,y2)) keyOutput = letter;
int getKeyboardInput(bool screen)
{
   int originalY = Stylus.Y;
   if (Stylus.Y-90 < 0)
	{
	   if (PA_StylusInZone(181,7,181+75,7+74)) return -2;
	   if (PA_StylusInZone(162,8,162+8,8+9)) return -3;
	   return -1;
	}   
   Stylus.Y -= 90;

   char keyOutput = 0;
   if (keyboardMode==0)
   {
      if (!(shiftOn || capsLock) || (shiftOn && capsLock))
      {
			assignKeyInZone(6, 5, 23, 22,'1');
			assignKeyInZone(26, 5, 43, 22,'2');
			assignKeyInZone(46, 5, 63, 22,'3');
			assignKeyInZone(66, 5, 83, 22,'4');
			assignKeyInZone(86, 5, 103, 22,'5');
			assignKeyInZone(106, 5, 123, 22,'6');
			assignKeyInZone(126, 5, 143, 22,'7');
			assignKeyInZone(146, 5, 163, 22,'8');
			assignKeyInZone(166, 5, 183, 22,'9');
			assignKeyInZone(186, 5, 203, 22,'0');
			assignKeyInZone(206, 5, 223, 22,'-');
			assignKeyInZone(226, 5, 243, 22,'=');
			
			assignKeyInZone(18, 24, 35, 40,'q');
			assignKeyInZone(38, 24, 55, 40,'w');
			assignKeyInZone(58, 24, 75, 40,'e');
			assignKeyInZone(78, 24, 95, 40,'r');
			assignKeyInZone(98, 24, 115, 40,'t');
			assignKeyInZone(118, 24, 135, 40,'y');
			assignKeyInZone(138, 24, 155, 40,'u');
			assignKeyInZone(158, 24, 175, 40,'i');
			assignKeyInZone(178, 24, 195, 40,'o');
			assignKeyInZone(198, 24, 215, 40,'p');
	
			assignKeyInZone(30, 43, 47, 59,'a');
			assignKeyInZone(50, 43, 67, 59,'s');
			assignKeyInZone(70, 43, 87, 59,'d');
			assignKeyInZone(90, 43, 107, 59,'f');
			assignKeyInZone(110, 43, 127, 59,'g');
			assignKeyInZone(130, 43, 147, 59,'h');
			assignKeyInZone(150, 43, 167, 59,'j');
			assignKeyInZone(170, 43, 187, 59,'k');
			assignKeyInZone(190, 43, 207, 59,'l');
	
			assignKeyInZone(41, 62, 58, 79,'z');
			assignKeyInZone(61, 62, 78, 79,'x');
			assignKeyInZone(81, 62, 98, 79,'c');
			assignKeyInZone(101, 62, 118, 79,'v');
			assignKeyInZone(121, 62, 138, 79,'b');
			assignKeyInZone(141, 62, 158, 79,'n');
			assignKeyInZone(161, 62, 178, 79,'m');
			assignKeyInZone(181, 62, 198, 79,',');
			assignKeyInZone(201, 62, 218, 79,'.');
			assignKeyInZone(221, 62, 238, 79,'/');
			
			assignKeyInZone(47, 81, 64, 97,';');
			assignKeyInZone(67, 81, 84, 97,'`');
			assignKeyInZone(87, 81, 104, 97,39); // '
			assignKeyInZone(167, 81, 184, 97,91); // [
			assignKeyInZone(187, 81, 204, 97,93); // ]
			assignKeyInZone(207, 81, 224, 97,92); // slash down
		}		
		else
      {
			assignKeyInZone(6, 5, 23, 22,'!');
			assignKeyInZone(26, 5, 43, 22,'@');
			assignKeyInZone(46, 5, 63, 22,'#');
			assignKeyInZone(66, 5, 83, 22,'$');
			assignKeyInZone(86, 5, 103, 22,'%');
			assignKeyInZone(106, 5, 123, 22,'^');
			assignKeyInZone(126, 5, 143, 22,'&');
			assignKeyInZone(146, 5, 163, 22,'*');
			assignKeyInZone(166, 5, 183, 22,'(');
			assignKeyInZone(186, 5, 203, 22,')');
			assignKeyInZone(206, 5, 223, 22,'_');
			assignKeyInZone(226, 5, 243, 22,'+');
			
			assignKeyInZone(18, 24, 35, 40,'Q');
			assignKeyInZone(38, 24, 55, 40,'W');
			assignKeyInZone(58, 24, 75, 40,'E');
			assignKeyInZone(78, 24, 95, 40,'R');
			assignKeyInZone(98, 24, 115, 40,'T');
			assignKeyInZone(118, 24, 135, 40,'Y');
			assignKeyInZone(138, 24, 155, 40,'U');
			assignKeyInZone(158, 24, 175, 40,'I');
			assignKeyInZone(178, 24, 195, 40,'O');
			assignKeyInZone(198, 24, 215, 40,'P');
	
			assignKeyInZone(30, 43, 47, 59,'A');
			assignKeyInZone(50, 43, 67, 59,'S');
			assignKeyInZone(70, 43, 87, 59,'D');
			assignKeyInZone(90, 43, 107, 59,'F');
			assignKeyInZone(110, 43, 127, 59,'G');
			assignKeyInZone(130, 43, 147, 59,'H');
			assignKeyInZone(150, 43, 167, 59,'J');
			assignKeyInZone(170, 43, 187, 59,'K');
			assignKeyInZone(190, 43, 207, 59,'L');
	
			assignKeyInZone(41, 62, 58, 79,'Z');
			assignKeyInZone(61, 62, 78, 79,'X');
			assignKeyInZone(81, 62, 98, 79,'C');
		  	assignKeyInZone(101, 62, 118, 79,'V');
			assignKeyInZone(121, 62, 138, 79,'B');
			assignKeyInZone(141, 62, 158, 79,'N');
			assignKeyInZone(161, 62, 178, 79,'M');
			assignKeyInZone(181, 62, 198, 79,'<');
			assignKeyInZone(201, 62, 218, 79,'>');
			assignKeyInZone(221, 62, 238, 79,'?');
			
			assignKeyInZone(47, 81, 64, 97, ':');
			assignKeyInZone(67, 81, 84, 97, '~');
			assignKeyInZone(87, 81, 104, 97, '"'); // '
			assignKeyInZone(167, 81, 184, 97,'{'); // [
			assignKeyInZone(187, 81, 204, 97,'}'); // ]
			assignKeyInZone(207, 81, 224, 97,'|'); // slash down
		}		
		if (keyOutput!=0 && shiftOn) toggleShift(screen);		
		if (PA_StylusInZone(107, 81, 164, 97)) keyOutput = ' ';
		if (PA_StylusInZone(5, 43, 27, 59))    toggleCaps(screen);		
		if (PA_StylusInZone(5, 62, 38, 79))    toggleShift(screen);
		if (PA_StylusInZone(217, 24, 250, 40)) keyOutput = 128; //backspace
		if (PA_StylusInZone(210, 43, 250, 59)) keyOutput = '\n';
		if (PA_StylusInZone(229, 81, 229+20, 97)) keyOutput = 129;
		
	}		
   if (keyboardMode==1)
   {
	   Stylus.Y += 90;
		assignKeyInZone(225,170,242,185,'}');
		assignKeyInZone(208,170,225,185,'{');
		assignKeyInZone(191,170,208,185,']');
		assignKeyInZone(174,170,191,185,'[');
		assignKeyInZone(157,170,174,185,')');
		assignKeyInZone(140,170,157,185,'(');
		assignKeyInZone(123,170,140,185,'>');
		assignKeyInZone(106,170,123,185,'<');
		assignKeyInZone(89,170,106,185,'\\');
		assignKeyInZone(72,170,89,185,'~');
		assignKeyInZone(55,170,72,185,'^');
		assignKeyInZone(233,155,250,170,'|');
		assignKeyInZone(216,155,233,170,'-');
		assignKeyInZone(199,155,216,170,'/');
		assignKeyInZone(182,155,199,170,';');
		assignKeyInZone(165,155,182,170,':');
		assignKeyInZone(148,155,165,170,'\"');
		assignKeyInZone(131,155,148,170,'k');
		assignKeyInZone(114,155,131,170,'c');
		assignKeyInZone(97,155,114,170,'w');
		assignKeyInZone(46,155,63,170,'&');
		assignKeyInZone(225,140,242,155,'%');
		assignKeyInZone(208,140,225,155,'=');
		assignKeyInZone(191,140,208,155,'0');
		assignKeyInZone(174,140,191,155,',');
		assignKeyInZone(157,140,174,155,'f');
		assignKeyInZone(140,140,157,155,'y');
		assignKeyInZone(123,140,140,155,'l');
		assignKeyInZone(106,140,123,155,'a');
		assignKeyInZone(89,140,106,155,'t');
		assignKeyInZone(72,140,89,155,'h');
		assignKeyInZone(55,140,72,155,'v');
		assignKeyInZone(38,140,55,155,'_');
		assignKeyInZone(233,125,250,140,'#');
		assignKeyInZone(216,125,233,140,'3');
		assignKeyInZone(199,125,216,140,'2');
		assignKeyInZone(182,125,199,140,'1');
		assignKeyInZone(148,125,165,140,',');
		assignKeyInZone(131,125,148,140,'p');
		assignKeyInZone(114,125,131,140,'s');
		assignKeyInZone(97,125,114,140,' ');
		assignKeyInZone(80,125,97,140,'e');
		assignKeyInZone(63,125,80,140,'v');
		assignKeyInZone(46,125,63,140,'j');
		assignKeyInZone(29,125,46,140,'@');
		assignKeyInZone(225,110,242,125,'6');
		assignKeyInZone(208,110,225,125,'5');
		assignKeyInZone(191,110,208,125,'4');
		assignKeyInZone(174,110,191,125,'+');
		assignKeyInZone(140,110,157,125,'x');
		assignKeyInZone(123,110,140,125,'m');
		assignKeyInZone(106,110,123,125,'i');
		assignKeyInZone(89,110,106,125,'d');
		assignKeyInZone(72,110,89,125,'r');
		assignKeyInZone(55,110,72,125,'b');
		assignKeyInZone(38,110,55,125,'$');
		assignKeyInZone(233,95,250,110,'9');
		assignKeyInZone(216,95,233,110,'8');
		assignKeyInZone(199,95,216,110,'7');
		assignKeyInZone(182,95,199,110,'*');
		assignKeyInZone(165,95,182,110,'!');
		assignKeyInZone(148,95,165,110,'?');
		assignKeyInZone(131,95,148,110,'z');
		assignKeyInZone(114,95,131,110,'g');
		assignKeyInZone(97,95,114,110,'n');
		assignKeyInZone(80,95,97,110,'o');
		assignKeyInZone(63,95,80,110,'u');
		assignKeyInZone(46,95,63,110,'q');
		assignKeyInZone(29,95,46,110,39);
      if (!(!(shiftOn || capsLock) || (shiftOn && capsLock))) keyOutput= toupper(keyOutput);
		if (keyOutput!=0 && shiftOn) toggleShift(screen);		
		if (Stylus.Newpress)
		{
			if (PA_StylusInZone(63,155,80,170))    toggleCaps(screen);		
			if (PA_StylusInZone(80,155,97,170))    toggleShift(screen);
		}			
		if (PA_StylusInZone(157,110,174,125)) keyOutput = 128; //backspace
		if (PA_StylusInZone(165,125,182,140)) keyOutput = '\n';
	   Stylus.Y -= 90;
   }   
	if (PA_StylusInZone(5, 80, 45, 108) && Stylus.Newpress)
	{
	   toggleKeyboardMode(screen);
//	   PA_WaitFor(Stylus.Released);
	}   
     
	Stylus.Y=originalY; 
   return keyOutput;
}   
bool inputKeyboard_EndedWithEnter()
{
   return endedWithEnter;
}
bool inputKeyboard_EndedWithSave()
{
   return endedWithSave;
}
void reset_inputKeyboard_EndedWithSave()
{
   endedWithSave=0;
}   

void reset_inputKeyboard_EndedWithEnter()
{
   endedWithEnter=0;
}   
void animateTextCursor(bool screen, int textCursorX, int textCursorY, int backdropColor, int color, int offsetY, int cursorOffset)
{

   if (PA_RTC.Frames==30)
   {
      int temp1;
	   for (temp1=-2;temp1<14;temp1++)
	   {
		   PA_16cDeletePixel(screen,textCursorX+3,textCursorY+temp1+offsetY);         
		   PA_16cPutPixel(screen,textCursorX+3,textCursorY+temp1+offsetY,color);
		}   
   }   
   if (PA_RTC.Frames==0)
   {
      int temp1;
	   for (temp1=-2;temp1<14;temp1++)
	   {
		   PA_16cDeletePixel(screen,textCursorX+3,textCursorY+temp1+offsetY);         
		   PA_16cPutPixel(screen,textCursorX+3,textCursorY+temp1+offsetY,backdropColor);
		}   
   }   
}   
void animatePreviewTextCursor(bool screen, int cursorOffset)
{
   if (!(PA_RTC.Frames==30 || PA_RTC.Frames==0)) return;
   int textCursorX=0;
	int textCursorY=0;
	if (cursorOffset==0)
	{
		textCursorX=0;
		textCursorY=6;
	}		
	else
	if (PA_LetterPos.Letter[cursorOffset].X == 5)
	{
		textCursorX=0;
		textCursorY=PA_LetterPos.Letter[cursorOffset].Y;
	}		
	else
	{
		textCursorX=PA_LetterPos.Letter[cursorOffset-1].X;
		textCursorY=PA_LetterPos.Letter[cursorOffset-1].Y;
	   textCursorX+=3;
	}   
   int colorBlack=PA_16cGetPixel(screen,165,11);   
   int colorWhite=PA_16cGetPixel(screen,181,6);   		   

   if (PA_RTC.Frames==30)
   {
      int temp1;
	   for (temp1=0;temp1<7;temp1++)
	   {
		   PA_16cDeletePixel(screen,textCursorX+3,textCursorY+temp1);         
		   PA_16cPutPixel(screen,textCursorX+3,textCursorY+temp1,colorBlack);
		}   
   }   
   if (PA_RTC.Frames==0)
   {
      int temp1;
	   for (temp1=0;temp1<7;temp1++)
	   {
		   PA_16cDeletePixel(screen,textCursorX+3,textCursorY+temp1);         
		   PA_16cPutPixel(screen,textCursorX+3,textCursorY+temp1,colorWhite);
		}   
   }   
}   
void inputLetter(char* output, int letter, int offset)
{
   int length = strlen(output);
   int i;

   for (i=length+1;i>offset;i--)
	   output[i]=output[i-1];
	output[i]=letter;
	output[length+2]=0;
//	output[length+1]=0;
}			
void backspace(char* output, int offset)
{
   if (offset==0) return;
   int length = strlen(output);
   int i;

   for (i=offset-1;i<length;i++)
	   output[i]=output[i+1];
	output[length]=0;
//	output[length+1]=0;
}			
char* inputKeyboard(bool screen, char* text,int x1, int y1,int x2, int y2, int backdropColor, int cursorColor, int OffsetY,int color,int font, bool instant, bool oneline, bool backgroundAnimate)
{
   PA_16cErase(!screen);
   //Load16cBMPtoBG(!screen, (void*)keyboard16c,0,0);
   keyboardMode=0;

   output = malloc(256);
   memset(output,0,256);
	sprintf(output,"%s",text);
//	return output;
   update16cKeyboardDisplay(screen);
   
	if (font==ANTIALIASED_FONT)
		spaceLetteringForAAText();	
	else
		spaceLetteringForDefault();
	if (!screen)
   	PA_EnableSpecialFx(1, SFX_NONE, SFX_BG2 , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
   else
	   PA_EnableSpecialFx(0, SFX_NONE, SFX_BG1 , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
   if (backgroundAnimate)
   {
	   if (!screen)
	   {
		   PA_EnableSpecialFx(1, SFX_BRIGHTDEC, SFX_BG0 | SFX_BG1 | SFX_BG3, 0);
		}   
		else
	   {
		   PA_EnableSpecialFx(0, SFX_BRIGHTDEC, SFX_BG0 | SFX_BG2 | SFX_BG3, 0);
		}   
	}		
   
//   int transition=-64;
   int transition=-64;
   //if (whiteBoardMode) 
	transition=0;
   if (backgroundAnimate)
	   PA_BGScrollXY(!screen,2,8,transition);
   if (!screen) PA_SwitchScreens();
   

   cursorOffset=strlen(text);

   
   int temp1=0;
   int textCursorX=x1;
   int textCursorY=y1;
   refreshText(screen, x1, y1,x2, y2,backdropColor, color,font,output,0);
   if (cursorOffset!=0)
   {
	   textCursorX = PA_LetterPos.Letter[cursorOffset-1].X;
	   textCursorY = PA_LetterPos.Letter[cursorOffset-1].Y;
		textCursorX+=5;
	   refreshText(screen, x1, y1,x2, y2,backdropColor, color,font,output,cursorOffset);
   }   
   
   refreshKeyboardPreviewText(screen, output,cursorOffset);
   endedWithEnter=0;
   endedWithSave=0;
   bool graffitiMode=0;
   u8 stylusHeldDuration=0;
   
	FILE* keyboardClickSnd = returnThemeResourcePathFILE("sounds/keyboardclick.wav","rb",1);
   int i=0;
   int originalKey=0;

   while(1)
   {
   
      if (Pad.Newpress.Up && ((PA_LetterPos.Letter[cursorOffset].Y-6)/10)-1 != -1)
      {
         temp1=0;
         temp1=cursorOffset;
			for (i=0;i<=PA_LetterPos.NLetters;i++)
			{
   			if (PA_LetterPos.Letter[i].Letter=='\n')	continue;
   			if ((PA_LetterPos.Letter[i].Y-6)/10<((PA_LetterPos.Letter[temp1].Y-6)/10)-1) continue;
   			if (PA_LetterPos.Letter[i].X<=PA_LetterPos.Letter[temp1].X) cursorOffset=i;
   			if (PA_LetterPos.Letter[i].X>PA_LetterPos.Letter[temp1].X) break;
   			if ((PA_LetterPos.Letter[i].Y-6)/10>((PA_LetterPos.Letter[temp1].Y-6)/10)-1) break;
      	}	
      	temp1=0;
		   refreshTextFull();
      }   
      
      if (Pad.Newpress.Down)
      {
         temp1=0;
         temp1=cursorOffset;
			for (i=0;i<=PA_LetterPos.NLetters;i++)
			{
   			if (PA_LetterPos.Letter[i].Letter=='\n')	continue;
   			if ((PA_LetterPos.Letter[i].Y-6)/10<((PA_LetterPos.Letter[temp1].Y-6)/10)+1) continue;
   			if (PA_LetterPos.Letter[i].X<=PA_LetterPos.Letter[temp1].X) cursorOffset=i;
   			if (PA_LetterPos.Letter[i].X>PA_LetterPos.Letter[temp1].X) break;
   			if ((PA_LetterPos.Letter[i].Y-6)/10>((PA_LetterPos.Letter[temp1].Y-6)/10)+1) break;
      	}	
      	temp1=0;
		   refreshTextFull();
      }   
		if (Pad.Newpress.Left && cursorOffset>0)
		{
		   cursorOffset--;
		   refreshTextFull();
		}   
		if (Pad.Newpress.Right && cursorOffset<strlen(output)) 
		{
		   cursorOffset++;
		   refreshTextFull();
		}
      if (Stylus.Newpress || ( Stylus.Held && stylusHeldDuration==60) || (Stylus.Held && keyboardMode==1 ))
		{
		   if (Stylus.Newpress) stylusHeldDuration=0;
			graffitiMode=0;
			
		   if (!( Stylus.Held && stylusHeldDuration==60))temp1 = getKeyboardInput(screen);
		   else
		   temp1= originalKey;
		   if (keyboardMode == 1 && stylusHeldDuration<60)
		   {
			   if (temp1>0 && temp1==originalKey) 
					temp1=0;
				else
					stylusHeldDuration=0;
		   }   
		   if (temp1>0)
			{
			   loadFatSndWav(keyboardClickSnd);
			}     
			if (temp1==-2 && PA_StylusInZone(181,7,181+75,7+74))
				graffitiMode=1;
		} 

		if (temp1==-1)
		{

		   if (PA_StylusInZone(0,6,160,6+76))
		   {
		      temp1=cursorOffset;
	      	refreshKeyboardPreviewText(screen, output,cursorOffset);
//   			animatePreviewTextCursor(!screen,PA_LetterPos.Letter[cursorOffset-1].X,PA_LetterPos.Letter[cursorOffset-1].Y);
		      while(Stylus.Held)
		      {
      			for (i=0;i<=PA_LetterPos.NLetters;i++)
      			{
	      			if ((PA_LetterPos.Letter[i].Y-6)/10<(Stylus.Y-6)/10) continue;
	      			if (PA_LetterPos.Letter[i].X<=Stylus.X || PA_LetterPos.Letter[i-1].Letter == '\n')
						   cursorOffset=i;
      			   if (PA_LetterPos.Letter[i].Letter == '\n') break;
	      			if (PA_LetterPos.Letter[i].X>Stylus.X) break;
	      			if ((PA_LetterPos.Letter[i].Y-6)/10>(Stylus.Y-6)/10) break;
		      	}			
		      	if (temp1!=cursorOffset)
		      	{
		      	   temp1=cursorOffset;
		      		refreshKeyboardPreviewText(screen, output,cursorOffset);
			     	} 		
//			     	animatePreviewTextCursor(!screen,PA_LetterPos.Letter[cursorOffset-1].X,PA_LetterPos.Letter[cursorOffset-1].Y);
      			Soul_waitForVBL();
//      			PA_16cErase(!screen);
		    	}  	
		    	originalKey = temp1;
			   temp1=0;
			   refreshTextFull();
		   }   
		}   
      if (Stylus.Held &&stylusHeldDuration<60) stylusHeldDuration++;
      if (!Stylus.Held || (Stylus.Y< 90))stylusHeldDuration=0;
      if (!Stylus.Held) originalKey=0;
		if (graffitiMode)
		{		
	      if (!Stylus.Held)
	      {
				clearGraffiti(screen);
				graffitiMode=0;
			}			
			else
	      {
				graffitiInput(screen);
			}						
			temp1=PA_CheckLetter();
			if (temp1 == PA_BACKSPACE && cursorOffset>0) 
			{
				backspace(output, cursorOffset);
				cursorOffset--;
				refreshTextFull();
				originalKey = temp1;
				temp1=0;
			}
		}			
	   if (temp1>0)
	   {
		   if (temp1=='\n' && oneline)
			{
			   endedWithEnter=1;
			   break;
			}   
		   if (temp1==129)
			{
			   endedWithSave=1;
			   break;
			}   
			else
		   if (temp1==128 && cursorOffset>0)
		   {
				backspace(output, cursorOffset);
				cursorOffset--;
	      }	  
	      else
	      {
				inputLetter(output,temp1,cursorOffset);
				cursorOffset++;
//				cursorOffset++;
			}			
			refreshTextFull();
		   originalKey = temp1;
			temp1=0;
		}			
      if (Pad.Newpress.L && cursorOffset>0)	
		{
		   backspace(output, cursorOffset);
		   cursorOffset--;
			refreshTextFull();
			
		}   
		
		animateTextCursor(screen,textCursorX,textCursorY,backdropColor,cursorColor,OffsetY,cursorOffset);
		animatePreviewTextCursor(!screen,cursorOffset);
      if (Pad.Newpress.B || temp1==-3)
      {
         sprintf(output,"%s",text);
         break;
      }   

      if (transition<-10)
		{
		   transition++;
		}   
      if (transition<0)
		{
		   transition++;
		}   
		if (Pad.Newpress.A) transition=-64;
		updateAmbience();  //Update Ambience / Animated Background
		   //use temp for text cursor hack
//		   temp1 = PA_LetterPos.Letter[cursorOffset].X;
//		   temp2 = PA_LetterPos.Letter[cursorOffset].Y;
//			spaceLetteringForAAText();
//			updateShrinkClock(1);

//		   temp1=0;
//      ZoomXY_3DProcess(112,(shrinkX+3)*-1,((shrinkY)*-1)+((64+transition)*-1));
		if (shrinkzoom) 
			ZoomXY_3DProcess(112,(shrinkX+3)*-1,(shrinkY)*-1);
		else
			ZoomXY_3DProcess(128,0,0);
      Soul_waitForVBL();
      if (backgroundAnimate)
      {
			if (!screen)
			   PA_BGScrollXY(1,2,8,(transition)+8);
		   else
			   PA_BGScrollXY(0,1,8,(transition)+8);
			REG_BLDY(1) = ((64+transition)*.15);
		   PA_SetBgRot(!screen,3,0,(transition/2)+32,0,0,0,256);
		}   
   }
   PA_16cErase(!screen);
   PA_SetBgRot(!screen,3,0,0,0,0,0,256);
   PA_BGScrollXY(!screen,2,8,8);
	refreshText(screen, x1, y1,x2, y2,backdropColor, color,font,"",cursorOffset);
   PA_EnableSpecialFx(!screen, SFX_NONE, SFX_BG0 | SFX_BG1 | SFX_BG3, 0);
   if (!screen) PA_SwitchScreens();
	Stylus.Newpress=false;
	Stylus.Held=false;
	fclose(keyboardClickSnd);
   return output;
}	


