#include <PA9.h>
#include "bmp3DSprite.h"
#include "bmpTex.h"
extern int bmp_height;
extern int bmp_width;	
extern int temp;
extern int temp1;

void bmpToTexAlpha (u8 *source, u8 *output, u16 colors,  u8 magenta)
{
   switch(getAlphaColorTexType(colors))
   {
		case TEX_A5I3   : //PA_Print(1,"8colors %s\n", magenta ? "transp On" : "transp Off");
							   bmpTo_A5I3Tex(source,output,magenta); 		//8  Colors + 5 bit alpha (31 layers of mask)
								break;
		case TEX_A3I5   : //PA_Print(1,"32colors %s\n", magenta ? "transp On" : "transp Off");
								bmpTo_A3I5Tex(source,output,magenta); 		//32 Colors + 3 bit alpha (7 layers of mask)
								break;
	}   


}	

void bmpToTex (u8 *source, u8 *output, u16 colors,  u8 magenta)
{
   switch(getColorTexType(colors))
   {
		case TEX_4COL	 : //PA_Print(1,"4colors %s\n", magenta ? "transp On" : "transp Off");
								bmpTo_4ColorTex(source,output,magenta);	//4  Colors
								break;
		case TEX_16COL  : //PA_Print(1,"16colors %s\n", magenta ? "transp On" : "transp Off");
								bmpTo_16ColorTex(source,output,magenta);	//16 Colors
								break;
		case TEX_256COL : //PA_Print(1,"256colors %s\n", magenta ? "transp On" : "transp Off"); 
								bmpTo_256ColorTex(source,output,magenta); //256 Colors
								break;
	}   


}	

void bmpTo_4ColorTex(u8 *source, u8 *output, u8 magenta )
{
	int i=0;
   if(magenta==0)
   {
		for(temp=bmp_height-1; temp>=0; temp--)
			for(temp1=0; temp1<bmp_width; temp1+=4)
			{
				output[i] = (byte)((source[(temp*bmp_width)+temp1]  +1) 		  +
										((source[(temp*bmp_width)+temp1+1]+1) << 2) +
										((source[(temp*bmp_width)+temp1+2]+1) << 4) +
										((source[(temp*bmp_width)+temp1+3]+1) << 6));
				i++;
			}	
	}			
   else
   {
		for(temp=bmp_height-1; temp>=0; temp--)
			for(temp1=0; temp1<bmp_width; temp1+=4)
			{
				colorToTransparent(source[(temp*bmp_width)+temp1],magenta);
				colorToTransparent(source[(temp*bmp_width)+temp1+1],magenta);
				colorToTransparent(source[(temp*bmp_width)+temp1+2],magenta);
				colorToTransparent(source[(temp*bmp_width)+temp1+3],magenta);
				
				output[i] = (byte)((source[(temp*bmp_width)+temp1]			 ) +
										((source[(temp*bmp_width)+temp1+1]) << 2) + 
										((source[(temp*bmp_width)+temp1+2]) << 4) +
										((source[(temp*bmp_width)+temp1+3]) << 6));
				 i++;
			}		
	}			
}	

void bmpTo_A5I3Tex(u8 *source, u8 *output, u8 magenta )
{
   int i=0;
   if(magenta==0)
   {
		for(temp=bmp_height-1; temp>=0; temp--)
			for(temp1=0; temp1<bmp_width; temp1++)
			{
				output[i] = (u32)(source[(temp*bmp_width)+temp1]+1);
//				output[i] += 31<<3; //31 max
				i++;
			}	
	}			
   else
   {
		for(temp=bmp_height-1; temp>=0; temp--)
			for(temp1=0; temp1<bmp_width; temp1++)
			{
				output[i] = (u32)(source[(temp*bmp_width)+temp1]);
				colorToTransparent(output[i],magenta);
				i++;
			}		
	}			
}
void bmpTo_16ColorTex(u8 *source, u8 *output, u8 magenta )
{
	int i=0;
   if(magenta==0)
   {
		for(temp=bmp_height-1; temp>=0; temp--)
			for(temp1=0; temp1<bmp_width; temp1+=2)
			{
				output[i] =  (u16)((source[(temp*bmp_width)+temp1]+1) + ((source[(temp*bmp_width)+temp1+1]+1) << 4));
//				output[i] += alpha_tex[i]<<3; //31 max
				i++;
			}	
	}			
   else
   {
		for(temp=bmp_height-1; temp>=0; temp--)
			for(temp1=0; temp1<bmp_width; temp1+=2)
			{
				colorToTransparent(source[(temp*bmp_width)+temp1],magenta);
				colorToTransparent(source[(temp*bmp_width)+temp1+1],magenta);
				output[i] =  (u16)((source[(temp*bmp_width)+temp1]) + 
										((source[(temp*bmp_width)+temp1+1]) << 4));
			  	i++;
			}		
	}		
}

void bmpTo_A3I5Tex(u8 *source, u8 *output, u8 magenta )
{
	int i=0;
   if(magenta==0)
   {
		for(temp=bmp_height-1; temp>=0; temp--)
			for(temp1=0; temp1<bmp_width; temp1++)
			{
				output[i] =  (u32)(source[(temp*bmp_width)+temp1]+1);
//				output[i] += (7)<<5;
				i++;
			}	
	}			
   else
   {
		for(temp=bmp_height-1; temp>=0; temp--)
			for(temp1=0; temp1<bmp_width; temp1++)
			{
				output[i] =  (u32)(source[(temp*bmp_width)+temp1]);
				colorToTransparent(output[i],magenta);
	//						output[i] += (alpha_tex[i]/4)<<5; //7 - no alpha 0- not visible anymore
				i++;
			}		
	}	
	
}

void bmpTo_256ColorTex(u8 *source, u8 *output, u8 magenta )
{
	int i=0;
   if(magenta==0)
   {
		for(temp=bmp_height-1; temp>=0; temp--)
			for(temp1=0; temp1<bmp_width; temp1++)
			{
				output[i] =  (u32)(source[(temp*bmp_width)+temp1]+1);
				i++;
			}	
	}			
   else
   {
		for(temp=bmp_height-1; temp>=0; temp--)
			for(temp1=0; temp1<bmp_width; temp1++)
			{
				output[i] =  (u32)(source[(temp*bmp_width)+temp1]);
//						output[i] += (alpha_tex[i]/4)<<5; //7 - no alpha 0- not visible anymore
				colorToTransparent(output[i],magenta);
			  	i++;
			}		
	}	

}
