#include <PA9.h>
#include "soulengine.h"
extern u8 pa_3Dbanks;
extern u8 pa_3Ddual;
extern u8 pa_3Dscreen;

void PA_3DUpdateSpriteAnims(void);
void PA_3DCapture(void);
void PA_glReset(void);


struct plainTexturesInfo
{
   u16 color;
   bool empty;
}   plainTex[10];
u8 plainTexCount=0;

#define PA_TEXTURE_PACK(u,v)    (((u) & 0xFFFF) | ((v) << 16))

extern inline void PA_glRotateX(u32 angle) {	
   angle = (((angle&511) * LUT_SIZE)>>9);

  	int32 sine = SIN[angle &  LUT_MASK];
	int32 cosine = COS[angle & LUT_MASK];

	MATRIX_MULT3x3 = inttof32(1);
	MATRIX_MULT3x3 = 0;
	MATRIX_MULT3x3 = 0;

	MATRIX_MULT3x3 = 0;
	MATRIX_MULT3x3 = cosine;
	MATRIX_MULT3x3 = sine;
  
	MATRIX_MULT3x3 = 0;
	MATRIX_MULT3x3 = -sine;
	MATRIX_MULT3x3 = cosine;	
	
}
extern inline void PA_glRotateY(u32 angle) {	
   angle = (((angle&511) * LUT_SIZE)>>9);

	int32 sine = SIN[angle &  LUT_MASK];
	int32 cosine = COS[angle & LUT_MASK];

	MATRIX_MULT3x3 = cosine;
	MATRIX_MULT3x3 = 0;
	MATRIX_MULT3x3 = -sine;
  
	MATRIX_MULT3x3 = 0;
	MATRIX_MULT3x3 = inttof32(1);
	MATRIX_MULT3x3 = 0;
  
	MATRIX_MULT3x3 = sine;
	MATRIX_MULT3x3 = 0;
	MATRIX_MULT3x3 = cosine;	
}
extern inline void PA_glRotateZ(u32 angle) {	
   angle = (((angle&511) * LUT_SIZE)>>9);
	
	int32 sine = SIN[angle &  LUT_MASK];
	int32 cosine = COS[angle & LUT_MASK];

	MATRIX_MULT3x3 = cosine;
	MATRIX_MULT3x3 = sine;
	MATRIX_MULT3x3 = 0;

	MATRIX_MULT3x3 = - sine;
	MATRIX_MULT3x3 = cosine;
	MATRIX_MULT3x3 = 0;
  
	MATRIX_MULT3x3 = 0;
	MATRIX_MULT3x3 = 0;
	MATRIX_MULT3x3 = inttof32(1);		
}   
  
 
extern inline void PA_glVertex(u16 x, u16 y, u16 z){
	GFX_VERTEX16 = (y << 16) | (x & 0xFFFF);
	GFX_VERTEX16 = ((uint32)z);
}	




extern inline void PA_glTranslate(s32 x, s32 y, s32 z) {
  MATRIX_TRANSLATE = (x);
  MATRIX_TRANSLATE = (y);
  MATRIX_TRANSLATE = (z);
}


void PA_glTranslate(s32 x, s32 y, s32 z);

int create3dBackgroundLayer(int sprite ,int red, int blue, int green)
{
   int texture = createPlainTexture(red, blue, green);
   PA_3DCreateSpriteFromTex(sprite,texture,256,192,0,128,96);
 	PA_3DSetSpritePrio(sprite,1);
   return texture;
}   

int create3dOuterCanvasLayer(int sprite ,int red, int blue, int green)
{
   int texture = createPlainTexture(red, blue, green);
	PA_3DCreateSpriteFromTex(sprite,   texture, 1024, 256, 0,512+0,128+192);
	PA_3DSetSpritePrio(sprite,3000);
	PA_3DCreateSpriteFromTex(sprite+1, texture, 1024, 256, 0,256+0,-128);	
	PA_3DSetSpritePrio(sprite+1,3000);	
	PA_3DCreateSpriteFromTex(sprite+2, texture, 1024, 512, 0,-512,256);	
	PA_3DSetSpritePrio(sprite+2,3000);
	PA_3DCreateSpriteFromTex(sprite+3, texture, 1024, 512, 0,512+256,256);	
	PA_3DSetSpritePrio(sprite+3,3000);
   return texture;
}   

u16 createPlainTexture(int red, int blue, int green)
{
   int i;
   int color =  RGB15(red, blue, green);
   for (i=0;i<plainTexCount;i++)
   {
		if(plainTex[i].color == color) return PLAINTEX_START+i;
   }   
	plainTex[plainTexCount].color = color;
	
   plainTexCount++;
   return PLAINTEX_START+(plainTexCount-1);
}   
void render3DSprite(u16 sprite, s16 ydecal){
    
   MATRIX_PUSH = 0;
  
	PA_glTranslate(pa_3dsprites[sprite].X, (192-(pa_3dsprites[sprite].Y+ydecal)), pa_3dsprites[sprite].Priority);
	bool textureFound=0;
	if (pa_3dsprites[sprite].textureID>=PLAINTEX_START)
	{
	   textureFound=0;
	   GFX_TEX_FORMAT = 0;
   	glMaterialf(GL_EMISSION, plainTex[pa_3dsprites[sprite].textureID-PLAINTEX_START].color);//31,0,0));   
	}		   
	else
	{
	   textureFound=1;
		glMaterialf(GL_EMISSION, RGB15(31,31,31));   
		GFX_TEX_FORMAT = textures[pa_3dsprites[sprite].textureID]; 
		activeTexture = pa_3dsprites[sprite].textureID; 
	   PA_PLTT_BASE = pa_3dsprites[sprite].palette<<5;	
	}

	PA_glRotateX(pa_3dsprites[sprite].RotX);	
	PA_glRotateY(pa_3dsprites[sprite].RotY); 
	PA_glRotateZ(pa_3dsprites[sprite].RotZ); 
   	
   POLYGON_ATTR = (0<<3)|(0<<4)|(1<<6)|(1<<7)|(0<<11)|(0<<12)|(pa_3dsprites[sprite].alpha<<16)|(pa_3dsprites[sprite].polyID<<24);


	
	u32 x1, x2, y1, y2;
	u8 hflip = pa_3dsprites[sprite].Hflip;	u8 vflip = pa_3dsprites[sprite].Vflip; 
	  	
	x1 = inttot16(pa_3dsprites[sprite].ImgWidth)*(hflip);	
	x2 = inttot16(pa_3dsprites[sprite].ImgWidth)*(!hflip);
	y1 = inttot16(pa_3dsprites[sprite].ImgHeight)*(!vflip);	
	y2 = inttot16(pa_3dsprites[sprite].ImgHeight)*(vflip);  
		
	s32 zoomx0 =  	pa_3dsprites[sprite].Width>>1;	s32 zoomx1 =  	(pa_3dsprites[sprite].Width+1)>>1;	
	s32 zoomy0 =  	pa_3dsprites[sprite].Height>>1;	s32 zoomy1 =  	(pa_3dsprites[sprite].Height+1)>>1;					

	// Start drawing texture
	glBegin(GL_QUADS);	
	
		GFX_NORMAL = NORMAL_PACK(0,inttov10(-1),0);

		if (textureFound) GFX_TEX_COORD = (PA_TEXTURE_PACK(x1,y1));
//		glColor3b(31,31,0);
		PA_glVertex(-zoomx1+pa_3dsprites[sprite].corner[2].x,	-zoomy1-pa_3dsprites[sprite].corner[2].y, 0 );			
		
		if (textureFound) GFX_TEX_COORD = (PA_TEXTURE_PACK(x2, y1));
//		glColor3b(0,31,31);
		PA_glVertex(zoomx0+pa_3dsprites[sprite].corner[3].x,	-zoomy1-pa_3dsprites[sprite].corner[3].y, 0 );	

		if (textureFound) GFX_TEX_COORD = (PA_TEXTURE_PACK(x2,y2));				
//		glColor3b(31,31,31);
		PA_glVertex(zoomx0+pa_3dsprites[sprite].corner[1].x,	zoomy0-pa_3dsprites[sprite].corner[1].y, 0 );		
		
		if (textureFound) GFX_TEX_COORD = (PA_TEXTURE_PACK(x1, y2));
//		glColor3b(0,31,0);
		PA_glVertex(-zoomx1+pa_3dsprites[sprite].corner[0].x,	zoomy0-pa_3dsprites[sprite].corner[0].y, 0 );		

	glEnd();
   
   MATRIX_POP = 1;

}  

void Soul_Load3DSpritePal(u16 palette_number, void* palette,int colors)
{
	vramSetBankF(VRAM_F_LCD);  
	DMA_Copy(palette, VRAM_F + (palette_number << 9), colors+1, DMA_16NOW);
	vramSetBankF(VRAM_F_TEX_PALETTE);
}

void ZoomXY_3DProcess(int zoom,int x, int y){
	if (!PA_LidClosed()) 
	{
	}   
	else
	{
		u16 power_cr = REG_POWERCNT; // backup the power...
	   char * sndpath = returnThemeResourcePath("sounds/closelid.wav", 1);
		FILE* snd = fopen(sndpath,"rb");
		loadFatSndWav(snd);
		free(sndpath);
		fclose(snd);
//		REG_POWERCNT = 0; // Shutdown everything :p
		// Wait for the lid to be opened again...
		while(PA_LidClosed())
		{
		   PAWaitForVBL();
		}   
//		REG_POWERCNT = power_cr;
	   sndpath = returnThemeResourcePath("sounds/openlid.wav", 1);
		snd = fopen(sndpath,"rb");
		free(sndpath);
		loadFatSndWav(snd);
		fclose(snd);		
		// Return the power !
//		return 1;
	}
		

	if(pa_3Ddual) PA_3DCapture();
	PA_3DUpdateSpriteAnims(); // Update animations...
	PA_glReset();
	glEnable(GL_BLEND);
	glAlphaFunc(BLEND_ALPHA);

//	PA_Set3D(0, 0, 0, 1, 1, 0, 0, 0, 0, 1);

	MATRIX_CONTROL = GL_PROJECTION;
	glLoadIdentity();

	glOrthof32 (((255*(zoom/128.0))-255)+x, (255/(zoom/128.0))+x, ((191*(zoom/128.0))-191)+y, (191/(zoom/128.0))+y, 1, 8192);
//	glOrthof32 (0, 255/(zoom/128.0), 0, 191/(zoom/128.0), 1, 8192);
//	glOrthof32 (0, 255, 0, 191, 1, 8192);
	gluLookAt(	0.0, 0.0, 1.0,		//camera possition 
				0.0, 0.0, 0.0,		//look at
				0.0, 1.0, 0.0);		//up

	MATRIX_CONTROL = GL_TEXTURE;
	glLoadIdentity();
	
	MATRIX_CONTROL = GL_MODELVIEW;

	glMaterialf(GL_AMBIENT, RGB15(31,31,31));
	glMaterialf(GL_DIFFUSE, RGB15(31,31,31));
	glMaterialf(GL_SPECULAR, BIT(15) | RGB15(15,15,15));
	glMaterialf(GL_EMISSION, RGB15(31,31,31));   

	//ds uses a table for shinyness..this generates a half-ass one
	glMaterialShinyness(); 
	
	PA_TEXIMAGE_PARAM |= (1<<29); // Palette index 0 = transparent

	s32 i;

	if(pa_3Ddual){
		if(pa_3Dscreen == 1)	{
		   for(i = 0; i < PA_NMAXSPRITES; i++) {
			   if(pa_3dsprites[i].Alive)  render3DSprite(i, 0);
			}
	
		}
			   
		else	{
		   for(i = 0; i < PA_NMAXSPRITES; i++) {
			   if(pa_3dsprites[i].Alive)  render3DSprite(i, -PA_ScreenSpace);	
			}
	
		}	
	   PA_SwitchScreens(); 
		pa_3Dscreen = !pa_3Dscreen;
	}		
	else { // Normal
	   for(i = 0; i < PA_NMAXSPRITES; i++) {
		   if(pa_3dsprites[i].Alive)  render3DSprite(i, 0);	
		}
	}			
	
	GFX_FLUSH = 0;

		
}   
extern bool enableLoading; 
void Soul_waitForVBL()
{
   if (!(Pad.Held.Up || Pad.Held.Down || Pad.Held.Left || Pad.Held.Right)) { resetNewpressHold(); }
   updateDoubleTap();
   updateWifiConnect();
//   PA_CheckLid();
   PA_SetAutoCheckLid(1);
//	while(PA_LidClosed()) PAWaitForVBL();
	if (Pad.Held.Y && Pad.Held.Start && Pad.Held.Select) enableLoading=(!enableLoading);
   PA_WaitForVBL(); 
} 	

