#include <PA9.h>
#include "text_engine.h"
#include "../../gfx/all_gfx.h"


void pa_16cTextDecompress(u8 size);

int convertAlignToInt(char* Align)
{
   if (stricmp(Align,"left")==0) return ALIGN_LEFT;
   if (stricmp(Align,"center")==0) return ALIGN_CENTER;
   if (stricmp(Align,"right")==0) return ALIGN_RIGHT;
   if (stricmp(Align,"justify")==0) return ALIGN_JUSTIFY;
   return ALIGN_LEFT;
}   
void clear16cZone(u8 screen, s16 x1, s16 y1, s16 x2, s16 y2){  
   x1 = x1 < 0? 0 : x1 > 256? 256:x1;
   y1 = y1 < 0? 0 : y1 > 192? 192:y1;
   x2 = x2 < x1? x1 : x2 > 256? 256:x2;
   y2 = y2 < y1? y1 : y2 > 192? 192:y2;
      
	x1 += 8; y1 += 8; y2 += 8;
	u16 temp, pos, temp2, pos2;
	s16 i, j;
	s16 minx = x1&(0xffffffff-7);
	if (minx != x1) minx += 8;
	s16 maxx = x2&(0xffffffff-7);

	pos = PA_16cPos(x1, y1);		temp = (x1&7)<<2;
	pos2 = PA_16cPos(x2, y1);		temp2 = (x2&7)<<2;	
	for (j = 0; j <= y2-y1; j++){
		PA_Draw1632[screen][pos] &= (0xffffffff>>(32-temp)); 
		PA_Draw1632[screen][pos+(26*8)] &= (0xffffffff<<temp);	
		pos++;
		PA_Draw1632[screen][pos2] &= (0xffffffff>>(32-temp2)); 
		PA_Draw1632[screen][pos2+(26*8)] &= (0xffffffff<<temp2);
		pos2++;
	}
   
	for (i = minx; i <= maxx; i+=8){ // 8 by 8...
		pos = PA_16cPos(i, y1);		
		for (j = 0; j <= y2-y1; j++){
			PA_Draw1632[screen][pos] = 0;
			pos++;
		}
	}
	
}  


void alignTextPostition(u16 start, s16 x, s16 maxx, u8 justify){
   s16 i;
   s16 width = (maxx+1)-x;

	if(textinfo.align == ALIGN_RIGHT){ // Cas simple, on rajoute la diffrence de largeur Etoutes les lettres...
		width++;
		for(i = start; i < PA_LetterPos.NLetters; i++) PA_LetterPos.Letter[i].X += width;
	}     
	else if(textinfo.align == ALIGN_CENTER){ // Cas simple, on rajoute la moitiEde la largeur Etoutes les lettres...
		width = (width+1)>>1;
		for(i = start; i < PA_LetterPos.NLetters; i++) PA_LetterPos.Letter[i].X += width;
	}    
	else if(justify && (textinfo.align == ALIGN_JUSTIFY)){ // Cas relou ^^
		u8 justify = 0; // Dcallage Efaire au dbut...
		u8 spaces = 0;
		u8 change = 0;
		u8 quickadd = 0;
		
		u8 nletters = PA_LetterPos.NLetters-1 - start;
		if(nletters < width){ // Less letters than the width to add, add 1 pixel/letter...
			quickadd = 1;
			width -= nletters;
		}
		// Compter le nombre d'espaces
		for(i = start; i < PA_LetterPos.NLetters-1; i++) if(PA_LetterPos.Letter[i].Letter == ' ') spaces++;
		
		for(i = start; i < PA_LetterPos.NLetters; i++) {
			justify+= quickadd;
			if (PA_LetterPos.Letter[i].X + justify < 0 || PA_LetterPos.Letter[i].X + justify > 256)
				PA_LetterPos.Letter[i].Letter = ' ';
			else
			   PA_LetterPos.Letter[i].X += justify;
		   if((PA_LetterPos.Letter[i].Letter == ' ')&&width){
		      change = (width+(spaces>>1))/spaces;
				justify+=change;		 
				width-=change; // Moins Ecorriger par la suite...  
				spaces--;   
		   }   
		}   
	}    
		
}   

extern inline void PA_AddLetterPos(s16 Letter, s16 x, s16 y, u8 size, u16 color){
   PA_LetterPos.Letter[PA_LetterPos.NLetters].Letter = Letter;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].X = x;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Y = y;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Size = size;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Color = color;
	PA_LetterPos.NLetters++;	
}
	
void Soul_AddLetterPos(u16 Letter, s16 x, s16 y, u8 size, u16 color){
//   if (Letter<=256)
	   PA_LetterPos.Letter[PA_LetterPos.NLetters].Letter = Letter;//-32;
//	else
//	   PA_LetterPos.Letter[PA_LetterPos.NLetters].Letter = Letter-JAPCHARACTERSTART;	
	PA_LetterPos.Letter[PA_LetterPos.NLetters].X = x;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Y = y;
//   if (Letter<=256)
		PA_LetterPos.Letter[PA_LetterPos.NLetters].Size = size;
//	else
//		PA_LetterPos.Letter[PA_LetterPos.NLetters].Size = JAPANESEFONT_BIG;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Color = color;
	PA_LetterPos.NLetters++;	
}

int getTextWidth(char* text, u8 size)
{
   
	s16 x = 0;
	u8 lx, letter = ' ';
	s16 i;
	
	PA_LetterPos.NLetters = 0;
	
	for(i = 0; text[i]; i++)
	{
	   letter = text[i]; 
	   lx = pa_bittextdefaultsize[size][letter]+textinfo.letterspacing;
	   x += lx;   
	}   
	return x;

}

void clear16c(bool screen)
{
   PA_16cErase(screen);
}   
void Text_DoLetterPos(s16 basex, s16 basey, s16 maxx, s16 maxy, char* text, u16 color, u8 size, int offset, int cursor)
{
	s16 x = basex; s16 y = basey;
	s16 width, letterstart;
	u8 lx, letter = ' ';
	s16 i;
	
	PA_LetterPos.NLetters = 0;
	letterstart = 0;
	
	bool wrapWord=0;	
	
	bool oneLineText=0;
	if (maxx>256) maxx=256;
   if (16+basey > maxy) oneLineText=1;
  	x+=offset;
//   if (cursor==-1) x +=5;	   
	for(i = 0; text[i] || (text[i]==0 && text[i-1]=='\n'); i++)
	{
		
	   letter = text[i]; 
	   if (text[i]==0 && text[i-1]=='\n') letter=' ';
	   lx = pa_bittextdefaultsize[size][letter]+textinfo.letterspacing;
	   if (x==basex && i-1 ==cursor)
	   {
	      x +=5;
	   }
		else   
	   if (cursor>=0 && i ==cursor) lx +=5;	   
	   if((letter == '\n') || ((x+lx > maxx)&&(letter != ' ')))
		{ // retour ligne, ou on d?asse...
			      	
			
			width = x - basex; // LARGEUR !

	      if(letter == '\n')PA_AddLetterPos(letter, x, y, size, color); // Retour ligne mettre dans le tableau
	      else if(letter == ' ') PA_AddLetterPos(letter, x, y, size, color); // Si espace, on met la suite
	      else 
			{
			   if (oneLineText)
			   {
			      break;
			   }   
			   if (wrapWord)
			   {
			      wrapWord=0;
				}   
				else
				{
		         while(text[i-1] != ' ') 
					{ 
					   i--; 
						x -= pa_bittextdefaultsize[size][(u8)text[i]]+textinfo.letterspacing; 
						PA_LetterPos.NLetters--;
						if (i==0) break;
					}
					if (i==0) 
					{
					   wrapWord=1;
					   i--;
					   x = basex;
						continue;
					}
					else
					{
					   letter = text[i]; 
					   lx = pa_bittextdefaultsize[size][letter]+textinfo.letterspacing;	 
						x--;
					}			
				}			
	      }  
			   
	  	   if(y+pa_bittextpoliceheight[size] * 2 > maxy) break;
	 
			if(text[i-1] == ' ') x-= pa_bittextdefaultsize[size][(' ')];

			PA_DoAlign(letterstart, x, maxx, (letter != '\n'));
     
	      x = basex;
	      y += pa_bittextpoliceheight[size]+textinfo.linespacing;
	      
	      letterstart = PA_LetterPos.NLetters; // Premi?e lettre de cette ligne !
	      if(letter > 32) 
			{
			   PA_AddLetterPos(letter, x, y, size, color);
			   x += lx;   	         
	      }   	      

		   
	   }   
	   else
		{
		   if (x+lx >= 0 && x >= basex && x+lx <= 256)
			if (y >= 0 && y >= basey && y <= 192) 
			{
			   PA_AddLetterPos(letter, x, y, size, color);
			   x += lx;   
			}   
		}		
	}   
	if(text[i-1] == ' ') x-= pa_bittextdefaultsize[size][(' ')]; // Retirer la largeur de l'espace	 
	PA_DoAlign(letterstart, x, maxx, (letter != '\n') && (text[i] != '\0'));

	PA_LetterPos.Letter[PA_LetterPos.NLetters].X = x;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Y = y;

}
void Text_DoLetterPosU16(s16 basex, s16 basey, s16 maxx, s16 maxy, u16* text, u16 originalcolor, u8 originalsize, int offset, int cursor)
{
	s16 x = basex; s16 y = basey;
	s16 width, letterstart;
	u8 lx, letter = ' ';
	s16 i;
	
	PA_LetterPos.NLetters = 0;
	letterstart = 0;
	
	bool wrapWord=0;	
	
	bool oneLineText=0;
	if (maxx>256) maxx=256;
   if (16+basey > maxy) oneLineText=1;
  	x+=offset;
  	u8 size=originalsize;
  	u8 color=originalcolor;

	bool JapaneseLetters=0;
	int lastspaceX=0;
	int lastspaceI=0;
	int lastspaceLetterPos=0;
	for(i = 0; text[i] || (text[i]==0 && text[i-1]=='\n'); i++)
	{
	   size = originalsize;
	   color=originalcolor;
		JapaneseLetters=0;
	   if (text[i]==0 && text[i-1]=='\n') 
			letter=' ';
	   else
		if (!(text[i]=='\n' || text[i]==' '))
		{
	 		//if (text[i]>128)
			 //size = 3;

	 		if (text[i]<256)
	 		{
			   letter = text[i]; 
			}   
			else
	 		if (text[i]>=JAPCHARACTERSTART)
	 		{
	 		   if (originalsize==ANTIALIASED_FONT)
					size = JAPANESEFONT_AA;
	 		   else
					size = JAPANESEFONT_BIG;
				letter = (text[i]-JAPCHARACTERSTART);
				JapaneseLetters=1;
			}			
			else
				continue;
//		   if (originalsize==ANTIALIASED_FONT && size!=originalsize) color=PLAIN_TEXTCOLOR;
		}	
		else
			letter = text[i];


	   lx = pa_bittextdefaultsize[size][letter]+textinfo.letterspacing;

	   if(text[i] == '\n' || (x+lx > maxx&&text[i] != ' '))
		{ // retour ligne, ou on d?asse...

			
			width = x - basex; // LARGEUR !

	      if(text[i] == '\n')PA_AddLetterPos('\n', x, y, originalsize, color); // Retour ligne mettre dans le tableau
	      else if(text[i] == ' ') PA_AddLetterPos(' ', x, y, originalsize, color); // Si espace, on met la suite
/*	      else 
			{
			   if (oneLineText)
			   {
			      break;
			   }   
			   if (wrapWord)
			   {
			      wrapWord=0;
				}   
				else
				{
				   x=lastspaceX;			      	
					i=lastspaceI;
					PA_LetterPos.NLetters=lastspaceLetterPos;
					if (i==0) 
					{
					   wrapWord=1;
					   i--;
					   x = basex;
						continue;
					}
					else
					{
					   size = originalsize;
				 		if (text[i]>128)size = 3;
				 		if (text[i]<256)
						   letter = text[i]; 
						else
				 		if (text[i]>=JAPCHARACTERSTART)
				 		{
							size = JAPANESEFONT_BIG;
							letter = (text[i]-JAPCHARACTERSTART);
						}			
					   lx = pa_bittextdefaultsize[size][letter]+textinfo.letterspacing;	 
						x--;
					}			
				}			
	      }  
			   */
	  	   if(y+(originalsize==5?pa_bittextpoliceheight[originalsize]/2:pa_bittextpoliceheight[originalsize]) * 2 > maxy) break;
	 
			if(text[i-1] == ' ') x-= pa_bittextdefaultsize[originalsize][' '];

			PA_DoAlign(letterstart, x, maxx, text[i] != '\n');
     
	      x = basex;
	      y += (originalsize==5?pa_bittextpoliceheight[originalsize]/2:pa_bittextpoliceheight[originalsize])+textinfo.linespacing;
	      
	      letterstart = PA_LetterPos.NLetters; // Premi?e lettre de cette ligne !
		   Soul_AddLetterPos(letter, x, y, size, color);
		   x += lx;   	         
			if (letter==' ')
			{
			   lastspaceX=x;			      	
				lastspaceI=i;
				lastspaceLetterPos=PA_LetterPos.NLetters;
			}						      	
		   
	   }   
	   else
		{
		   if (x+lx >= 0 && x >= basex && x+lx <= 256)
			if (y >= 0 && y >= basey && y <= 192) 
			{
			   Soul_AddLetterPos(letter, x, y, size, color);
			   x += lx;   
			}   
		}		
	}   
	if(text[i-1] == ' ') x-= pa_bittextdefaultsize[originalsize][(' ')]; // Retirer la largeur de l'espace	 
	PA_DoAlign(letterstart, x, maxx, text[i] != '\n' && text[i] != '\0');

	PA_LetterPos.Letter[PA_LetterPos.NLetters].X = x;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Y = y;
}
void convertCharToInt(u16* result,char* source)
{
   int i=0;
	while(source[i])
	{
		result[i]=source[i];
		i++;
	}	
	result[i]=0;
}	
int render16cString(u8 screen)
{
	int i;
	int limit = PA_LetterPos.NLetters;
	for(i = 0; i < limit; i++) 
	{
	   PA_16cLetter(screen, PA_LetterPos.Letter[i].X, PA_LetterPos.Letter[i].Y, 
										PA_LetterPos.Letter[i].Letter, PA_LetterPos.Letter[i].Size, PA_LetterPos.Letter[i].Color);
	}		
	return limit;
}	


int display16cTextForKeyboard(u8 screen, s16 basex, s16 basey, s16 maxx, s16 maxy, char* text, u8 color, u8 size, int cursor)
{
	pa_16cTextDecompress(size);
	Text_DoLetterPos(basex, basey, maxx, maxy, text, color, size,0,-2);
	return render16cString(screen);
}
int display16cText(u8 screen, s16 basex, s16 basey, s16 maxx, s16 maxy, char* text, u8 color, u8 size)
{
	pa_16cTextDecompress(size);
	Text_DoLetterPos(basex, basey, maxx, maxy, text, color, size,0,-2);
	return render16cString(screen);
}
int display16cTextWithOffset(u8 screen, s16 basex, s16 basey, s16 maxx, s16 maxy, char* text, u8 color, u8 size, int offset)
{
	pa_16cTextDecompress(size);
	Text_DoLetterPos(basex, basey, maxx, maxy, text, color, size,offset,-2);
	return render16cString(screen);
}

int display16cTextUInt16(u8 screen, s16 basex, s16 basey, s16 maxx, s16 maxy, u16* text, u8 color, u8 size)
{
	pa_16cTextDecompress(size);
	pa_16cTextDecompress(JAPANESEFONT_BIG);
	Text_DoLetterPosU16(basex, basey, maxx, maxy, text, color, size,0,-2);
	return render16cString(screen);
}
int display16cTextWithOffsetUInt16(u8 screen, s16 basex, s16 basey, s16 maxx, s16 maxy, u16* text, u8 color, u8 size, int offset)
{
	pa_16cTextDecompress(size);
	pa_16cTextDecompress(JAPANESEFONT_BIG);
	Text_DoLetterPosU16(basex, basey, maxx, maxy, text, color, size,offset,-2);
	return render16cString(screen);
}


void initFonts()
{
	PA_16cCustomFont(2, arial_size2);
	PA_16cCustomFont(3, arial_size3);
	PA_16cCustomFont(4, arial_size4);
	PA_16cCustomFont(5, arialAA12);
//	PA_16cCustomFont(7, arialAA12gray);

//	PA_16cCustomFont(5, smallfont);
//	PA_16cCustomFont(6, bigfont);	
//	PA_16cCustomFont(5, us_fontb);
//	PA_16cCustomFont(7, us_fontb);
	PA_16cCustomFont(JAPANESEFONT_BIG, jap_font);	
	PA_16cCustomFont(JAPANESEFONT_AA, arialAA12_jap);			 		
}
