#include <PA9.h>
#include <fat.h>


u32 audio_offset;
u16 audio_pointer;
u16 audio_size = 11500;
char* audio_buffer = NULL;

u8 video_height;
u32 frame_count;
u32 video_offset;
u16 current_frame;
u16 frame_size;
char frame_buffer[98304];

u8 audio_timer;
u32 audio_begin;
u8 video_timer;
u32 video_begin;

int frm_number[250]; // 250 frame numbers for progress bar
int frm_offset[250]; // 250 locations for progress bar

int taboffset=0;

FILE* video_file;
bool screenSMF=0;
bool SMFloaded=0;
bool initSMF(bool screen, char* path)
{
   deinitSMF();
	video_file = fopen(path, "rb");
	if (!video_file)
	{
	   fclose(video_file);
	   return 0;
	}   
   screenSMF=screen;

	if (audio_buffer != NULL) free(audio_buffer);
	
	
	taboffset=0;
	StartTime(true);
	audio_timer = NewTimer(true);
	audio_begin = Tick(audio_timer);
	video_timer = NewTimer(true);
	video_begin = Tick(video_timer);
	audio_buffer = (char*)malloc(sizeof(char) * audio_size * 4);
	


  fread(&video_height, 2, 1, video_file);
  fread(&frame_count, 4, 1, video_file);
  fread(&video_offset, 4, 1, video_file);

// These to arrays for the bar, thay have the frame numbers and file offsets for those frames

	fread(&taboffset,4,1,video_file); // the location of the frame table
	// read the progress bar data
	fseek (video_file , taboffset , SEEK_SET);
	fread(&frm_offset[0],4,250,video_file);
	fread(&frm_number[0],4,250,video_file);

// use the following to set the new file location
	current_frame = 0;//frm_number[100];
//	video_offset = frm_offset[100] + video_offset;
	SMFloaded=1;
	return 1;
}	

void deinitSMF()
{
	audio_offset = 0;
	audio_pointer = 0;
	
	
	video_height = 0;
	frame_count = 0;
	video_offset = 0;
	current_frame = 0;
	frame_size = 0;
	int i=0;
//	for (i=0;i<16;i++)
//	AS_SoundStop(i);
   if (video_file) fclose (video_file);
  SMFloaded=0;
}  


bool updateSMF()
{
  if (frame_count-1 >= current_frame)
  {
     PA_16cErase(1);
     PA_TextAlign(0);
/*	    if(Tick(audio_timer) - audio_begin >= 512 && frame_count-10 >= current_frame)
	    { 
			testtest(0,"0");
	      audio_begin = Tick(audio_timer);
	
	      //if (!feof(video_file) && (5< current_frame))AS_SoundDefaultPlay(&audio_buffer[audio_pointer * audio_size], (u32)audio_size, 127, 64, 0, 0);
			testtest(1,"1");	
	      if(audio_pointer == 3) audio_pointer = 0;
	        else audio_pointer++;
			testtest(2,"2");
	      audio_offset = (((1837 * (current_frame + 6) + 58)>>1)<<1);
			testtest(3,"3");
	      fseek (video_file, audio_offset, SEEK_SET);
			testtest(4,"4");
	      if (!feof(video_file)) fread(&audio_buffer[audio_pointer * audio_size], 1, audio_size, video_file);
			testtest(5,"5");
	    }
*/	
	    if(Tick(video_timer) - video_begin >= 85) // 1024/12 = 85.3333333
	    { 

	      video_begin = Tick(video_timer);

	      fseek(video_file, video_offset, SEEK_SET);

  	      if (feof(video_file)) return 0;
	      fread(&frame_size, 2, 1, video_file);

  	      if (feof(video_file)) return 0;
			memset(frame_buffer,0,98304);	// 98304
			if (frame_size<sizeof(frame_buffer))
			{
			   int i=0;
			   int x;
			   int count=10;
			   for(x=frame_size/count;x>=0;x--)
			   {
			   	fread(frame_buffer+i, 1, count, video_file);
			      i+=count;
				}  	
				if (frame_size%count>0)
				{
			   	fread(frame_buffer+i, 1, frame_size%count, video_file);				   
			 	}  	
			}   
  	      if (feof(video_file)) return 0;

	      video_offset += frame_size + 2;

	      REG_IME = 0x00;

			JPEG_DecompressImage((u8*)frame_buffer,(void*)PA_DrawBg[screenSMF], 256, video_height);

	      REG_IME = 0x01;
	      current_frame++;	
			frame_count++;
	    }
		return 1;
  }
  else
  {
//     deinitSMF();
     return 0;
  }   
}   

