#include <PA9.h>
#include "window.h"
#include "logo.h"
#include "windowCorner.h"
#include "windowCorner_alpha.h"
#include "..\engine.h"
#include "..\..\misc\math.h"
#include "..\..\misc\misc.h"
#include "..\..\system\services\filedetector.h"
#include "..\..\system\services\music\music.h"
#include "..\..\system\services\mwifi.h"
#define WINDOW_CLOSE_TIME 200
const unsigned short window16cPal[8] __attribute__ ((aligned (4))) = {PA_RGB(31,31,31), 38053, 51794, 43338, 46509, 58136, 62364, 65535};

u8 lastStylusX;
u8 lastStylusY;
struct windowInfo
{
   u8 height;
   u8 width;
   bool alive;

   unsigned char type;
   bool semiTransparent;
   bool minimized;
   
   u16 imageTex;
   char text[3][60];
   float minimizedX;
   float minimizedY;
   bool autoNotMinimize;
	struct WindowTransitionInfo
	{
	   s16 x;
	   s16 y;
	   u16 height;
	   u16 width;
	   bool opening;
	   bool closed;
	   u8 timer;
	   bool zoomingIcon;
	} transition;
	
	struct accelInfo
	{
	   s16 x;
	   s16 y;	
	} accelleration;
	bool initialized;
	struct WindowInputInfo
	{
	   s16 ClickedX, ClickedY;
	   int timeNotTouched;
	   u8 marqueePlayerTimer;
		bool Hit;
		bool disableHitTillStylusReleased;
		bool doubleClicked;
		bool ResizeHit;
	} input;
} window;

u16 windowCornerTexture;

#define WINDOWSPRITE_UPPERLEFT_CORNER 90
#define WINDOWSPRITE_UPPERRIGHT_CORNER 91
#define WINDOWSPRITE_LOWERLEFT_CORNER 92
#define WINDOWSPRITE_LOWERRIGHT_CORNER 93
#define WINDOWSPRITE_PLAINSPRITE1 94
#define WINDOWSPRITE_PLAINSPRITE2 95
#define WINDOWSPRITE_IMAGE 96
#define WINDOWSPRITE_WIDTH_CORNER 16
#define WINDOWSPRITE_HEIGHT_CORNER 16
#define WINDOWSPRITE_PALLETE 28
#define WINDOWSPRITE_IMAGE_PALLETE 29

extern char CurrentTheme[256];
u16 greyTexture;
bool isStylusInWindowZone()
{
   return PA_StylusInZone(getWindowX()-12
									,getWindowY()-12
									,getWindowX()+window.width+12
									,getWindowY()+window.height+12);
}   
void initWindowSystem()
{
   if (textScreenColorIsBlack(0))
   {
		//windowCornerTexture = CreateTexFromBmpWithAlpha((void*)windowCorner,WINDOWSPRITE_PALLETE,(void*)windowCorner_alpha);
		greyTexture = createPlainTexture(31,31,31);
	}
	else
	{
		//windowCornerTexture = CreateTexFromBmpWithAlpha((void*)windowCorner,WINDOWSPRITE_PALLETE,(void*)windowCorner_alpha);
		greyTexture = createPlainTexture(0,0,0);
	}		
	windowCornerTexture = greyTexture;
	killWindow();
}

void createNdsPopUp(char* path)
{
   char textInfo[3][100];
	int iconTexture = getIconTexture(path, WINDOWSPRITE_IMAGE_PALLETE);
	if (iconTexture==-1)
		window.imageTex = CreateTexFromThemeResource("filetypes/nds/defaultIcon.bmp",WINDOWSPRITE_IMAGE_PALLETE,1); 
	else
	{
		window.imageTex = iconTexture;
		
		int i=0;
	   int datalocation=0x68;
	   u32 newlocation=0;
	   char data[570];
	   FILE *handle = fopen(path, "rb");
	
	   
	    if (handle) {
	      fseek(handle, datalocation, SEEK_SET); // move datalocation bytes from start of file
	      fread(&newlocation, sizeof(u32), 1, handle);
			datalocation=newlocation+832; // word+832 is english title
			fseek(handle, datalocation, SEEK_SET);
			fread(&data, 1, 560, handle); // read the part of the header we need
		   char letter=0;
	
			int lineCounter=0;
			int j=0;
			for(i=0; i<256; i+=2)//+=2
			{
				letter=makeint(0,0,data[i+1],data[i],1);
				if(letter==10) 
				{
				   lineCounter++;
				   textInfo[lineCounter][j] = '\0';
				   j=0;
				}
				else
				{
				   textInfo[lineCounter][j] = letter;
				   j++;
				}			   
			}
		   textInfo[lineCounter][j] = '\0';
	    }
	    else
	    {
	    	memset(textInfo[0],0,100);
	    	memset(textInfo[1],0,100);
	    	memset(textInfo[2],0,100);
		 }  	
		fclose(handle);
	}		
		
	createWindow(0,0,WINDOW_TYPE_TEXTANDIMAGE,textInfo[0], textInfo[1], textInfo[2]);
}		

void moveWindow(int x, int y)
{
	if (x<5) x=5;
	if (x+getWindowWidth()>251)  x = 251-getWindowWidth();
	if (y<5) y=5;


	if(y+getWindowHeight()>195) 
	{
		if (!window.minimized && window.type == WINDOW_TYPE_TEXTONLY)
		{
		   int i=window.autoNotMinimize;
		   setWindowAutoMinimize(true);
		   createWindow(0, window.semiTransparent, window.type,window.text[0],window.text[1],window.text[2]) ;
  	   	window.input.disableHitTillStylusReleased=true;
		   setWindowAutoMinimize(i);
		}   
	}   
	if (y+getWindowHeight()>200) y = 200-getWindowHeight();
   int width = window.width-WINDOWSPRITE_WIDTH_CORNER;
   int height = window.height-WINDOWSPRITE_HEIGHT_CORNER;

	PA_3DSetSpriteXY(WINDOWSPRITE_UPPERLEFT_CORNER,  x, y);	
	if (window.type==WINDOW_TYPE_TEXTANDIMAGE) PA_3DSetSpriteXY(WINDOWSPRITE_IMAGE,  x+20, y+(height/2)+8);	
	PA_3DSetSpriteXY(WINDOWSPRITE_UPPERRIGHT_CORNER, x+width+pa_3dsprites[WINDOWSPRITE_UPPERLEFT_CORNER].corner[1].x+WINDOWSPRITE_HEIGHT_CORNER+(pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].corner[0].x/1.5), y);
	PA_3DSetSpriteXY(WINDOWSPRITE_LOWERLEFT_CORNER,  x, y+height+WINDOWSPRITE_HEIGHT_CORNER);
	PA_3DSetSpriteXY(WINDOWSPRITE_LOWERRIGHT_CORNER, x+width+pa_3dsprites[WINDOWSPRITE_LOWERLEFT_CORNER].corner[1].x+WINDOWSPRITE_HEIGHT_CORNER+(pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].corner[0].x/1.5), y+height+WINDOWSPRITE_HEIGHT_CORNER);

	PA_3DSetSpriteXY(WINDOWSPRITE_PLAINSPRITE1,  x+WINDOWSPRITE_WIDTH_CORNER+pa_3dsprites[WINDOWSPRITE_UPPERLEFT_CORNER].corner[1].x, y);	
	PA_3DSetSpriteXY(WINDOWSPRITE_PLAINSPRITE2,  x, y+WINDOWSPRITE_HEIGHT_CORNER+pa_3dsprites[WINDOWSPRITE_LOWERLEFT_CORNER].corner[3].y);	
}   

void resizeWindow(int width, int height)
{
   if (getWindowType()==WINDOW_TYPE_MULTIMEDIA)  
	{
	   height = 16;
	   if (width <80) width=80;
	}   
   if (width <0) width=0;
   if (height <0) height=0; 
   window.width = width;
   window.height = height;
   
   width -= WINDOWSPRITE_WIDTH_CORNER;
   height -= WINDOWSPRITE_HEIGHT_CORNER;
	if (height <0 || width<0)
	{
	   int lowSize;
	   if (height< width)
		   lowSize = height;
	   else
		   lowSize = width;
		PA_3DSetSpriteTopRight(WINDOWSPRITE_UPPERLEFT_CORNER,  lowSize, 0);
		PA_3DSetSpriteBottomRight(WINDOWSPRITE_UPPERLEFT_CORNER,  lowSize, lowSize);
		PA_3DSetSpriteBottomLeft(WINDOWSPRITE_UPPERLEFT_CORNER,  0, lowSize);

		PA_3DSetSpriteTopLeft(WINDOWSPRITE_UPPERRIGHT_CORNER,  -lowSize, 0);
		PA_3DSetSpriteBottomRight(WINDOWSPRITE_UPPERRIGHT_CORNER,  0, lowSize);
		PA_3DSetSpriteBottomLeft(WINDOWSPRITE_UPPERRIGHT_CORNER,  -lowSize, lowSize);

		PA_3DSetSpriteBottomLeft(WINDOWSPRITE_LOWERLEFT_CORNER,  0, lowSize);
		PA_3DSetSpriteTopRight(WINDOWSPRITE_LOWERLEFT_CORNER,  lowSize, 0);
		PA_3DSetSpriteBottomRight(WINDOWSPRITE_LOWERLEFT_CORNER,  lowSize, lowSize);
		
		PA_3DSetSpriteBottomLeft(WINDOWSPRITE_LOWERRIGHT_CORNER,  -lowSize, lowSize);
		PA_3DSetSpriteTopLeft(WINDOWSPRITE_LOWERRIGHT_CORNER,  -lowSize, 0);
		PA_3DSetSpriteBottomRight(WINDOWSPRITE_LOWERRIGHT_CORNER,  0, lowSize);

	}   
	else
	{
		PA_3DSetSpriteTopRight(WINDOWSPRITE_UPPERLEFT_CORNER,  0, 0);
		PA_3DSetSpriteBottomRight(WINDOWSPRITE_UPPERLEFT_CORNER,  0, 0);
		PA_3DSetSpriteBottomLeft(WINDOWSPRITE_UPPERLEFT_CORNER,  0, 0);
		
		PA_3DSetSpriteTopLeft(WINDOWSPRITE_UPPERRIGHT_CORNER,  0, 0);
		PA_3DSetSpriteBottomRight(WINDOWSPRITE_UPPERRIGHT_CORNER,  0, 0);
		PA_3DSetSpriteBottomLeft(WINDOWSPRITE_UPPERRIGHT_CORNER,  0, 0);

		PA_3DSetSpriteBottomLeft(WINDOWSPRITE_LOWERLEFT_CORNER,  0, 0);
		PA_3DSetSpriteTopRight(WINDOWSPRITE_LOWERLEFT_CORNER,  0, 0);
		PA_3DSetSpriteBottomRight(WINDOWSPRITE_LOWERLEFT_CORNER,  0, 0);
		
		PA_3DSetSpriteBottomLeft(WINDOWSPRITE_LOWERRIGHT_CORNER,  0, 0);
		PA_3DSetSpriteTopLeft(WINDOWSPRITE_LOWERRIGHT_CORNER,  0, 0);
		PA_3DSetSpriteBottomRight(WINDOWSPRITE_LOWERRIGHT_CORNER,  0, 0);
	}   
	
	PA_3DSetSpriteBottomRight(WINDOWSPRITE_PLAINSPRITE1,  (width-(pa_3dsprites[WINDOWSPRITE_UPPERLEFT_CORNER].corner[1].x-(pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].corner[0].x/1.5)))-WINDOWSPRITE_WIDTH_CORNER, (height+(pa_3dsprites[WINDOWSPRITE_LOWERRIGHT_CORNER].corner[2].y))+WINDOWSPRITE_HEIGHT_CORNER);
	PA_3DSetSpriteBottomLeft(WINDOWSPRITE_PLAINSPRITE1,  0, (height+(pa_3dsprites[WINDOWSPRITE_LOWERLEFT_CORNER].corner[3].y))+WINDOWSPRITE_HEIGHT_CORNER);
	PA_3DSetSpriteTopRight(WINDOWSPRITE_PLAINSPRITE1,  (width-(pa_3dsprites[WINDOWSPRITE_UPPERLEFT_CORNER].corner[1].x-(pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].corner[0].x/1.5)))-WINDOWSPRITE_WIDTH_CORNER, 0);
	
	PA_3DSetSpriteBottomRight(WINDOWSPRITE_PLAINSPRITE2,  width+pa_3dsprites[WINDOWSPRITE_LOWERLEFT_CORNER].corner[1].x+WINDOWSPRITE_HEIGHT_CORNER, (height-(pa_3dsprites[WINDOWSPRITE_LOWERLEFT_CORNER].corner[3].y))-WINDOWSPRITE_HEIGHT_CORNER);
	PA_3DSetSpriteBottomLeft(WINDOWSPRITE_PLAINSPRITE2,  0, (height-(pa_3dsprites[WINDOWSPRITE_LOWERLEFT_CORNER].corner[3].y))-WINDOWSPRITE_HEIGHT_CORNER);
	PA_3DSetSpriteTopRight(WINDOWSPRITE_PLAINSPRITE2,  width+pa_3dsprites[WINDOWSPRITE_UPPERLEFT_CORNER].corner[1].x+WINDOWSPRITE_HEIGHT_CORNER, 0);
	moveWindow(getWindowX(),getWindowY());

 

}	

void setWindowAutoMinimize(bool i) {window.autoNotMinimize=!(i);}
void createWindow(int windowStyle, bool semiTransparent, int type,char* text1, char* text2, char* text3) 
{


   window.input.doubleClicked=false;
   window.alive=true;
	int height = 10 + (8 * ((text2[0]!=0) + (text3[0]!=0)));
	int width = getTextWidth(strlen(text1)>strlen(text2)? 
										strlen(text3)>strlen(text1) ? 
											text3:text1 
									:strlen(text3)>strlen(text2)?
										text3:text2
									, 5);
	      window.minimized=false;
   switch(type)
	{
	   case WINDOW_TYPE_MULTIMEDIA:
	      window.input.marqueePlayerTimer=0;
	      width = 150;
			break;

	   case WINDOW_TYPE_TEXTANDIMAGE:
	      PA_3DCreateSpriteFromTex(WINDOWSPRITE_IMAGE,window.imageTex,32,32,WINDOWSPRITE_IMAGE_PALLETE,60,60);
	      PA_3DSetSpritePrio(WINDOWSPRITE_IMAGE,3001);
	      PA_3DSetSpritePolyID(WINDOWSPRITE_IMAGE,62);
	      width+=32;
			break;

		default:
		   PA_3DSetSpriteVisible(WINDOWSPRITE_IMAGE,0);
	      window.minimized=!(window.autoNotMinimize);
   }   
   width+=16;
   
	if (width<40) width=40;
	if (height<16) height=16;

	PA_3DCreateSpriteFromTex(WINDOWSPRITE_UPPERLEFT_CORNER,  windowStyle==0 || windowStyle==1?windowCornerTexture:greyTexture, 16, 16, WINDOWSPRITE_PALLETE, 0, 0);
	PA_3DCreateSpriteFromTex(WINDOWSPRITE_UPPERRIGHT_CORNER, windowStyle==0 || windowStyle==2?windowCornerTexture:greyTexture, 16, 16, WINDOWSPRITE_PALLETE, 0, 0);
	PA_3DCreateSpriteFromTex(WINDOWSPRITE_LOWERLEFT_CORNER,  windowStyle==0 || windowStyle==2?windowCornerTexture:greyTexture, 16, 16, WINDOWSPRITE_PALLETE, 0, 0);
	PA_3DCreateSpriteFromTex(WINDOWSPRITE_LOWERRIGHT_CORNER, windowStyle==0 || windowStyle==1?windowCornerTexture:greyTexture, 16, 16, WINDOWSPRITE_PALLETE, 0, 0);
	PA_3DCreateSpriteFromTex(WINDOWSPRITE_PLAINSPRITE1, greyTexture, 16,16,0,0,0);
	PA_3DCreateSpriteFromTex(WINDOWSPRITE_PLAINSPRITE2, greyTexture, 16,16,0,0,0);
   window.type = type;

	sprintf(window.text[0],"%s",text1);
   sprintf(window.text[1],"%s",text2);
   sprintf(window.text[2],"%s",text3);
   
	window.semiTransparent = semiTransparent;
	if (semiTransparent)
	{
		PA_3DSetSpriteAlpha(WINDOWSPRITE_UPPERRIGHT_CORNER, 15);
		PA_3DSetSpriteAlpha(WINDOWSPRITE_LOWERLEFT_CORNER,  15);
		PA_3DSetSpriteAlpha(WINDOWSPRITE_UPPERLEFT_CORNER, 15);
		PA_3DSetSpriteAlpha(WINDOWSPRITE_LOWERRIGHT_CORNER, 15);
		PA_3DSetSpriteAlpha(WINDOWSPRITE_PLAINSPRITE1, 15);
		PA_3DSetSpriteAlpha(WINDOWSPRITE_PLAINSPRITE2, 15);
	}		
	else
	{
		PA_3DSetSpriteAlpha(WINDOWSPRITE_UPPERRIGHT_CORNER, 31);
		PA_3DSetSpriteAlpha(WINDOWSPRITE_LOWERLEFT_CORNER,  31);
		PA_3DSetSpriteAlpha(WINDOWSPRITE_UPPERLEFT_CORNER, 31);
		PA_3DSetSpriteAlpha(WINDOWSPRITE_LOWERRIGHT_CORNER, 31);
		PA_3DSetSpriteAlpha(WINDOWSPRITE_PLAINSPRITE1, 31);
		PA_3DSetSpriteAlpha(WINDOWSPRITE_PLAINSPRITE2, 31);
	}   

	PA_3DSetSpritePrio(WINDOWSPRITE_UPPERRIGHT_CORNER, 3000);
	PA_3DSetSpritePrio(WINDOWSPRITE_LOWERLEFT_CORNER,  3000);
	PA_3DSetSpritePrio(WINDOWSPRITE_UPPERLEFT_CORNER, 3000);
	PA_3DSetSpritePrio(WINDOWSPRITE_LOWERRIGHT_CORNER, 3000);
	PA_3DSetSpritePrio(WINDOWSPRITE_PLAINSPRITE1, 3000);
	PA_3DSetSpritePrio(WINDOWSPRITE_PLAINSPRITE2, 3000);	


	PA_3DSetSpritePolyID(WINDOWSPRITE_UPPERRIGHT_CORNER, 61);
	PA_3DSetSpritePolyID(WINDOWSPRITE_LOWERLEFT_CORNER,  61);
	PA_3DSetSpritePolyID(WINDOWSPRITE_UPPERLEFT_CORNER, 61);
	PA_3DSetSpritePolyID(WINDOWSPRITE_LOWERRIGHT_CORNER, 61);
	PA_3DSetSpritePolyID(WINDOWSPRITE_PLAINSPRITE1, 61);
	PA_3DSetSpritePolyID(WINDOWSPRITE_PLAINSPRITE2, 61);	
	

	PA_3DSetSpriteHflip(WINDOWSPRITE_UPPERRIGHT_CORNER, 1);
	PA_3DSetSpriteVflip(WINDOWSPRITE_LOWERLEFT_CORNER, 1);
	PA_3DSetSpriteHflip(WINDOWSPRITE_LOWERRIGHT_CORNER, 1);
	PA_3DSetSpriteVflip(WINDOWSPRITE_LOWERRIGHT_CORNER, 1);
	if (window.minimized)
	{	
		resizeWindow(250, 10);
		moveWindow(128, 216);
		window.minimizedX=0;
		window.minimizedY=190;
	}		
	else
	{	
		
		resizeWindow(width, height);
		moveWindow(128, 152);
		window.transition.x=128;
		window.transition.y=152;
	}		
	window.input.timeNotTouched=0;
	window.transition.opening = true;
	window.transition.closed = false;
	window.transition.timer = 0;
	window.transition.width=0;
	window.transition.height=0;

   window.transition.zoomingIcon = PA_RandMax(2);
   window.input.Hit=false;
   window.input.ResizeHit=false;
	window.accelleration.x=0;
	window.accelleration.y=0;
}	

int getWindowX()
{
   return pa_3dsprites[WINDOWSPRITE_UPPERLEFT_CORNER].X;
}   
int getWindowY()
{
   return pa_3dsprites[WINDOWSPRITE_UPPERLEFT_CORNER].Y;
}   
int getWindowWidth()
{
   return window.width;
}   
int getWindowHeight()
{
   return window.height;
}   
void drawPlayArrow16c(int x, int y)
{
   int a=0;
   int b=0;
   y-=2;
   for(a=0;a<20;a++)
   {
	   for(b=0;b<=(a<10?a:(20-a));b++)      
	   {
	      PA_16cPutPixel(0,b+x,a+y,PLAIN_TEXTCOLOR);
	      
	   }   
   }   
}   
void drawPlayBox16c(int x, int y,int width)
{
   int a=0;
   int b=0;
   y-=2;
   for(a=0;a<20;a++)
   {
	   for(b=0;b<width;b++)      
	   {
	      PA_16cPutPixel(0,b+x,a+y,PLAIN_TEXTCOLOR);
	      
	   }   
   }   
}   
#include "../../userConfigFunctions.h"
	bool charging = 0;
void updateWindowText()
{

	if ((Pad.Newpress.B || isWindowDoubleClicked()) && isWindowAlive())
	{
	  Pad.Newpress.B=0;
	  setWindowTimeNotTouched(300);
	}   
	PA_16cClearZone(0	,pa_3dsprites[WINDOWSPRITE_UPPERLEFT_CORNER].X-8
							,pa_3dsprites[WINDOWSPRITE_UPPERLEFT_CORNER].Y-8
							,pa_3dsprites[WINDOWSPRITE_LOWERRIGHT_CORNER].X+8
							,pa_3dsprites[WINDOWSPRITE_LOWERRIGHT_CORNER].Y+8);
	if (window.minimized)
	{
	   PA_16cTextAlign(ALIGN_RIGHT);
//		if (Pad.Held.A) window.accelleration.x=-10;
		if (isStylusInWindowZone() && Stylus.Newpress)
		{
		   window.input.ClickedX=Stylus.X;
		   window.input.ClickedY=Stylus.Y;		   
		   window.accelleration.x=0;
		   window.accelleration.y=0;
		   
		   window.input.Hit=true;
		}
		else
		if (Stylus.Held && window.input.Hit)   
		{
			window.accelleration.x =Stylus.X-window.input.ClickedX;
			window.accelleration.y =Stylus.Y-window.input.ClickedY;
		   window.minimizedX+=window.accelleration.x;
		   window.minimizedY+=window.accelleration.y;
		   window.input.ClickedX=Stylus.X;		   
		   window.input.ClickedY=Stylus.Y;		   

		}   
		else
		{
		   window.input.Hit=false;
	   }			
		if (!window.input.Hit && window.minimizedX!=250)
		{
		   window.minimizedX+=(250-window.minimizedX)*.05;
		   
		}	
		char displayText[650];
		sprintf(displayText, "%s %s", window.text[0],window.text[1]);		
		display16cText(0,0 ,window.minimizedY-8
									,window.minimizedX 
									,0
									,displayText
									,PLAIN_TEXTCOLOR,2);
		return;
	}			
	if ((IPC->battery >>2)) //is lite
	{
		if ((getBattery()==1 ||  getBattery()==3) && charging==0)
		{
		   charging=1;
			if (!isWindowAlive()) createWindow(0,0,WINDOW_TYPE_TEXTONLY,"Your DS is charging","Backlight set to Highest", "");
			PA_SetDSLBrightness(3);
		}			
		if ((getBattery()==0 ||  getBattery()==2) && charging==1)
		{
			PA_SetDSLBrightness(system.BacklightStrength);
		   charging=0;
		}   
	}	
   if (getWindowType()==WINDOW_TYPE_MULTIMEDIA)  
	{
	   
	   spaceLetteringForDefault();
	   int textX1 = getWindowX()+45;
	   if (isMusicPlaying())
	   {
		   drawPlayArrow16c(getWindowX()+10,getWindowY());
		   
		}  	
	   else
	   {
		   drawPlayBox16c(getWindowX()+10,getWindowY(),4);
		   drawPlayBox16c(getWindowX()+18,getWindowY(),4);	      
	   }   
	   drawPlayArrow16c(getWindowX()+27,getWindowY());
	   drawPlayBox16c(getWindowX()+35,getWindowY(),5);
	   
	   if (window.input.marqueePlayerTimer==250) window.input.timeNotTouched -= 2;
	   
		if (getWindowTimeNotTouched() == 0) window.input.marqueePlayerTimer=0;
		
		char* durationString = getDurationString();
		char displayText[650];
		sprintf(displayText, "%s - %s (%s)",getSongTitle(),getSongAuthor(),durationString);
		free(durationString);
 	 	display16cTextWithOffset(0,textX1 ,getWindowY()+((getWindowHeight()*.25)-6)
		  										,getWindowX()+getWindowWidth()-3
												,0
												,displayText,PLAIN_TEXTCOLOR,2,(getWindowTimeNotTouched()>250)?(250-getWindowTimeNotTouched())>>1:0);
		if (PA_LetterPos.Letter[PA_LetterPos.NLetters].Letter == ')')
			if (PA_LetterPos.Letter[PA_LetterPos.NLetters].X < getWindowX()+getWindowWidth()-10)
			{
			   window.input.timeNotTouched--;
			   if (window.input.marqueePlayerTimer<250) window.input.marqueePlayerTimer++;
			}   
		char* currentTime = getCurrentTimeString();
		//setWindowTimeNotTouched(-1000);
 	 	display16cText(0,textX1 ,getWindowY()+((getWindowHeight()*.75)-2)
		  										,getWindowX()+getWindowWidth()-3
												,0
												,currentTime,PLAIN_TEXTCOLOR,2);
		free(currentTime);
	}   
   else
	if (getWindowHeight()>2)
	{
	   if (getWindowHeight()>=16)
	   {
	      if (window.minimized)
	      spaceLetteringForDefault();
	      else
		   spaceLetteringForAAText();
		   int textX1;
		   if (window.type == WINDOW_TYPE_TEXTANDIMAGE)
		   {
			   PA_16cTextAlign(ALIGN_LEFT);
			   textX1 = getWindowX()+40;
			}   
			else   
			{
			   PA_16cTextAlign(ALIGN_CENTER);
			   textX1 = getWindowX();
			}   
		   
		   bool textAvailable[3];
			if (window.text[1][0]!= 0  && getWindowHeight() > 16)
				textAvailable[1] = true;
			else
				textAvailable[1] = false;
				
			if (window.text[2][0]!= 0  && getWindowHeight() > 22) 
				textAvailable[2] = true;
			else
				textAvailable[2] = false;
				
	 	 	display16cText(0,textX1 ,getWindowY()+(textAvailable[2]? (getWindowHeight()*.1)-1:
																						textAvailable[1]?
																						(getWindowHeight()*.25)-2:
																					   getWindowHeight()*.5)-8
			  										,getWindowX()+getWindowWidth()-3
													,0
													,window.text[0]
													,1,5);
			if (textAvailable[1])
			{
		 	 	display16cText(0,textX1 ,getWindowY()+(textAvailable[2]? (getWindowHeight()*.5+1): (getWindowHeight()*.75)+2)-10	
				  										,getWindowX()+getWindowWidth()-3
														,0
														,window.text[1]
														,1,5);
				if (textAvailable[2])
				{
			 	 	display16cText(0,textX1 ,getWindowY()+(getWindowHeight()*.9)-8
					  										,getWindowX()+getWindowWidth()-3
															,0
															,window.text[2]
															,1,5);
				}			
			}
			spaceLetteringForDefault();
		 } 	 	
	}   

}

void closeWindow()
{

   window.input.timeNotTouched=0;
   window.transition.opening=false;
   window.transition.closed=true;
   window.transition.timer=0;
	window.transition.width=getWindowWidth()<<1;
	window.transition.height=getWindowHeight()<<1;
	window.transition.x=getWindowX();
	window.transition.y=getWindowY()+11;
   if (window.type==WINDOW_TYPE_TEXTANDIMAGE)
   {
      PA_3DSetSpriteAlpha(WINDOWSPRITE_IMAGE,31);
		PA_3DSetSpriteWidthHeight(WINDOWSPRITE_IMAGE,32,32);
   }  
}   

bool isWindowAlive()
{
   return window.alive;
}   
void updateWindowTransitions()
{
   if (window.minimized && isWindowAlive()) 
	{
      if (window.transition.closed)
      killWindow();
      else
	   updateWindowText();
	   return;
	}   
   if (window.transition.opening)
   {
      if (window.transition.timer>32+16)window.transition.timer++;
      window.transition.timer++;
      window.transition.width = window.width<<1;
      window.transition.x=128-((window.transition.width>>1)/2);
      int tempWidth = window.width;
      int tempHeight= window.height;

      if (window.transition.height < window.height<<1) 
		{
		   if (window.transition.height < (int)(window.height*.8)<<1)
			   window.transition.height+=2;
		   else
			   window.transition.height++;
		   window.transition.y=162-((window.transition.height>>1)/2);
	      resizeWindow(window.transition.width>>1,
	      				 window.transition.height>>1);
	      moveWindow  (window.transition.x,
							 window.transition.y);


		}            
		else
		{
		   if ((window.transition.timer>=128+16 && !window.transition.zoomingIcon) || (window.transition.timer>=96+16 && window.transition.zoomingIcon))
		   {
			   if (window.type==WINDOW_TYPE_TEXTANDIMAGE)
			   {
			      PA_3DSetSpriteAlpha(WINDOWSPRITE_IMAGE,31);
					PA_3DSetSpriteWidthHeight(WINDOWSPRITE_IMAGE,32,32);
			   }  
			   window.transition.opening=false;
			}   
		}   
      window.width = tempWidth;
      window.height = tempHeight;

	   updateWindowText();
	   clear16cZone(0,getWindowX()-8,getWindowY()+window.transition.height-12,getWindowX()+window.width,getWindowY()+window.transition.height+32);
	   if (window.type==WINDOW_TYPE_TEXTANDIMAGE)
	   {
		      PA_3DSetSpriteAlpha(WINDOWSPRITE_IMAGE,(31));
		   u8 bounceFreq = (window.transition.timer+16)/32;
		   if (window.transition.zoomingIcon)
			PA_3DSetSpriteWidthHeight(WINDOWSPRITE_IMAGE,32+(abs((PA_Cos((window.transition.timer<<1)<<2))>>2)>>(int)((bounceFreq)*1))
																	  ,32+(abs((PA_Cos((window.transition.timer<<1)<<2))>>2)>>(int)((bounceFreq)*1)));
			else
			PA_3DSetSpriteY(WINDOWSPRITE_IMAGE,(getWindowY()+(window.height/2))-((abs((PA_Cos((window.transition.timer<<1)<<2))>>2)>>(int)((bounceFreq)*2))*3));
//			if (window.transition.timer%32==0) PA_Print(1,"%d\n",window.transition.timer);
	   }  
   }
   else
   if (window.transition.closed)
   {
      window.transition.timer+=1;
      window.transition.width = window.width<<1;
      int tempWidth = window.width;
      int tempHeight= window.height;
/*      int tempX	  = getWindowX();
      int tempY	  = getWindowY();*/
      if (window.transition.height > 0) 
		{
		   if (window.transition.height > (int)(window.height*.2)<<1)
			   window.transition.height-=2;
		   else
			   window.transition.height--;
//		   window.transition.y=getWindowY()-((window.transition.height>>1)/2);
			
		}            
		else
		{
			PA_3DSetSpriteVisible(WINDOWSPRITE_UPPERRIGHT_CORNER, 0);
			PA_3DSetSpriteVisible(WINDOWSPRITE_LOWERLEFT_CORNER,  0);
			PA_3DSetSpriteVisible(WINDOWSPRITE_UPPERLEFT_CORNER, 0);
			PA_3DSetSpriteVisible(WINDOWSPRITE_LOWERRIGHT_CORNER, 0);
			PA_3DSetSpriteVisible(WINDOWSPRITE_PLAINSPRITE1, 0);
			PA_3DSetSpriteVisible(WINDOWSPRITE_PLAINSPRITE2, 0);
			sprintf(window.text[0]," ");
		   sprintf(window.text[1]," ");
		   sprintf(window.text[2]," ");
		   window.alive=false;
			if (window.type!=WINDOW_TYPE_TEXTANDIMAGE || pa_3dsprites[WINDOWSPRITE_IMAGE].Y>=192)
			{
				PA_3DSetSpriteVisible(WINDOWSPRITE_IMAGE, 0);
			   window.transition.closed=false;
			}   
		}   
      resizeWindow(window.transition.width>>1,
      				 window.transition.height>>1);
      if (window.transition.height > 0) 
      moveWindow  (window.transition.x,
						 window.transition.y-((window.transition.height>>1)/2));
	   pa_3dsprites[WINDOWSPRITE_IMAGE].Y += (PA_Sin((int)(window.transition.timer*(window.transition.timer*-.2)))>>2)*(window.transition.timer*.075);
      window.width = tempWidth;
      window.height = tempHeight;

	   updateWindowText();
	   clear16cZone(0,getWindowX()-8,getWindowY()+window.transition.height-12,getWindowX()+window.width,getWindowY()+window.transition.height+32);
   }
}   

int easeValueTo(int value, int dest)
{

	if (value<dest)
	{
	   value+=2;
		if (value<dest-40) value+=4;
		if (value<dest-80) value+=5;
		if (value>dest) value = dest;		
	}		

	if (value>dest) 
	{
	   value-=2;
		if (value>dest+40) value-=4;
		if (value>dest+80) value-=5;	  	
		if (value<dest) value = dest;
	}		
  	return value;
} 

void updatePhysics()
{
   if (!(Stylus.Held && window.input.Hit))
   {
		if (getWindowX()<=5 || getWindowX()+getWindowWidth()>=251) 
		{
		   window.accelleration.x*=-1;
		   if (getWindowX()+getWindowWidth()>=251)
			   moveWindow(	251-getWindowWidth(), getWindowY());
			else
			   moveWindow(	5, getWindowY());
		}   
		if (getWindowY()<=5 || getWindowY()+getWindowHeight()>=187) 
		{
		   window.accelleration.y*=-1;
		   if (getWindowY()+getWindowHeight()>=187)
			   moveWindow(	getWindowX(), 187-getWindowHeight());		   
		   else
			   moveWindow(	getWindowX(), 5);		   
		}
		window.accelleration.x = easeValueTo(window.accelleration.x,0);
		window.accelleration.y = easeValueTo(window.accelleration.y,0);
		if (window.accelleration.x!=0 || window.accelleration.y!=0)
		   moveWindow(	getWindowX()+(window.accelleration.x*.1), getWindowY()+(window.accelleration.y*.05));

	}   
}   

char* getWindowText(int line)
{
   if (line >2) line = 2;
   return window.text[line];
}   
 
int getWindowTimeNotTouched()
{
   return window.input.timeNotTouched;
}	 
int setWindowTimeNotTouched(int value)
{
   window.input.timeNotTouched = value;
   return value;
}	 
int getWindowType()
{
   return window.type;
}	 
bool isWindowHit()
{

   if (window.input.disableHitTillStylusReleased) 
   {
	   if (!Stylus.Held) window.input.disableHitTillStylusReleased=0;
	   else
	   return true;
	}   
   return window.input.Hit;
}	 
bool isWindowDoubleClicked()
{
   return window.input.doubleClicked;
}	 

u8 newNdsFile_WindowCounter=0;

void killWindow()
{
   window.input.timeNotTouched=0;
   window.transition.opening=false;
   window.transition.closed=true;
   window.transition.timer=0;
	window.transition.width=getWindowWidth()<<1;
	window.transition.height=getWindowHeight()<<1;
	window.transition.x=getWindowX();
	window.transition.y=getWindowY()+11;
   if (window.type==WINDOW_TYPE_TEXTANDIMAGE)
   {
      PA_3DSetSpriteAlpha(WINDOWSPRITE_IMAGE,31);
		PA_3DSetSpriteWidthHeight(WINDOWSPRITE_IMAGE,32,32);
   }  
	PA_3DSetSpriteVisible(WINDOWSPRITE_UPPERRIGHT_CORNER, 0);
	PA_3DSetSpriteVisible(WINDOWSPRITE_LOWERLEFT_CORNER,  0);
	PA_3DSetSpriteVisible(WINDOWSPRITE_UPPERLEFT_CORNER, 0);
	PA_3DSetSpriteVisible(WINDOWSPRITE_LOWERRIGHT_CORNER, 0);
	PA_3DSetSpriteVisible(WINDOWSPRITE_PLAINSPRITE1, 0);
	PA_3DSetSpriteVisible(WINDOWSPRITE_PLAINSPRITE2, 0);
	pa_3dsprites[WINDOWSPRITE_IMAGE].Y=192;
	sprintf(window.text[0]," ");
   sprintf(window.text[1]," ");
   sprintf(window.text[2]," ");
   window.alive=false;
	if (window.type!=WINDOW_TYPE_TEXTANDIMAGE || pa_3dsprites[WINDOWSPRITE_IMAGE].Y>=192)
	{
		PA_3DSetSpriteVisible(WINDOWSPRITE_IMAGE, 0);
	   window.transition.closed=false;
	}   
}   

void displayLastGameWindow()
{
   char lastPlayed[256];
	FILE* historyFile = fopen ("fat:/_menudo/logs/HISTORY.LASTOPENED", "rb"); //rb = read
	if (historyFile)
	{			
		fgets(lastPlayed, 256, historyFile);
		fclose(historyFile);
	}			
	else
	{
  		fclose(historyFile);
		return;
	}			
  	int iconTexture = getIconTexture(lastPlayed, WINDOWSPRITE_IMAGE_PALLETE);
	if (iconTexture==-1)
		window.imageTex = CreateTexFromThemeResource("filetypes/nds/defaultIcon.bmp",WINDOWSPRITE_IMAGE_PALLETE,1); 
	else
	{
		window.imageTex = iconTexture;
	}		
   createWindow(0,0,WINDOW_TYPE_TEXTANDIMAGE,"Load Last Played Game?","","");
}   
void setWindowText(int line,char* text)
{
   sprintf(window.text[line],"%s",text);
}   
void displayNewNdsWindow()
{
	if (isNewNDSFound()) 
	{
	   char temp[256];
	   if (getAmountOfNewNDS()>1)
	   {
		   sprintf(temp, "%d New NDS Files",getAmountOfNewNDS());
		   createWindow(0,0,WINDOW_TYPE_TEXTONLY,"New Set of NDS Found",temp,"");
		}   
		else
	   {
		   createWindow(0,0,WINDOW_TYPE_TEXTONLY,"New NDS File Found",getFileNameTrimmed(getPathOfNewNDS(0)),"");
		}   
	}   
}   
void updateWifiConnect()
{
   if (wifi.connecting)
   {
     	setWindowTimeNotTouched(0);
		int k=Wifi_AssocStatus(); // check status
		if(k==ASSOCSTATUS_ASSOCIATED) {
			initWifiService();
		   wifi.connecting = 0;
			createWindow(0,0,WINDOW_TYPE_TEXTONLY,"Connected as",wifi.username, "");
		}
		else
		if(k==ASSOCSTATUS_CANNOTCONNECT) {
			cancellWifiConnect();
		   createWindow(0,0,WINDOW_TYPE_TEXTONLY,"Access point not found","", "");
		}
	}		
}	
void updateWindow()
{

   updateWindowTransitions();
   if (!pa_3dsprites[WINDOWSPRITE_UPPERLEFT_CORNER].Alive) return;
   
   if (!isWindowHit() && getWindowType()!= WINDOW_TYPE_MULTIMEDIA)
		if (getWindowTimeNotTouched() > WINDOW_CLOSE_TIME)
		{
			if (newNdsFile_WindowCounter < getAmountOfNewNDS() &&(stricmp(getWindowText(0),"New NDS File Found")   == 0 ||
																					stricmp(getWindowText(0),"New Set of NDS Found") == 0 || 
																					(getWindowType()== WINDOW_TYPE_TEXTANDIMAGE && stricmp(getWindowText(0),"Load Last Played Game?") != 0))) 
			{
			   setWindowTimeNotTouched(300);
				createNdsPopUp(getPathOfNewNDS(newNdsFile_WindowCounter));
				window.input.doubleClicked=false;
				newNdsFile_WindowCounter++;
			}			
			else
			{
			   if (stricmp(getWindowText(0),"New NDS File Found")!=0 && isNewNDSFound() && newNdsFile_WindowCounter < getAmountOfNewNDS())
				{
				   displayNewNdsWindow();
				}
				else	      
					closeWindow();
			}			
		}			
   window.input.timeNotTouched++;
   if (window.minimized)
   	updateWindowMinimized();
   else
   	updateWindowNotMinimized();
}   
void updateWindowNotMinimized()
{

	if (!window.semiTransparent)
	{
		if (pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].alpha < 31)
		{
			if (Stylus.Newpress && isStylusInWindowZone())
			   window.input.doubleClicked=true;
			else
			   window.input.doubleClicked=false;
		   pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].alpha++;
		}   
	}
	else
	{
		if (pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].alpha > 15)
		{
			if (Stylus.Newpress && isStylusInWindowZone())
			   window.input.doubleClicked=true;
			else
			   window.input.doubleClicked=false;
		   pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].alpha--;
		}
	}	
	pa_3dsprites[WINDOWSPRITE_LOWERLEFT_CORNER].alpha =  pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].alpha;   
	pa_3dsprites[WINDOWSPRITE_UPPERLEFT_CORNER].alpha = pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].alpha;   
	pa_3dsprites[WINDOWSPRITE_LOWERRIGHT_CORNER].alpha = pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].alpha;   
	pa_3dsprites[WINDOWSPRITE_PLAINSPRITE1].alpha = pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].alpha;   
	pa_3dsprites[WINDOWSPRITE_PLAINSPRITE2].alpha = pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].alpha;   
	
   if (Stylus.Released && window.input.Hit)
   {

		window.accelleration.x=(window.accelleration.x)*10;
		window.accelleration.y=(window.accelleration.y)*10;

      window.input.Hit = false;
      window.input.ResizeHit = false;
   }  
		   
	if (Stylus.Newpress && isStylusInWindowZone())
	{
		if (getWindowType()!= WINDOW_TYPE_MULTIMEDIA) window.input.timeNotTouched=0;
		
		if (PA_StylusInZone(getWindowX()+10,getWindowY(),getWindowX()+20,getWindowY()+20)) togglePlayPauseMusic();
		
	   window.input.Hit=true;
	   window.transition.opening=false;
   	resizeWindow(getWindowWidth(), getWindowHeight());
      PA_3DSetSpriteAlpha(WINDOWSPRITE_IMAGE,31);
		PA_3DSetSpriteWidthHeight(WINDOWSPRITE_IMAGE,32,32);
		pa_3dsprites[WINDOWSPRITE_UPPERRIGHT_CORNER].alpha = (!window.semiTransparent? 15 : 31);
      if (PA_StylusInZone(getWindowX()+window.width-8,getWindowY()+window.height-8,getWindowX()+window.width+8,getWindowY()+window.height+8))
      {
         window.input.ResizeHit = true;
	      window.input.ClickedX = getWindowX();
	      window.input.ClickedY = getWindowY();
//			PA_Print(1,"%d %d\n %d %d",Stylus.X,Stylus.Y,getWindowX(),getWindowY());
      }   
      else
      {
	      window.input.ClickedX = Stylus.X - getWindowX();
	      window.input.ClickedY = Stylus.Y - getWindowY();
			window.input.ResizeHit = false;
      }   
      

   }   


   if (Stylus.Held && window.input.Hit)
   {
		if (getWindowType()!= WINDOW_TYPE_MULTIMEDIA) window.input.timeNotTouched=0;
      window.accelleration.x= Stylus.X-lastStylusX;
      window.accelleration.y= Stylus.Y-lastStylusY;
      lastStylusX=Stylus.X;
      lastStylusY=Stylus.Y;

      if (window.input.ResizeHit)
      {
	      resizeWindow(Stylus.X - window.input.ClickedX < 40? 40 : Stylus.X - window.input.ClickedX,
	      				 Stylus.Y - window.input.ClickedY < 16? 16 : Stylus.Y - window.input.ClickedY);
      }   
      else
      {
	      moveWindow(	Stylus.X - window.input.ClickedX,
	      				Stylus.Y - window.input.ClickedY);
     	}			
   }   



	
	if (!(window.transition.opening || window.transition.closed)) updatePhysics();
   if (!window.transition.opening) updateWindowText();
}   
void updateWindowMinimized()
{
	if (window.minimizedY<190-14)
	{
	   int i=window.autoNotMinimize;
	   setWindowAutoMinimize(false);
	   createWindow(0, window.semiTransparent, window.type,window.text[0],window.text[1],window.text[2]) ;
	   	window.transition.opening = false;
		moveWindow(Stylus.X,Stylus.Y);
	   	window.accelleration.y=100;	   
	   	window.input.disableHitTillStylusReleased=true;
	   	window.input.Hit=false;
	   setWindowAutoMinimize(i);
	   return;
	}   
   if (!isWindowHit())
		window.minimizedY+=(190-window.minimizedY)*.05;
	moveWindow(250,window.minimizedY);

   if (!window.transition.opening) updateWindowText();
}   
void createMultimediaWindow()
{
	loadMusic();
	createWindow(0,1,WINDOW_TYPE_MULTIMEDIA,"","", "");
	window.transition.height = window.height<<1;
	updateWindowTransitions();
	moveWindow(12,10);
//	window.transition.y = 10;

}   
