#include <PA9.h>       // Include for PA_Lib

#include "../engine/engine.h"
#include "alarm_color.h"
#include "alarm_color_m.h"
#include "alarm_0.h"
#include "alarm_1.h"
#include "alarm_2.h"
#include "alarm_3.h"
#include "alarm_4.h"
#include "alarm_5.h"
#include "alarm_6.h"
#include "alarm_7.h"
#include "alarm_8.h"
#include "alarm_9.h"
#include "alarm_colon.h"
#include "alarm_A.h"
#include "alarm_P.h"
#include "alarm_M.h"
#include "alarm_hours_remaining.h"
#include "alarm_hours_remaining_color.h"
#include "alarm_hand0_color.h"
#include "alarm_hand0.h"
extern u8 pa_3Dscreen;
u16 numberTex[10];
u16 colonTex;
u16 letterATex;
u16 letterPTex;
u16 letterMTex;
int alarmHour=1;
bool alarmPM=0;
int alarmMinute=0;
bool startAlarm=0;
void initTextures()
{
   int i=0;
/*   char chartemp[256];
   for (i=0;i<10;i++)
   {
	   sprintf(chartemp,"apps/alarm/%d.bmp",i);
	   numberTex[i] = CreateTexFromThemeResource(chartemp, i, true);
	}   

	colonTex   = CreateTexFromThemeResource("apps/alarm/colon.bmp",10,true);
	letterPTex = CreateTexFromThemeResource("apps/alarm/P.bmp",11,true);
	letterATex = CreateTexFromThemeResource("apps/alarm/A.bmp",12,true);
	letterMTex = CreateTexFromThemeResource("apps/alarm/M.bmp",13,true);*/
	numberTex[0] = CreateTexFromBmpWithAlpha((void*)alarm_color,0,(void*)alarm_0);
	numberTex[1] = CreateTexFromBmpWithAlpha((void*)alarm_color,0,(void*)alarm_1);
	numberTex[2] = CreateTexFromBmpWithAlpha((void*)alarm_color,0,(void*)alarm_2);	
	numberTex[3] = CreateTexFromBmpWithAlpha((void*)alarm_color,0,(void*)alarm_3);
	numberTex[4] = CreateTexFromBmpWithAlpha((void*)alarm_color,0,(void*)alarm_4);
	numberTex[5] = CreateTexFromBmpWithAlpha((void*)alarm_color,0,(void*)alarm_5);	
	numberTex[6] = CreateTexFromBmpWithAlpha((void*)alarm_color,0,(void*)alarm_6);
	numberTex[7] = CreateTexFromBmpWithAlpha((void*)alarm_color,0,(void*)alarm_7);
	numberTex[8] = CreateTexFromBmpWithAlpha((void*)alarm_color,0,(void*)alarm_8);	
	numberTex[9] = CreateTexFromBmpWithAlpha((void*)alarm_color,0,(void*)alarm_9);

	colonTex   = CreateTexFromBmpWithAlpha((void*)alarm_color,0,(void*)alarm_colon);
	letterPTex = CreateTexFromBmpWithAlpha((void*)alarm_color_M,0,(void*)alarm_P);
	letterATex = CreateTexFromBmpWithAlpha((void*)alarm_color_M,0,(void*)alarm_A);
	letterMTex = CreateTexFromBmpWithAlpha((void*)alarm_color_M,0,(void*)alarm_M);
	
}		
void initScreen(bool screen)
{
   int i;
	PA_3DCreateSpriteFromTex(0+((1-screen)*10),numberTex[0],64,32,0,8+32,67+16+((1-screen)*250));
	PA_3DCreateSpriteFromTex(1+((1-screen)*10),numberTex[0],64,32,0,38+32,67+16+((1-screen)*250));
	PA_3DCreateSpriteFromTex(2+((1-screen)*10),colonTex,64,32,0,60+32,67+16+((1-screen)*250));
	PA_3DCreateSpriteFromTex(3+((1-screen)*10),numberTex[0],64,32,0,84+32,67+16+((1-screen)*250));
	PA_3DCreateSpriteFromTex(4+((1-screen)*10),numberTex[0],64,32,0,115+32,67+16+((1-screen)*250));
	PA_3DCreateSpriteFromTex(5+((1-screen)*10),letterPTex,64,32,0,166+16,67+16+((1-screen)*250));
	PA_3DCreateSpriteFromTex(6+((1-screen)*10),letterMTex,64,32,0,206+16,67+16+((1-screen)*250));
	if (screen)
	{
		PA_3DCreateSpriteFromTex(7,numberTex[1],64,32,0,206+9-64,67+32+2);
		PA_3DCreateSpriteFromTex(8,numberTex[1],64,32,0,206-64,67+32+2);
		PA_3DSetSpriteWidthHeight(7,64/2.3,32/2.3);
		PA_3DSetSpriteWidthHeight(8,64/2.3,32/2.3);
		CreateSpriteFromBmpWithAlpha(9,(void*)alarm_hours_remaining_color,0,(void*)alarm_hours_remaining,206+8-32,67+32+4);
	}		
	for (i=0+((1-screen)*10);i<=9+((1-screen)*10);i++)
	PA_3DSetSpritePolyID(i,i);
}   
void initAMInput()
{
	PA_3DCreateSpriteFromTex(61,letterATex,64,32,0,166+16,67+32+250 - (60));
	PA_3DSetSpriteAlpha(61,15);
	PA_3DSetSpritePolyID(61,40);

	PA_3DCreateSpriteFromTex(62,letterMTex,64,32,0,206+16,67+32+250 - (60));
	PA_3DSetSpriteAlpha(62,15);
	PA_3DSetSpritePolyID(62,41);

}  
void initClockInput()
{
   int i;
	for (i=0;i<10;i++)
	{
		PA_3DCreateSpriteFromTex(50+i,numberTex[i],64,32,0,32,67+32+250 + (i*20));
		PA_3DSetSpriteAlpha(50+i,15);
		PA_3DSetSpritePolyID(50+i,30+i);
		PA_3DSetSpriteWidthHeight(50+i,64/1.5,32/1.5);
	}		

}   
void hideInput()
{
   int i;
	for (i=0;i<10;i++)
	{
		PA_3DSetSpriteVisible(50+i,0);
	}	
}   
void hideAMInput()
{
	PA_3DSetSpriteVisible(61,0);  
	PA_3DSetSpriteVisible(62,0);  
}   
int getInput(int currentValue, int limit, int max, int x)
{

   int i;
	if (Pad.Newpress.Up)currentValue++;
	if (Pad.Newpress.Down) currentValue--;
	if (currentValue>max) currentValue=max;
	if (currentValue<limit) currentValue=limit;
	for (i=0;i<10;i++)
	{
		if (i>max || limit>i || currentValue == i)
			PA_3DSetSpriteVisible(50+i,0);
		else
		{
		   PA_3DSetSpriteX(50+i,PA_3DGetSpriteX(x)-6);
			PA_3DSetSpriteVisible(50+i,1);
			if (i-currentValue>0)
				PA_3DSetSpriteY(50+i,359 + ((i-currentValue)*20));
			else
				PA_3DSetSpriteY(50+i,309 + ((i-currentValue)*20));
		}			
//		PA_3DSetSpriteY(50+i,349 + (PA_Sin((i-currentValue)<<3)));
	}		
   return currentValue;
}   
bool getAMInput(bool currentValue)
{
	if (Pad.Newpress.Up) currentValue=false;
	if (Pad.Newpress.Down) currentValue=true;
   PA_3DSetSpriteVisible(61,1);
   PA_3DSetSpriteVisible(62,1);
	if (currentValue)
	{
		PA_3DSetSpriteY(61,349-(60));
		PA_3DSetSpriteY(62,349-(60));
		PA_3DSetSpriteTex(61,letterATex);
	}		
	else
	{
		PA_3DSetSpriteY(61,349+(40));
		PA_3DSetSpriteY(62,349+(40));
		PA_3DSetSpriteTex(61,letterPTex);
	}	
   return currentValue;
}   

void setClock(bool screen, int hour, int minute)
{
   if (hour>=12)
		PA_3DSetSpriteTex(5+((1-screen)*10),letterPTex);
	else
		PA_3DSetSpriteTex(5+((1-screen)*10),letterATex);
		
	hour = hour %12;
	if (hour==0) hour=12;
	
	if (10>hour)
		PA_3DSetSpriteTex(0+((1-screen)*10),numberTex[0]);
	else
		PA_3DSetSpriteTex(0+((1-screen)*10),numberTex[1]);
	
	PA_3DSetSpriteTex(1+((1-screen)*10),numberTex[hour%10]);
	
	PA_3DSetSpriteTex(3+((1-screen)*10),numberTex[(int)(minute*.1)]);
	PA_3DSetSpriteTex(4+((1-screen)*10),numberTex[minute%10]);
}   
void updateRemainingTime()
{
   int i=PA_RTC.Hour;
   int remaining=0;
   if (PA_RTC.Hour==alarmHour+(alarmPM?12:0) && PA_RTC.Minutes>alarmMinute)
	{
	   remaining++;
	   i++;
	}   
   while(i!=alarmHour+(alarmPM?12:0))
   {
      remaining++;
      i++;
      if (i==24)i=0;
   }   
   if (remaining<10) 
		PA_3DSetSpriteVisible(8,0);
	else
		PA_3DSetSpriteVisible(8,1);

	PA_3DSetSpriteTex(8,numberTex[(int)(remaining*.1)]);
	PA_3DSetSpriteTex(7,numberTex[remaining%10]);
}   
void initClockAmbience()
{
   int i;
   for (i=0;i<3;i++)
   {
		CreateSpriteFromBmpWithAlpha(70+i,(void*)alarm_hand0_color,1,(void*)alarm_hand0,40,170);
		PA_3DSetSpriteBottomLeft (70+i,0+(i*2),22-(i*5));
		PA_3DSetSpriteBottomRight(70+i,0-(i*2),22-(i*5));
		PA_3DSetSpriteTopLeft	 (70+i,0+(i*2),22);
		PA_3DSetSpriteTopRight	 (70+i,0-(i*2),22);
		PA_3DSetSpriteAlpha		 (70+i,10-(i*2));
		PA_3DSetSpritePolyID(70+i,50+i);
	}		
	
   for (i=0;i<2;i++)
   {
		CreateSpriteFromBmpWithAlpha(73+i,(void*)alarm_hand0_color,1,(void*)alarm_hand0,200,173);
		PA_3DSetSpriteBottomLeft (73+i,0+(i*2),22-(i*5));
		PA_3DSetSpriteBottomRight(73+i,0-(i*2),22-(i*5));
		PA_3DSetSpriteTopLeft	 (73+i,0+(i*2),22);
		PA_3DSetSpriteTopRight	 (73+i,0-(i*2),22);
		PA_3DSetSpriteAlpha		 (73+i,10-(i*2));
		PA_3DSetSpritePolyID(73+i,50+i);
	}
	
}  
void updateClockAmbience(bool clock, int hour, int minute, int second)
{
	pa_3dsprites[70+(clock*3)].RotZ=256-(((hour*60)+minute)*.7);
//	pa_3dsprites[70].RotZ=256-(hour*42.6);
//	pa_3dsprites[71].RotZ=256-(minute*8.5);
	pa_3dsprites[71+(clock*3)].RotZ=256-(((minute*60)+second)*.14);
	pa_3dsprites[72+(clock*3)].RotZ=256-(second*8.5);
}
void sleepMode()
{
   hideAMInput();
   hideInput();
   int i;
   for (i=0;i<=6;i++)
	   PA_3DSetSpriteVisible(i+10,0);
   while(true)
   {
      if (startAlarm)
      {
         if (PA_RTC.Frames/20%2)
         {
	         PA_SetBrightness(0,5);
	         PA_SetBrightness(1,5);
	      }   
	      else
	      {
	         PA_SetBrightness(0,0);
	         PA_SetBrightness(1,0);
	      }   
      }   
      else
		   updateRemainingTime();
	   setClock(1,PA_RTC.Hour,PA_RTC.Minutes);	   
	   if (PA_RTC.Hour==alarmHour+(alarmPM?12:0) && PA_RTC.Minutes==alarmMinute) startAlarm=1;
	   
	   updateClockAmbience(0, PA_RTC.Hour,PA_RTC.Minutes,PA_RTC.Seconds);

		ZoomXY_3DProcess(128,0,0);
      Soul_waitForVBL();
      if (Pad.Newpress.A) break;
   }   
   startAlarm=0;
   for (i=0;i<=6;i++)
	   PA_3DSetSpriteVisible(i+10,1);
}	   
void alarmApp()
{
//	PA_SwitchScreens();

   clearSystem();
	PA_SetBrightness(0,-31);
	PA_SetBrightness(1,-31);
//	if (PA_Screen) PA_SwitchScreens();
	PA_Init3DDual(); // Uses Bg0, Init 3D...
	PA_Reset3DSprites(); // Init or Reset 3D Sprites
//	PA_Screen=0;	
//	PA_Screen=0;
	PA_Init16cBg(0,1);
	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);

	initAntiAliasedText(0,1,0);

	create3dBackgroundLayer(29,0,0,0);
	
	PA_3DSetSpriteY(29,250);
	PA_3DSetSpriteHeight(29,500);

	initTextures();
	initScreen(1);
	initScreen(0);
	initClockAmbience();
	initAMInput();
	hideAMInput();
	initClockInput();
	int select=0;
	
	alarmHour=PA_RTC.Hour;
	if (alarmHour>12) 
	{
	   alarmHour-=12;
	   alarmPM=1;
	}   
	alarmMinute=PA_RTC.Minutes; 
	int transitionBrightness=62;
	while(1) 
	{
	   if (Pad.Newpress.A) transitionBrightness=0;
	   if (transitionBrightness>0) transitionBrightness--;
	  	PA_SetBrightness(0,-(transitionBrightness/2));
		PA_SetBrightness(1,-(transitionBrightness/2));
		
	   if (Pad.Newpress.Left && select>0) select--;
	   if (Pad.Newpress.Right && select<4) select++;
		switch(select)
		{
		   case 0:  
						if (alarmHour==0) alarmHour=12;
			   		if (Pad.Newpress.Down)
		   			{
		   			   if (alarmHour==10)
			   			   alarmHour=1;
		   			   else
					   		alarmHour=(alarmHour%10)+(getInput(alarmHour*.1,0,1,0)*10);
						}			
						else
						{
				   		alarmHour=(alarmHour%10)+(getInput(alarmHour*.1,0,1,0)*10);
						}			
						if (alarmHour>=12) alarmHour=0;
		   			break;
		   case 1:  
						if (alarmHour==0) alarmHour=12;
			   		if (alarmHour>=10) 
				   		alarmHour=((int)(alarmHour*.1)*10)+getInput(alarmHour%10,0,2,1);
				   	else
				   		alarmHour=((int)(alarmHour*.1)*10)+getInput(alarmHour%10,1,9,1);
						if (alarmHour>=12) alarmHour=0;
		   			break;
		   case 2:  alarmMinute=(alarmMinute%10)+(getInput(alarmMinute*.1,0,5,3)*10);
		   			break;
		   case 3:  hideAMInput();
			   		alarmMinute=((int)(alarmMinute*.1)*10)+getInput(alarmMinute%10,0,9,4);
		   			break;
		   case 4:  hideInput();
			   		alarmPM=getAMInput(alarmPM);
		   			break;
		}

	   setClock(1,PA_RTC.Hour,PA_RTC.Minutes);	   
	   
	   
	   setClock(0,alarmHour+(alarmPM?12:0),alarmMinute);
	   updateRemainingTime();
	   updateClockAmbience(0, PA_RTC.Hour,PA_RTC.Minutes,PA_RTC.Seconds);
	   updateClockAmbience(1, alarmHour,alarmMinute,0);
//	   PA_3DSetSpriteXY(0,Stylus.X,Stylus.Y);

		if (Pad.Newpress.A)
		{
			sleepMode();
		}	

		ZoomXY_3DProcess(128,0,0);
		Soul_waitForVBL();
		if (Pad.Newpress.B) break;
	}
	
	if (pa_3Dscreen==1)
	{
	   PA_SwitchScreens(); 
		pa_3Dscreen = !pa_3Dscreen;
	}		
}   
