#include <PA9.h>
#include <fat.h>
#include <sys/dir.h>
//#include "canvasFull_topscreen.h"
#include "../engine/engine.h"
#include "../gfx/all_gfx.h"
extern u8 PA_Screen;
#define updateBrightness16cCursor(); circleCursor(146+BrightnessPicker_X,147+5);
#define updateColor16cCursor(); pointCursor(53+ColorPicker_X,32+ColorPicker_Y);
u8 ColorPicker_X=0;
u8 ColorPicker_Y=0;
u8 BrightnessPicker_X=0;
bool fileChanged=0;
bool isAlphaPressureSensitive()
{
   return PA_GetSpriteX(0,0) != 10;
}   
bool isThicknessPressureSensitive()
{
   return PA_GetSpriteX(0,1) != 30;
}   
int getFullDoodleColor()
{
   return PA_Get16bitPixel(0,146+BrightnessPicker_X,147+5);
}   
float getFullDoodleAlpha()
{
   if (isAlphaPressureSensitive()) return -1;
   return 1.0-((float)(PA_GetSpriteY(0,0) - 33) /80);
}   
float getFullDoodleThickness()
{
   if (isThicknessPressureSensitive()) return -1;
   return (1.0-((float)(PA_GetSpriteY(0,1) - 33)/80))*4;
}
void updateFilenameText(char* filename)
{
//   fileChanged=1;
   char temp[200];
   sprintf(temp,"%s.bmp %s",filename,fileChanged?"*":"");
   display16cText(0,5,2,200,2,temp,1,5);
}   
void pointCursor(int x,int y)
{
   int i=0;
   for (i=2;i<6;i++)
   {
	   PA_16cPutPixel(0,x+i,y,PLAIN_TEXTCOLOR);
	   PA_16cPutPixel(0,x-i,y,PLAIN_TEXTCOLOR);
	   PA_16cPutPixel(0,x,y+i,PLAIN_TEXTCOLOR);
	   PA_16cPutPixel(0,x,y-i,PLAIN_TEXTCOLOR);
	}   
}   
void circleCursor(int x,int y)
{
   int i=0;
   for (i=-1;i<=1;i++)
	   PA_16cPutPixel(0,x+i,y-6,PLAIN_TEXTCOLOR);   

   for (i=-1;i<=1;i++)
	   PA_16cPutPixel(0,x+i,y+7,PLAIN_TEXTCOLOR);   	   
	   
   for (i=-6;i<=6;i++)
   {
	   PA_16cPutPixel(0,x-1,y+i,PLAIN_TEXTCOLOR);   
	   PA_16cPutPixel(0,x+1,y+i,PLAIN_TEXTCOLOR);   
	}    
	   //11
}  

void WuLine(int screen, float x1, float y1, float x2, float y2, int color,float alpha,float thickness);

  

void putPixelAlpha_16bit(u8 screen, s16 x, s16 y, u16 color, float alpha) ;
void draw16cBox(u8 screen, s16 x, s16 y, s16 x2, s16 y2, u16 color, float alpha);   
void draw16cRoundedBox(u8 screen, s16 x, s16 y, s16 x2, s16 y2, u16 color)
{
   int i1,i2;
   for (i1=x;i1<=x2;i1++)
	   for (i2=y;i2<=y2;i2++)
	   {
		   if ((i1== x || i1== x2) && (i2== y || i2== y2)) 
				putPixelAlpha_16bit(screen, i1, i2, color, .2);
			else
				putPixelAlpha_16bit(screen, i1, i2, color, 1);
		}   
}   
void updatePreview()
{
   //WuLine(0, 58, 160, 58+78, 160, getFullDoodleColor(),getFullDoodleAlpha(),getFullDoodleThickness());
   draw16cBox(0, 55, 149, 55+79, 149+12, 60250, 1);

/*   for (i=0; i<=5;i++)
   WuLine(0, 70+(i*10), 160, 70+((i+1)*10), 160, getFullDoodleColor(),getFullDoodleAlpha(),getFullDoodleThickness());*/
   //56/8 == 7
   WuLine(0, 68, 154, 124, 154, getFullDoodleColor(),getFullDoodleAlpha() == -1?2:getFullDoodleAlpha(),getFullDoodleThickness() == -1?2:getFullDoodleThickness());

}
void updateBrightnessPicker()
{   
   int i;
   int red, green, blue;
   red = (getRed(PA_Get16bitPixel(0,53+ColorPicker_X,32+ColorPicker_Y))*2.5);
   if (red<0) red=0;
   if (red>31) red=31;
	green = (getGreen(PA_Get16bitPixel(0,53+ColorPicker_X,32+ColorPicker_Y))*2.5);
   if (green<0) green=0;
   if (green>31) green=31;
	blue = (getBlue(PA_Get16bitPixel(0,53+ColorPicker_X,32+ColorPicker_Y))*2.5);
   if (blue<0) blue=0;
   if (blue>31) blue=31;
   for (i=0;i<=31;i++)
   {
	   draw16cBox(0, 145+(3*i), 147, 145+(3*(i+1)), 147+11, PA_RGB(red,green,blue), 1);
	   red--;
	   if (red<0) red=0;
	   if (red>31) red=31;
		green--;
	   if (green<0) green=0;
	   if (green>31) green=31;
		blue--;
	   if (blue<0) blue=0;
	   if (blue>31) blue=31;

	}   
}

void setAlphaPressureSensitive(bool on)
{
   if (!on)
   {
		PA_SetSpriteX(0,0,256);
     	draw16cRoundedBox(0,13,149,13+9,149+9,PA_RGB(0,0,0)); 
	}			
	else
	{
		PA_SetSpriteX(0,0,10);
	   draw16cBox(0, 13,149,13+9,149+9,PA_RGB(31,31,31), 1);
	}	
}   
void setThicknessPressureSensitive(bool on)
{
   if (!on)
   {
		PA_SetSpriteX(0,1,256);
     	draw16cRoundedBox(0,33,149,33+9,149+9,PA_RGB(0,0,0)); 
	}			
	else
	{
		PA_SetSpriteX(0,1,30);
	   draw16cBox(0, 33,149,33+9,149+9,PA_RGB(31,31,31), 1);
	}			
}   
bool flipDoodleScreen(char* filename)
{
   //if (PA_Screen) 
	PA_SwitchScreens();
   
	bool sliderThickness_Held = false;
   bool sliderAlpha_Held = false;
   bool colorPicker_Held = false;
   bool brightnessPicker_Held = false;
   u8 StylusButtonY = 0;
//   draw16cRoundedBox(0,15,155,15+9,155+9,PA_RGB(0,0,0));
   while(1)
   {
      updateFilenameText(filename);
      updateColor16cCursor();
      if (Stylus.Newpress)
      {
         if (Stylus.X >= 10 && Stylus.X <= 26) 
         {
	         if (Stylus.Y >= PA_GetSpriteY(0,0) && Stylus.Y <= PA_GetSpriteY(0,0)+23) 
	         {
	            StylusButtonY = Stylus.Y - PA_GetSpriteY(0,0);
	            sliderThickness_Held=true;
  				   if (isAlphaPressureSensitive()) setAlphaPressureSensitive(1);	   
	         }   
	         else
	         if (Stylus.Y >= 39-6 && Stylus.Y <=  119-6)
	         {
	            StylusButtonY = 10;
	            sliderThickness_Held=true;
  				   if (isAlphaPressureSensitive()) setAlphaPressureSensitive(1);
	         }

	      }   
         if (Stylus.X >= 30 && Stylus.X <= 46) 
         {
	         if (Stylus.Y >= PA_GetSpriteY(0,1) && Stylus.Y <= PA_GetSpriteY(0,1)+23) 
	         {
	            StylusButtonY = Stylus.Y - PA_GetSpriteY(0,1);
	            sliderAlpha_Held=true;
				   if (isThicknessPressureSensitive()) setThicknessPressureSensitive(1);
	         }   
	         else
	         if (Stylus.Y >= 39-6 && Stylus.Y <=  119-6)
	         {
	            StylusButtonY = 10;
	            sliderAlpha_Held=true;
				   if (isThicknessPressureSensitive()) setThicknessPressureSensitive(1);
	         }   

	      }   
			if (PA_StylusInZone(13,149,13+9,149+9)) 
			{
				setAlphaPressureSensitive(isAlphaPressureSensitive());
				updatePreview();	   
		   }   
			if (PA_StylusInZone(33,149,33+9,149+9)) 
			{
				setThicknessPressureSensitive(isThicknessPressureSensitive());
				updatePreview();	   
		   }  
			if (PA_StylusInZone(53,32,53+189,32+108)) 
			{
	         colorPicker_Held = true;
	      }   
			if (PA_StylusInZone(148, 153-8, 148+93,153+8)) 
			{
			   brightnessPicker_Held = true;
			}   
			if (PA_StylusInZone(177,0,177+25,18))
			{
			   mirrorDoodle(0);
			   fileChanged=1;
			}   
			if (PA_StylusInZone(202,0,202+30,18))	
			{
				mirrorDoodle(1);
			   fileChanged=1;
			}
			if (PA_StylusInZone(202+30,0,256,18)) 
			{
			   fillBitmap(1,getFullDoodleColor());
			   fileChanged=1;
			}   
			
			if (PA_StylusInZone(164,175,164+31,192))
			{
			   saveDoodle(filename);
			   break;
			}   
			if (PA_StylusInZone(206,175,206+25,192)) 
			{
			   loadDoodle(filename);			
			   break;
			}   
			if (PA_StylusInZone(231,175,256,192)) return 1;

      }   
      if (Stylus.Held)
		{
		   if (sliderThickness_Held) 
			{
			   if (Stylus.Y-StylusButtonY != PA_GetSpriteY(0,0))
			   {
				   PA_SetSpriteY(0,0,Stylus.Y-StylusButtonY);
				   if (Stylus.Y-StylusButtonY < 39-6) PA_SetSpriteY(0,0	,39-6);
				   if (Stylus.Y-StylusButtonY > 119-6) PA_SetSpriteY(0,0,119-6);
					updatePreview();	   
				}			
			}   
		   if (sliderAlpha_Held) 
			{
			   if (Stylus.Y-StylusButtonY != PA_GetSpriteY(0,1))
			   {
				   PA_SetSpriteY(0,1,Stylus.Y-StylusButtonY);
				   if (Stylus.Y-StylusButtonY < 39-6) PA_SetSpriteY(0,1,39-6);
				   if (Stylus.Y-StylusButtonY > 119-6) PA_SetSpriteY(0,1,119-6);
					updatePreview();	   
				}			
			}   
			if (colorPicker_Held) 
			{
			   ColorPicker_X = Stylus.X-53;
			   ColorPicker_Y = Stylus.Y-32;
			   if (Stylus.X-53 < 0) ColorPicker_X = 0;
			   if (Stylus.X-53 > 189) ColorPicker_X = 189;
			   if (Stylus.Y-32 < 0) ColorPicker_Y = 0;
			   if (Stylus.Y-32 > 109) ColorPicker_Y = 109;		
			   
				
				updateBrightnessPicker();
			}   
			if (brightnessPicker_Held)
			{
			   BrightnessPicker_X = Stylus.X-148;
			   if (Stylus.X-146 < 0) BrightnessPicker_X = 0;
			   if (Stylus.X-(148+95) > 0) BrightnessPicker_X = 95;
			     

			}   
			
		}
		else   
		{
			if (Stylus.Released && (colorPicker_Held || brightnessPicker_Held)) updatePreview();	   
         sliderThickness_Held = false;
         sliderAlpha_Held = false;
         colorPicker_Held = false;
         brightnessPicker_Held = false;
      } 
		updateBrightness16cCursor();
	   

      Soul_waitForVBL();
      PA_16cErase(0);
      if (Pad.Newpress.L) break;
   }   
	updateBrightness16cCursor();
   updateColor16cCursor();
	updateFilenameText(filename);
	setDrawThickness(getFullDoodleThickness());
	setDrawAlpha(getFullDoodleAlpha());
	setDrawColor(getFullDoodleColor());
   //if (!PA_Screen) 
	PA_SwitchScreens();
   return 0;
}   
#define REG_BLDY(screen) *(volatile u16*)(0x04000054 + (screen * 0x1000))   
void saveDoodle(char* filename)
{
   fileChanged=0;
   PA_EnableSpecialFx(1, SFX_BRIGHTINC, SFX_BG3, 0);
	REG_BLDY(1) = 31;
   sprintf(filename,"%s",inputKeyboard(0, filename,5,2,200,2, 0, 6, 2,1,5, 0, 1, 0));
   PA_EnableSpecialFx(1, SFX_NONE, SFX_BG2 , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
   if (inputKeyboard_EndedWithEnter() || inputKeyboard_EndedWithSave())
   {
		int length=strlen(filename);
		filename[length+0]='.';
		filename[length+1]='b';
		filename[length+2]='m';
		filename[length+3]='p';
		screenshot16bitToBmp(1,filename);
		filename[length+0]=0;
		filename[length+1]=0;
		filename[length+2]=0;
		filename[length+3]=0;
	}		
	reset_inputKeyboard_EndedWithSave();
	reset_inputKeyboard_EndedWithEnter();
}

void mirrorDoodle(bool vertical)
{
//   PA_DrawBg[0]
//   int original[256*192];
   int x,y;
//   irqDisable(IRQ_VBLANK);
   PA_SetBrightness(0,-31);
   if (vertical)
   {
		for (x=0;x<256;x++)
			for (y=0;y<192;y++)
				PA_Put16bitPixel(0,x,y,PA_Get16bitPixel(1,255-x,y));
	}
	else
	{
		for (x=0;x<256;x++)
			for (y=0;y<192;y++)
				PA_Put16bitPixel(0,x,y,PA_Get16bitPixel(1,x,191-y));
	}

	for (x=0;x<256;x++)
		for (y=0;y<192;y++)
			PA_Put16bitPixel(1,x,y,PA_Get16bitPixel(0,x,y));
			
	char* path = returnThemeResourcePath("apps/doodle/doodleInterface.jpg", 1);
	if (path!=NULL)
	{
		loadJPEGWithPath(0,path);
		free(path);
	}		
   PA_SetBrightness(0,0);

	updateBrightnessPicker();
	updatePreview();
//	irqEnable(IRQ_VBLANK);

}
void loadDoodle(char* filename)
{
//   PA_SwitchScreens();
   PA_EnableSpecialFx(1, SFX_NONE, SFX_BG2 , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
   PA_EnableSpecialFx(1, SFX_BRIGHTDEC, SFX_BG3, 0);
	int i=0;
   while (i<=20)
   {
      i++;
		REG_BLDY(1) = (i);
		PA_SetBrightness(0,i/-2);
		Soul_waitForVBL();
	}	
	struct stat st;
	char temp[256];
	int imageAmount=0;

	DIR_ITER* doodledir;
	doodledir = diropen("/");
	if (doodledir == NULL) 
	{
	   imageAmount=1;
	}   
	else
	{
		char file[50][100];
		while (dirnext(doodledir, temp, &st) == 0) 
		{
		   i=strlen(temp);
		   if (i>=100) continue;
			if (st.st_mode & S_IFDIR) continue;
			if (imageAmount>=50) break;		
			if (!(((temp[i-4] == '.') &&
			    (((temp[i-3] == 'J' || temp[i-3] == 'j') &&
				   (temp[i-2] == 'P' || temp[i-2] == 'p') &&
				   (temp[i-1] == 'G' || temp[i-1] == 'g')) ||
				  ((temp[i-3] == 'B' || temp[i-3] == 'b') &&
				   (temp[i-2] == 'M' || temp[i-2] == 'm') &&
				   (temp[i-1] == 'P' || temp[i-1] == 'p')))) ||
			    (((temp[i-5] == '.') &&
				   (temp[i-4] == 'J' || temp[i-4] == 'j') &&
				   (temp[i-3] == 'P' || temp[i-3] == 'p') &&
				   (temp[i-2] == 'E' || temp[i-2] == 'e') &&
				   (temp[i-1] == 'G' || temp[i-1] == 'g')))))
				  continue;
	
			imageAmount++;
		   sprintf(file[imageAmount-1],"%s", temp);
		}
	
		i=0;
		int page=0;
		int selected=0;
		while(true)
		{
			for (i=0;i<10;i++)
			{
			   if (i+(page*10) == imageAmount) break;
			   if (selected-(page*10)==i)
				   sprintf(temp,">%s", file[i+(page*10)]);
			   else
				   sprintf(temp,"%s", file[i+(page*10)]);
				display16cText(1,10,10+(i*(16)),256,0,temp,1,5);		
				
			}		
			if (Pad.Newpress.Up && selected>0)
			{
			   if (selected%10==0) page--;
			   selected--;
			}   
			if (Pad.Newpress.Down  && selected<imageAmount-1)
			{
			   if (selected%10==9) page++;
			   selected++;
			}   
			if (Pad.Newpress.B) break;
			if (Pad.Newpress.A) 
			{
				sprintf(temp,"fat:/%s",file[selected]);
				FILE* loadIMG = fopen(temp,"rb");
			   i=strlen(temp);
				if ((temp[i-4] == '.') &&
				    (((temp[i-3] == 'J' || temp[i-3] == 'j') &&
					   (temp[i-2] == 'P' || temp[i-2] == 'p') &&
					   (temp[i-1] == 'G' || temp[i-1] == 'g')) ||
				    (((temp[i-5] == '.') &&
					   (temp[i-4] == 'J' || temp[i-4] == 'j') &&
					   (temp[i-3] == 'P' || temp[i-3] == 'p') &&
					   (temp[i-2] == 'E' || temp[i-2] == 'e') &&
					   (temp[i-1] == 'G' || temp[i-1] == 'g')))))
				{
					loadFatBgJpeg(1, loadIMG);
				}			
				else
				{
					if (((temp[i-3] == 'B' || temp[i-3] == 'b') &&
						   (temp[i-2] == 'M' || temp[i-2] == 'm') &&
						   (temp[i-1] == 'P' || temp[i-1] == 'p')))
						loadFatBgBmp(1, loadIMG);
				}			
				fclose(loadIMG);
				sprintf(filename,"%s",file[selected]);
				updateFilenameText(filename);
				 break;
			}			
		   Soul_waitForVBL();
		   PA_16cErase(1);
		}   
	}	
   PA_16cErase(1);
	PA_SetBrightness(0,0);
	REG_BLDY(1) = (0);
   PA_EnableSpecialFx(1, SFX_NONE, SFX_BG2 , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
//   PA_SwitchScreens();
}   
void doodleApp()
{
//   fatInitDefault();


	clearSystem();
	PA_ResetBgSys();
	PA_ResetSpriteSys();
   //if (PA_Screen) 
	PA_SwitchScreens();
	spaceLetteringForAAText();
/*	DIR_ITER* doodledir;
	doodledir = diropen("/");
*/	
	PA_Init16bitBg(1, 3);
	PA_Init16bitBg(0, 3);
	PA_Init16cBg(1,1);

	PA_Init16cBg(0,1);
	
	fillBitmap(1,PA_RGB(31,31,31));
//   if (!PA_Screen) PA_SwitchScreens();
   PA_16cErase(1);
//   PA_LoadBmp(0,(void*)canvasFull_topscreen);
	char* path = returnThemeResourcePath("apps/doodle/doodleInterface.jpg", 1);
	if (path!=NULL)
	{
		loadJPEGWithPath(0,path);
		free(path);
	}			
	initDraw(1,0,0,256,192);
	   
	PA_LoadSpritePal(0, // Screen
					0, // Palette number
					(void*)slider_Pal);	// Palette name
					
	PA_CreateSprite(0, 0,(void*)slider_Sprite, OBJ_SIZE_16X32,1, 0, 10, 105);	
	PA_CreateSprite(0, 1,(void*)slider_Sprite, OBJ_SIZE_16X32,1, 0, 30, 42);	

	BrightnessPicker_X = 95;
	setThicknessPressureSensitive(0);
	updateBrightness16cCursor();
   updateColor16cCursor();
	updateBrightnessPicker();
	updatePreview();

	setDrawThickness(getFullDoodleThickness());
	setDrawAlpha(getFullDoodleAlpha());
	setDrawColor(getFullDoodleColor());

	initAntiAliasedText(1,1,0);
	initAntiAliasedText(0,1,1);
//	PA_EnableSpecialFx(1,SFX_NONE, SFX_BG1, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	PA_EnableSpecialFx(0,SFX_NONE, SFX_BG1, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	PA_EnableSpecialFx(1,SFX_NONE, SFX_BG1, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	char filename[256];
	sprintf(filename,"untitled");
	fileChanged=0;
	updateFilenameText(filename);
//	PA_16cText(1,10,10,256,10,"YO!",5,2,100);	
//	DIR_ITER* doodledir = diropen("/");
	while(Stylus.Held){ Soul_waitForVBL();}
   while(1) {
/*      if (PA_StylusInZone(2 , 21 , 2+20 , 21+20) && Stylus.Newpress)  toggleThickness();
      if (PA_StylusInZone(2,48,2+20,48+20) &&Stylus.Newpress)  toggleAlpha();
      if (PA_StylusInZone(209,177,209+42,177+14) &&Stylus.Newpress) break;
		checkStylus_ColorPanel();*/
//		updateAlphaPanelText();

//		setCanvasDrawColor(PA_RGB(r,g,b));
      if (Pad.Newpress.L) 
      {
			if (flipDoodleScreen(filename)) 
			{
			   PA_ResetSpriteSys();
			   break;
			}   
			else
			{
			   PA_WaitFor(!Stylus.Held);
			}   
		}		
		if (Stylus.Held && fileChanged==0)
		{
		   fileChanged=1;
			updateFilenameText(filename);
		}		
		
		updateDraw();
		
      Soul_waitForVBL();
   }   
   PA_SwitchScreens();
//   PA_LoadJpeg(1,(void*)Shrink_TopScreen);
}   



