#include <PA9.h>       // Include for PA_Lib
#include <fat.h>
#include <sys/dir.h>

#include "../gfx/all_gfx.h"
#include "../engine/engine.h"	
#include "../commands\multimedia\music\player_sound.h"
u8 selectedButton=1;
int playlistScroll=0;
int visualizerScroll=0;
u8 menuMode=0;
#define MUSICICON_SPRITE 8
u16 playerBgAmbience_Counter = 0;
extern u16 PA_oldx[2];
extern u16 PA_oldy[2];
u32 songPlaying=0;
u32 visualizerPlaying=0;
u32 buttonHolding=0;
bool isStylusButtonHolding=0;
u32 musicAmount=0;
u32 visualizerAmount=1;

u16 popupAnimationCounter=512;
bool musicPopupped=0;
char visualizerPopupped=0;
char musicFilePath[15];

char* getVisualizerName(int visualizerName)
{
   switch(visualizerName)
   {
   	case 0: return "Dual Screen Symphony";
	}  	
	return "Out of Range";
}   
char musicFile[100][100];

char* getSongFileName(int songNumber)
{
   if (musicAmount<=1) return "No Music";
   if (songNumber>=musicAmount-1) return "Out of Range";
   return musicFile[songNumber];
/*   switch(songNumber)
   {
   	case 0: return "HtheB - Victorious MENUdo's Theme";
   	case 1: return "HtheB - Commodore 64";
   	case 2: return "HtheB - Dance to the Rhythm";
   	case 3: return "HtheB - Beat For Bro (no laugh)";
   	case 4: return "HtheB - Short Beat";
   	case 5: return "HtheB - 2 Songs";
	}  	
	return "Out of Range";*/
}   

int moveButtons(bool Up)
{
   int animationValue;
   if (Up)
	   animationValue=1;
   else
   	animationValue=-1;
   int StylusPivotX=Stylus.X;
	int StylusPivotY=Stylus.Y;
	int i;
	Pad.Newpress.Up=0;
	Pad.Newpress.Down=0;
   while(animationValue>-64 && animationValue<64)
   {

		if (Stylus.Held)
		{
		   if (StylusPivotX-100>Stylus.X)
		   {
			   menuMode=1;
			   updateMenu(1,false);
			   return selectedButton;
		   }   
		   animationValue=StylusPivotY-Stylus.Y;
         if (animationValue>0 && selectedButton==3) animationValue=0;
	      if (animationValue<0 && selectedButton==0) animationValue=0;
		}
		else   
		{
	      if (Pad.Newpress.Down || Pad.Newpress.Up)
			{
			   if (Up)
				   animationValue=1;
			   else
			   	animationValue=-1;
			   if (!Up)
					selectedButton--;
				else
					selectedButton++;
			}  
	      if (animationValue==0) return selectedButton;
	      if (animationValue>0 && selectedButton==3) return selectedButton;
	      if (animationValue<0 && selectedButton==0) return selectedButton;
	      if (animationValue<0)
	      {

				if (animationValue>-64) animationValue-=2;
				if (animationValue>-50) animationValue-=2;
				if (animationValue>-40) animationValue-=2;

			}			
			else
			{
				if (animationValue<64) animationValue+=2;
				if (animationValue<50) animationValue+=2;
				if (animationValue<40) animationValue+=2;
			}
		}	
      if (animationValue>=64) animationValue=64;
      if (animationValue<=-64) animationValue=-64;	
		for(i=0;i<=7;i++)
		{
		   if (i%2)
			   PA_SetSpriteX(1,i,64+(PA_Cos((((i/2)-selectedButton)*64)-animationValue)>>2)-30);
		   else
			   PA_SetSpriteX(1,i,(PA_Cos((((i/2)-selectedButton)*64)-animationValue)>>2)-30);
		   PA_SetSpriteY(1,i,82+(int)(((PA_Sin((((i/2)-selectedButton)*40)-(int)(animationValue*0.625)))>>1)/1.4));
		}   
      updateMusicAndGraphics();
		Soul_waitForVBL();
	}	
   if (animationValue<64)
   {
		selectedButton--;
	}
	else
   {
		selectedButton++;
	}			

	return selectedButton;
}   

void initPlayerMenu()
{
	PA_EasyBgLoad(1, 2, BG1);	
	PA_EasyBgLoad(1, 1, BG2);	
	PA_BGScrollY(1,1,8);
	PA_EasyBgLoad(1, 3, BG3);	
	PA_SetBgPrio(1,1,2);
	PA_LoadSprite16cPal(1, 9, (void*)bgEdge_Pal);
	int i;
	for(i=0;i<=256/16;i++)
	{
		PA_CreateSprite(1,20+i,(void*)bgEdge_Sprite,OBJ_SIZE_16X32,0,9,16*i, -1);
	   PA_SetSpritePrio(1,20+i,1);
	   
		PA_CreateSprite(1,37+i,(void*)bgEdge_Sprite,OBJ_SIZE_16X32,0,9,16*i, 192-23);
	   PA_SetSpritePrio(1,37+i,1);
	}		
	
	PA_LoadSprite16cPal(1, 0, (void*)button1_Pal);
	PA_LoadSprite16cPal(1, 1, (void*)button2_Pal);
	PA_LoadSprite16cPal(1, 2, (void*)button3_Pal);
	PA_LoadSprite16cPal(1, 3, (void*)button4_Pal);
	PA_LoadSprite16cPal(1, 4, (void*)button5_Pal);
	PA_LoadSprite16cPal(1, 5, (void*)button6_Pal);	
	PA_LoadSprite16cPal(1, 6, (void*)button7_Pal);
	PA_LoadSprite16cPal(1, 7, (void*)button8_Pal);
	PA_LoadSprite16cPal(1, 8, (void*)musicIcon_Pal);
	
	PA_CreateSprite(1,0,(void*)next0_Sprite,OBJ_SIZE_64X32,0,0,50, 	50+(34*0));
	PA_CreateSprite(1,1,(void*)next1_Sprite,OBJ_SIZE_64X32,0,1,50+64, 50+(34*0));
	PA_CreateSprite(1,2,(void*)play0_Sprite,OBJ_SIZE_64X32,0,2,50, 	50+(34*1));
	PA_CreateSprite(1,3,(void*)play1_Sprite,OBJ_SIZE_64X32,0,3,50+64, 50+(34*1));
	PA_CreateSprite(1,4,(void*)prev0_Sprite,OBJ_SIZE_64X32,0,4,50, 	50+(34*2));
	PA_CreateSprite(1,5,(void*)prev1_Sprite,OBJ_SIZE_64X32,0,5,50+64, 50+(34*2));
	PA_CreateSprite(1,6,(void*)menu0_Sprite,OBJ_SIZE_64X32,0,6,50, 	50+(34*3));
	PA_CreateSprite(1,7,(void*)menu1_Sprite,OBJ_SIZE_64X32,0,7,50+64, 50+(34*3));
	PA_CreateSprite(1,MUSICICON_SPRITE,(void*)musicIcon_Sprite,OBJ_SIZE_16X16,0,8,3, 3);


	PA_InitSpriteExtPrio(1);
	for(i=0;i<=7;i++)
	{
	   PA_SetSpritePrio(1,i,2);
	}   
   PA_SetSpritePrio(1,MUSICICON_SPRITE,1	);
   int toValue =-3;
   int selectedButton=1;

   int animationValue= (selectedButton-toValue)*60;

	for(i=60;i<=60+8;i++)
	{
		PA_CreateSprite(1,i,(void*)miniButton_Sprite,OBJ_SIZE_64X32,0,9,60, 200);
	   PA_SetSpriteDblsize(1, i, 1);
	   PA_SetSpriteRotEnable(1,i,i-60);
	   PA_SetSpritePrio(1,i,2);
		PA_SetRotset(1, i-60, 0, 128, 256);
	}   
   while(animationValue!=0)
   {
		PA_16cErase(1);
  		displayPlayerText();
		for(i=0;i<=1;i++)
		{
			if (animationValue>0) animationValue-=1;
			if (animationValue>20) animationValue-=1;
			if (animationValue>30) animationValue-=2;
	
		}			
		if (animationValue<=0) animationValue=0;
		for(i=0;i<=7;i++)
		{
		   if (i%2)
			   PA_SetSpriteX(1,i,64+(PA_Cos((((i/2)-selectedButton)*64)+animationValue)>>2)-30);
		   else
			   PA_SetSpriteX(1,i,(PA_Cos((((i/2)-selectedButton)*64)+animationValue)>>2)-30);
		   PA_SetSpriteY(1,i,82+(int)(((PA_Sin((((i/2)-selectedButton)*40)+(int)(animationValue*0.625)))>>1)/1.4));
		}   
   	updateMusicAndGraphics();
		Soul_waitForVBL();
	}	



}   

void scrollList(bool visualizerList, int y)
{
	PA_TextAlign(ALIGN_CENTER);
   display16cText(1,0,5,256,0,visualizerList? "Visualizer": "Playlist",1,5);


   int i=0;
   int counter=0;
   int result;
  	PA_SetSpriteY(1,MUSICICON_SPRITE,192);
  	PA_SetSpritePrio(1,MUSICICON_SPRITE,2);
  	while(true)
  	{
	   result = 10+((counter)*22)+y+18;
		if (result<=5)
		{
		   counter++;
		   continue;
		}   
		else
		break;
  	}   

	for(i=0;i<=8;i++)
	{
	   if ((i+counter>=(musicAmount-1) && !visualizerList) || (i+counter>visualizerAmount && visualizerList)) 
		{
		   PA_SetSpriteY(1,60+i,192);
		   continue;
		}   
	   result = 10+((i+counter)*22)+y;
		if (result<-32) PA_SetSpriteY(1,60+i,-32);
		else
		if (result>165) PA_SetSpriteY(1,60+i,192);
		else
		{
			PA_SetSpriteY(1,60+i,result);
		}		
		result+=18;
		if (result>5 && result<192)
		{	

		   if (PA_StylusInZone(80,PA_GetSpriteY(1,60+i)+20,200,PA_GetSpriteY(1,60+i)+40) && (!isStylusButtonHolding || (isStylusButtonHolding && buttonHolding==i+counter))) 
			{
			   if (isStylusButtonHolding)
			   {
					if (Stylus.Held) 
					{
					   result++;
					   PA_SetSpriteY(1,60+i,result-18);
					}   
				   if (Stylus.Released) 
					{

					   if (visualizerList)
					   {
					      if (i==visualizerAmount)
								clearVisualizer();
							else
							{
								if (visualizerPlaying!=i+counter) loadVisualizer(); 
							}			
							visualizerPlaying = i+counter;
						   if (i!=visualizerAmount) resetVisualizerPlayingText();
					 	}  	
					 	else
						{
						   songPlaying = i+counter;
						   loadPlayerAppMusic(songPlaying);
/*						   if (!musicPopupped)
						   {
							displayNowPlayingText();*/
							if (visualizerPopupped!=2) popupAnimationCounter=512;
							resetNowPlayingText(); 
/*							}			
							else
							resetNowPlayingText(); */
						}   
					}   
				}		
				else
			   if (Stylus.Newpress)
			   {
			      isStylusButtonHolding=1;
			      buttonHolding=i+counter;

			   }   					
			   
			   
			}   
			if (!Stylus.Held && buttonHolding==i+counter)
			{
			   isStylusButtonHolding=0;
			}   
		   PA_TextAlign(ALIGN_LEFT);
		   if (i+counter==songPlaying && !visualizerList)
		   {
		   	PA_SetSpriteXY(1,MUSICICON_SPRITE,PA_GetSpriteX(1,60+i),result);
		   	display16cText(1,80,result,190,0,visualizerList?(i==visualizerAmount?"No Visualizer":getVisualizerName(i)):
				   															getSongFileName(i+counter),1,5);
			}			  	
			else
			{
		   	display16cText(1,70,result,190,0,visualizerList?(i==visualizerAmount?"No Visualizer":getVisualizerName(i)):
				   															getSongFileName(i+counter),1,5);
		 	}  	

		}   
		if (result<20)
		{
		   clear16cZone(1,0,0,255,20);
			PA_TextAlign(ALIGN_CENTER);
		   display16cText(1,0,5,256,0,visualizerList? "Visualizer" :"Playlist",1,5);

		}  
	}			
	clear16cZone(1,0,179,255,191);
	
}   
void updateMenu(int menuMode, bool reverse)
{
	int i;
	int transitionAnimation=0;
	while (transitionAnimation<200)
	{
		if (transitionAnimation<170)
	   {
			transitionAnimation+=2;
		}			
		if (transitionAnimation<180)
	   {
			transitionAnimation+=2;
		}			
	   if (transitionAnimation<200)
	   {
			transitionAnimation+=2;
		}			
	   if (transitionAnimation>=200) transitionAnimation=200;
		if (!reverse)
		{
		   switch(menuMode)
		   {
			   case 1: 	
				   		if (transitionAnimation==200)
				   		{
								for(i=0;i<8;i++)  PA_SetSpriteX(1,i,-64);
				   		}   
				   		if (transitionAnimation>=90)
							{
							   PA_16cErase(1);
								scrollList(0,playlistScroll+(200-(transitionAnimation)));
								for(i=0;i<=8;i++) 
									PA_SetSpriteX(1,60+i,(int)(60+((200-(transitionAnimation))*1.8)));
							}			
		
				   		if (transitionAnimation<90) 
				   		{
								for(i=0;i<=8;i++)  PA_SetSpriteX(1,i,PA_GetSpriteX(1,i)-12);
								PA_BGScrollX(1,0,transitionAnimation*3);
		
							}			
							else
							{
							   PA_BGScrollX(1,0,((transitionAnimation*2)-400)+10);
							}   
		
				   		PA_BGScrollY(1,2,1+(transitionAnimation/25));
				   		PA_BGScrollY(1,1,10-((transitionAnimation/10)/2));
							for(i=0;i<=16;i++)
							{
								PA_SetSpriteY(1,20+i,-1-(transitionAnimation/22));
								PA_SetSpriteY(1,37+i,169+((transitionAnimation/10)/2));
							}
			   			break;
			   case 2:  if (transitionAnimation==200)
				   		{
								for(i=0;i<=8;i++)  PA_SetSpriteX(1,i,-64);
				   		}   
				   		if (transitionAnimation>=90)
							{
							   PA_16cErase(1);
								scrollList(1,visualizerScroll+(200-(transitionAnimation)));
								for(i=0;i<=8;i++) 
									PA_SetSpriteX(1,60+i,(int)(60+((200-(transitionAnimation))*2.2)));
							}			
		
				   		if (transitionAnimation<90) 
				   		{
							   PA_16cErase(1);
								scrollList(0,playlistScroll+(transitionAnimation*2.2));
								for(i=0;i<=8;i++)  
								{
									PA_SetSpriteX(1,60+i,(int)(60-(transitionAnimation*2.2)));
								}   
								PA_BGScrollX(1,0,transitionAnimation*2.2);
		
							}			
							else
							{
							   PA_BGScrollX(1,0,((transitionAnimation*2.2)-440)+10);
							}   
			}  
		}			
		else
		{
		   switch(menuMode)
		   {
			   case 0: 	
				   		if (transitionAnimation<90) 
				   		{
							   PA_16cErase(1);
								for(i=0;i<=8;i++)  
								{
									PA_SetSpriteX(1,60+i,(int)(60+(transitionAnimation*2.4)));
								}   
								scrollList(0,playlistScroll+(transitionAnimation*2));
								PA_BGScrollX(1,0,(transitionAnimation*-2.4)+10);
		
							}			
							else
							{
							   PA_16cErase(1);
							   displayPlayerText();
								for(i=0;i<=7;i++)
								{
								   if (i%2)
									   PA_SetSpriteX(1,i,64+(PA_Cos((((i/2)-selectedButton)*64))>>2)-30-((200-transitionAnimation)*2));
								   else
									   PA_SetSpriteX(1,i,(PA_Cos((((i/2)-selectedButton)*64))>>2)-30-((200-transitionAnimation)*2));
								   PA_SetSpriteY(1,i,82+(int)(((PA_Sin((((i/2)-selectedButton)*40)))>>1)/1.4));
								}   

								PA_SetSpritePrio(1,MUSICICON_SPRITE,0);
							   PA_SetSpriteXY(1,MUSICICON_SPRITE,3-((200-transitionAnimation)*2),3);
							   PA_BGScrollX(1,0,(400-(transitionAnimation*2))+8);
							}   
							
				   		PA_BGScrollY(1,2,1+((200-transitionAnimation)/25));
				   		PA_BGScrollY(1,1,10-(((200-transitionAnimation)/10)/2));
							for(i=0;i<=16;i++)
							{
								PA_SetSpriteY(1,20+i,-1-((200-transitionAnimation)/22));
								PA_SetSpriteY(1,37+i,169+(((200-transitionAnimation)/10)/2));
							}
			   			break;
			   case 1:  if (transitionAnimation==200)
				   		{
								for(i=0;i<=8;i++)  PA_SetSpriteX(1,i,-64);
				   		}   
				   		if (transitionAnimation>=90)
							{
							   PA_16cErase(1);
								scrollList(0,playlistScroll+(200-(transitionAnimation)));
								for(i=0;i<=8;i++) 
									PA_SetSpriteX(1,60+i,(int)(60-((200-(transitionAnimation))*2.2)));
							}			
		
				   		if (transitionAnimation<90) 
				   		{
							   PA_16cErase(1);
								scrollList(1,visualizerScroll+(transitionAnimation*2));
								for(i=0;i<=8;i++)  
								{
									PA_SetSpriteX(1,60+i,(int)(60+(transitionAnimation*2.2)));
								}   
								PA_BGScrollX(1,0,(transitionAnimation*-2.2)+10);
		
							}			
							else
							{
							   PA_BGScrollX(1,0,(440-(transitionAnimation*2.2))+10);
							}   
							break;
			}  
		}			
		updateMusicAndGraphics();
		Soul_waitForVBL();	
	   if (Pad.Newpress.Anykey && transitionAnimation<199) transitionAnimation=199;
	}		
}   

void updateMusicAndGraphics()
{
	updatePopupText();
  	playerBgAmbience_Counter+=2; 
  	if (playerBgAmbience_Counter>511) playerBgAmbience_Counter=0;;
	updateVisualizer();
	ZoomXY_3DProcess(128,0,0);  
}   
void playervisualizer(){

   s16 vcount = PA_GetVcount();
   vcount++;
   if(vcount > 192) vcount = 0; // Get correct vcount
// PA_BGScrollX(0, 3, (PA_Sin((vcount)*height+add)*width)>>8);
	
   PA_BGScrollX(1, 3, (PA_Sin((vcount)*4+playerBgAmbience_Counter)*4)>>8);
   PA_BGScrollY(1, 3, (PA_Cos((vcount)*4+playerBgAmbience_Counter)*4)>>8);
}   


int accelStylusYInput()
{
   if (Stylus.Held)
   {
	   if (Stylus.Newpress)
	   {
			PA_oldx[1] = Stylus.X;
			PA_oldy[1] = Stylus.Y;
		}		
		int result = Stylus.Y - PA_oldy[1];
		PA_oldx[1] = Stylus.X;
		PA_oldy[1] = Stylus.Y;	
		return result;
	}	
	return 0;		
	
}  

void resetNowPlayingText()
{
	musicPopupped=0;
}	
s16 titleMarqueeCounter=0;
unsigned char titleMarqueePause=0;
bool titleMarqueeReverse=0;

void displayPlayerText()
{
	spaceLetteringForDefault();
	PA_TextAlign(ALIGN_LEFT);
	char filename[256];
	sprintf(filename,"%s",getSongFileName(songPlaying));

	display16cText(1,20,4,246,0,filename,1,5);
//	display16cTextWithOffset(1,20,4,246,0,filename,1,5,(titleMarqueeCounter*-1)>>1);
/* 	display16cTextWithOffset(0,textX1 ,getWindowY()+((getWindowHeight()*.25)-6)
	  										,getWindowX()+getWindowWidth()-3
											,0
											,displayText,PLAIN_TEXTCOLOR,2,titleMarqueeCounter);*/

	if (titleMarqueePause==0)
	{
		if (titleMarqueeReverse)
			titleMarqueeCounter--;
		else
			titleMarqueeCounter++;	
			
		if (PA_LetterPos.Letter[PA_LetterPos.NLetters].Letter == filename[strlen(filename)-1])
			if (PA_LetterPos.Letter[PA_LetterPos.NLetters].X < 236)
			{
			   if (!titleMarqueeReverse)
			   {
					titleMarqueePause=200;
					titleMarqueeReverse=1;
				}			
			}			
			
	
		if (titleMarqueeCounter==0)
		{
		   if (titleMarqueeReverse)
		   {
				titleMarqueeReverse=0;
				titleMarqueePause=200;
			}			

		}			
	

	}		
	else
	{
		titleMarqueePause--;
	}	
	PA_TextAlign(ALIGN_RIGHT);

	char timer[100];
	sprintf(timer, "%d:%02d",getSongElapsed()/60,getSongElapsed()%60);

	display16cText(1,20,17,246,0,timer,2,3);
/*	if (PA_LetterPos.Letter[PA_LetterPos.NLetters].Letter == ')')
		if (PA_LetterPos.Letter[PA_LetterPos.NLetters].X < getWindowX()+getWindowWidth()-10)
		{
		   window.input.timeNotTouched--;
		   if (window.input.marqueePlayerTimer<250) window.input.marqueePlayerTimer++;
		}   */
	display16cText(1,20,171,250,0,"Playlist",1,5);
	int i;
	for(i=173;i<186;i++)
	PA_16cPutPixel(1,200,i,4); 
}   
void resetVisualizerPlayingText()
{
	visualizerPopupped=0;
}	
void displayVisualizerPlayingText()
{
	popupAnimationCounter=0;
   PA_16cErase(0);
	PA_TextAlign(ALIGN_RIGHT);
	spaceLetteringForDefault();
	display16cText(0,2,160,256,0,getVisualizerName(visualizerPlaying),1,5);
	display16cText(0,0,176,256,0,"Visualizer",PLAIN_TEXTCOLOR,2);
	visualizerPopupped=2;
} 
void displayNowPlayingText()
{
	popupAnimationCounter=0;
   PA_16cErase(0);
	PA_TextAlign(0);
	spaceLetteringForDefault();
	display16cText(0,2,160,256,0,getSongName(),1,5);
	display16cText(0,0,176,256,0,"Now Playing",PLAIN_TEXTCOLOR,2);
	musicPopupped=1;
} 

void updatePopupText()
{  
	
   if (popupAnimationCounter<512) 
		popupAnimationCounter++;
   else
   {
      if (!musicPopupped && visualizerPopupped!=2) displayNowPlayingText();
      else
      if (visualizerPopupped==2) 
		   visualizerPopupped=1;
      else
      if (!visualizerPopupped) displayVisualizerPlayingText();
      else
		   PA_16cErase(0);
   }   
//   if (popupAnimationCounter==100) popupAnimationCounter=400;
   if (visualizerPopupped==2)
   {
	   if (popupAnimationCounter>448)
			PA_BGScrollX(0,1,(276-(PA_Sin(popupAnimationCounter*2))));
		if (popupAnimationCounter<64)
			PA_BGScrollX(0,1,(236-(PA_Sin((512-popupAnimationCounter)*2)))*-1);         
   }
	else
	{   
	   if (popupAnimationCounter>448)
			PA_BGScrollX(0,1,(256-(PA_Sin((512-popupAnimationCounter)*2))));   
		if (popupAnimationCounter<64)
			PA_BGScrollX(0,1,(256-(PA_Sin(popupAnimationCounter*2)))*-1);
	}
}	
void loadPlayerAppMusic(int songNumber)
{
   if (musicAmount<=1) return;

   bool autoplay=1;
   char filepath[256];
   sprintf(filepath,"%s%s",musicFilePath,musicFile[songNumber]);
   fatLoadMikModMusic(filepath,autoplay);
/*   switch (songNumber)
   {
	  case 0: loadMikModMusic(music0, (u32)music0_size, autoplay);
	  				break;
	  case 1: loadMikModMusic(music1, (u32)music1_size, autoplay);
	  				break;
	  case 2: loadMikModMusic(music2, (u32)music2_size, autoplay);
	  				break;
	  case 3: loadMikModMusic(music3, (u32)music3_size, autoplay);
	  				break;
	  case 4: loadMikModMusic(music4, (u32)music4_size, autoplay);
	  				break;
	  case 5: loadMikModMusic(music5, (u32)music5_size, autoplay);
	  				break;

 	}			*/
 	
}	
void nextSong()
{
   if (musicAmount<=1) return;
	songPlaying++;
   if (musicAmount==songPlaying) songPlaying=0;
   loadPlayerAppMusic(songPlaying);
   displayNowPlayingText();
}
void previousSong()
{
   if (musicAmount<=1) return;
   if (songPlaying==0) 
		songPlaying=musicAmount-1;   
   else
	   songPlaying--;
   loadPlayerAppMusic(songPlaying);
   displayNowPlayingText();
}	
void listFiles()
{
   musicAmount = 0;
	struct stat st;
	char filename[256];
	DIR_ITER* dir = diropen(musicFilePath);
//	int stringLength=0;
	if (dir == NULL) 
	{
	   musicAmount=1;
	   return;
	}   

	while (dirnext(dir, filename, &st) == 0) 
	{
	   if (strlen(filename)>=100) continue;
		if (st.st_mode & S_IFDIR) continue;
		if (musicAmount>=99) break;		
		musicAmount++;

	   sprintf(musicFile[musicAmount-1],"%s", filename);
	}
	if (musicAmount==0) musicAmount = 1;
//	for (musicAmount=1;musicAmount<=0;musicAmount++)
//	   sprintf(musicFile[musicAmount-1],"lorem%d", musicAmount);
} 
void playerApp(){
   cleanMemory();
   sprintf(musicFilePath,"fat:/music/");
   Player_SetVolume(128);
	clearSystem();
	PA_ResetBgSys();
	PA_ResetSpriteSys();

	titleMarqueeCounter=0;
	titleMarqueePause=0;
	titleMarqueeReverse=0;
	selectedButton=1;
	playlistScroll=0;
	visualizerScroll=0;
	menuMode=0;
	songPlaying=0;
	visualizerPlaying=0;
	buttonHolding=0;
	playerBgAmbience_Counter = 0;
	isStylusButtonHolding=0;
	musicAmount=0;
	visualizerAmount=1;
	popupAnimationCounter=512;
	musicPopupped=0;
	visualizerPopupped=0;

  	listFiles();

	PA_Init3D();
	PA_Reset3DSprites();
	loadVisualizer();
	PA_SwitchScreens();
 	PA_Init16cBg(1,0);
	initAntiAliasedText (1,0,1);
 	PA_Init16cBg(0,1);
	initAntiAliasedText (0,1,0);
	visualizerPopupped=2;
	musicPopupped=1;
	PA_SetBgPrio(0,1,0);
	PA_SetBgPrio(0,0,1);
	PA_SetSFXAlpha(1, 31, 0);
	

	songPlaying=0;
	loadPlayerAppMusic(songPlaying);
	togglePlayMusic();
	irqSet(IRQ_HBLANK, playervisualizer);
	irqEnable(IRQ_HBLANK);
 	initPlayerMenu();
 	
	

	


	u8 musicIcon_Animation=0;

	int accellY = 0;
	int StylusPivotX=0;
	u8 doubleClick=0;
	u8 originalSelectedButton=0;
	while (1)
	{
		if (doubleClick>0) doubleClick--;
	   switch(menuMode)
	   {
		   case 0: 	
					   if (Pad.Newpress.A || (Stylus.Newpress && doubleClick>0 && !PA_StylusInZone(200,170,254,192)))
					   {

					      switch (selectedButton)
					      {
					         case 0: 	nextSong();
					         			break;
					         case 1: 	togglePlayMusic();
					         			break;
					         case 2: 	previousSong();
					         			break;
					         case 3: 	if (!Player_Paused()) togglePlayMusic();
										   clearMikModMusic();
											return;
					      }   
					      if (Pad.Newpress.A)
					      {
							   PA_SetSpriteY(1,(selectedButton*2),51+(32));
							   PA_SetSpriteY(1,(selectedButton*2)+1,51+(32));
							}   
						}
						else
						if (Stylus.Newpress) doubleClick=60;
						if (Pad.Newpress.Right || (Stylus.Newpress && PA_StylusInZone(200,170,254,192))) 
						{
						   menuMode=1;
						   updateMenu(1,false);
						   
						}  
						else 
			   		if (Stylus.Held)
						{
						   originalSelectedButton=selectedButton;
						   selectedButton=moveButtons(0);
						   if (originalSelectedButton!=selectedButton) doubleClick=0;
						}   
		   			if (Pad.Newpress.Up) 
						{
  						   originalSelectedButton=selectedButton;
						   selectedButton=moveButtons(0);
						   if (originalSelectedButton!=selectedButton) doubleClick=0;
						}   
		   			if (Pad.Newpress.Down) 
						{
  						   originalSelectedButton=selectedButton;
						   selectedButton=moveButtons(1);
						   if (originalSelectedButton!=selectedButton) doubleClick=0;
						}   

					   if (Pad.Released.A)
					   {
						   PA_SetSpriteY(1,(selectedButton*2),50+(32));
						   PA_SetSpriteY(1,(selectedButton*2)+1,50+(32));	      
					   }   
			   		PA_16cErase(1);
						displayPlayerText();

					   break;
		   case 1: 	PA_16cErase(1);
		   			if (Pad.Held.Up) playlistScroll+=5;
		   			if (Pad.Held.Down) playlistScroll-=5;
	   				if (Stylus.Released)
	   				{
	   				   accellY = accellY*2;
	   				}  
	   				if (!isStylusButtonHolding)
	   				{
						   if (Stylus.Held)
						   {
			   				accellY = accelStylusYInput();
					   	}			
					   	else
					   	{
					   	   if (accellY>0) accellY--;
					   	   if (accellY<0) accellY++;
					   	   if (playlistScroll>100 || playlistScroll<(musicAmount*-22)+172)accellY=0;
					   	   if (accellY==0)
					   	   {
					   	      if (playlistScroll>0) playlistScroll*=.9;
					   	      else
					   	      {
					   	         if (musicAmount<=8)
					   	         { 
							   	      if (playlistScroll<0 && playlistScroll<0)
							   	      {
							   	         playlistScroll-=0;
							   	         playlistScroll*=.8;
							   	         playlistScroll+=0;
							   	      }   
					   	         }
										else
										{   
							   	      if (playlistScroll<(musicAmount*-22)+152 && playlistScroll<0)
							   	      {
							   	         playlistScroll-=(musicAmount*-22)+152;
							   	         playlistScroll*=.8;
							   	         playlistScroll+=(musicAmount*-22)+152;
							   	      }   
							   	   }   
						   	   }   
					   	   }   
					   	}   
					   }			
		   			playlistScroll += accellY;
						scrollList(0,playlistScroll);
						PA_oldx[1] = Stylus.X;
						PA_oldy[1] = Stylus.Y;
				      if (Stylus.Newpress || (StylusPivotX==0 && Stylus.Held)) StylusPivotX=Stylus.X;
				      if (!Stylus.Held)StylusPivotX=0;
					   if (Pad.Newpress.Right || ( Stylus.Held && StylusPivotX-100>Stylus.X))
						{
						   StylusPivotX=0;
						   menuMode=2;
						   updateMenu(2,false);
						}   
					   if (Pad.Newpress.Left || ( Stylus.Held && StylusPivotX+100<Stylus.X) )
						{
						   StylusPivotX=0;
						   menuMode=0;
						   updateMenu(0,true);
						}   
						break;
		   case 2: 	PA_16cErase(1);
		   			if (Pad.Held.Up) visualizerScroll++;
		   			if (Pad.Held.Down) visualizerScroll--;
	   				if (Stylus.Released)
	   				{
	   				   accellY = accellY*2;
	   				}  
	   				if (!isStylusButtonHolding)
	   				{
						   if (Stylus.Held)
						   {
			   				accellY = accelStylusYInput();
					   	}			
					   	else
					   	{
					   	   if (accellY>0) accellY--;
					   	   if (accellY<0) accellY++;
					   	   if (visualizerScroll>100 || visualizerScroll<(visualizerAmount*-22)+172)accellY=0;
					   	   if (accellY==0)
					   	   {
					   	      if (visualizerScroll>0) visualizerScroll*=.9;
					   	      else
					   	      {
					   	         if (visualizerAmount<=8)
					   	         { 
							   	      if (visualizerScroll<0 && visualizerScroll<0)
							   	      {
							   	         visualizerScroll-=0;
							   	         visualizerScroll*=.8;
							   	         visualizerScroll+=0;
							   	      }   
					   	         }
										else
										{   
							   	      if (visualizerScroll<(visualizerAmount*-22)+152 && visualizerScroll<0)
							   	      {
							   	         visualizerScroll-=(visualizerAmount*-22)+152;
							   	         visualizerScroll*=.8;
							   	         visualizerScroll+=(visualizerAmount*-22)+152;
							   	      }   
							   	   }   
						   	   }   
					   	   }   
					   	}   
					   }			
		   			visualizerScroll += accellY;
						scrollList(1,visualizerScroll);
						PA_oldx[1] = Stylus.X;
						PA_oldy[1] = Stylus.Y;
				      if (Stylus.Newpress || (StylusPivotX==0 && Stylus.Held)) StylusPivotX=Stylus.X;
				      if (!Stylus.Held)StylusPivotX=0;
					   if (Pad.Newpress.Left || ( Stylus.Held && StylusPivotX+100<Stylus.X)) 
						{
						   StylusPivotX=0;
						   menuMode=1;
						   updateMenu(1,true);
						}   
						break;
		}   
		updateMusicAndGraphics();
		Soul_waitForVBL();
	}
}

