#include <PA9.h>
#include "..\engine\engine.h"
#include "..\structDef.h"
#include "misc.h"
#include "fat.h"

struct clockInfo
{
	textBox Text;
	spriteNoRotSet Battery;
	bool Black;
} Clock;

extern char CurrentTheme[256];

bool batteryIconAvailable=0;

bool customClockThemeLoaded=0;

extern u8 pa_giftotextransp;
extern u16 pa_giftotexcolor;

bool spriteClockLoaded=0;
bool spriteClockAlpha=0;
u8 spriteClockCoeff1=0;
u8 spriteClockCoeff2=0;

bool isSpriteClockLoaded()
{
   return spriteClockLoaded;
}   

u8* Soul_GifToTiles(void *gif, u16 *temppal){
	debugTxt("Soul_GifToTiles");
	u8 zero = 0;
	u16 width = PA_GetGifWidth(gif);
	u16 height = PA_GetGifHeight(gif);
	debugTxt("canvas");	
	u8 *decodgif = (u8*)malloc(width*height);
	debugTxt("malloc");
	u8 *newtiles = (u8*)malloc(width*height);
	debugTxt("malloc");
	
	DMA_Force(zero, decodgif, (width*height)>>1, DMA_16NOW); // Blank out the gif
	debugTxt("dma");
	DecodeGif((const u8*)gif, decodgif, temppal, 0, width);
	debugTxt("decode");
//	Soul_waitForVBL();	
	s32 i, j, tile;
	tile = 0; 
	s32 tempx, tempy;
	tempx = 0; tempy = 0;
	u16 temp;
	
	u16 tilemax = (width*height)>>6;
		debugTxt("calculate max");
	for (tile = 0; tile < tilemax; tile++){
		//tileexists[0][tile] = 0;
		for (i = 0; i < 8; i++){ // put the right transp color	
			for (j = 0; j < 8; j++) {
				temp = decodgif[tempx + i + ((tempy+j)*width)];
				newtiles[(tile<<6) + i + (j<<3)] = temp;
				//tileexists[0][tile] |= temp;
			}
		}
		tempx += 8; 
		if (tempx >= width) {
			tempy += 8;
			tempx = 0;
		}
	}
	Soul_waitForVBL();
		debugTxt("vbl");	//flushToMemory();
	if(pa_giftotextransp){
		debugTxt("pa_giftotextransp");
		// Scan palette for magenta...
		s16 magenta = 0;
		u32 pos = 0;
		while((magenta < 255) && ((temppal[magenta]|(1<<15)) != pa_giftotexcolor)) magenta++;
		if(magenta == 256) magenta = 255;
		temppal[magenta] = temppal[0];
		
		if(magenta != 0){
			for(j = 0; j < height; j++){
			   pos = j*width;
			   for(i = 0; i < width; i++){
			      if(newtiles[pos] == 0){
			         newtiles[pos] = magenta;
			      }   
			      else if(newtiles[pos] == magenta){
			         newtiles[pos] = 0;
			      }   			      
			      pos++;
			   }
			}	
		}					   
	}	

	free(decodgif); // free the malloc
		debugTxt("free");
	//free(newtiles);
	initDebugTxt();
	return newtiles;

}
u8* batterygfx = NULL;
u16* batterypal = NULL;
void initClock(char* menu,int obj, int pal)
{
   debugTxt("initclock");
   spriteClockLoaded=0;
	loadSpriteClock(menu);
   debugTxt(menu);
	if (spriteClockLoaded) return;
   if (batterypal!=NULL) free(batterypal);
   if (batterygfx!=NULL) free(batterygfx);
   char* gifbuffer = NULL;
   batterypal= malloc (sizeof(u16)*256);   
   char batteryGifPath[256];
   if (strcmp(menu,"settings")==0)
   {
      char * path = returnThemeResourcePath("settings/battery.gif",1);
	   if(path==NULL)
		   sprintf(batteryGifPath,"blank");
	   else
   	   sprintf(batteryGifPath,"%s",path);
      free(path);
   }   
   else
   	sprintf(batteryGifPath,"fat:/_menudo/themes/%s/%s/battery.gif",CurrentTheme,menu);
   debugTxt("get theme path");
   debugTxt(batteryGifPath);
   FILE* fileFound = fopen(batteryGifPath,"rb");
   if (fileFound)
   {
      fclose(fileFound);

      gifbuffer = FAT_loadGIF(batteryGifPath);
		batterygfx = Soul_GifToTiles(gifbuffer, batterypal); // our palette

		PA_CreateSprite(1, obj, batterygfx, OBJ_SIZE_16X8,1, pal, Clock.Battery.x,Clock.Battery.y);
	   PA_SetSpriteAnim(1, obj, 0);
		PA_LoadSpritePal(1, pal, batterypal); 
		batteryIconAvailable=1;
		showsprite(1,obj);
	}		
	else
	{
//	   PA_DeleteSprite(1, obj);
		batteryIconAvailable=0;
		PA_CreateSprite(1, obj, 0, OBJ_SIZE_8X8,1, 0	, 250,200);
//		PA_SetSpriteXY(1,obj,250,200);
//		hidesprite(1,obj);
	}		
   fclose(fileFound);
   debugTxt("file init");
//	if (customClockThemeLoaded==0)
	{
	   char inipath[256];
	   if (strcmp(menu,"settings")==0)
	   {
	      char * path = returnThemeResourcePath("settings/misc.ini",1);
	      sprintf(inipath,"%s",path);
	      free(path);
	   }   
	   else
	   	sprintf(inipath,"fat:/_menudo/themes/%s/%s/misc.ini",CurrentTheme,menu);
   debugTxt(inipath);
		readINI=fopen(inipath,"rb");
		sprintf(Clock.Text.format, "%s", readIniFileString("ClockTextFormat"));
		Clock.Text.alignment = convertAlignToInt(readIniFileString("ClockTextAlignment"));
		Clock.Text.x1 = limitValueToScreenX(readIniFileInt("ClockTextX1"));
		Clock.Text.y1 = limitValueToScreenY(readIniFileInt("ClockTextY1"));
		Clock.Text.x2 = maxLimitValueTo(readIniFileInt("ClockTextX2"),Clock.Text.x1,256);
		Clock.Text.y2 = maxLimitValueTo(readIniFileInt("ClockTextY2"),Clock.Text.y1,256);
		if (strcmp(menu,"gamenavigate")!=0) Clock.Black= readIniFileInt("ClockBlack");
		Clock.Battery.x=limitValueToScreenX(readIniFileInt("BatteryIconX"));
		Clock.Battery.y=limitValueToScreenY(readIniFileInt("BatteryIconY"));

	   PA_SetSpriteXY(1,obj,Clock.Battery.x,Clock.Battery.y);
//		sprintf(Clock.Text.format, "$0/$2/$3\n$6 $3:$4:$5");
		fclose(readINI);
		customClockThemeLoaded=1;
	}		

	   if (gifbuffer!=NULL) free(gifbuffer);
   debugTxt("init finished");
   initDebugTxt();
}	



char* formatTimer(char* text)
{
 	 char year[5];
   char month[10];
   char day[3];
   char hour[5];
   char minutes[3];
   char seconds[3];
   sprintf (year,"%d",2000+PA_RTC.Year);
	sprintf (month,"%d",PA_RTC.Month);
	sprintf (day,"%d",PA_RTC.Day);
	if (PA_RTC.Hour % 12 == 0)
		sprintf (hour,"12");
	else
		sprintf (hour,"%d",PA_RTC.Hour % 12);
	sprintf (minutes,"%02d",PA_RTC.Minutes);
	sprintf (seconds,"%d",PA_RTC.Seconds);
	
	return formatText(text, 7, year,
										month,
										day,
									   hour,
										minutes,
										seconds,
										PA_RTC.Hour < 12 ? "AM": "PM");
							
//			PA_RTC.Year
}   
   
//"$1/$2 $3:$4 $6"


void updateClock(int obj, bool antialiased, bool forceUpdate)
{
//   return;
   if (isSpriteClockLoaded()) 
	{
	   updateSpriteClock();
	   return;
	}   
//   PA_SetSpriteAnim(1, obj, 0);
   int color;
   if (antialiased)
   color = PLAIN_TEXTCOLOR;
   else
	color = Clock.Black?10:1;
   
   //Execute this every 60 frames to consume less cpu cycles or force it if needed
	if (PA_RTC.Seconds == 0 || forceUpdate)
	{
	   spaceLetteringForDefault();
		//if (!forceUpdate)
		clear16cZone(1, Clock.Text.x1-8,Clock.Text.y1-8,Clock.Text.x2+8,Clock.Text.y2+8); 
	   PA_16cTextAlign(Clock.Text.alignment);
	   char* timerFormat = formatTimer(Clock.Text.format);
     display16cText (1, Clock.Text.x1,Clock.Text.y1,Clock.Text.x2,Clock.Text.y2, timerFormat, color, 2);
     free(timerFormat);
	   PA_16cTextAlign(0);
	}   
	if (batteryIconAvailable)

	{
		if (getBattery()<=1) // battery is full
		{
		   PA_SetSpriteAnim(1, obj, 0);
		}
		else   
		{ //battery needs charge
		   if (PA_RTC.Frames > 30) 
			{
			   PA_SetSpriteAnim(1, obj, 1);
			}
			else
			{
			   PA_SetSpriteAnim(1, obj, 2);
			}			   
		}   
	}		

}

#define YPOS 60
#define XPOS 38
#define SPACEX 15



void loadSpriteClockCoeff()
{
   if (!spriteClockLoaded) return;
   if(spriteClockAlpha)
   {
		PA_EnableSpecialFx(1, SFX_ALPHA, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
		PA_SetSFXAlpha(1, spriteClockCoeff1, spriteClockCoeff2);
	}		
	else
	PA_DisableSpecialFx(1);
}		

#define createClockSprite(i,INIVARX,INIVARY,INIVARP) \
	x = readIniFileInt(INIVARX);\
	y = readIniFileInt(INIVARY);\
	PA_CreateSprite(1, i+3,buffergfx, OBJ_SIZE_64X64,1, 0, x, y);\
	PA_SetSpritePrio(1,i+3,readIniFileInt(INIVARP));\
	if ((x==0 && y==0)) PA_SetSpriteX(1,i+3,310);
	
bool loadSpriteVar(char* menu,u8* buffergfx)
{
   char inipath[256];
	sprintf(inipath,"fat:/_menudo/themes/%s/%s/spriteclock.ini",CurrentTheme,menu);
	readINI=fopen(inipath,"rb");
	if (!readINI)
	{
	   return 0;
	}   
	int i=readIniFileInt("Clock_Alpha");
	int x,y;	
	createClockSprite(0,"HourDigit1_X","HourDigit1_Y","HourDigit1_P");
	createClockSprite(1,"HourDigit2_X","HourDigit2_Y","HourDigit2_P");
	
	createClockSprite(2,"ClockSeparator1_X","ClockSeparator1_Y","ClockSeparator1_P");
	PA_SetSpriteAnim(1, 2+3, 10);
			
	createClockSprite(3,"MinuteDigit1_X","MinuteDigit1_Y","MinuteDigit1_P");
	createClockSprite(4,"MinuteDigit2_X","MinuteDigit2_Y","MinuteDigit2_P");

	createClockSprite(5,"ClockSeparator2_X","ClockSeparator2_Y","ClockSeparator2_P");
	PA_SetSpriteAnim(1, 5+3, 10);
	
	createClockSprite(6,"SecondsDigit1_X","SecondsDigit1_Y","SecondsDigit1_P");
	createClockSprite(7,"SecondsDigit2_X","SecondsDigit2_Y","SecondsDigit2_P");
	
	createClockSprite(8,"ClockSeparator3_X","ClockSeparator3_Y","ClockSeparator3_P");
	PA_SetSpriteAnim(1, 8+3, 10);

	createClockSprite(9,"DayPeriodLetter1_X","DayPeriodLetter1_Y","DayPeriodLetter1_P");
	createClockSprite(10,"DayPeriodLetter2_X","DayPeriodLetter2_Y","DayPeriodLetter2_P");
	PA_SetSpriteAnim(1, 10+3, 14);
	
	createClockSprite(11,"MonthDigit1_X","MonthDigit1_Y","MonthDigit1_P");
	createClockSprite(12,"MonthDigit2_X","MonthDigit2_Y","MonthDigit2_P");

	createClockSprite(13,"DateSeparator1_X","DateSeparator1_Y","DateSeparator1_P");
	PA_SetSpriteAnim(1, 13+3, 11);
		
	createClockSprite(14,"DayDigit1_X","DayDigit1_Y","DayDigit1_P");
	createClockSprite(15,"DayDigit2_X","DayDigit2_Y","DayDigit2_P");
	
	createClockSprite(16,"DateSeparator2_X","DateSeparator2_Y","DateSeparator2_P");
	PA_SetSpriteAnim(1, 16+3, 11);
	
	createClockSprite(17,"YearDigit1_X","YearDigit1_Y","YearDigit1_P");
	createClockSprite(18,"YearDigit2_X","YearDigit2_Y","YearDigit2_P");
	
	


	
	spriteClockAlpha = (i!=0);
	spriteClockCoeff1 = readIniFileInt("Clock_Coeff1");
	spriteClockCoeff2 = readIniFileInt("Clock_Coeff2");
		
	fclose(readINI);
	return 1;
}		
void loadSpriteClock(char* menu)
{
   int i;
   char batteryGifPath[256];
   sprintf(batteryGifPath,"fat:/_menudo/themes/%s/%s/spriteclock.gif",CurrentTheme,menu);

	debugTxt("load sprite");
   FILE* fileFound = fopen(batteryGifPath,"rb");
	debugTxt("Finding file");
   if (fileFound)
   {
	   fclose(fileFound);
   	debugTxt("file found");
      u16* batterypal = NULL;
      u8* buffergfx = NULL;
      char* gifbuffer = NULL;

   	debugTxt("malloc");      
      batterypal= malloc (sizeof(u16)*256);   
   	debugTxt("load gif");
      gifbuffer = FAT_loadGIF(batteryGifPath);
   	debugTxt("convert to tiles");
		buffergfx = Soul_GifToTiles(gifbuffer,batterypal); // our palette
   	debugTxt("pal");
		PA_LoadSpritePal(1, 0, batterypal); 
   	debugTxt("sprite var");
		if (!loadSpriteVar(menu,buffergfx))
		{
		   if (buffergfx!=NULL) free(buffergfx);
		   if (batterypal!=NULL) free(batterypal);
		   if (gifbuffer!=NULL) free(gifbuffer);
		   spriteClockLoaded=0;
		   return;
		}   
/*
		for(i=0; i<6; i++)
		{
			PA_CreateSprite(1, i+3,buffergfx, OBJ_SIZE_64X64,1, 0, (i*XPOS + SPACEX*(i/2) + 3) - 10, YPOS );
			PA_SetSpritePrio(1,i+3,1);
		}		
		for(i=6; i<8; i++)
		{
		   PA_CreateSprite(1, i+3,buffergfx, OBJ_SIZE_64X64,1, 0, ((i-5)*2*XPOS + SPACEX*(i-6) + 3)-10, YPOS+10 );
			PA_SetSpriteAnim(1, i+3, 10);
		}	
		*/
		
		
		
   	debugTxt("freeing");		
	   if (buffergfx!=NULL) free(buffergfx);
	   if (batterypal!=NULL) free(batterypal);
	   if (gifbuffer!=NULL) free(gifbuffer);
	   spriteClockLoaded=1;
   	debugTxt("load effects");		
		loadSpriteClockCoeff();
   	debugTxt("update");		
		updateSpriteClock();

	}		
	else
	{
	   spriteClockLoaded=0;
	}		
   fclose(fileFound);
   	debugTxt("finished");		   

}
void updateSpriteClock()
{
   if (!spriteClockLoaded) return;

	int i=0;
	for (i=0;i<19;i++)
		PA_SetSpriteY(1,i+3,60+(PA_Cos((getTimerCounter())+(i*500))>>4));
	PA_SetSpriteAnim(1, 0+3, PA_RTC.Hour/10);
	PA_SetSpriteAnim(1, 1+3, PA_RTC.Hour%10);
	PA_SetSpriteAnim(1, 3+3, PA_RTC.Minutes/10);
	PA_SetSpriteAnim(1, 4+3, PA_RTC.Minutes%10);
	PA_SetSpriteAnim(1, 6+3, PA_RTC.Seconds/10);
	PA_SetSpriteAnim(1, 7+3, PA_RTC.Seconds%10);
	PA_SetSpriteAnim(1, 9+3, (PA_RTC.Hour<12?12:13));

	PA_SetSpriteAnim(1, 11+3, PA_RTC.Day/10);
	PA_SetSpriteAnim(1, 12+3, PA_RTC.Day%10);	
	PA_SetSpriteAnim(1, 14+3, PA_RTC.Month/10);
	PA_SetSpriteAnim(1, 15+3, PA_RTC.Month%10);
	PA_SetSpriteAnim(1, 17+3, PA_RTC.Year/10);
	PA_SetSpriteAnim(1, 18+3, PA_RTC.Year%10);		
}   
