#include <PA9.h>
#include "misc.h"
#include "../gfx/all_gfx.h"
#include "../engine/engine.h"
#include "transition.h"

//Debug Alert intensity ratings
//0 - Do not show any warning dialogs EXCEPT for a Code 'RED' error (MENUdo could not work because of an error)
//1 - Alert Code RED and Theme Related Errors
unsigned char alertLevel=1;


//Activating enableDebugLog will allow menudo to log processes in fat:\_menudo\debuglog
bool enableDebugLog = 0;
bool firstLog = 1;


extern const unsigned short blackarialAA12_Pal[8] __attribute__ ((aligned (4)));
extern unsigned short pal_16c[16] __attribute__ ((aligned (4)));
bool dialogBoxShownOnce=1;
bool printLoading=0;
u16 debugLine=0;   
bool enableLoading=0;
u16 lastcounter=0;
void resetDebugCounter()
{
   lastcounter=0;
   PA_VBLCounter[0]=0;
   PA_VBLCountersReset();
   PA_VBLCounterStart(0);

}
   
void initDebugTxt()
{
   if (!enableLoading) 
	{
	   return;
	}   
   debugMiliSec(true);
  	PA_SetBrightness(0,0);
	PA_SetBrightness(1,0);

   if (debugLine!=0)
	do{Soul_waitForVBL();}while(!(Pad.Held.Start || Pad.Newpress.Select));
   resetDebugCounter();
   printLoading=1;
//   if (!enableDebugLog) return;
   PA_16cErase(0);
   debugLine=0;   
   


}   
void debugTxt(char* text)
{
   if (!printLoading) return;
   if (!enableLoading) 
	{
//	   updateLoadScreen();
	   return;
	}   
	if (debugLine>192) 
	{
	   initDebugTxt();
	}   
	u8 size = 1;
   char temp[100];
   sprintf(temp,"[%ld] [%ld] %s",PA_VBLCounter[0], PA_VBLCounter[0]-lastcounter,text);
   lastcounter=PA_VBLCounter[0];
   display16cText(0,0,debugLine,256,192,temp,5,size);
   debugLine = PA_LetterPos.Letter[PA_LetterPos.NLetters].Y + pa_bittextpoliceheight[size];
//Pad.Newpress.Start=0;
//PA_WaitFor(Pad.Newpress.Start);   
}  
void debugMiliSec(bool resetcounter)
{
   resetcounter=1;
   if (!printLoading) return;
   if (!enableLoading) 
	{
	   updateLoadScreen();
	   return;
	}   

	if (debugLine>192) 
	{
	   initDebugTxt();
	   return;
	}   
   char temp[100];
   sprintf(temp,"[%ld] execution time",PA_VBLCounter[0]);
   if (resetcounter) lastcounter=PA_VBLCounter[0];
   display16cText(0,0,debugLine,256,192,temp,5,1);
   debugLine = PA_LetterPos.Letter[PA_LetterPos.NLetters].Y + pa_bittextpoliceheight[1];

//Pad.Newpress.Start=0;
//PA_WaitFor(Pad.Newpress.Start);   
}  

void deinitDebugTxt()
{
   if (!enableLoading)
	{
	   
	   return;
	}   

   printLoading=0;
   PA_16cErase(0);
   debugLine=0;   

}   
void sparkBrightnessUntilL()
{
	setBrightness(1,31);
	setBrightness(0,31);   
	PA_WaitFor(Pad.Newpress.L);
   setBrightness(0,0);
   setBrightness(1,0);
}   

void logMessage(char* text, ...)
{
   if (enableDebugLog)
   {
      FILE* log;
	 	if (firstLog)
		{
			log = fopen("fat:/_menudo/debuglog.txt","wb");	   
			firstLog=0;
		}   
		else
		{
		   log = fopen("fat:/_menudo/debuglog.txt","ab");	   
		}   
		char outputtext[300];
		s16 j, i;
		u16 textcount = 0; // compte le nombre de lettres...
		u8 PAtext[32]; // tableau o l'on copie les nombres et tout...
		u8 PAtextcount = 0; // Quand on a un nombre, il faut savoir sa longueur
		u8 *PAextext; // Extra text
		s32 PAtextnumber;
		double tempdouble = 0;
		     
		
		va_list varg;           /* Variable identifiant le prochain paramtre. */
	
	   va_start(varg, text);
	   
	   PAtextcount = 0;
	   
	
	
	
	   
	   for (j = 0; text[j]; j++) {
	      if (text[j] == '%') {
				if (text[j+1] == 's') {  // S'il y a %s, c'est une chaine de caractres...
	            PAextext = (u8*)va_arg(varg, const u8 *);  // Pointeur vers la chaine de charactres...
	            for (i = 0; PAextext[i]; i++) {
	               outputtext[textcount] = PAextext[i];
	               ++textcount;
	            }
	            j += 1;
	         }
	         else if ((text[j+1] == 'x')) {
				u32 test = va_arg(varg, u32);
				u8 temp;
				u8 started = 0;
				for(i = 0; i < 32; i+=4){
				   temp = (test>>(28-i))&15;
				   if(started || temp){
					   if(temp >= 10) outputtext[textcount] = 'A'+(temp-10); 
					   else outputtext[textcount] = '0'+(temp); 
						textcount++;
					   started = 1;
					}					   
				}   
				j++;
			}	
	         else if ((text[j+1] == 'd') || (text[j+1] == 'f')) {
				double test = 0;
	            if (text[j+1] == 'd') {
					PAtextnumber = va_arg(varg, s32);
					test = PAtextnumber;
				}
	            else {  // On ne prend que la partie entire pour l'instant, on garde le reste pour plus tard :p
	               tempdouble = va_arg(varg, double);
				   test = tempdouble;
				   PAtextnumber = (s32)tempdouble ;
	               tempdouble -= PAtextnumber;
	            }
	
	            s8 neg = 0; // Si negatif, passe  1...
	            if (test < 0) {
	               PAtextnumber = -PAtextnumber;
				   //tempdouble = -tempdouble;
	               neg = 1;
	            }
	
	            for (i = 0; PAtextnumber || (!PAtextnumber && !i); i++) {  // tant que le nombre ne vaut pas 0 mais que i est positif, on continu  la convertir...
	               PAtext[i] = '0' + (PAtextnumber%10);
	               PAtextnumber = PAtextnumber / 10; // Nombre de dpart...
	            }
	            if (neg) {
	               PAtext[i] = '-';
	               ++i;
	            }
	            for (i--; i > -1; i--) {
	               	outputtext[textcount] = PAtext[i];
	               ++ textcount;
	            }
	            j += 1;
	            
	            if (text[j] == 'f') { // Il reste donc la virgule  traiter...
	               outputtext[textcount] = '.';
	
	               ++ textcount;
	               i = text[j+1] - 48;  // Nombre de chiffres aprs la virgule...
	               PAtext[1] = 0; // Permet de stopper si c'est vba...
				   if (tempdouble < 0) tempdouble = -tempdouble;
	               while((i-- > 0)) { // Pas plus de 6 chiffres aprs la virgule...
	                  tempdouble *= 10;
					  //if (
	                  PAtextnumber = (s32)tempdouble;
	                  tempdouble -= PAtextnumber;
	                  PAtext[0] = '0' + PAtextnumber;
							outputtext[textcount] = PAtext[0];
	                  ++ textcount;
	               }
	            j += 1;
	            }
	
	          }
			  else if ((text[j+3] == 'd') && (text[j+1] != ' ')&& (text[j+2] != ' ')){ // C'est plus loin, donc on a genre %02d...
	            PAtextnumber = va_arg(varg, s32);
	            s8 neg = 0; // Si negatif, passe  1...
				u8 amettre = text[j+1]; // Nombre  mettre pour remplir
				s8 nfois = text[j+2] - '0'; // Nombre de caractres  mettre
		
	            if (PAtextnumber < 0) {
	               PAtextnumber = -PAtextnumber;
	               neg = 1;
	            }
	
	            for (i = 0; PAtextnumber || (!PAtextnumber && !i); i++) {  // tant que le nombre ne vaut pas 0 mais que i est positif, on continu  la convertir...
	               PAtext[i] = 48 + (PAtextnumber%10);
	               PAtextnumber = PAtextnumber / 10; // Nombre de dpart...
				   nfois--; // Un nombre de moins  mettre...
	            }
				
				while(nfois > 0) { // On complte de 0 est tout...
					outputtext[textcount] = amettre;//'X';
					++textcount;
					--nfois;
				}
				
	            if (neg) {
	               PAtext[i] = '-';
	               ++i;
	            }
	            for (i--; i > -1; i--) {
	     				outputtext[textcount] = PAtext[i];
	               ++ textcount;
	            }
	            j += 3;
			  
			  }
	          else { // Sinon c'est juste
					outputtext[textcount] = text[j];
	            ++textcount;
	          }
	      }
	      else{
				outputtext[textcount] = text[j];
	         ++textcount;
	      }
	   }
	
				outputtext[textcount] = '\n';
				outputtext[textcount+1] = '\0';
	    va_end(varg);           /* Terminaison. */
		
	
		fwrite(outputtext, strlen(outputtext), 1, log);
		fclose(log);
	}		
}		  
void ShowDialogBox(unsigned char priority, bool screen, int layer, char* text, ...) 
{
   if (alertLevel < priority) return;
//   logMessage(text);

   setBrightness(0,0);
   setBrightness(1,0);
	char outputtext[300];
	s16 j, i;
	u16 textcount = 0; // compte le nombre de lettres...
	u8 PAtext[32]; // tableau o l'on copie les nombres et tout...
	u8 PAtextcount = 0; // Quand on a un nombre, il faut savoir sa longueur
	u8 *PAextext; // Extra text
	s32 PAtextnumber;
	double tempdouble = 0;
	     
	
	va_list varg;           /* Variable identifiant le prochain paramtre. */

   va_start(varg, text);
   
   PAtextcount = 0;
   



   
   for (j = 0; text[j]; j++) {
      if (text[j] == '%') {
			if (text[j+1] == 's') {  // S'il y a %s, c'est une chaine de caractres...
            PAextext = (u8*)va_arg(varg, const u8 *);  // Pointeur vers la chaine de charactres...
            for (i = 0; PAextext[i]; i++) {
               outputtext[textcount] = PAextext[i];
               ++textcount;
            }
            j += 1;
         }
         else if ((text[j+1] == 'x')) {
			u32 test = va_arg(varg, u32);
			u8 temp;
			u8 started = 0;
			for(i = 0; i < 32; i+=4){
			   temp = (test>>(28-i))&15;
			   if(started || temp){
				   if(temp >= 10) outputtext[textcount] = 'A'+(temp-10); 
				   else outputtext[textcount] = '0'+(temp); 
					textcount++;
				   started = 1;
				}					   
			}   
			j++;
		}	
         else if ((text[j+1] == 'd') || (text[j+1] == 'f')) {
			double test = 0;
            if (text[j+1] == 'd') {
				PAtextnumber = va_arg(varg, s32);
				test = PAtextnumber;
			}
            else {  // On ne prend que la partie entire pour l'instant, on garde le reste pour plus tard :p
               tempdouble = va_arg(varg, double);
			   test = tempdouble;
			   PAtextnumber = (s32)tempdouble ;
               tempdouble -= PAtextnumber;
            }

            s8 neg = 0; // Si negatif, passe  1...
            if (test < 0) {
               PAtextnumber = -PAtextnumber;
			   //tempdouble = -tempdouble;
               neg = 1;
            }

            for (i = 0; PAtextnumber || (!PAtextnumber && !i); i++) {  // tant que le nombre ne vaut pas 0 mais que i est positif, on continu  la convertir...
               PAtext[i] = '0' + (PAtextnumber%10);
               PAtextnumber = PAtextnumber / 10; // Nombre de dpart...
            }
            if (neg) {
               PAtext[i] = '-';
               ++i;
            }
            for (i--; i > -1; i--) {
               	outputtext[textcount] = PAtext[i];
               ++ textcount;
            }
            j += 1;
            
            if (text[j] == 'f') { // Il reste donc la virgule  traiter...
               outputtext[textcount] = '.';

               ++ textcount;
               i = text[j+1] - 48;  // Nombre de chiffres aprs la virgule...
               PAtext[1] = 0; // Permet de stopper si c'est vba...
			   if (tempdouble < 0) tempdouble = -tempdouble;
               while((i-- > 0)) { // Pas plus de 6 chiffres aprs la virgule...
                  tempdouble *= 10;
				  //if (
                  PAtextnumber = (s32)tempdouble;
                  tempdouble -= PAtextnumber;
                  PAtext[0] = '0' + PAtextnumber;
						outputtext[textcount] = PAtext[0];
                  ++ textcount;
               }
            j += 1;
            }

          }
		  else if ((text[j+3] == 'd') && (text[j+1] != ' ')&& (text[j+2] != ' ')){ // C'est plus loin, donc on a genre %02d...
            PAtextnumber = va_arg(varg, s32);
            s8 neg = 0; // Si negatif, passe  1...
			u8 amettre = text[j+1]; // Nombre  mettre pour remplir
			s8 nfois = text[j+2] - '0'; // Nombre de caractres  mettre
	
            if (PAtextnumber < 0) {
               PAtextnumber = -PAtextnumber;
               neg = 1;
            }

            for (i = 0; PAtextnumber || (!PAtextnumber && !i); i++) {  // tant que le nombre ne vaut pas 0 mais que i est positif, on continu  la convertir...
               PAtext[i] = 48 + (PAtextnumber%10);
               PAtextnumber = PAtextnumber / 10; // Nombre de dpart...
			   nfois--; // Un nombre de moins  mettre...
            }
			
			while(nfois > 0) { // On complte de 0 est tout...
				outputtext[textcount] = amettre;//'X';
				++textcount;
				--nfois;
			}
			
            if (neg) {
               PAtext[i] = '-';
               ++i;
            }
            for (i--; i > -1; i--) {
     				outputtext[textcount] = PAtext[i];
               ++ textcount;
            }
            j += 3;
		  
		  }
          else { // Sinon c'est juste
				outputtext[textcount] = text[j];
            ++textcount;
          }
      }
      else{
			outputtext[textcount] = text[j];
         ++textcount;
      }
   }

			outputtext[textcount] = '\0';
    va_end(varg);           /* Terminaison. */
	


      PA_Init16cBg(screen,0);
		PA_16cTextAlign(ALIGN_CENTER);
		PA_16cText(screen,layer,60,256,192,outputtext,1,2,256);
		do { Soul_waitForVBL();} while(!Pad.Newpress.A);
	/*
	

//		PA_16cTextLetterSpacing(-1);
		PA_16cTextAlign(0);
		PA_16cErase(screen);
		PA_16cText(screen,38,40,218,171,outputtext,1,5,300);
		Load16cBMPtoBG(screen,(void*)wiiwarning,28,21);

		for(i=1;i<8;i++)
		{
		   pal_16c[i]=blackarialAA12_Pal[i];
		}   

		PA_LoadPal16c(screen? PAL_BG1 : PAL_BG0, (void*)pal_16c);
		if (dialogBoxShownOnce)	
		{
			PA_EnableSpecialFx(screen, SFX_ALPHA, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
			i=95;
		   while(i>0)
		   {
		      if (((95-i)/3)<32) PA_SetSFXAlpha(screen, (95-i)/3, (95-i)/3);
		      PA_BGScrollY(screen,layer,i);
		      if (i>10)
					i-=3;
				else
					i--;
		      Soul_waitForVBL();
		      if (Pad.Newpress.A || Pad.Newpress.B || Stylus.Newpress) break;
		   }   
	      PA_BGScrollY(screen,layer,0);
	   }   

		PA_EnableSpecialFx(screen, SFX_NONE,SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	   while(1)
	   {
			Soul_waitForVBL();
	      if (Pad.Newpress.A || Pad.Newpress.B || Stylus.Newpress) break;
		}	
		PA_EnableSpecialFx(screen, SFX_ALPHA, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
		
		if (dialogBoxShownOnce)	
		{
			i=80;
		   while(i>0)
		   {
		      if ((i/3)<32) PA_SetSFXAlpha(screen, i/3, i/3);
		      PA_BGScrollY(screen,layer,(80-i)*-1);
		      if (i>70)
					i--;
					else
					i-=3;
		      Soul_waitForVBL();
		      if (Pad.Newpress.A || Pad.Newpress.B || Stylus.Newpress) break;
		   }   
			PA_16cErase(screen);	
	      PA_BGScrollY(screen,layer,0);
	   }   
	   dialogBoxShownOnce=0;
	   PA_SetSFXAlpha(screen, 31,15);
	   */
}	


bool loadScreenEnabled=0;
u8 loadTimer=0;
extern bool bootupfinished;
bool isLoadScreenEnabled(){ return loadScreenEnabled==1;}
void startLoadScreen()
{
   return;
   if (!bootupfinished) return;
   if (!isLoadScreenEnabled())
   {
	   loadScreenEnabled=1;
		loadTimer=0;
	   createAjaxCircles(5);
	   updateLoadScreen();
	   PA_VBLFunctionInit(updateLoadScreen);
	}   
   
}
void stopLoadScreen()
{
   if (enableLoading || !bootupfinished) return;
   if (isLoadScreenEnabled())
   {
	   loadScreenEnabled=0;
	   PA_VBLFunctionReset();
	}   
}   

void updateLoadScreen()
{
   if (enableLoading || !bootupfinished) return;
	updateAjaxSprite((loadTimer>>2)%8);
	loadTimer++;   
//	if (loadTimer==8) loadTimer=0;
}	  

void drawCircle16c(bool screen, int xCenter, int yCenter, int radius, int color){
int x = 0;
int y = radius;
int p = 3 - 2 * radius;
int i;
   while (x <= y){
      for (i=xCenter - x;i<=xCenter + x;i++)
	      PA_16cPutPixel(screen, i, yCenter + y, color);

      for (i=xCenter - x;i<=xCenter + x;i++)
	      PA_16cPutPixel(screen, i, yCenter - y, color);

      for (i=xCenter - y;i<=xCenter + y;i++)
	      PA_16cPutPixel(screen, i, yCenter + x, color);

      for (i=xCenter - y;i<=xCenter + y;i++)
	      PA_16cPutPixel(screen, i, yCenter - x, color);
      if (p < 0) p += 4 * x++ + 6;
      else p += 4 * (x++ - y--) + 10;
   }
}

void updateAjaxSprite(int frame)
{
   int i;
	pal_16c[0]=0;
	for (i=0;i<8;i++)
	{
	   if (i>3)
		   pal_16c[((frame+i)%8)+1] = 0;
	   else
		   pal_16c[((frame+i)%8)+1] = PA_RGB(10+(i*7),10+(i*7),10+(i*7));
	}   
	
	PA_LoadPal16c(PAL_BG0,pal_16c);
}   

void createAjaxCircles(int y)
{
	drawCircle16c(0,97,140-y,5,1);
	drawCircle16c(0,106,118-y,5,2);
	drawCircle16c(0,128,109-y,5,3);
	drawCircle16c(0,150,118-y,5,4);
	drawCircle16c(0,158,140-y,5,5);
	drawCircle16c(0,150,162-y,5,6);
	drawCircle16c(0,128,170-y,5,7);
	drawCircle16c(0,106,162-y,5,8);
}   

