#include <PA9.h>
#include <fat.h>
#include <sys/dir.h>
#include "debug.h"
//#include "stdlib.h"

FILE* readINI; 
struct stat st;
int atoi ( const char * str );
bool verifyDir(char* path)
{
   char directory[256];
   sprintf(directory,"fat:/%s",path);
	DIR_ITER* dir = diropen(directory);
	if (dir != NULL) 
	{
	   dirclose(dir);
		return 1;
	} 
	dirclose(dir);
	return 0;
}   

char* getFileLastModified(char* filename)
{

    if( -1 == stat( filename, &st ) ) {
        return "Cant find file";
    }
	st.st_mtime += 312784909; // dunno what this does :|
   struct tm * filetime = gmtime(&st.st_mtime);
   char *charTemp= (char*)malloc(256); 
   memset(charTemp, 0, 256);
	sprintf(charTemp, "%d-%d-%d %02d:%02d:%02d\n",
        filetime->tm_year + 1900, filetime->tm_mon+1, filetime->tm_mday,
        filetime->tm_hour, filetime->tm_min, filetime->tm_sec );
   return charTemp;
}   

bool seekLine(char *line, char *param)
{
   int i;

   fseek(readINI, 0, SEEK_SET);
   memset(line, 0, 256);
   while(fgets(line, 256, readINI)!=NULL)
   { 
      if(strlen(line)>strlen(param)) // check if there's a param
      {
         if(strlen(line)>0&&line[0]!='#') // not a comment line
         {
            bool foundLine = true;
            for(i=0;i<(int)strlen(param);i++)
            {
               if(line[i]!=param[i])
                  foundLine = false;
            }
            if(foundLine)
               return true;
         }
      }
      memset(line, 0, 256);
   }
   
   return false;
}

int readIniFileInt(char *param)//reminder it only search the first letter so testas would be read as test
{

   int i,j;
   if(readINI==NULL) 
   {
      logMessage(param);
      /*
		PA_Init16cBg(0, 1);
		PA_SetBgPrio(0,0,1);
		PA_SetBgPrio(0,1,0);

	   ShowDialogBox(0, 0, 1,"%s\nIni could not be found",param);*/
	   return 0;
	}   

   char line[256];
   
   if(!seekLine(line, param))
   {
      logMessage(param);
/*		PA_Init16cBg(0, 1);
		PA_SetBgPrio(0,0,1);
		PA_SetBgPrio(0,1,0);
	   ShowDialogBox(0, 0, 1,"Missing INT ini value\n%s",param);*/
	   return 0;	   
	}   
      
   char value[16]; memset(value, 0, 16);
   bool parse = false;
   bool strip = false;
   j=0;
   for(i=0;i<(int)strlen(line);i++)
   {
      if(parse)
      {
         if(line[i]!=' ')
            strip = true;
         
         if(strip && line[i] > 0x13)
         {
            value[j] = line[i];
            j++;
         }
      }
      if(line[i]=='=')
         parse = true;
   }
   
   return atoi(value);
} 

char* readIniFileString(char *param)//reminder it only search the first letter so testas would be read as test
{
   
   int i,j;
   if(readINI==NULL) 
   {
      logMessage(param);
/*		PA_Init16cBg(0, 1);
		PA_SetBgPrio(0,0,1);
		PA_SetBgPrio(0,1,0);
	   ShowDialogBox(0, 0, 1,"%s\nIni could not be found",param);*/
	   return NULL;

	}   
   char line[256];

   char *value = (char*)malloc(256); memset(value, 0, 256);
   
   if(!seekLine(line, param))
   {
      logMessage("not found string");
            logMessage(param);
/*		PA_Init16cBg(0, 1);
		PA_SetBgPrio(0,0,1);
		PA_SetBgPrio(0,1,0);
	   ShowDialogBox(0, 0, 1,"Missing STRING ini value\n%s",param);*/
	   memset(value, 0, 256);
	   return value;
	}   
      
   bool parse = false;
   bool strip = false;
   j=0;
   
   for(i=0;i<256;i++)
   {
      if(parse)
      {
         if(line[i]!=' ')
            strip = true;
         
         if(strip && line[i] > 0x13)
         {
            value[j] = line[i];
            j++;
         }
      }
      if(line[i]=='=')
      {
         parse = true;
         //fwrite("teast", 30, 10, readINI);
      }   
   }

   return value;
}




