#include <PA9.h>
#include "../userConfigFunctions.h"
#include "../engine/engine.h"
#include "fat.h"
#include "transition.h"
char ScreenBrightness[2];

extern FILE* readINI; 
extern bool AfterSMFIntro;
int setBrightness(bool screen, int brightness)
{
   ScreenBrightness[screen]=brightness;
   PA_SetBrightness(screen,ScreenBrightness[screen]);
   return ScreenBrightness[screen];
}   
int getScreenBrightnessValue(bool screen)
{
   return ScreenBrightness[screen];
}   
int transiteScreenBrightness(bool screen,int transiteTo)
{
   if (transiteTo>31) transiteTo = 31;
   if (transiteTo<-31) transiteTo = -31;
	if (getScreenBrightnessValue(screen)>transiteTo) 
	{
	   setBrightness(screen,getScreenBrightnessValue(screen)-1);
	}   
	if (getScreenBrightnessValue(screen)<transiteTo) 
	{
	   setBrightness(screen,getScreenBrightnessValue(screen)+1);
	}
	return getScreenBrightnessValue(screen);
}		   
bool transitionAnimOn;
bool transitionAnimFadeOn;
bool transitionAnimFadeWhite;
bool transitionAnimZoom;
bool transiteIn;
char transiteTime=0;	   
bool excludeAfterMovie;
extern u8 transitionCounter;
void initThemeTransition(char* currentMenu, bool enteringTransition)
{
//   return;
	if (transitionCounter>0) return;
   transiteIn=enteringTransition;
   transiteTime=0;	   
   char charTemp[256];
   if (strcmp(currentMenu,"settings")==0 || strcmp(currentMenu,"explorer")==0)
   {
      sprintf(charTemp,"%s/transitions.ini",currentMenu);
      char * path = returnThemeResourcePath(charTemp,1);
      sprintf(charTemp,"%s",path);
      free(path);
   }   
   else
		sprintf(charTemp,"fat:/_menudo/themes/%s/%s/transitions.ini", CurrentTheme,currentMenu);
	readINI = fopen(charTemp,"rb");
   logMessage("%s",charTemp);
	if (enteringTransition)
	{
	   transitionAnimOn = (bool)readIniFileInt("IN_TransitionAnimationOn");
	   transitionAnimFadeOn = (bool)readIniFileInt("IN_TransitionAnimationFadeOn");
	   transitionAnimFadeWhite = (bool)readIniFileInt("IN_TransitionAnimationFadeWhite");
	   transitionAnimZoom = (bool)readIniFileInt("IN_TransitionAnimationZoom");
	}
	else
	{
	   transitionAnimOn = (bool)readIniFileInt("OUT_TransitionAnimationOn");
	   transitionAnimFadeOn = (bool)readIniFileInt("OUT_TransitionAnimationFadeOn");
	   transitionAnimFadeWhite = (bool)readIniFileInt("OUT_TransitionAnimationFadeWhite");
	   transitionAnimZoom = (bool)readIniFileInt("OUT_TransitionAnimationZoom");	   
	}
	if (!transitionAnimOn) AfterSMFIntro=0;
	if (PA_CompareText(currentMenu,"Mainmenu")) 
		excludeAfterMovie = (bool)readIniFileInt("EXCLUDE_Screen1_TransitionIfAfterMovie");
		else
		excludeAfterMovie = 0;
	fclose(readINI);
	setBrightness(0, transitionAnimFadeWhite? 31 : -31);
	if (!excludeAfterMovie) setBrightness(1, transitionAnimFadeWhite? 31 : -31);
}   
bool isScreenTransiting()
{
   return transitionAnimOn;
}   
bool isScreenFadeColorWhite()
{
   return transitionAnimFadeWhite;
}
void setTransitionTimer(int i )
{
   transiteTime = i;
}   
void updateScreenTransition()
{
	if (transitionCounter>0) return;
	if (transitionAnimOn)
	{
		if (transiteTime<31)
		{
		   if (transiteIn)
			{
			   if (transitionAnimFadeOn)
			   {
				   setBrightness(0,transitionAnimFadeWhite?
																				(31-transiteTime) : (31-transiteTime)*-1);
			      if (!(AfterSMFIntro && excludeAfterMovie))
			      {
					   setBrightness(1,transitionAnimFadeWhite?
																				(31-transiteTime) : (31-transiteTime)*-1);
					}			
					else
					{
					   setBrightness(1,0);
					}   
				}  
				else
				{
				   resetScreenBrightness();
				}			 
			}   
			else
		   {
			   if (transitionAnimFadeOn)
			   {
				   setBrightness(0,transitionAnimFadeWhite?
																				transiteTime : transiteTime*-1);

					   setBrightness(1,transitionAnimFadeWhite?
																				transiteTime : transiteTime*-1);

				}   
				else
				{
				   resetScreenBrightness();
				}			 
			}			
		   
		   if (transitionAnimZoom)
		   {
			   if (transiteIn)
			   {
  					ZoomXY_3DProcess(128+(31-transiteTime),0,0);  
		  		}			
		  		else
			   {
  					ZoomXY_3DProcess(128+(transiteTime),0,0);  
		  		}			
		   }
			else   
			{
			   ZoomXY_3DProcess(128,0,0);  
			}   
			transiteTime++;
			if (transiteTime==31) AfterSMFIntro=0;
		   if (Pad.Newpress.Anykey)
			{
			   transiteTime=31;
			   transitionAnimOn=0;
			}   
		}	
		else
		{
		   transitionAnimOn=0;
		}   
	}		

}		   
void resetScreenBrightness()
{
   setBrightness(0,0);
   setBrightness(1,0);
}   

void transiteScreenAnd3DProcess()
{
	if (isScreenTransiting())
	{
		updateScreenTransition();
	}	
	else	
	{
		ZoomXY_3DProcess(128,0,0);  //PA_3DProcess();  
	}	
}		
