//#define emulate
#include <PA9.h>       // Include for PA_Lib
#include <sys/dir.h>
#include "interfaceScreen.h"
#include "commonVariables.h"
#include "functions.h"

//#include "background.h"
#include "../gfx/all_gfx.h"
#include "../misc/fat.h"

#define DOUBLETAP_DURATION 30

#include "..\commands\main_menu\types.h"

int canvasZoom=128;
int navigationspeed=2;
u8 functionMode=0;
s16 functionOldY=0;
s16 functionOldX=0;

FILE* recipeFile; 
FILE* imgFile;
FILE* projectInfo;
extern FILE* readINI;
int abs(int v);
extern bool horizontalNavigationControls;
extern u32 idleCounter;
char CurrentBottomScreenTheme[30];

u8 max_anim=30;


u16 y;

u8 play_mode;
u8 menu_select[5];




struct systemConfig
{
   char startup[4][100];
   char menuRuns[9][100];
	u8 Language;
	u8 BacklightStrength;
	bool EnergySaving;
	bool PromptCommands;
	bool iniLoaded;
} system;


#include "../engine/engine.h"
u16 TP_giftotexcolor;

//inline void clipKeyFrame_IfAtCornerMenu(property,value)

																			

char* addFileType (char* filename,char* filetype)
{
   char *temp = (char*)malloc(100);
   sprintf (temp,"%s%s",filename,filetype);
   return temp;
}   

FILE * fileChecker;


void loadIngredient(u16 sprite,char* path)
{
   LoadSpriteIngredient(sprite,path);
}   
extern char CurrentTheme[256];
void rcpimaker()
{
//   PA_Init();

	PA_Init3D(); // Uses Bg0, Init 3D...
	PA_Reset3DSprites(); // Init or Reset 3D Sprites
/*
	PA_Init16bitBg(1, 3);
	PA_Init16cBg(1, 2); 	*/
	PA_Init16cBg(0, 1);

	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);

	initAntiAliasedText(0,1,0);
	
	char charTemp[256];
	sprintf(charTemp,"fat:/_menudo/themes/%s/topscreen/theme.recipe",CurrentTheme);


	FILE* recipeFile = fopen (charTemp, "rb"); 
	int i,k;
	memset (charTemp,0,256);
	if (recipeFile)
	{
		for (i=0;i<30;i++)
		for (k=0;k<30;k++)
		{
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].key_frame = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].angle = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].x = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].y = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].pivot_x = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].pivot_y = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].width = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].height = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].alpha = atoi(charTemp);
		   fread (charTemp,1,6,recipeFile);
		   sprite[i].data[k].prio = atoi(charTemp);
		}	
	}		
	fclose(recipeFile);
	sprintf(charTemp,"fat:/_menudo/themes/%s/mainscreen/mainscreen.ini",CurrentTheme);
	readINI = fopen (charTemp, "rb"); 
	if (readINI)
	{
		horizontalNavigationControls = !((bool)readIniFileInt("NavigationHorizontalControls"));
	}		
	else
	{
		horizontalNavigationControls = 0;
	}	
	fclose(readINI);
	initXMB_default();
	
//	readINI = fopen ("fat:/system_theme.ini", "rb"); 
//	sprintf(CurrentBottomScreenTheme,"/%s",(char *)readIniFileString("CurrentBottomScreenTheme"));
//	fclose(readINI);
	
//	i=0;l=0;k=0;
//	readINI = fopen ("fat:/user_config.ini", "rb"); 
  	system.Language = 0;//readIniFileInt("Language");	
//	fclose(readINI);	  			
	

/*	loadIngredient(0	,"1");
	loadIngredient(1	,"2");
	loadIngredient(2	,"3");
	loadIngredient(3	,"4");
	loadIngredient(4	,"5");
	loadIngredient(5	,"a");
	loadIngredient(6	,"b");
	loadIngredient(7	,"c");
	loadIngredient(8	,"d");
	loadIngredient(9	,"e");
	loadIngredient(10 ,"1a"); 
	loadIngredient(11 ,"1b"); 
	loadIngredient(12 ,"1c"); 
	loadIngredient(13 ,"1d"); 
	loadIngredient(14 ,"1e"); 
	loadIngredient(15 ,"1f"); 
	loadIngredient(16 ,"2a");
	loadIngredient(17 ,"2b");
	loadIngredient(18 ,"3a");
	loadIngredient(19 ,"3b");
	loadIngredient(20 ,"4a");
	loadIngredient(21 ,"4b");
	loadIngredient(22 ,"5a");
	loadIngredient(23 ,"5b");
	loadIngredient(24 ,"5c");
	loadIngredient(25 ,"5d");
	loadIngredient(26 ,"5e");
	loadIngredient(27 ,"5f");




	u16 blackBackground= PA_3DCreateTex((void*)black_background_Texture,8,8,TEX_4COL);
	PA_Load3DSpritePal(40,(void*)black_background_Pal);
	PA_3DCreateSpriteFromTex(1000, blackBackground, 1024, 256, 40,512+0,128+192);
	PA_3DSetSpritePrio(1000,3000);
	PA_3DCreateSpriteFromTex(1001, blackBackground, 1024, 256, 40,256+0,-128);	
	PA_3DSetSpritePrio(1001,3000);	
	PA_3DCreateSpriteFromTex(1002, blackBackground, 1024, 512, 40,-512,256);	
	PA_3DSetSpritePrio(1002,3000);
	PA_3DCreateSpriteFromTex(1003, blackBackground, 1024, 512, 40,512+256,256);	
	PA_3DSetSpritePrio(1003,3000);
	


//	CreateSpriteFromFatBmp(28,"backgroundcolor.bmp",0,128, 96);   									
//	PA_3DSetSpriteWidth(28,256);
//	PA_3DSetSpriteHeight(28,192);
	PA_3DCreateSpriteFromTex(29, blackBackground, 1024, 512, 40,256*.5,192*.5);	
	PA_3DSetSpriteWidth (29,256);
	PA_3DSetSpriteHeight(29,192);
	PA_3DSetSpritePrio(29,10);										
*/

	

	create3dOuterCanvasLayer(1000,31,31,31);
   
	create3dBackgroundLayer(888,0,0,0); //place bg ini here
	PA_3DSetSpritePrio(888,5);
	
	create3dBackgroundLayer(889,31,31,31);
	PA_3DSetSpritePrio(889,4);



	
	PA_Load3DSpritePal(28, (void*)scaleButton_Pal);
	PA_3DCreateSpriteFromTex(123,
	PA_3DCreateTex((void*)scaleButton_Texture,  16, 16,  TEX_4COL)
	,16, 16, 28,32,32);

	PA_Load3DSpritePal(28, (void*)rotateButton_Pal);
	PA_3DCreateSpriteFromTex(124,
	PA_3DCreateTex((void*)rotateButton_Texture,  16, 16,  TEX_4COL)
	,16, 16, 28,32,32);

	PA_3DCreateSpriteFromTex(125,
	PA_3DCreateTex((void*)scaleButton_Texture,  16, 16,  TEX_4COL)
	,16, 16, 28,32,32);
	







//	u16 Aurora_texture = PA_3DCreateTexFromGif((void*)FAT_loadGIF("BG_ribbon.bmp"),30);
//k =PA_GetGifWidth((void*)FAT_loadGIF("BG_ribbon.bmp"));
//i =PA_GetGifHeight((void*)FAT_loadGIF("BG_ribbon.bmp"));
//   PA_3DCreateSpriteFromTex(50, Aurora_texture, k,i, 30, 128, 80);								
//   PA_3DCreateSpriteFromTex(49, Aurora_texture, k,i, 30, 128, 80);								
	k=0; //(clear temp)
	i=0; //(clear temp)
	sprintf(charTemp,"fat:/_menudo/themes/%s/topscreen/project.info",CurrentTheme);
	projectInfo = fopen (charTemp, "rb"); 
	if (projectInfo)
	for (k = 0; k <= numberofsprites-1; k++)
	{
		fread(charTemp, 1 , 1 , projectInfo);
		spriteIsLocked[k] = atoi(charTemp);
	}		
	fclose(projectInfo);

											



	menu_select[1]=1;
	menu_select[4]=1;


	for (k = 22; k <= 27; k++) sprite[k].var2.time=180; //moves GAME menu's time to 150 where they have alpha=0




	
//	sprite[selectedMenu].var2.time=sprite[selectedMenu].data[sprite[selectedMenu].var2.current_sprite].key_frame;
	bool screenswitched=0;
	int doubleTapL=0;
	if (screenswitched) PA_SwitchScreens();
	initInterface();
	LoadSpriteIngredient(0	,"1");
	LoadSpriteIngredient(1	,"2");
	LoadSpriteIngredient(2	,"3");
	LoadSpriteIngredient(3	,"4");
	LoadSpriteIngredient(4	,"5");
	LoadSpriteIngredient(5	,"a");
	LoadSpriteIngredient(6	,"b");
	LoadSpriteIngredient(7	,"c");
	LoadSpriteIngredient(8	,"d");
	LoadSpriteIngredient(9	,"e");
	LoadSpriteIngredient(10 ,"1a"); 
	LoadSpriteIngredient(11 ,"1b"); 
	LoadSpriteIngredient(12 ,"1c"); 
	LoadSpriteIngredient(13 ,"1d"); 
	LoadSpriteIngredient(14 ,"1e"); 
	LoadSpriteIngredient(15 ,"1f"); 
	LoadSpriteIngredient(16 ,"2a");
	LoadSpriteIngredient(17 ,"2b");
	LoadSpriteIngredient(18 ,"3a");
	LoadSpriteIngredient(19 ,"3b");
	LoadSpriteIngredient(20 ,"4a");
	LoadSpriteIngredient(21 ,"4b");
	LoadSpriteIngredient(22 ,"5a");
	LoadSpriteIngredient(23 ,"5b");
	LoadSpriteIngredient(24 ,"5c");
	LoadSpriteIngredient(25 ,"5d");
	LoadSpriteIngredient(26 ,"5e");
	LoadSpriteIngredient(27 ,"5f");
	initAmbienceFromTheme("Mainmenu",50);
/*	#ifdef emulate
	#else
	initAmbience("fat:/amb.defaultxmb","amb.00",50);
	#endif*/
	while(1) {
  	PA_16cErase(1);
	if (Pad.Newpress.L)
	{
		if (doubleTapL > 0)
		{
		   PA_SwitchScreens();
		   screenswitched = !screenswitched;
		   doubleTapL=0;
		}  	
		else
		{
		   doubleTapL=DOUBLETAP_DURATION;
		}   
	}		
	else
	if (doubleTapL > 0) 		--doubleTapL;
	
	if(!screenswitched && Stylus.Released)
	{
		if (functionMode != 10)functionMode=0;
	}   
	if (functionMode != 10 && functionMode != 3)
	{
		PA_3DSetSpriteXY(123,(pa_3dsprites[selectedMenu].X+(pa_3dsprites[selectedMenu].Width>>1))+16,(pa_3dsprites[selectedMenu].Y-(pa_3dsprites[selectedMenu].Height>>1))-8);
		PA_3DSetSpriteXY(124,(pa_3dsprites[selectedMenu].X+(pa_3dsprites[selectedMenu].Width>>1))+16,(pa_3dsprites[selectedMenu].Y-(pa_3dsprites[selectedMenu].Height>>1))+8);
		PA_3DSetSpriteXY(125,(pa_3dsprites[selectedMenu].X+(pa_3dsprites[selectedMenu].Width>>1))+16,(pa_3dsprites[selectedMenu].Y+(pa_3dsprites[selectedMenu].Height>>1))+8);
	   PA_3DSetSpriteVisible(123,1);
	   PA_3DSetSpriteVisible(124,1);
	   PA_3DSetSpriteVisible(125,1);
	   if (functionMode==1)
	   {
		   PA_3DSetSpriteVisible(123,0);
		   PA_3DSetSpriteVisible(125,0);
		}   
	   if (functionMode==2)
		{
		   PA_3DSetSpriteVisible(124,0);
		   PA_3DSetSpriteVisible(125,0);
		}   
	   if (functionMode==4)
		{
		   PA_3DSetSpriteVisible(123,0);
		   PA_3DSetSpriteVisible(124,0);
		}   
	}	
	else
	{
	   PA_3DSetSpriteVisible(123,0);
	   PA_3DSetSpriteVisible(124,0);
	   PA_3DSetSpriteVisible(125,0);
	}   
	if (screenswitched)
	{
		if (interactInterface()) return; //to be called before updateInterface(); and after PA_16cErase(1);
	}
   updateInterface(screenswitched); //Update Info Interface
	if (!screenswitched)
	{
	
	


	
	if (Stylus.Newpress)
	{
	   if (functionMode != 10)
	   {
			if(PA_3DSpriteTouched(123)) 
				functionMode=2;
			
			if(PA_3DSpriteTouched(124)) 
				functionMode=1;
		   functionOldX = Stylus.X;
		   
			if(PA_3DSpriteTouched(125)) 
			{
				functionMode=4;
				functionOldX = sprite[selectedMenu].data[sprite[selectedMenu].var2.current_sprite].alpha; // X is now for old Alpha
			}			
	
		   functionOldY = Stylus.Y;
		}   
		if (functionMode == 0 || functionMode == 10)
		{   
			if(PA_3DSpriteTouched(selectedMenu)) 
			{
			   functionOldX = Stylus.X-pa_3dsprites[selectedMenu].X;
			   functionOldY = Stylus.Y-pa_3dsprites[selectedMenu].Y;
			   functionMode = 3;
			}   
			else
			{
				 functionMode = 10;
				 for (i = 0; i <= numberofsprites-1; i++)  
				 if(PA_3DSpriteTouched(i) && pa_3dsprites[i].Alive && !spriteIsLocked[i]) 
				 {
				   selectedMenu = i;
				   functionMode = 0;
				   break;
				 }   
				 if (functionMode==10) 
				 {
					 for (i = 0; i <= numberofsprites-1; i++)  
					 if(PA_3DSpriteTouched(i) && !pa_3dsprites[i].Alive && !spriteIsLocked[i]) 
					 {
					   selectedMenu = i;
					   functionMode = 0;
					   break;
					 }   
				}		 
			}		 
		}		 
	
	
	
	
	
	
	}
	if (Pad.Newpress.B)
	{
	  		sprite[selectedMenu].data[getKeyframe(selectedMenu)].angle= 0;
		   sprite[selectedMenu].data[getKeyframe(selectedMenu)].width = pa_3dsprites[selectedMenu].ImgWidth;
		   sprite[selectedMenu].data[getKeyframe(selectedMenu)].height = pa_3dsprites[selectedMenu].ImgHeight;
			sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha = 31;
	}		
	
	
	
	if(Stylus.Held)
	{
		if(functionMode==2)
		{
		   sprite[selectedMenu].data[getKeyframe(selectedMenu)].width += (Stylus.X - pa_3dsprites[selectedMenu].X)-(functionOldX - pa_3dsprites[selectedMenu].X);
		   if (Pad.Held.L)
			   sprite[selectedMenu].data[getKeyframe(selectedMenu)].height = sprite[selectedMenu].data[getKeyframe(selectedMenu)].width*(.0+pa_3dsprites[selectedMenu].ImgWidth/pa_3dsprites[selectedMenu].ImgHeight);
		   else
			   sprite[selectedMenu].data[getKeyframe(selectedMenu)].height -= (Stylus.Y - pa_3dsprites[selectedMenu].Y)-(functionOldY - pa_3dsprites[selectedMenu].Y);
		   if (sprite[selectedMenu].data[getKeyframe(selectedMenu)].width < 5 || 1000 < sprite[selectedMenu].data[getKeyframe(selectedMenu)].width)
			   sprite[selectedMenu].data[getKeyframe(selectedMenu)].width= 5;
		   if (sprite[selectedMenu].data[getKeyframe(selectedMenu)].height < 5 || 1000 < sprite[selectedMenu].data[getKeyframe(selectedMenu)].height)
			   sprite[selectedMenu].data[getKeyframe(selectedMenu)].height= 5;

			clipKeyFrame_IfAtCornerMenu(height);
			clipKeyFrame_IfAtCornerMenu(width);
		   functionOldX = Stylus.X;
		   functionOldY = Stylus.Y;
		}   
		if(functionMode==1)
		{
			sprite[selectedMenu].data[getKeyframe(selectedMenu)].angle+=  PA_GetAngle((sprite[selectedMenu].var1.x>>8),(sprite[selectedMenu].var1.y>>8),Stylus.X,Stylus.Y)-PA_GetAngle((sprite[selectedMenu].var1.x>>8),(sprite[selectedMenu].var1.y>>8),functionOldX,functionOldY);
			clipKeyFrame_IfAtCornerMenu(angle);
		   functionOldX = Stylus.X;
		   functionOldY = Stylus.Y;
		}
		if(functionMode==3)
		{
		   PA_3DSetSpriteXY(selectedMenu,Stylus.X-functionOldX,Stylus.Y-functionOldY);
			sprite[selectedMenu].data[getKeyframe(selectedMenu)].x= pa_3dsprites[selectedMenu].X<<8;
			sprite[selectedMenu].data[getKeyframe(selectedMenu)].y= pa_3dsprites[selectedMenu].Y<<8;
			clipKeyFrame_IfAtCornerMenu(x);
			clipKeyFrame_IfAtCornerMenu(y);
		}   
		if (functionMode==4)
		{
	  		sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha=functionOldX+((pa_3dsprites[125].Y - Stylus.Y)>>1);
			if (functionOldX+((pa_3dsprites[125].Y - Stylus.Y)>>1)> 31) sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha = 31;
			if (functionOldX+((pa_3dsprites[125].Y - Stylus.Y)>>1)< 1) sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha = 1;
			clipKeyFrame_IfAtCornerMenu(alpha);
		   functionOldY = Stylus.Y;
		}   
	}
	
	//PA_OutputText(1, 0, k+6, "%d : %d : %d: %d : %d : %d:", sprite[selectedMenu].data[sprite[selectedMenu].var2.current_sprite].key_frame ,sprite[selectedMenu].data[sprite[selectedMenu].var2.current_sprite].angle ,sprite[selectedMenu].data[k].x>>8,sprite[selectedMenu].data[k].y>>8 ,sprite[selectedMenu].data[k].pivot_x ,sprite[selectedMenu].data[k].pivot_y);
	
//	if (Pad.Newpress.R) spriteIsLocked[selectedMenu] = !spriteIsLocked[selectedMenu];
	if (Pad.Newpress.Y) copyAll();
	if (Pad.Newpress.A) 
	{
	   pasteAll();

	}   
	
	//if (Pad.Held.Y)
	//{
	//	PA_3DSetSpriteXY(selectedMenu,Stylus.X-functionOldX,Stylus.Y-functionOldY);
	//
	//   if(sprite[selectedMenu].var2.time==sprite[selectedMenu].data[sprite[selectedMenu].var2.current_sprite].key_frame)
	//   {
	//		sprite[selectedMenu].data[sprite[selectedMenu].var2.current_sprite].x= pa_3dsprites[selectedMenu].X<<8;
	//		sprite[selectedMenu].data[sprite[selectedMenu].var2.current_sprite].y= pa_3dsprites[selectedMenu].Y<<8;
	//	}		
	//   if(sprite[selectedMenu].var2.time==sprite[selectedMenu].data[sprite[selectedMenu].var2.next_sprite].key_frame)
	//   {
	//		sprite[selectedMenu].data[sprite[selectedMenu].var2.next_sprite].x= pa_3dsprites[selectedMenu].X<<8;
	//		sprite[selectedMenu].data[sprite[selectedMenu].var2.next_sprite].y= pa_3dsprites[selectedMenu].Y<<8;
	//	}		
	//   
	//}   
		if (Pad.Newpress.Start) return;
		for (k = 0; k <= numberofsprites-1; k++)
		{
			update_transpeed(k,sprite[k].var2.current_sprite, sprite[k].var2.next_sprite);
			
			update_spritevars(k);
			update_spritelocation(k);
		}
	if (Pad.Newpress.R)
	{
   	if (shrinkMenu("Mainmenu","",0,10)) return;
	 }  	
	 if (Pad.Newpress.Select)
	 {

	   if (!Pad.Held.L)
	    {
			 if(selectedMenu < numberofsprites-1)
			  	{
			  	  ++selectedMenu;
				}
				else	    
				{
				   selectedMenu=0;
				}   
		}			
		else
	   {
			 if(selectedMenu==0)
			  	  selectedMenu=numberofsprites-1;
			else	    
			{
			 	--selectedMenu;
			}   
		}	
/*	   #ifdef emulate
	   #else
	   chdir("rcpitheme");
	   #endif
		sprintf(charTemp, "%s.bmp",spriteToFilename(selectedMenu));
		PA_Clear16bitBg(1);
	//	PA_LoadGifXY(1,10,10,FAT_loadGIF(charTemp));
	   #ifdef emulate
	   #else
		chdir("..");
		#endif*/
	 }   
	
	if (Pad.Newpress.X)
	{
	      if (Pad.Held.L)
	      {
			   sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio++;
			   if (sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio > 3) sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio =0;	   
			}   
			else
			{
			   if (sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio ==0)
				   sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio=3;
			   else
					sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio--;
			}   
			PA_3DSetSpritePrio(selectedMenu,  sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio+1024);		
			clipKeyFrame_IfAtCornerMenu(prio);
	
	}
	
}
	
	if (Pad.Held.L && !screenswitched)
	{
	   if(Pad.Held.Left) sprite[selectedMenu].data[getKeyframe(selectedMenu)].x-= 100;
		if(Pad.Held.Right) sprite[selectedMenu].data[getKeyframe(selectedMenu)].x+= 100;
		if(Pad.Held.Up) sprite[selectedMenu].data[getKeyframe(selectedMenu)].y-= 100;
		if(Pad.Held.Down) sprite[selectedMenu].data[getKeyframe(selectedMenu)].y+= 100;
		clipKeyFrame_IfAtCornerMenu(x);
		clipKeyFrame_IfAtCornerMenu(y);
	}
	if ((!Pad.Held.L && !screenswitched) || (Pad.Held.L && screenswitched))
		{
				if (getInputReverseDown())  
				{
					if (menu_select[1] < 2 && menu_select[0]==0)
					{
						for (k = 0; k < 10 ; k++)
						sprite[k].var2.time= 0;
					   if ((sprite[10].var2.play_mode2!=1) || Pad.Newpress.Down)
					   {
						 	for (k = 10; k <= 15 ; k++)
							{
							   if (sprite[k].var2.play_mode2==1 || sprite[k].var2.time > 60)
								  	sprite[k].var2.time = (menu_select[1])*30 ;
								sprite[k].var2.next_sprite = menu_select[1]+1;
								sprite[k].var2.current_sprite =menu_select[1];
	
								if (sprite[k].var2.time < sprite[k].data[sprite[k].var2.last_sprite].key_frame)
								{
									sprite[k].var2.play_mode2=1;
									move_time(k, 1,1);
								}		
						
							}		
						menu_select[1]++;
						}			
					}		
					
					//Game
					// icons: k=22 ; k<=27
					
					if (menu_select[5] < 2 && menu_select[0]==4)
				   {
						if ((sprite[22].var2.play_mode2!=1) || Pad.Newpress.Down)
					   {
						 	for (k = 22; k <= 27 ; k++)
							{
							   if (sprite[k].var2.play_mode2==1 || sprite[k].var2.time > 60)
								  	sprite[k].var2.time = (menu_select[5])*30 ;
								sprite[k].var2.next_sprite = menu_select[5]+1;
								sprite[k].var2.current_sprite =menu_select[5];
								if (sprite[k].var2.time < sprite[k].data[sprite[k].var2.last_sprite].key_frame)
								{
									sprite[k].var2.play_mode2=1;
									move_time(k, 1,1);
								}		
						
							}		
							menu_select[5]++;
						}		
					}
				}		
				
				if (getInputReverseUp()) 
				{
	 				if (menu_select[1] > 0 && menu_select[0]==0)
					{		
					   if ((sprite[10].var2.play_mode2!=2) || Pad.Newpress.Up)
					   {
						  menu_select[1]--;
							for (k = 0; k < 10 ; k++)
							sprite[k].var2.time= 0;
						  	for (k = 10; k <= 15 ; k++)
							{
	//						   if (sprite[k].var2.time >= 61)
							   if (sprite[k].var2.play_mode2==2 || sprite[k].var2.time > 60)
								  	sprite[k].var2.time = ((menu_select[1]+1)*30);//-1 ;
								sprite[k].var2.next_sprite = menu_select[1]+1;
								sprite[k].var2.current_sprite =menu_select[1];
							   if (sprite[k].var2.time > 0)
								{   
									sprite[k].var2.play_mode2=2;
									move_time(k, 2,1);		
								}		
							}
							
						}   
			
					
					}	
					if (menu_select[5] > 0 && menu_select[0]==4)
				   {
						if ((sprite[22].var2.play_mode2!=2)  || Pad.Newpress.Up)
					   {
						menu_select[5]--;
						 	for (k = 22; k <= 27 ; k++)
								{
	//							   if (sprite[k].var2.time >= 61)
	//							  	{
							   if (sprite[k].var2.play_mode2==2 || sprite[k].var2.time > 60)
									  	sprite[k].var2.time = ((menu_select[5]+1)*30);//-1 ;
										sprite[k].var2.next_sprite = menu_select[5]+1;
										sprite[k].var2.current_sprite =menu_select[5];
	//								}			
									if (sprite[k].var2.time < sprite[k].data[sprite[k].var2.last_sprite].key_frame)
									{
									sprite[k].var2.play_mode2=2;
									move_time(k, 2,1);
									}		
							
								}		
				
	
						}		
					}

				}		
			
				if (getInputLeft())
				{
					if(menu_select[0]>0)
					{
						if (sprite[0].var2.play_mode2!=2  || Pad.Newpress.Left )
						{
			//			   if (sprite[1].var2.play_mode2==0 || sprite[1].var2.play_mode2==1)
									for (k = 0; k < 10 ; k++)
										{
											if(sprite[k].var2.time > 0)
											{
				//								if (sprite[sprite_id].var2.time >= sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame && mode == 1) 
												if (!(sprite[k].var2.play_mode2==0 || sprite[k].var2.play_mode2==1))
													jumpTime(k,2);
												sprite[k].var2.play_mode2=2;
												move_time(k, 2,1);
											}			
				
										}		
				
							   {
				
									
							   if (menu_select[0]==1)
							   {
	
									for (k = 10; k <= 15 ; k++)
									{
	
	
										sprite[k].var2.time = 60+(menu_select[1]*30)+(sprite[k].var2.time%30 ==0?30:sprite[k].var2.time%30);
										sprite[k].var2.play_mode2=2;
										sprite[k].var2.next_sprite = 4+(menu_select[1]*2);
										sprite[k].var2.current_sprite =3+(menu_select[1]*2);
									}		
				
									for (k = 16; k <= 17 ; k++)
										setSpriteAnim(k,30,2,1,0);
									for (k = 18; k <= 19 ; k++)
									   if (sprite[k].var2.play_mode2==2) sprite[k].var2.time =0;	
								}			
							   if (menu_select[0]==2)
							   {
									for (k = 16; k <= 17 ; k++)
										setSpriteAnim(k,60,2,2,1);	
									for (k = 18; k <= 19 ; k++)
										setSpriteAnim(k,30,2,1,0);
									for (k = 20; k <= 21 ; k++)
									   if (sprite[k].var2.play_mode2==2) sprite[k].var2.time =0;	
								}			
							   if (menu_select[0]==3)
							   {
									for (k = 18; k <= 19 ; k++)
										setSpriteAnim(k,60,2,2,1);
									for (k = 20; k <= 21 ; k++)
										setSpriteAnim(k,30,2,1,0);		
									for (k = 22; k <= 27 ; k++)
									{
										sprite[k].var2.time = 180+(menu_select[5]*30);
									}			
								}			
							   if (menu_select[0]==4)
							   {
						
									for (k = 20; k <= 21 ; k++)
										setSpriteAnim(k,60,2,2,1);
									for (k = 22; k <= 27 ; k++)
									{
										sprite[k].var2.time = 150+(menu_select[5]*30)+(sprite[k].var2.time <60?0:sprite[k].var2.time%30);
	//									sprite[k].var2.time = 150+(menu_select[5]*30)+(sprite[k].var2.time%30 ==0?30:sprite[k].var2.time%30);
	//									sprite[k].var2.time = (150+(menu_select[5]*30))-(sprite[k].var2.time < 60?30:(30-(sprite[k].var2.time%30)));	
	//									sprite[k].var2.time = 151+(menu_select[5]*30);
										sprite[k].var2.play_mode2=1;
										sprite[k].var2.next_sprite = 10+(menu_select[5]*2);
										sprite[k].var2.current_sprite =9+(menu_select[5]*2);
									}	
								}			
								menu_select[0]--;

							}   
						}	
					}			
		
				}		

				if (getInputRight()) 
				{
					if(menu_select[0]<4)
					{
						if (sprite[0].var2.play_mode2!=1  || Pad.Newpress.Right)
						{
							for (k = 0; k < 10 ; k++)
							{
								if(sprite[k].var2.time < sprite[k].data[sprite[k].var2.last_sprite].key_frame)
								{
	//								if (sprite[sprite_id].var2.time >= sprite[sprite_id].data[sprite[sprite_id].var2.next_sprite].key_frame && mode == 1) 
									if (!(sprite[k].var2.play_mode2==0 || sprite[k].var2.play_mode2==2))
									jumpTime(k,1);
									sprite[k].var2.play_mode2=1;
									move_time(k, 1,1);
								}			
	
							}		

						   if (menu_select[0]==0)
						   {
	
								for (k = 10; k <= 15 ; k++)
								{
									sprite[k].var2.time = (91+(menu_select[1]*30))-(sprite[k].var2.time < 60?30:(30-(sprite[k].var2.time%30)));	
									sprite[k].var2.play_mode2=1;
									sprite[k].var2.next_sprite = 4+(menu_select[1]*2);
									sprite[k].var2.current_sprite = 3+(menu_select[1]*2);
								}		
								for (k = 16; k <= 17 ; k++)
									setSpriteAnim(k,0,1,1,0);
	
					
							}			
							   if (menu_select[0]==1)
						   {

								for (k = 10; k <= 15 ; k++)
								{
										sprite[k].var2.time = (90+(menu_select[1]*30));	
								}	
								for (k = 16; k <= 17 ; k++)
									setSpriteAnim(k,30,1,2,1);
					
								for (k = 18; k <= 19 ; k++)
									setSpriteAnim(k,0,1,1,0);
					
							}			
						   if (menu_select[0]==2)
						   {
	
								for (k = 16; k <= 17 ; k++)
							   if (sprite[k].var2.play_mode2==1)
									sprite[k].var2.time =60;
								for (k = 18; k <= 19 ; k++)
									setSpriteAnim(k,30,1,2,1);
					
								for (k = 20; k <= 21 ; k++)
									setSpriteAnim(k,0,1,1,0);
					
							}			
					
						   if (menu_select[0]==3)
						   {
								for (k = 18; k <= 19 ; k++)
							   if (sprite[k].var2.play_mode2==1)
									sprite[k].var2.time =60;				
								for (k = 20; k <= 21 ; k++)
									setSpriteAnim(k,30,1,2,1);
								for (k = 22; k <= 27 ; k++)
								{
//									sprite[k].var2.time = 151+30+(menu_select[5]*30);
//									sprite[k].var2.time = 150+(menu_select[5]*30)+(sprite[k].var2.time%30==0?30:((sprite[k].var2.time%30)));	
									sprite[k].var2.time = 150+(menu_select[5]*30)+(sprite[k].var2.time%30==0?30:((sprite[k].var2.time%30)));	
//									sprite[k].var2.time = 60+(menu_select[1]*30)+(sprite[k].var2.time%30 ==0?30:sprite[k].var2.time%30);

									sprite[k].var2.play_mode2=2;
									sprite[k].var2.next_sprite = 10+(menu_select[5]*2);
									sprite[k].var2.current_sprite =9+(menu_select[5]*2);
								}		
							}
							menu_select[0]++;


						}
					}   
				}			
		}	


	   
/// UPDATES SPRITES
// sprite[sprite_id].var1.alpha
//PA_3DSetSpriteAlpha(10,31)f;      

	for (k = 0; k <= numberofsprites-1 ; k++)
	{
		if (spriteIsHidden) 
			PA_3DSetSpriteVisible(k,0);
		else
			PA_3DSetSpriteVisible(k,1);
		update_transpeed(k,sprite[k].var2.current_sprite, sprite[k].var2.next_sprite);
		
		update_spritevars(k);
		update_spritelocation(k);

		//update individual timers
		switch (sprite[k].var2.play_mode2)
		{
		   case 1:	if (sprite[k].var2.time < sprite[k].data[sprite[k].var2.next_sprite].key_frame )
					   {
						   if (navigationspeed==1)
						   	sprite[k].var2.time+= navigationspeed;
							   else
							   {
							      if (abs(sprite[k].data[sprite[k].var2.next_sprite].key_frame - sprite[k].var2.time) < 5)
								   	sprite[k].var2.time+= navigationspeed*.5;
									else
								   	sprite[k].var2.time+= navigationspeed;
			
								}   
							idleCounter=0;					
						}			
							if(sprite[k].var2.time >= sprite[k].data[sprite[k].var2.next_sprite].key_frame) 
							{
							   sprite[k].var2.time = sprite[k].data[sprite[k].var2.next_sprite].key_frame;
							   sprite[k].var2.play_mode2=0;

							}   

						break;
		   case 2: 	if(sprite[k].var2.time > sprite[k].data[sprite[k].var2.next_sprite-1].key_frame)
		   			{
						   if (navigationspeed==1)
						   	sprite[k].var2.time-= navigationspeed;
						   else
						   {
						      if (abs(sprite[k].data[sprite[k].var2.next_sprite].key_frame - sprite[k].var2.time) < 25)
							   	sprite[k].var2.time-= navigationspeed;
								else
							   	sprite[k].var2.time-= navigationspeed*.5;
							}   			   
							idleCounter=0;					
						}			
						   if(sprite[k].var2.time <= sprite[k].data[sprite[k].var2.next_sprite-1].key_frame) 
							{
							   sprite[k].var2.time = sprite[k].data[sprite[k].var2.next_sprite-1].key_frame;
							   sprite[k].var2.play_mode2=0;

							}   
						break;
		}			
		PA_3DSetSpritePolyID(k,k);
		PA_3DSetSpritePrio(k,1500+(k*10));
	}	

		updateAmbience();  //Update Ambience / Animated Background
		ZoomXY_3DProcess(canvasZoom,0,0);    //Update sprites
//		if (Pad.Newpress.
		Soul_waitForVBL();
		updateIdleCounter();

}	


	
//	return;
} // End of main()






