#include <PA9.h>
#include "..\..\..\engine\engine.h"
#include "../../shrink.h"

#include <nds.h>
#include <stdlib.h>
#include <stdio.h>

#include <fat.h>

#include "../../../screenshot.h"
#include "../../../bmp.h"


extern u8 PA_Screen;

void updateInkSpriteIcon()
{
	initDraw(1,0,0,256,192);
	putCircleAlpha_16bit(1,11,20,7,PA_RGB(31,31,31),1);
	if (getDrawThickness() == -1)
	{
		drawLetterP(1,11-3,20-4,getDrawColor(),1);
	}
	else
		putCircleAlpha_16bit(1,11,20,getDrawThickness()*2,getDrawColor(),1);

	initDraw(1,26,10,26+204,10+154);
}   
   
void setCanvasDrawColor(int color)
{
   setDrawColor(color);
   updateInkSpriteIcon();
}   
void checkStylus_ColorPanel()
{
	if (PA_StylusInZone(238 , 11 , 238+38 , 11+18)) setCanvasDrawColor(PA_RGB(0 , 0 , 0));
	else
	if (PA_StylusInZone(238 , 25, 238+38 , 25+18)) setCanvasDrawColor(PA_RGB(31 , 31 , 31));
	else
	if (PA_StylusInZone(238 , 39 , 238+38 , 39+18)) setCanvasDrawColor(PA_RGB(31 , 0 , 0));
	else
	if (PA_StylusInZone(238 , 53 , 238+38 , 53+18)) setCanvasDrawColor(PA_RGB(0 , 31 , 0));
	else
	if (PA_StylusInZone(238 , 67 , 238+38 , 67+18)) setCanvasDrawColor(PA_RGB(0 , 0 , 31));
	else
	if (PA_StylusInZone(238 , 79 , 238+38 , 79+18)) setCanvasDrawColor(PA_RGB(31 , 31 , 0));
	else
	if (PA_StylusInZone(238 , 91 , 238+38 , 91+18)) setCanvasDrawColor(PA_RGB(0 , 31 , 31));
	else
	if (PA_StylusInZone(238 , 105 , 238+38 , 105+18)) setCanvasDrawColor(PA_RGB(31 , 0 , 31));
	else
	if (PA_StylusInZone(238 , 119 , 238+38 , 119+18)) setCanvasDrawColor(PA_RGB(31 , 14 , 14));
	else
	if (PA_StylusInZone(238 , 131 , 238+38 , 131+18)) setCanvasDrawColor(PA_RGB(31 , 26 , 24));
	else
	if (PA_StylusInZone(238 , 145 , 238+38 , 145+18)) setCanvasDrawColor(PA_RGB(31 , 25 , 31));
}
void toggleThickness()
{
   if (getDrawThickness()==-1) 
	{   
	   setDrawThickness(1);
	}   
   else
   {
      setDrawThickness(getDrawThickness()+.5);
	   if (getDrawThickness()>=4) 
	   {
		   setDrawThickness(-1);
		}   
   }  
	updateInkSpriteIcon(); 
}   
void toggleAlpha()
{
   if (getDrawAlpha()==-1) 
	{   
	   setDrawAlpha(.05);
	}   
   else
   {
      setDrawAlpha(getDrawAlpha()+.05);
	   if (getDrawAlpha()>1) 
	   {
		   setDrawAlpha(-1);
		}   
   }  
	updateInkSpriteIcon(); 
}   
void updateAlphaPanelText()
{

	spaceLetteringForAAText();
	PA_TextAlign(ALIGN_CENTER);
	
	char text[10];
	if (getDrawAlpha()==-1)
		sprintf (text,"P");
	else
	if (getDrawAlpha()==1)
		sprintf (text,"1.0");
	else
	{
		sprintf (text,"%f2",getDrawAlpha());
		text[0]=text[1];
		text[1]=text[2];
		text[2]=text[3];
		text[3]=0;
	}		
	PA_16cErase(1);
	display16cText(1,2,38,22,38,text,ANTIALIASED_COLOR,ANTIALIASED_FONT);

	spaceLetteringForDefault();
}   
#define SHRINKEDCANVAS_WIDTH 204
#define SHRINKEDCANVAS_HEIGHT 155
extern int bookpage;
void saveShrinkedDoodle(int loadedImage)
{

   char path[50];
   if (loadedImage)
	sprintf(path,"fat:/_menudo/notes/note%02d.bmp",bookpage-1);
   else
   sprintf(path,"fat:/_menudo/notes/note%02d.bmp",getLastBookPage()-1);
	FILE* file=fopen(path, "wb");

	u8* temp=(u8*)malloc(SHRINKEDCANVAS_WIDTH*SHRINKEDCANVAS_HEIGHT*3+sizeof(INFOHEADER)+sizeof(HEADER));

	HEADER* header=(HEADER*)temp;
	INFOHEADER* infoheader=(INFOHEADER*)(temp+sizeof(HEADER));

	write16(&header->type, 0x4D42);
	write32(&header->size, SHRINKEDCANVAS_WIDTH*SHRINKEDCANVAS_HEIGHT*3+sizeof(INFOHEADER)+sizeof(HEADER));
	write32(&header->offset, sizeof(INFOHEADER)+sizeof(HEADER));
	write16(&header->reserved1, 0);
	write16(&header->reserved2, 0);

	write16(&infoheader->bits, 24);
	write32(&infoheader->size, sizeof(INFOHEADER));
	write32(&infoheader->compression, 0);
	write32(&infoheader->width, SHRINKEDCANVAS_WIDTH);
	write32(&infoheader->height, SHRINKEDCANVAS_HEIGHT);
	write16(&infoheader->planes, 1);
	write32(&infoheader->imagesize, SHRINKEDCANVAS_WIDTH*SHRINKEDCANVAS_HEIGHT*3);
	write32(&infoheader->xresolution, 0);
	write32(&infoheader->yresolution, 0);
	write32(&infoheader->importantcolours, 0);
	write32(&infoheader->ncolours, 0);
	int y=0;
	int x=0;
	for(y=0;y<SHRINKEDCANVAS_HEIGHT;y++)
	{
		for(x=0;x<SHRINKEDCANVAS_WIDTH;x++)
		{
			u16 color=PA_Get16bitPixel(1,26+x,((9+SHRINKEDCANVAS_HEIGHT)-y));

			u8 b=(color&31)<<3;
			u8 g=((color>>5)&31)<<3;
			u8 r=((color>>10)&31)<<3;

			temp[((y*SHRINKEDCANVAS_WIDTH)+x)*3+sizeof(INFOHEADER)+sizeof(HEADER)]=r;
			temp[((y*SHRINKEDCANVAS_WIDTH)+x)*3+1+sizeof(INFOHEADER)+sizeof(HEADER)]=g;
			temp[((y*SHRINKEDCANVAS_WIDTH)+x)*3+2+sizeof(INFOHEADER)+sizeof(HEADER)]=b;
		}
	}

//	DC_FlushAll();
	fwrite(temp, 1, SHRINKEDCANVAS_WIDTH*SHRINKEDCANVAS_HEIGHT*3+sizeof(INFOHEADER)+sizeof(HEADER), file);
	fclose(file);
	free(temp);
   

}   


void doodleWhiteboard()
{
   if (!PA_Screen) PA_SwitchScreens();
   PA_16cErase(1);
	char* jpgpath = returnThemeResourcePath("apps/doodle/shrinkedInterface.jpg", 1);
	if (jpgpath!=NULL)
	{
		loadJPEGWithPath(1,jpgpath);
		free(jpgpath);
	}		
	initDraw(1,26,10,24+SHRINKEDCANVAS_WIDTH,10+SHRINKEDCANVAS_HEIGHT);
	
	char path[40];
	bool loadedImage=0;
	sprintf(path,"fat:/_menudo/notes/note%02d.bmp",bookpage-1);
	FILE* whiteboardFile = fopen (path, "rb");
	if (whiteboardFile)
	{
	   loadedImage=1;
		loadShrinkedFatBgBmp(1,whiteboardFile);
	}			
	fclose(whiteboardFile);	


	setDrawThickness(1);
	setDrawAlpha(1);
	updateInkSpriteIcon(); 
   while(1) {
      if (Stylus.Newpress)
      {

         
	      if (PA_StylusInZone(168,177,197,191)) 
	      {
				saveShrinkedDoodle(loadedImage);
				break;
	      }   
	      if (PA_StylusInZone(2 , 21 , 2+20 , 21+20))  toggleThickness();
	      if (PA_StylusInZone(2,48,2+20,48+20)) toggleAlpha();
	      if (PA_StylusInZone(197,177,225,191)) 
			{
//			   PA_LoadBmp(1,(void*)whiteBoardText);
				jpgpath = returnThemeResourcePath("apps/doodle/shrinkedInterface.jpg", 1);
				if (jpgpath!=NULL)
				{
					loadJPEGWithPath(1,jpgpath);
					free(jpgpath);
				}		
				updateInkSpriteIcon(); 
			}   
	      if (PA_StylusInZone(225,177,256,191)) break;
			checkStylus_ColorPanel();
		}			
		updateAlphaPanelText();

//		setCanvasDrawColor(PA_RGB(r,g,b));
		updateDraw();
		updateAmbience();  //Update Ambience / Animated Background
		ZoomXY_3DProcess(112,(shrinkX+3)*-1,(shrinkY)*-1);
      Soul_waitForVBL();
   }   
   PA_SwitchScreens();
//   PA_LoadBmp(1,(void*)whiteBoardText);
}   



