#include <PA9.h>
#include <fat.h>
#include <sys/dir.h>

#include "shrink.h"

extern char CurrentTheme[256];
extern bool customClockThemeLoaded;
void updateThemePreview(int scrollAnimation)
{
/*	if (scrollAnimation>-256)
		PA_SetBgRot(1, 3,128, 96+10,  ((256+(int)(scrollAnimation*1.5))%768)-128, 96, 0, 256);
	else
		PA_SetBgRot(1, 3,128, 96+10,  ((256+(int)(scrollAnimation*1.5))+768)-128, 96, 0, 256);*/
	PA_SetBgRot(1, 3,128, 96, 128, 96, 0, 256);
	updateAmbience();  //Update Ambience / Animated Background
	ZoomXY_3DProcess(112,(shrinkX+3)*-1,(shrinkY)*-1);
}   
int getThemeAmount()
{
	struct stat st;
	char filename[256]; 
	DIR_ITER* dir = diropen("fat:/_menudo/themes/");
	int folderCounter=0;
	while (dirnext(dir, filename, &st) == 0) 
	{
	   if (strcmp(filename,"..") == 0 || strcmp(filename,".") == 0 || stricmp(filename,"_mycreations") == 0) continue;
	   if (st.st_mode & S_IFDIR) folderCounter++;
	}   
	return folderCounter;
}   
char* getThemeName(int selectedTheme)
{
	struct stat st;
	char * filename = malloc(256); 
	DIR_ITER* dir = diropen("fat:/_menudo/themes/");
	int folderCounter=0;
	while (dirnext(dir, filename, &st) == 0) 
	{
	   if (strcmp(filename,"..") == 0 || strcmp(filename,".") == 0 || stricmp(filename,"_mycreations") == 0) continue;
	   if (st.st_mode & S_IFDIR) 
	   {
	      if (selectedTheme==folderCounter) break;
	      folderCounter++;
		}
	}   
	return filename;
}   
void updateImagePreview(int selectedTheme)
{
	struct stat st;
	char filename[256]; 
	DIR_ITER* dir = diropen("fat:/_menudo/themes/");
	int folderCounter=0;

	while (dirnext(dir, filename, &st) == 0) 
	{
	   if (strcmp(filename,"..") == 0 || strcmp(filename,".") == 0 || stricmp(filename,"_mycreations") == 0) continue;
	   if (st.st_mode & S_IFDIR) 
	   {
	      if (selectedTheme==folderCounter) break;
	      folderCounter++;
		}
	}
	clear16cZone(1,3,178,201,189);
	PA_TextAlign(ALIGN_CENTER);
	display16cText(1,2,176,201,189,filename,1,5);	
	int x;
	int y;
 	for (x=3;x<=201;x++)
	 	for (y=178;y<=189;y++)
	if (PA_16cGetPixel(1,x,y) ==0) PA_16cPutPixel(1,x,y,11);
	PA_TextAlign(ALIGN_CENTER);
//	PA_Clear16bitBg(1);
	char path[512];
	sprintf(path,"fat:/_menudo/themes/%s/thumbnail_nds.jpg",filename);
	FILE* preview = fopen (path, "rb");
	if(!preview)
	{
		fclose(preview);	   
		sprintf(path,"fat:/_menudo/themes/%s/thumbnail_nds.jpeg",filename);
	}   
	loadFatBg16bit(1,path);
	


}   
extern const unsigned short blackarialAA12_Pal[8] __attribute__ ((aligned (4)));
unsigned short pal_16c[16] __attribute__ ((aligned (4)));
bool manageThemes()
{
   int themeAmount=getThemeAmount();
//	PA_SetBgColor(1,PA_RGB(21,23,28));
	int selectedTheme = 0;

	PA_16cErase(1);
	PA_Init16bitBg(1, 3);

   load16cBMPWithResource(1,0,0,"shrink/ThemeSelect.16c.bmp");
	PA_SwitchScreens();
//	initAntiAliasedText(1,1,1);
	int i;
	for (i=0;i<8;i++) pal_16c[i] = blackarialAA12_Pal[i];
	
	PA_EnableSpecialFx(1, SFX_NONE,0,0);
//	PA_SetBgPrio(1,3,0);
	PA_LoadPal16c(PAL_BG1, (void*)pal_16c);
	clear16cZone(1,0,0,256,173);
	clear16cZone(1,205,177,253,176+13);

	PA_TextAlign(ALIGN_CENTER);
 	display16cText(1,204,175,254,0,"Cancel",1,5);
	int x;
	int y;
 	for (x=205;x<=253;x++)
	 	for (y=177;y<=176+13;y++)
	if (PA_16cGetPixel(1,x,y) ==0) PA_16cPutPixel(1,x,y,11);

	updateImagePreview(selectedTheme);
	// Infinite loop to keep the program running
	int scrollAnimation = 0;
	int accelerationX = 0;
	PA_SetBgColor(1,PA_RGB(21, 23, 28));	
PA_InitRand();
	while (1)
	{
	   if (Pad.Newpress.Y)
	   {
	      selectedTheme=PA_RandMax(themeAmount);
	      updateImagePreview(selectedTheme);
	   }   
	   if (Pad.Newpress.A)
	   {
	      break;
	   }   
	   if ((Stylus.Newpress && 	PA_StylusInZone(205,177,253,176+13)) || Pad.Newpress.B  || Pad.Newpress.L)
		{
			PA_SetBgRot(1, 3,128, 96, 128, 96, 0, 256);
			PA_SetBgPrio(1,3,3);
		   return 0;
		}   

		if (Pad.Newpress.Right)
		{
		   selectedTheme++;
         if (selectedTheme>=themeAmount) selectedTheme = selectedTheme-themeAmount;
         updateImagePreview(selectedTheme);
      } 		

		if (Pad.Newpress.Left)
		{
		   selectedTheme--;
         if (selectedTheme<0) selectedTheme = themeAmount+selectedTheme;
         updateImagePreview(selectedTheme);
      } 		         
/*			if (Pad.Newpress.Right)
			{
			   if (scrollAnimation>0 && scrollAnimation<256) updateImagePreview(selectedTheme);
//			   scrollAnimation=1;
			   scrollAnimation=510;
			   selectedTheme++;
			}   
			if (Pad.Newpress.Left) 
			{
			   if (scrollAnimation<0 && scrollAnimation>-256) updateImagePreview(selectedTheme);
//			   scrollAnimation=-1;
			   scrollAnimation=-510;
			   selectedTheme--;
			}   
	*/
			if (scrollAnimation>0)
			{
			   if (accelerationX!=0)
			   {
		         if (scrollAnimation<256 && scrollAnimation+accelerationX>=256) updateImagePreview(selectedTheme);		         
			      scrollAnimation+=accelerationX/4;
			      if (accelerationX/4>5) 
						accelerationX--;
					else
						accelerationX=5*4;
			   }   
			   else
			   {
		         if (scrollAnimation<256 && scrollAnimation+20>=256) updateImagePreview(selectedTheme);	
					if (scrollAnimation<402)
						scrollAnimation+=10;
					if (scrollAnimation<452)
						scrollAnimation+=7;
					if (scrollAnimation<512)
						scrollAnimation+=3;
				}			
				if (scrollAnimation>=512) 
				{
				   
		   	   if (accelerationX/4<=5) 
					{
					   accelerationX=0;
					   scrollAnimation=0;	
					}
					else
					{
					   scrollAnimation=1;
					   selectedTheme++;
					}			   
				}   
			}			
			if (scrollAnimation<0)
			{
			   if (accelerationX!=0)
			   {
		         if (scrollAnimation>-256 && scrollAnimation+accelerationX<=-256) updateImagePreview(selectedTheme);
			      scrollAnimation+=accelerationX/4;
			      if (accelerationX/4<-5) 
						accelerationX++;
					else
						accelerationX=-5*4;
			   }   
			   else
			   {
		         if (scrollAnimation>-256 && scrollAnimation-20<=-256) updateImagePreview(selectedTheme);
					if (scrollAnimation>-402)
						scrollAnimation-=10;
					if (scrollAnimation>-452)
						scrollAnimation-=7;
					if (scrollAnimation>-512)
						scrollAnimation-=3;
				}			
				if (scrollAnimation<=-512) 
				{
			      if (accelerationX/4>=-5) 
			      {
					   scrollAnimation=0;	
					   accelerationX=0;
					}
					else
					{
					   scrollAnimation=-1;
					   selectedTheme--;
					}			   
				}   
			}			

         if (selectedTheme<0) selectedTheme = themeAmount+selectedTheme;
         if (selectedTheme>=themeAmount) selectedTheme = selectedTheme-themeAmount;


		updateThemePreview(scrollAnimation);
		Soul_waitForVBL();
		//flushToMemory();
	}
	PA_SetBgRot(1, 3,128, 96, 128, 96, 0, 256);
	PA_SetBgPrio(1,3,3);
	
	char* changeTheme = getThemeName(selectedTheme);
	if (strcmp(changeTheme,CurrentTheme)!=0)
	{
	   sprintf(CurrentTheme,"%s",changeTheme);
		FILE* themeFile = fopen ("fat:/_menudo/logs/HISTORY.LASTTHEME", "wb");
		fwrite(changeTheme,strlen(changeTheme),1,themeFile);
		fclose(themeFile);
		free(changeTheme);
		customClockThemeLoaded=0;
		return 1;
	}		
	free(changeTheme);
	return 0;
}   
