#include <PA9.h>       // Include for PA_Lib
#include <fat.h>
#include "md5.h"
#include <ctype.h>

//#define BLOCKLIST_PATH "bannedmd5.txt"
#define BLOCKLIST_PATH "fat:/_menudo/md5_blocklist.txt"
#define BYTELIMIT 1048576
char* checkFileMD5(char* filepath)
{

	int j;
	unsigned char buffer[256], signature[16];
	struct MD5Context md5c;

	FILE* in = fopen(filepath,"rb");
	fseek (in, 0, SEEK_END);
	if (ftell(in)>BYTELIMIT)
	{
	   fclose(in);
	   return NULL;
	}   

	//PA_Print(1,"%d",ftell(in));
	rewind(in);
   MD5Init(&md5c);
	while ((j = (int) fread(buffer, 1, 256, in)) > 0)
		MD5Update(&md5c, buffer, (unsigned) j);
	MD5Final(signature, &md5c);
	fclose(in);
	char*output=malloc(33);
	memset(output,0,33);
	for (j = 0; j < sizeof(signature); j++) 
	sprintf(output,"%s%02x",output,signature[j]);
	return output;
	//PA_Print(1,output);
	
}	
char* checkIfBanned(char * path)
{
   char* fileMD5 = checkFileMD5(path);
   if (fileMD5==NULL)
   {
      return NULL;
   }   
//   PA_Print(1,"%s\n\n%d",fileMD5,strlen(fileMD5));
   FILE* bannedlist=fopen(BLOCKLIST_PATH,"rb");
//   char str[256];
   int i=0;
   int x=0;
//   int len=0;
   bool banned=0;
   char * output=malloc(256);
   memset (output,0,256);
   while(fgets (output , 256 , bannedlist))
   {
      
//      PA_Print(0,"%s\n",str);	
      for (i=0;i<32;i++)
      {
         if (tolower(output[i])!=fileMD5[i]) break;
      }   
      if (i==32)
      {
         banned = 1;
         break;
      }   
   }   

   fclose(bannedlist);
   free(fileMD5);
   if (!banned)
   {
	   free(output);
	   return NULL;
	}   
   else
   {
	   return output;
	}   
}	


