#include <PA9.h>
#include "../engine/engine.h"

#include "../misc/misc.h"
#include "../misc/clock.h"
#include "../misc/transition.h"
#include "../structDef.h"
#include "services/wificenter.h"
#include "services/fileDetector.h"
#include "services/mwifi.h"


#include "internalapps/doodle/shrinked_canvas.h"
#include "whiteBoard.h"
#include "manageTheme.h"
struct clockInfo
{
	textBox Text;
	spriteNoRotSet Battery;
} Clock;

typedef struct
{
    FILE* Menu[9];
} Topscreendata;
 
Topscreendata TOPscreen;


extern const unsigned short blackarialAA12_Pal[8] __attribute__ ((aligned (4)));
extern unsigned short pal_16c[16] __attribute__ ((aligned (4)));
extern char CurrentTheme[256];
int shrinkX=10;
int shrinkY=-10;
bool backgroundShrinked=0;
extern bool whiteBoard_isImage;
extern int bookpage;
//extern u32 timer_counter;
void updateShrinkClock(bool forceUpdate)
{
   if (!whiteBoard_isImage)
   {
		if (PA_RTC.Frames==0|| forceUpdate)
		{
		   spaceLetteringForDefault();
			if (!forceUpdate) clear16cZone(1, 15,160,15+225,177+36); 
		   PA_16cTextAlign(ALIGN_CENTER);
		   char temp[100];
		   char* monthFormat = formatTimer("$2 $0");
		   switch(PA_RTC.Month-1)
		   {
		      case 0:	sprintf(temp,"%s %s", "January", monthFormat);
		      			break;
		      case 1:	sprintf(temp,"%s %s", "February", monthFormat);
		      			break;
		      case 2:	sprintf(temp,"%s %s", "March", monthFormat);
		      			break;
		      case 3:	sprintf(temp,"%s %s", "April", monthFormat);
		      			break;
		      case 4:	sprintf(temp,"%s %s", "May", monthFormat);
		      			break;
		      case 5:	sprintf(temp,"%s %s", "June", monthFormat);
		      			break;
		      case 6:	sprintf(temp,"%s %s", "July", monthFormat);
		      			break;
		      case 7:	sprintf(temp,"%s %s", "August", monthFormat);
		      			break;
		      case 8:	sprintf(temp,"%s %s", "September", monthFormat);
		      			break;
		      case 9:	sprintf(temp,"%s %s", "October", monthFormat);
		      			break;
		      case 10:	sprintf(temp,"%s %s", "November", monthFormat);
		      			break;
		      case 11: sprintf(temp,"%s %s", "December", monthFormat);
		      			break;
		   }   
			display16cText (1, 15,165,15+225,177+36, temp, ANTIALIASED_COLOR, ANTIALIASED_FONT);

			free(monthFormat);
	
		   char* timerFormat = formatTimer("$3:$4 $6");
	//		PA_16cText (1, 15,175,15+225,177+36, timerFormat, ANTIALIASED_COLOR, ANTIALIASED_FONT,100);
			display16cText(1, 15,175,15+225,177+36, timerFormat, ANTIALIASED_COLOR, ANTIALIASED_FONT);
			free(timerFormat);
		   PA_16cTextAlign(0);
		   spaceLetteringForDefault();
		}   	
	}		
}   

void changeShrinkPage(int shrinkPage)
{
   PA_16cErase(0);
	switch(shrinkPage)
	{
	   case 0: 	load16cBMPWithResource(0,0,0,"shrink/MainScreen1.16c.bmp");
	   			break;
	   case 1: 	load16cBMPWithResource(0,0,0,"shrink/MainScreen2.16c.bmp");
	   			break;
	}		
	flushToMemory();

/*	int i1, i2;
   for (i1=21;i1<192;i1++)
	   for (i2=31;i2<256;i2++)
	   {
	      //if (PA_16cGetPixel(0,x,y) == 7) 
			PA_16cDeletePixel(0,i2,i1);
	   }     */ 
}   
void initShrink(int x,int y,int shrinkPage)
{
   create3dOuterCanvasLayer(1000,21, 23, 28);
   create3dOuterCanvasLayer(900,21, 23, 28);
   PA_SetSFXAlpha(0, 31,31);  
   setBrightness(1,20);
	loadBMPWithResource(1,0,0,"shrink/whiteBoardTxt.bmp");
	changeShrinkPage(shrinkPage);
//	clear16cZone(0,32+x,maxLimitValueTo(24-(y),24,168),226+x,maxLimitValueTo(168-(y),24,192));
}   

void notepadWhiteBoard()
{
	create3dBackgroundLayer(917,31,31,31);
	PA_3DSetSpriteWidthHeight(917,1022,1022);
	PA_3DSetSpritePrio(917,3100);
   setKeyboardWhiteBoardMode(1);
   char* output;
   bool notefound=0;
	int n=0;
//   bool bmpfound=0;
   FILE* whiteboardFile;
   if (bookpage==0)
	{
	   output = inputKeyboard(1, "",29,19,233,174,	 0, PLAIN_TEXTCOLOR, 2,1,5, 0, 0,0);	   
	}   
	else
	{
	   char text[768];
		sprintf(text,"fat:/_menudo/notes/note%02d.txt",bookpage-1);
		whiteboardFile = fopen (text, "rb"); //rb = read

		if (whiteboardFile) 
		{
		   n=0;
		   while (!feof(whiteboardFile)) {
		     text[n]= getc(whiteboardFile);
		     if ( text[n]== '\r') continue;
		     n++;
		   }
			fclose(whiteboardFile);
			text[n-1]= 0;
			output = inputKeyboard(1, text,29,19,233,174,	 0, PLAIN_TEXTCOLOR, 2,1,5, 0, 0,0);	   
			notefound=1;
		}		
		else
		{
			fclose(whiteboardFile);
			sprintf(text,"fat:/_menudo/notes/note%02d.bmp",bookpage-1);
			whiteboardFile = fopen (text, "rb"); //rb = read
			if (whiteboardFile)
			{
				loadBMPWithResource(1,0,0,"shrink/whiteBoardTxt.bmp");
			}   
			fclose(whiteboardFile);
			output = inputKeyboard(1, "",29,19,233,174,	 0, PLAIN_TEXTCOLOR, 2,1,5, 0, 0,0);	   
		}			
	   
	}   


   setKeyboardWhiteBoardMode(0);
   if (inputKeyboard_EndedWithSave())
   {
	   bool fileFound;
	   int counter=0;
	   char path[50];
	   if (!notefound)
	   {
		   counter = getLastBookPage();
		}			
		else
			counter = bookpage;
		

		sprintf(path,"fat:/_menudo/notes/note%02d.txt",counter-1);
		whiteboardFile = fopen (path, "wb"); //rb = read		
		for (n=0; output[n]; n++)
		{
			if (output[n]=='\n')  fputc ( '\r' , whiteboardFile );
			fputc ( output[n] , whiteboardFile );
		}
		fclose(whiteboardFile);

   }   
  if (output!=NULL) free(output);
   reset_inputKeyboard_EndedWithSave();
   initShrink(shrinkX,shrinkY,0);
	changeWhiteBoard();

	PA_3DSetSpriteVisible(917,0);
}			
#define rowIconClicked(x) PA_StylusInZone(5,22+(21*x),25,42+(21*x))
u8 sprite2d_ShowY[20];
void hideAll2dSprites()
{
   int i=0;
   for (i=0;i<20;i++)
	{
	   hidesprite(1,i);
	}   
}   
void showAll2dSprites()
{
   int i=0;
   for (i=0;i<20;i++) //PA_SetSpriteY(1,i,PA_GetSpriteY(1,i)+300);
   	   showsprite(1,i);
}   
bool shrinkMenu(char* menu, char* fileJpg, bool allowWindowApps, int battsprite)
{
   if (wifi.connecting) cancellWifiConnect();
   u8 shrinkPage=0;
	FILE* snd = returnThemeResourcePathFILE("sounds/startshrink.wav", "rb",1);
	loadFatSndWav(snd);
	fclose(snd);
   //PA_TextLineSpacing(0);
   PA_TextLineSpacing(1);
   killWindow();
   updateWindow();

//	hidesprite(1, battsprite);

	shrinkX=10;
	shrinkY=-10;
	backgroundShrinked=0;

   create3dOuterCanvasLayer(1000,31,31,31);
	PA_3DSetSpritePrio(1000,3100);
	PA_3DSetSpritePrio(1000+1,3100);	
	PA_3DSetSpritePrio(1000+2,3100);
	PA_3DSetSpritePrio(1000+3,3100);
   create3dOuterCanvasLayer(900,0,0,0);
	create3dBackgroundLayer(888,0,0,0); //place bg ini here
	PA_3DSetSpritePrio(888,5);
	
	create3dBackgroundLayer(889,31,31,31);
	PA_3DSetSpritePrio(889,4);

   create3dOuterCanvasLayer(1000,21, 23, 28);
   create3dOuterCanvasLayer(900,21, 23, 28);
		
   create3dOuterCanvasLayer(900,0,0,0);
   create3dOuterCanvasLayer(1000,31,31,31);
   
	create3dBackgroundLayer(888,0,0,0); //place bg ini here
	PA_3DSetSpritePrio(888,5);
	
	create3dBackgroundLayer(889,31,31,31);
	PA_3DSetSpritePrio(889,4);
	

	PA_3DSetSpritePrio(1000,3100);
	PA_3DSetSpritePrio(1000+1,3100);	
	PA_3DSetSpritePrio(1000+2,3100);
	PA_3DSetSpritePrio(1000+3,3100);
	PA_oldx[0]=0;
	PA_oldy[0]=0;
	int accelX=0;
	int accelY=0;
	u8 doubleTapTimer=0;
	PA_EnableSpecialFx(0, SFX_ALPHA, SFX_BG1 , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	initAntiAliasedText(0,1,0);
	initAntiAliasedText(1,2,1);
	PA_SetSFXAlpha(1, 12, 2); 
	PA_SetSFXAlpha(0, 31,31);   
	setBrightness(0, 0);
	setBrightness(1, 0);
/*   PA_BGScrollXY(0,1,8,9);
   PA_BGScrollXY(1,2,8,9);*/
   PA_BGScrollXY(0,1,8,8);
   PA_BGScrollXY(1,2,8,8);

	bool doubleTapExit = 1;
	
	while(true)
	{
		//check if buttons pressed
	   if ((PA_StylusInZone(224,0,256,12) && Stylus.Newpress) || Pad.Newpress.R) 
		{
		   SaveCurrentConfig();
		   PA_Shutdown(); //X Close tab
		}   
      if (backgroundShrinked)
      {

         if (Stylus.Newpress)
         {
				switch (shrinkPage)
				{
				   case 0:
						   if (rowIconClicked(0)) toogleLights();
						   if (rowIconClicked(1)) 
							{
								doodleWhiteboard();
								PA_SwitchScreens();
								loadBMPWithResource(1,0,0,"shrink/whiteBoardTxt.bmp");
								PA_SwitchScreens();
								changeWhiteBoard();
							}
						   if (rowIconClicked(2)) notepadWhiteBoard();
						   if (rowIconClicked(3)) 
							{
							   if (manageThemes())
							   {
							      PA_SwitchScreens();
							      return 1;
							   }   

								loadBMPWithResource(1,0,0,"shrink/whiteBoardTxt.bmp");
								PA_SwitchScreens();
								changeWhiteBoard();
							}   
						   if (rowIconClicked(4))
						   {
						      shrinkPage=1;
								changeShrinkPage(shrinkPage);						      
							}			
							break;							
					case 1: 
						   if (rowIconClicked(1)) shrinkFlashLightApp();
						   if (rowIconClicked(2))
							{
							   if (shrinkThemeEdit(menu)!=0)
							   {
							      return 1;
							   }   
							      
							}  	
						   if (rowIconClicked(3))
						   {
						      shrinkPage=0;
								changeShrinkPage(shrinkPage);						      
							}			
							break;
					
				}			
				if (shrinkPage==1)
				   if (rowIconClicked(0) && allowWindowApps) 
					{
				   	createMultimediaWindow();
				   	break;
					}   
			   if (PA_StylusInZone(5,170,25,190)) //Wifi Tab
				{
				  	if (wifi.online)
				  	{
					   cleanMemory();
					   mWifi_interface();
				      return 1;
			   	}   
			   	else
			   	{
					   showWifiLoginScreen();
					   setBrightness(1,31);
					   backgroundShrinked=0;
					   shrinkPage=0;
					   Stylus.Held=0;
					   Stylus.Newpress=0;
					}  	
				}   
			}			
         PA_SetSFXAlpha(0, 31,getScreenBrightnessValue(1)/2);  
//			PA_SetBgRot(1, 3,128, 960,  128-(getScreenBrightnessValue(1)/2), 96, 0, 256);
         transiteScreenBrightness(1,0);
         transiteScreenBrightness(1,0);
         updateShrinkClock(0);
//         if (PA_StylusInZone(0,176,50,192) && Stylus.Newpress) return;
      }
		else   
      {
			PA_16cErase(0);
			transiteScreenBrightness(1,31);
			if (getScreenBrightnessValue(1) < 20)
			transiteScreenBrightness(1,31);
			PA_3DSetSpriteAlpha(1000,getScreenBrightnessValue(1));
			PA_3DSetSpriteAlpha(1000+1,getScreenBrightnessValue(1));	
			PA_3DSetSpriteAlpha(1000+2,getScreenBrightnessValue(1));
			PA_3DSetSpriteAlpha(1000+3,getScreenBrightnessValue(1));
			if (getScreenBrightnessValue(1) == 31)
			{
				snd = returnThemeResourcePathFILE("sounds/startshrinkthud.wav", "rb",1);
				loadFatSndWav(snd);
				fclose(snd);

			   initShrink(shrinkX,shrinkY,shrinkPage);
				updateShrinkClock(1); 			   
				changeWhiteBoard();
		      hideAll2dSprites();
			   backgroundShrinked=1;
			}   
			else
			{
			   PA_SetSFXAlpha(0, 0,0);  
			}   
		}			

		
	   if (Stylus.Held && PA_StylusInZone(32+shrinkX,maxLimitValueTo(24-(shrinkY),24,168),226+shrinkX,maxLimitValueTo(168-(shrinkY),24,168)))
		{
		   
		   if (Stylus.Newpress) 
			{
			   if (doubleTapTimer != 0) break;
			   doubleTapTimer=20;
			}
		   if (PA_oldx[0] == 0 || PA_oldy[0] == 0)
		   {
		      PA_oldx[0] = Stylus.X;
		      PA_oldy[0] = Stylus.Y;
		   }   
			shrinkX -= PA_oldx[0] - Stylus.X;
			shrinkY += PA_oldy[0] - Stylus.Y;
	      PA_oldx[0] = Stylus.X;
	      PA_oldy[0] = Stylus.Y;		   

		}   
		else
	   {
		   if (!(PA_oldx[0] == 0 || PA_oldy[0] == 0))
		   {
		      accelX = (PA_oldx[0] - Stylus.X)<<2;
		      accelY = (PA_oldy[0] - Stylus.Y)<<2;
		   }   
			accelX/=1.1;
			shrinkX-=accelX;
			accelY/=1.1;
			shrinkY+=accelY;
		
	      PA_oldx[0] = 0;
	      PA_oldy[0] = 0;
//			if (x>31)accelX*=-1;
//			if (x<-31)accelX*=-1;
//			if (y>16)accelY*=-1;
//			if (y<-22)accelY*=-1;
	   }   
		if (shrinkX>31)shrinkX=31;
		if (shrinkX<-31)shrinkX=-31;
		if (shrinkY>16)shrinkY=16;
		if (shrinkY<-22)shrinkY=-22;
	   if (doubleTapTimer>0) doubleTapTimer--;
		if (backgroundShrinked)
		{
/*			if (Pad.Held.Right || Pad.Held.Left ||Pad.Held.Up || Pad.Held.Down ||Stylus.Held || accelX != 0|| accelY != 0 )  clear16cZone(0,limitValueTo(32+x,31),maxLimitValueTo(24-(y),24,192),226+x,maxLimitValueTo(168-(y),24,192));
		   for (temp2=24;temp2<=192;temp2++)
			   for (temp1=31;temp1<=256;temp1++)
			   {
			      if (PA_16cGetPixel(0,temp1,temp2)==0 && !(temp1 >= 32+x && temp1 <=226+x &&temp2 >= 24-(y)&&temp2 <=168-(y))) PA_16cPutPixel(0,temp1,temp2,7);
			   }   */
		}   

		if (backgroundShrinked)
			ZoomXY_3DProcess(112 - (doubleTapTimer>10?(doubleTapTimer-10)/3:0),(shrinkX+3)*-1,(shrinkY)*-1);
		else
			ZoomXY_3DProcess(127 - (getScreenBrightnessValue(1)/2)- (doubleTapTimer>10?(doubleTapTimer-10)/3:0),((PA_Sin((30-getScreenBrightnessValue(1))<<3)>>2)+3+(shrinkX/(31-getScreenBrightnessValue(1))))*-1,(getScreenBrightnessValue(1))/3); 
		updateAmbience();  //Update Ambience / Animated Background
      Soul_waitForVBL();
		detectFlipPageInput();

      if (Pad.Newpress.L) 
		{
		   doubleTapExit = 0;
		   break;
		}   

	}	
//	timer_counter=0;
	snd = returnThemeResourcePathFILE("sounds/endshrink.wav", "rb",1);
	loadFatSndWav(snd);
	fclose(snd); 
	setBrightness(1,31); 
   PA_16cErase(1);
	if (backgroundShrinked)
	{
	   PA_16cErase(0);
		initAntiAliasedText(0,1,0);

	   create3dOuterCanvasLayer(1000,31,31,31);
		PA_3DSetSpritePrio(1000,3100);
		PA_3DSetSpritePrio(1000+1,3100);	
		PA_3DSetSpritePrio(1000+2,3100);
		PA_3DSetSpritePrio(1000+3,3100);
	   create3dOuterCanvasLayer(900,0,0,0);
		create3dBackgroundLayer(888,0,0,0); //place bg ini here
		PA_3DSetSpritePrio(888,5);
		
		create3dBackgroundLayer(889,31,31,31);
		PA_3DSetSpritePrio(889,4);
      char filepath[100];
		sprintf(filepath,"fat:/_menudo/themes/%s/%s/%s",CurrentTheme,menu,fileJpg);
		loadFatBg16bit(1,filepath);
	}   
	while(getScreenBrightnessValue(1) != 0)
	{

	   transiteScreenBrightness(1,0);
	   if (getScreenBrightnessValue(1) > 15) transiteScreenBrightness(1,0);
		PA_3DSetSpriteAlpha(1000,getScreenBrightnessValue(1));
		PA_3DSetSpriteAlpha(1000+1,getScreenBrightnessValue(1));	
		PA_3DSetSpriteAlpha(1000+2,getScreenBrightnessValue(1));
		PA_3DSetSpriteAlpha(1000+3,getScreenBrightnessValue(1));
		updateAmbience();
		if (doubleTapExit)
			ZoomXY_3DProcess(127 - (getScreenBrightnessValue(1)/1.7),(((shrinkX+3)*-1)*((float)getScreenBrightnessValue(1)/31)),((shrinkY)*-1)*((float)getScreenBrightnessValue(1)/31));
		else
			ZoomXY_3DProcess(127 - (getScreenBrightnessValue(1)/1.7),(((shrinkX+3)*-1)*((float)getScreenBrightnessValue(1)/31))+((PA_Sin((getScreenBrightnessValue(1))<<3)>>2)+1),((shrinkY)*-1)*((float)getScreenBrightnessValue(1)/31));
      Soul_waitForVBL();
	   if (Pad.Newpress.Anykey || Stylus.Newpress) setBrightness(1,0); 
	}   
				snd = returnThemeResourcePathFILE("sounds/endshrinkthud.wav", "rb",1);
				loadFatSndWav(snd);
				fclose(snd);
	PA_EnableSpecialFx(1, SFX_NONE, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	showAll2dSprites();

	
	//loadSpriteClockCoeff();
	
	return 0;
}   

