#include <PA9.h>
#include "../engine/engine.h"

#include "../misc/misc.h"
#include "../misc/clock.h"
#include "../misc/transition.h"
#include "../structDef.h"
#include "services/wificenter.h"
#include "services/mWifi.h"
#include "services/fileDetector.h"
#include "shrink.h"
#include "internalapps/doodle/shrinked_canvas.h"





#define PAGE_AMOUNT 2
int bookpage=0;

bool whiteBoard_isImage=0;
bool whiteBoardChanged=0;

char* getLastGameStarted()
{
	FILE* testRead = fopen ("fat:/_menudo/logs/HISTORY.LASTGAMESTARTED", "rb");
	char line[256];
	int i=0;
	int duration=0;
	char* result=malloc(50);
	if (testRead)
	{
		result[0]=0;
		while(fgets(line, 256, testRead)!=NULL)
		{
		   switch(i)
		   {
		      case 0: 	duration = PA_RTC.Year - atoi(line);
						   if (duration>0) sprintf(result,"%d Year",duration);
		      			break;
		      case 1: 	duration = PA_RTC.Month - atoi(line);
						   if (duration>0) sprintf(result,"%d Month",duration);
		      			break;
		      case 2: 	duration = PA_RTC.Day - atoi(line);
						   if (duration>0) sprintf(result,"%d Day",duration);
		      			break;
		      case 3: 	duration = PA_RTC.Hour - atoi(line);
						   if (duration>0) sprintf(result,"%d Hour",duration);
		      			break;
		      case 4: 	duration = PA_RTC.Minutes - atoi(line);
						   if (duration>0) sprintf(result,"%d Minute",duration);
		      			break;
		      case 5: 	duration = PA_RTC.Seconds - atoi(line);
						   if (duration>0) sprintf(result,"%d Second",duration);
		      			break;
		   }  
			if (duration>1)
			{
			   result[strlen(result)+1]=0;
			   result[strlen(result)]='s';
			}   
		   if (result[0]!=0)
			{
			   fclose(testRead);  
			   return result;
			}   
		   i++;
		}		
	}		
	fclose(testRead);  
	free(result);

	return NULL;
}   


int getLastBookPage()
{
   FILE* whiteboardFile;
   int counter=0;
   bool fileFound=0;
   char path[50];
	do{
	   counter++;
	   fileFound=0;
		sprintf(path,"fat:/_menudo/notes/note%02d.txt",counter-1);
		whiteboardFile = fopen (path, "rb"); //rb = read
		if (whiteboardFile) 
		{
		   fileFound=1;
		   fclose(whiteboardFile);
		   continue;
		}		
		fclose(whiteboardFile);
	
		sprintf(path,"fat:/_menudo/notes/note%02d.bmp",counter-1);
		whiteboardFile = fopen (path, "rb"); //rb = read
		if (whiteboardFile) 
		{
		   fileFound=1;
		}		
		fclose(whiteboardFile);
		
	} while (fileFound);
	return counter;
}   

void changeWhiteBoard()
{
   whiteBoardChanged=1;  
   PA_16cErase(1);
   spaceLetteringForAAText();
   PA_TextAlign(ALIGN_LEFT);
   char text[768];
   memset(text,0,sizeof(text));
   if (bookpage==0)
   {
      char userInfo[100];
	  if (getAmountOfNewNDS() == 1 )
			sprintf(userInfo, "1 New Game");	   		  
	  if (getAmountOfNewNDS() > 1 )
			sprintf(userInfo, "%d New Games", getAmountOfNewNDS());

	  if (wifi.online)
	  {
	     sprintf(text, "Hi, %s(%s)\nYou are connected to GameNow.Asia\n\n",PA_UserInfo.Name,wifi.username);				  
	  }   
		else
	 {
	     sprintf(text, "Hi, %s\nYou are not connected online\n\n",PA_UserInfo.Name);				  		
	  }   
	  if (getAmountOfNewNDS() != 0)
   	  sprintf(text, "%sYou have\n     %s\n\n", text,userInfo);
   	
		char* LastGameStarted = getLastGameStarted();
		if (LastGameStarted!=NULL)
		{
   		sprintf(text, "%sLast Game Started : %s ago\n",text,LastGameStarted);
   		free(LastGameStarted);
	   } 		
//   	sprintf(text, "%s\nIP: 192.168.1.3",text);   	
	  if (wifi.online)
		if (Wifi_GetIP()!=0)
		{
			char* IPaddress = GetLanIP();
	   	sprintf(text, "%sI.P. Address : %s",text,IPaddress);   	
			if (IPaddress!=NULL)
			{
	   		free(IPaddress);
		   } 		
		}   
	   if (whiteBoard_isImage==1)
	   {
			loadBMPWithResource(1,0,0,"shrink/whiteBoardTxt.bmp");
	      whiteBoard_isImage=0;
	   } 
   }
	else
	{	  

		sprintf(text,"fat:/_menudo/notes/note%02d.txt",bookpage-1);
		FILE* whiteboardFile = fopen (text, "rb"); //rb = read
		if (whiteboardFile)
		{
		   if (whiteBoard_isImage==1)
		   {
				loadBMPWithResource(1,0,0,"shrink/whiteBoardTxt.bmp");
		      whiteBoard_isImage=0;
		   } 
		   int n=0;
		   int c=0;
		   while (true)
			{
		      c = fgetc (whiteboardFile);
		      if (c == EOF) break;
		      if (c == '\r') continue;
		      text[n]=(char)c;
		      n++;
		   } 
		   text[n]=0;
			fclose(whiteboardFile);
		}   
		else
		{
			fclose(whiteboardFile);	   
			sprintf(text,"fat:/_menudo/notes/note%02d.bmp",bookpage-1);
			whiteboardFile = fopen (text, "rb");
			if (whiteboardFile)
			{
			   whiteBoard_isImage=1;
			   int x,y;
			   for (x=0;x<256;x++)
				   for (y=0;y<192;y++)
					   PA_Put16bitPixel(1,x,y,PA_RGB(31,31,31));
				loadFatBgBmp(1,whiteboardFile);
				PA_16cErase(1);
			}			
			fclose(whiteboardFile);
		}   

	
//	   case 2: whiteBoard_isImage=1;
//				  PA_LoadBmpEx(1,26,20,(void*)whiteBoardPicture);
//				  break;
	}   
	if (!whiteBoard_isImage) 
	{
	   display16cText(1,29,20,233,174,text,1,5);         
		spaceLetteringForDefault();
		updateShrinkClock(1);
	}		

}
void flipPage_Next()
{
   if (!whiteBoardChanged)
   {
	   char text[40];
	   bool fileFound=0;
		sprintf(text,"fat:/_menudo/notes/note%02d.txt",bookpage);
		FILE* whiteboardFile = fopen (text, "rb"); //rb = read
		if (whiteboardFile) 
		{
		   fileFound=1;
		}		
		fclose(whiteboardFile);
	
		sprintf(text,"fat:/_menudo/notes/note%02d.bmp",bookpage);
		whiteboardFile = fopen (text, "rb"); //rb = read
		if (whiteboardFile) 
		{
		   fileFound=1;
		}		
		fclose(whiteboardFile);

		if (fileFound)
		{
		   bookpage++;	   
		   changeWhiteBoard();
		}   
	}		

}   
void flipPage_Previous()
{
   if (bookpage>0 && !whiteBoardChanged) 
	{
	   bookpage--;
	   changeWhiteBoard();
	}   
}   

void detectFlipPageInput()
{
   if (Pad.Held.Left) 
	{
	   flipPage_Previous();
	}   
	else
   if (Pad.Held.Right) 
	{
	   flipPage_Next();
	}   
	else
	{
		whiteBoardChanged =0;
	}		
}		

