#include <PA9.h>       // Include for PA_Lib
#include "userConfigFunctions.h"
#include "misc/fat.h"
extern char menuSelected[6];
char CurrentTheme[256];
//bool IncompleteFiles=0;
void toogleLights()
{
   system.BacklightStrength++;
   if (system.BacklightStrength > 5) system.BacklightStrength =1;
	PA_SetDSLBrightness(system.BacklightStrength);
}
#define STARTUP_CMD_INILINE "directToMain=\nstartupUp   = \nstartupDown = \nstartupLeft = \nstartupRight= \nstartupY=\nstartupX=\nstartupA=\nstartupSelect=\nstartupStart=\nstartupDefault=\n"
#define MENU_CMD_INILINE "CustomMenuAction0   = \nCustomMenuAction1   = \nCustomMenuAction2   = \nCustomMenuAction3   = \nCustomMenuAction4   = \nCustomMenuAction5   = \nCustomMenuAction6   = \nCustomMenuAction7   = \nCustomMenuAction8   = \n"
#define USER_PREF_INILINE  "BacklightStrength    = \nEnergySaving         = \nLanguage             = \nInvertScroll       = \nSelectStylusSpeed       =\nDetectNewFiles =\nSMFCoverDelay = \nScreenSaverDelay=\nShuffleThemes="
bool isStylusInverted()
{
   return system.InvertScroll;
}   

#define getIniInt(dest, inistring) dest = readIniFileInt(inistring);
#define getIniString(dest, inistring)  chrpointer = (char *)readIniFileString(inistring);\
													if (chrpointer!=NULL){\
														sprintf(dest,"%s",chrpointer);\
														free(chrpointer);\
													}			\
													else\
													{dest[0]=0;dest[1]=0;}
void LoadCurrentConfig()
{
  	system.Language = 0;
  	system.BacklightStrength = 1;
  	system.EnergySaving = 1;
  	system.InvertScroll = 0;

  	system.SelectStylusSpeed = 8;
  	system.DoubleClickSpeed = 30;
  	system.SMFCoverDelay = 0;
  	system.ScreenSaverDelay = 60;
  	system.ShuffleThemes = 1;
	system.Password[0]=0;
	system.AutoLoginWifi=0;
		  	
  	readINI = fopen ("fat:/_menudo/settings.ini", "rb"); 
  	if (readINI)
  	{
  	   char* chrpointer;
	  	getIniInt(system.Language,"Language");
	  	getIniInt(system.BacklightStrength,"BacklightStrength");
	  	getIniInt(system.EnergySaving,"EnergySaving");
	  	getIniInt(system.InvertScroll,"InvertScroll");
	  	getIniInt(system.SelectStylusSpeed,"SelectStylusSpeed");
	  	getIniInt(system.DoubleClickSpeed,"DoubleClickSpeed");
	  	getIniInt(system.SMFCoverDelay,"SMFCoverDelay");
	  	getIniInt(system.ScreenSaverDelay,"ScreenSaverDelay");
	  	getIniInt(system.ShuffleThemes,"ShuffleThemes");
	  	getIniInt(system.AutoLoginWifi,"AutoLoginWifi");
  	   getIniInt(system.directToMain,"DirectToMain");

	   getIniString(system.menuRuns[0],"CustomMenuAction0");
	   getIniString(system.menuRuns[1],"CustomMenuAction1");
	   getIniString(system.menuRuns[2],"CustomMenuAction2");
	   getIniString(system.menuRuns[3],"CustomMenuAction3");
	   getIniString(system.menuRuns[4],"CustomMenuAction4");
	   getIniString(system.menuRuns[5],"CustomMenuAction5");
	   getIniString(system.menuRuns[6],"CustomMenuAction6");
	   getIniString(system.menuRuns[7],"CustomMenuAction7");
	   getIniString(system.menuRuns[8],"CustomMenuAction8");

	   getIniString(system.startup[0],"startupUp");
	   getIniString(system.startup[1],"startupDown");
	   getIniString(system.startup[2],"startupLeft");
	   getIniString(system.startup[3],"startupRight");
	   getIniString(system.startup[4],"startupY");
	   getIniString(system.startup[5],"startupX");
	   getIniString(system.startup[6],"startupA");
	   getIniString(system.startup[7],"startupDefault"); 

	   getIniString(system.Password,"Password");
		
		system.iniLoaded=1;

	}   
	fclose(readINI);
	loadWifiConfig();
}		
#define writeToINI(str,var);	\
			sprintf (charTemp,str,var);\
			fwrite(charTemp, strlen(charTemp), 1, readINI);
	
void SaveCurrentConfig()
{

   char charTemp[256];
  	readINI = fopen ("fat:/_menudo/settings.ini", "wb"); 
	writeToINI("BacklightStrength    = %d\n",	system.BacklightStrength);
	writeToINI("EnergySaving         = %d\n",	system.EnergySaving);
	writeToINI("Language             = %d\n",	system.Language);
	writeToINI("InvertScroll       	= %d\n",	system.InvertScroll);
	writeToINI("SelectStylusSpeed    = %ld\n",system.SelectStylusSpeed);
	writeToINI("SMFCoverDelay	      = %ld\n",system.SMFCoverDelay	);
	writeToINI("ScreenSaverDelay	   = %ld\n",system.ScreenSaverDelay	);
	writeToINI("ShuffleThemes	      = %s\n",	system.ShuffleThemes?"1":"0"	);
	writeToINI("DoubleClickSpeed	   = %ld\n",system.DoubleClickSpeed	);
	writeToINI("AutoLoginWifi		   = %d\n",	system.AutoLoginWifi	);
	writeToINI("DirectToMain	   	= %d\n",	system.directToMain	);
 
	writeToINI("CustomMenuAction0   = %s\n",system.menuRuns[0]);
	writeToINI("CustomMenuAction1   = %s\n",system.menuRuns[1]);
	writeToINI("CustomMenuAction2   = %s\n",system.menuRuns[2]);
	writeToINI("CustomMenuAction3   = %s\n",system.menuRuns[3]);
	writeToINI("CustomMenuAction4   = %s\n",system.menuRuns[4]);
	writeToINI("CustomMenuAction5   = %s\n",system.menuRuns[5]);
	writeToINI("CustomMenuAction6   = %s\n",system.menuRuns[6]);
	writeToINI("CustomMenuAction7   = %s\n",system.menuRuns[7]);
	writeToINI("CustomMenuAction8   = %s\n",system.menuRuns[8]);

	writeToINI("startupUp     = %s\n",	 system.startup[0]);
	writeToINI("startupDown   = %s\n",	 system.startup[1]);
	writeToINI("startupLeft   = %s\n",	 system.startup[2]);
	writeToINI("startupRight  = %s\n",	 system.startup[3]);
	writeToINI("startupY		  = %s\n",	 system.startup[4]);
	writeToINI("startupX		  = %s\n",	 system.startup[5]);
	writeToINI("startupA		  = %s\n",	 system.startup[6]);
	writeToINI("startupDefault= %s\n",	 system.startup[7]);

	writeToINI("Password	      = %s\n",	system.Password);
	fclose(readINI);
}   
u8 getMENUdoBootConfirmation()
{
   u8 result=0;
   char chrTemp[10];
	FILE* bootupConfirmation = fopen("fat:/_menudo/logs/check.bootup","rb");
	if (!bootupConfirmation)
		result=0;
	else
	{
	   fgets(chrTemp,10,bootupConfirmation);
	   result = atoi(chrTemp);
	}   
	fclose(bootupConfirmation);
	return result;
}  

bool didPreviousBootupSucceed() 
{
   u8 i= getMENUdoBootConfirmation();
	return (i==0);
}   

void writeMENUdoBootConfirmation(u8 i)
{
   char chrTemp[10];
   sprintf(chrTemp,"%d",i);
   FILE* bootupConfirmation = fopen("fat:/_menudo/logs/check.bootup","wb");
   fwrite(chrTemp,strlen(chrTemp),1,bootupConfirmation);
	fclose(bootupConfirmation);
}   

bool isFirstMENUdoBootup()
{
  FILE* bootupConfirmation = fopen("fat:/_menudo/logs/check.bootup","rb");
  if(bootupConfirmation)
    return false;
  else 
    return true;
}
bool bootUpSucceedWritten=0;
void confirmBootupSucceeded(bool yes)
{
   
   if (yes)
   {
      if (bootUpSucceedWritten) return;
      bootUpSucceedWritten=1;
	   writeMENUdoBootConfirmation(0);
	}   
	else
	   writeMENUdoBootConfirmation(1);
}   

u8 getMenuSequence()
{
   switch (menuSelected[0])
   {
      case 0: 	switch (menuSelected[1])
      			{
      			   case 0: return 0;
      			   case 1: return 1;
      			   case 2: return 2;
      			}   
      case 1: return 3;
      case 2: return 4;
      case 3: return 5;
      case 4: switch (menuSelected[5])
      			{
      			   case 0: return 6;
      			   case 1: return 7;
      			   case 2: return 8;
      			}
   }			
   return 0;
}   

void convertMenuSequence(u8 i)
{
	menuSelected[2]=0;
	menuSelected[3]=0;
	menuSelected[4]=0;
	menuSelected[1]=1;
	menuSelected[5]=1;
	if (i<3) 
	{
	menuSelected[0]=0;
	menuSelected[1]=i;
	}
	else
	if (i>5)
	{
	menuSelected[0]=4;
	menuSelected[5]=i-6;
	}
	else
	menuSelected[0]=i-2;
	

}   
  
int getNavigateSpeed(){
   switch(system.SelectStylusSpeed)
   {
	   case 0: return 1; //very slow 
	   case 1: return 2; //slow
	   case 3: return 4; // fast
	   case 4: return 5; // very fast
	   default:return 3; //normal
	}
}
#define GAMESELECT_NORMAL_ANIMATION_SPEED 8 
int getGameSelectSpeed(){
   switch(system.SelectStylusSpeed)
   {  
	   case 0: return 4; //very slow 
	   case 1: return 6; //slow
	   case 3: return 16; // fast
	   case 4: return 24; // very fast
	   default:return GAMESELECT_NORMAL_ANIMATION_SPEED; //normal
	}
}
int getDoubleClickValue()
{
   switch(system.DoubleClickSpeed)
   { 
	   case 0: return 50; //very slow 
	   case 1: return 40; //slow
	   case 3: return 20; // fast
	   case 4: return 10; // very fast
	   default:return 30; //normal
	} 
}
