#include <PA9.h>
#include "engine/engine.h"
#include "misc/misc.h"
#include "misc/transition.h"
#include "Xmenu.h"

extern unsigned short pal_16c[16] __attribute__ ((aligned (4)));
extern int shrinkX;
extern int shrinkY;
s8 saveSlot=0;
void xmenu_changeHighlightTo(int selected)
{
   int i;   
	for (i=0;i<8;i++)
	{
		pal_16c[i+1]=PA_RGB(192>>3,192>>3,214>>3);
	}		
	pal_16c[selected+1]=PA_RGB(31,31,31);
	Soul_waitForVBL();
	PA_LoadPal16c(PAL_BG0, (void*)pal_16c);
}	
void xmenu_renderText(u8 xMenuPage)
{
//   Soul_waitForVBL();
	int x,y;
	for(x=26;x<26+205;x++)
		for(y=30;y<30+133;y++)
			PA_16cDeletePixel(0,x,y);
	char chrtemp[256];
	switch(xMenuPage)
	{
	   case 0:
			display16cText(0,30,33+(15*0),26+205,0,"Play game normally",0+1,3);
			display16cText(0,30,33+(15*1),26+205,0,"Play game without mWifi",1+1,3);
			sprintf(chrtemp,"Save Slot <%s>",saveSlot==0?"Default":"Create New");
			display16cText(0,30,33+(15*2),26+205,0,chrtemp,2+1,3);
		//	display16cText(0,30,33+(15*3),26+205,0,"Move to Folder",3+1,3);
			display16cText(0,30,33+(15*4),26+205,0,"Browse Cheats",3+1,3);
			display16cText(0,30,33+(15*5),26+205,0,"View Game Info Page",4+1,3);
			display16cText(0,30,33+(15*6),26+205,0,"More..",5+1,3);
			display16cText(0,30,33+(15*8),26+205,0,"Return to Menu",6+1,3);
			break;
		case 1:
			display16cText(0,30,33+(15*0),26+205,0,"Move to Folder",0+1,3);
			display16cText(0,30,33+(15*1),26+205,0,"Delete Game",1+1,3);
			display16cText(0,30,33+(15*2),26+205,0,"Trim Game",2+1,3);
			display16cText(0,30,33+(15*4),26+205,0,"Rename",3+1,3);
			display16cText(0,30,33+(15*5),26+205,0,"Rename to Game's Title",4+1,3);
			display16cText(0,30,33+(15*6),26+205,0,"More..",5+1,3);
			display16cText(0,30,33+(15*8),26+205,0,"Return to Menu",6+1,3);
	}	
	for(x=26;x<26+205;x++)
		for(y=30;y<30+133;y++)
			if (PA_16cGetPixel(0,x,y)==0)PA_16cPutPixel(0,x,y,15);
//   Soul_waitForVBL();
}		
	
void xmenu_customText(char* text, int color)
{
//   Soul_waitForVBL();
	int x,y;
	for(x=26;x<26+205;x++)
		for(y=30;y<30+133;y++)
			PA_16cDeletePixel(0,x,y);
	display16cText(0,30,33+(15*0),26+205,33+(15*9),text,color+1,3);

	for(x=26;x<26+205;x++)
		for(y=30;y<30+133;y++)
			if (PA_16cGetPixel(0,x,y)==0)PA_16cPutPixel(0,x,y,15);
//   Soul_waitForVBL();
}		
void xmenu_renderSaveText()
{
//   Soul_waitForVBL();
	int x,y;
	for(x=26;x<26+205;x++)
		for(y=33+(15*2)-4;y<33+(15*3);y++)
			PA_16cDeletePixel(0,x,y);
	char chrtemp[256];
	sprintf(chrtemp,"Save Slot <%s>",saveSlot==0?"Default":"Create New");
	display16cText(0,30,33+(15*2),26+205,0,chrtemp,2+1,3);
	for(x=26;x<26+205;x++)
		for(y=33+(15*2)-4;y<33+(15*3);y++)
			if (PA_16cGetPixel(0,x,y)==0)PA_16cPutPixel(0,x,y,15);
//   Soul_waitForVBL();
}			
int xmenu_Load16cBMPtoBG(bool screen, void *bmp,int pos_x, int pos_y)
{
   u8 xMenuPage=0;
   killWindow();
		updateWindow();
	PA_DisableSpecialFx(0);
	PA_EnableSpecialFx(0, SFX_ALPHA, 	SFX_BG1, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	PA_SetBrightness(1,-14);
	PA_SetSFXAlpha(0, 23, 1);
	int bmp_height;
	int bmp_width;	
	int temp=0; 
	int temp1=0; 
	int i=0;
	u16 zero = 0;
	u8 *tempbmp = (u8*)bmp;
	BMPHeader0 *Bmpinfo0 = (BMPHeader0 *) (tempbmp);
	BMP_Headers *Bmpinfo = (BMP_Headers*)(tempbmp+14);

	u8 *gfx = tempbmp+(Bmpinfo0->ImageStart1 + ((Bmpinfo0->ImageStart2)<<16));

	bmp_width = Bmpinfo->Width; 
	bmp_height = Bmpinfo->Height;

	

	
	u8 *colormap = tempbmp+14+Bmpinfo->SizeofHeader;

	DMA_Force(zero, pal_16c, (16)>>1, DMA_16NOW); // Blank out

	int magenta=0; 
 	u16 colors = Bmpinfo->ImportantColors;
	i = 0;

	for(temp=0; temp<colors; temp++)
	{
		pal_16c[15-temp]= PA_RGB(((colormap[(temp<<2)+2])>>3)&31, ((colormap[(temp<<2)+1])>>3)&31, ((colormap[(temp<<2)+0])>>3)&31);
		if(pal_16c[15-temp]==PA_RGB(31,0,31))
		{
		   magenta=15-temp;
		   pal_16c[15-temp]=pal_16c[15];
		}   
	}   
	xmenu_changeHighlightTo(0);
	Soul_waitForVBL();
	PA_LoadPal16c(PAL_BG0, (void*)pal_16c);
	Soul_waitForVBL();	

	for(temp=bmp_height-1; temp>=0; temp--)
		for(temp1=0; temp1<bmp_width; temp1++)
		{
		   if (pos_x+temp1 > 256 || pos_y+(bmp_height-temp)-1 > 192) continue;
			if (PA_16cGetPixel(screen,pos_x+temp1,pos_y+(bmp_height-temp)-1 )==0)PA_16cPutPixel(screen,pos_x+temp1,pos_y+(bmp_height-temp)-1,15-((u32)(gfx[(temp*bmp_width)+temp1])));
		}		
	for(temp1=0; temp1<256; temp1++)
	{
	   if (PA_16cGetPixel(screen,temp1,191 )==0)PA_16cPutPixel(screen,temp1,191,PA_16cGetPixel(0,1,190));
	}   
	PA_TextAlign(ALIGN_LEFT);	
	xmenu_renderText(xMenuPage);
	

	int selected=0;		
//	return;
	while(true)
  
	{
	   if (Pad.Newpress.Down || Pad.Newpress.Up)
	   {
	      if (Pad.Newpress.Up)
			{
			   selected--;
			   switch(xMenuPage)	
			   {
			   	case 0: if (selected<0) selected=6;
			   				break;
			   	case 1: if (selected<0) selected=6;
			   				break;
				}  	
			}   
	      if (Pad.Newpress.Down)
			{
			   selected++;
			   switch(xMenuPage)	
			   {
			   	case 0: if (selected>6) selected=0;
			   				break;
			   	case 1: if (selected>6) selected=0;
			   				break;
				 }  	
			}
	     	xmenu_changeHighlightTo(selected);

		 }  
		if (xMenuPage==0)	
      if ((Pad.Newpress.Left || Pad.Newpress.Right) && selected==2)
		{
	      if (Pad.Newpress.Left) saveSlot--;
			if (Pad.Newpress.Right) saveSlot++;
			if (saveSlot>1) saveSlot=0;
			if (saveSlot<0) saveSlot=1;

			xmenu_renderSaveText();
		}
 		updateAmbience();  //Update Ambience / Animated Background
		ZoomXY_3DProcess(128,0,0);  
		PA_WaitForVBL();
		if (Pad.Newpress.B || Pad.Newpress.L)
		{
		   PA_16cErase(0);
	   	PA_SetBrightness(1,0);
		   return 0;
		}   
		if (Pad.Newpress.A)
		{
		   switch(xMenuPage)	
			{
			   case 0:
					   if (selected==5)
					   {
					      xMenuPage=1;
							xmenu_renderText(xMenuPage);
							selected=0;
					     	xmenu_changeHighlightTo(selected);
					   }
						else   
						if (selected!=2 && selected!=3)
						{
						   PA_16cErase(0);
					   	PA_SetBrightness(1,0);
						   return selected+1;
						}
						break;
			   case 1:
					   if (selected==5)
					   {
					      xMenuPage=0;
							xmenu_renderText(xMenuPage);
							selected=0;
					     	xmenu_changeHighlightTo(selected);
					   }
						else   
						if (selected==6)
						{
						   PA_16cErase(0);
					   	PA_SetBrightness(1,0);
						   return 0;
						}
						break;
			}			
		}							   
	}   
}

int xmenu_LoadHelpScreen(bool screen,char* helptext)
{
   int pos_x=0;
   int pos_y=0;
   killWindow();
	updateWindow();
	PA_DisableSpecialFx(0);
	PA_EnableSpecialFx(0, SFX_ALPHA, 	SFX_BG1, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	PA_SetBrightness(1,-14);
	PA_SetSFXAlpha(0, 23, 1);
	int bmp_height;
	int bmp_width;	
	int temp=0; 
	int temp1=0; 
	int i=0;
	u16 zero = 0;
	u8 *tempbmp = (u8*)Xmenu;
	BMPHeader0 *Bmpinfo0 = (BMPHeader0 *) (tempbmp);
	BMP_Headers *Bmpinfo = (BMP_Headers*)(tempbmp+14);

	u8 *gfx = tempbmp+(Bmpinfo0->ImageStart1 + ((Bmpinfo0->ImageStart2)<<16));

	bmp_width = Bmpinfo->Width; 
	bmp_height = Bmpinfo->Height;

	

	
	u8 *colormap = tempbmp+14+Bmpinfo->SizeofHeader;

	DMA_Force(zero, pal_16c, (16)>>1, DMA_16NOW); // Blank out

	int magenta=0; 
 	u16 colors = Bmpinfo->ImportantColors;
	i = 0;

	for(temp=0; temp<colors; temp++)
	{
		pal_16c[15-temp]= PA_RGB(((colormap[(temp<<2)+2])>>3)&31, ((colormap[(temp<<2)+1])>>3)&31, ((colormap[(temp<<2)+0])>>3)&31);
		if(pal_16c[15-temp]==PA_RGB(31,0,31))
		{
		   magenta=15-temp;
		   pal_16c[15-temp]=pal_16c[15];
		}   
	}   
	xmenu_changeHighlightTo(0);
	Soul_waitForVBL();
	PA_LoadPal16c(PAL_BG0, (void*)pal_16c);
	Soul_waitForVBL();	
	for(temp=bmp_height-1; temp>=0; temp--)
		for(temp1=0; temp1<bmp_width; temp1++)
		{
			if (PA_16cGetPixel(screen,pos_x+temp1,pos_y+(bmp_height-temp)-1 )==0)PA_16cPutPixel(screen,pos_x+temp1,pos_y+(bmp_height-temp)-1,15-((u32)(gfx[(temp*bmp_width)+temp1])));
		}		
	for(temp1=0; temp1<256; temp1++)
	{
	   if (PA_16cGetPixel(screen,temp1,191 )==0)PA_16cPutPixel(screen,temp1,191,PA_16cGetPixel(0,1,190));
	}   
	xmenu_customText(helptext,0);
	
	
	while(true)
	{

 		updateAmbience();  //Update Ambience / Animated Background
		ZoomXY_3DProcess(128,0,0);  
		Soul_waitForVBL();
		if (Stylus.Newpress || Pad.Newpress.Anykey || Pad.Held.Y)
		{
		   PA_16cErase(0);
	   	PA_SetBrightness(1,0);
		   return 0;
		}   
	}   
}


void mWifi_GameInfoPage()
{
	PA_16cErase(0);
	PA_16cErase(1);
	loadBMPWithResource(1,0,0,"xmenu/gameinfo_top.bmp");
	load16cBMPWithResource(0,0,0,"xmenu/gameinfo_bot.16c.bmp");
	//Load16cBMPtoBG(0,(void*)gameinfo_bottomscreen,0,0);
	
	PA_DisableSpecialFx(0);
	PA_DisableSpecialFx(1);
	PA_SetSpriteY(1,0,205);
   PA_SetSpriteY(1,10,205);
	while(true)
	{
	   if (Pad.Newpress.B || (Stylus.Newpress && PA_StylusInZone(0,176,35,192)))
	   {
	      break;
	   }   
		Soul_waitForVBL();
	}  	
	PA_16cErase(0);
	return;
}	
void openXMenu()
{
   int i = xmenu_Load16cBMPtoBG(0,(void*)Xmenu,0,0);
   switch(i)
   {
      case 5:	mWifi_GameInfoPage();
//          PA_LoadJpeg(1,(void*)shortcutTopScreen);
          PA_SetSFXAlpha(1, 12, 2); 
          PA_SetSFXAlpha(0, 31,31);   
          break;
    }  	
}

