#include <PA9.h>       // Include for PA_Lib
#include <fat.h>
#include <sys/dir.h>
#include "../userConfigFunctions.h"
#include "../engine/engine.h"
#include "../misc/fat.h"
#include "../misc/misc.h"
#include "../misc/transition.h"
#include "../system/services/mWifi.h"
extern FILE* readINI; 
extern FILE* imgFile;
extern FILE* movieJPG;
extern FILE* historyFile;
extern FILE* fileChecker;
extern bool AfterSMFIntro;

void loadGameBootSMF()
{
   int i;
   
	setBrightness(0,0);
	setBrightness(1,0);
	char * resourcepath = returnThemeResourcePath("videos/videos.ini",1);
	if (resourcepath !=NULL) 
	{
	   readINI = fopen (resourcepath, "rb"); 
		free(resourcepath);
		PA_Init2D();
		if (readINI)
		{
			i = readIniFileInt("GamebootScreen");
			fclose(readINI);
			free(resourcepath);
		   PA_Init16bitBg((1-i),3);
			resourcepath = returnThemeResourcePath("videos/gameboot.jpg",1);
			movieJPG = fopen (resourcepath , "rb");
			if (!movieJPG)
			{
			   free(resourcepath);
			   fclose(movieJPG);
				resourcepath = returnThemeResourcePath("videos/gameboot.jpeg",1);
				movieJPG = fopen (resourcepath , "rb");
			}   
			loadFatBg16bit(1-i,resourcepath);
		  	fclose(movieJPG);
			if (resourcepath !=NULL) free(resourcepath);
		  	char* smfpath =returnThemeResourcePath("videos/gameboot.smf",1);
		   if (initSMF(i, smfpath))
		   {
		     PA_Init16bitBg(i, 3);
				while(updateSMF() && !Pad.Held.Anykey && !Pad.Held.Y && !Stylus.Held)Soul_waitForVBL();
		     deinitSMF();
		   }   
		   if (smfpath!=NULL) free(smfpath);
		}	
	}		
}

bool bootndsCHISHMS(char* filename,bool dldipatch);
#include "../system/services/md5checker.h"

static char filename[256];
bool gamebootactivate=0;
bool bootFile=0;
void menudo_runNDS(char* path, bool gameboot,bool saveAsLastGame)
{
   menudo_prepareNDS(path, gameboot,saveAsLastGame);
   checkBoot();
}
bool enableSaveAsLastGame=1;   
void menudo_prepareNDS(char* path, bool gameboot,bool saveAsLastGame)
{
   enableSaveAsLastGame=saveAsLastGame;
   gamebootactivate=gameboot;
   bootFile=1;
   sprintf(filename,"%s",path);
   if (wifi.connecting==1)
	{
	   cancellWifiConnect();
	   wifi.connecting=0;
	   wifi.online=0;
	}	
}   
void checkBoot()
{
   
   if (!bootFile) return;

	clearSystem();
	PA_SetBrightness(0,0);
	PA_SetBrightness(1,0);
	PA_ResetBg(0);
	PA_ResetBg(1);
	PA_Init16cBg(0,0);
	PA_Init16cBg(1,0);

 	bootFile=0;  
	
  bool fileavailable=0;
	char temp[256];   
   bool _isHomebrew=0;
  	fileChecker = fopen (filename, "rb"); //rb = read
   
	if(fileChecker)
	{
	   char* md5ban = checkIfBanned(filename);
	   if (md5ban != NULL)
	   {
			sprintf(temp,"MENUdo has ceased file execution.\nMENUdo has detected that the file you are attempting to execute is a blocked file,\n\"%s\"\nMD5: %s", filename,md5ban); 
			ShowDialogBox(0, 1, 1, temp);
			while(true) { Soul_waitForVBL();}
	   }   
      fseek(fileChecker, 0x0C, SEEK_SET);
      int temp;
      fread(&temp, sizeof(u32), 1, fileChecker);

      if (0x23232323 == temp) //GAME CODE == '####'
      {
			_isHomebrew=1;
      }   
	   fileavailable = 1;
	}   
	fclose (fileChecker);
	
	if (fileavailable)
	{

//	   mWifi_setWaitForReply(0);
		if (enableSaveAsLastGame)
		{
			historyFile = fopen ("fat:/_menudo/logs/HISTORY.LASTOPENED", "wb"); //rb = read
			fwrite(filename,strlen(filename),1,historyFile);
			fclose(historyFile);
			char LastGameStarted[40];
			sprintf(LastGameStarted,"%d\n%d\n%d\n%d\n%d\n%d", PA_RTC.Year, PA_RTC.Month, PA_RTC.Day, PA_RTC.Hour, PA_RTC.Minutes, PA_RTC.Seconds);
			historyFile = fopen ("fat:/_menudo/logs/HISTORY.LASTGAMESTARTED", "wb"); //rb = read
			fwrite(LastGameStarted,strlen(LastGameStarted),1,historyFile);
			fclose(historyFile);
		}		
	   char *launcherPath;
	   if (gamebootactivate)
		{
//			loadGameBootSMF();
		}	
		readINI = fopen ("fat:/_menudo/donors/nds.ini", "rb");
		bool homebrewDonor = readIniFileInt("loadHomebrewAsWell");
		if (!_isHomebrew || homebrewDonor)
		{
		   char * exploitPath;
			launcherPath = readIniFileString("loaderPath");
			exploitPath = readIniFileString("iniPath");
			int c;
				#define compare_fgetc(letter) {c = toupper(fgetc (readINI));} if (c== letter )
			while(true) 
			{
				c = fgetc (readINI);			   
				if (c == EOF) break;
					  if (c == '#')
				compare_fgetc('C')
				compare_fgetc('O')
				compare_fgetc('N')
				compare_fgetc('T')
				compare_fgetc('E')
				compare_fgetc('N')
				compare_fgetc('T')
				compare_fgetc('S')				
				compare_fgetc('#') break;
			}   
			fgetc (readINI);			    // remove \n
			FILE* exploitFile = fopen (exploitPath, "wb");
			int shortcounter=0;
			bool hasspace=0;
			int count;
			bool useshort=0;
		   while(true)
			{
				c = fgetc (readINI);
				if (c == EOF) break;
				if (c == '%')
				{
				   c = fgetc (readINI);
					if (c == 's' || c == 'x')				   
					{
					   if (c=='s')
							useshort=0;
					   else
						   useshort=1;
						   shortcounter=0;
						   hasspace=0;
					   for (count=5;filename[count]!=0;count++)
					   {
					      if(!useshort)
					      { 
					   		fputc(filename[count],exploitFile);
							} 		
							else
							{
							   if (filename[count]==' ')count++;
							   if (filename[count]=='\\' || filename[count]=='/' || filename[count]=='.')
							   {
									shortcounter=0;
									if (hasspace)
									{
									   fputc('~',exploitFile);
									   fputc('1',exploitFile);
									}   
									hasspace=0;
								}			
								else
							   	shortcounter++;
							   if (shortcounter>6)
							   {
								   while (filename[count]!='\\' && filename[count]!='/' && filename[count]!=0 && filename[count]!='.') count++;
								   fputc('~',exploitFile);
								   fputc('1',exploitFile);
						   		fputc(toupper(filename[count]),exploitFile);
								   hasspace=0;
								  	shortcounter=0;
								}		 
							   else
					   		fputc(toupper(filename[count]),exploitFile);

							}   
							   
					 	}  	
					}   
					else
					{
					   fputc('%',exploitFile);
						if (c == EOF) break;
					   fputc(c,exploitFile);					   
					}   
				}   
				else
				   fputc(c,exploitFile);
			}   
			fclose(exploitFile);
			fclose(readINI);
		}	
	   initAntiAliasedText(1,1,0);
		if (wifi.online)
		{
			PA_16cErase(1);		
		   spaceLetteringForAAText();
		   display16cText(1,0,0,256,192,"[1] Sending game card info (Press B to cancel) xx",1,5);
		   spaceLetteringForDefault();   
		   BB_getIconAndUpdate(filename);
		}   

		if (!(_isHomebrew) && 0)
		{
			//Insert Commercial Loader Here
			//sprintf(temp,"Cannot load file\n%s\nSorry, MENUdo can only load Homebrew",filename);
			historyFile = fopen ("fat:/_menudo/logs/HISTORY.LASTOPENED", "wb"); //rb = read
			fwrite(filename,strlen(filename),1,historyFile);
			fclose(historyFile);
			bootndsCHISHMS(filename,0);
		}			
		sprintf(temp,"Cannot load file\n%s\nCurrently on debug mode",filename);

		if (wifi.online)
		{
			PA_16cErase(1);		
		   spaceLetteringForAAText();
		   display16cText(1,0,0,256,192,"[2] Sending sav backup",1,5);
		   spaceLetteringForDefault();   
//			backupSav(filename);
		}			
		if (Wifi_CheckInit()!=0)  Wifi_DisableWifi();
 
		int i=0;
//		for(i=0;i<100;i++) PA_WaitForVBL();
		PA_16cErase(1);		
	   spaceLetteringForAAText();
//		PA_WaitFor(Pad.Newpress.R);
		PA_WaitForVBL();PA_WaitForVBL();PA_WaitForVBL();PA_WaitForVBL();
		if (_isHomebrew && !homebrewDonor)
		{
		   display16cText(1,0,0,256,192,"Loading Homebrew",1,5);
			bootndsCHISHMS(filename,1);
		}			
		else
		{
		   display16cText(1,0,0,256,192,"Loading ROM",1,5);
			bootndsCHISHMS(launcherPath,1); 
		}			
/*
	if (ndsloader==0) bootnds(filename); //auto
	if (ndsloader==1) bootndsCHISHMS(filename); //Chishm's DLDI loader
	if (ndsloader==2) bootndsM3(filename); //M3 Internal loader
	if (ndsloader==3) bootndsGBAMP(filename); //GBAMP Internal loader
	if (ndsloader==4) bootndsEZ4(filename); //EZ-Flash IV (4) Internal loader
	if (ndsloader==5) bootndsSC(filename); //SuperCard Internal Loader
*/
	}	
}

void backupSav(char* filename){
   if (!wifi.online) return;
   char* charTemp =malloc(256);
   sprintf(charTemp,"%s",filename);
   int i= strlen(charTemp);
   charTemp[i-3]='s';
   charTemp[i-2]='a';
   charTemp[i-1]='v';
   FILE* filechecker = fopen(charTemp,"rb");
   if (!filechecker) return;

   logMessage(charTemp);
   dsCompress(charTemp,"fat:/_menudo/logs/zipupload.zip");
   if (charTemp!=NULL) free(charTemp);
//   PA_SetBrightness(0,31);
    BB_uploadSav("fat:/_menudo/logs/zipupload.zip");
//   PA_SetBrightness(0,0);
}   

void loadLastFile()
{
   char charTemp[256];
	historyFile = fopen ("fat:/_menudo/logs/HISTORY.LASTOPENED", "rb"); //rb = read
	if (historyFile)
	{			
		fgets(charTemp, 256, historyFile);
		fclose(historyFile);
		menudo_runNDS(charTemp,1,0);
	}			
	fclose(historyFile);
}			

void blank_gba_frame(int screen)
{
	int x,y;
	u32 i,j;
	//char r,g,b;
	char col[3];
	for(y=0; y<192; y++)
	{
	 for(x=0; x<128; x++)
	 {
		i=PA_RGB(0,0,0);
		j=PA_RGB(0,0,0);
		i+=(j<<16);
		swiFastCopy(&i, (u32*)0x6800000+(((256*(191-y)+(x*2))*2)/4), 0x01000000 | (1));
		swiFastCopy(&i, (u32*)0x6820000+(((256*(191-y)+(x*2))*2)/4), 0x01000000 | (1));
	 }//x	   
	}//y

}
void load_gba_frame(int screen)
{
   char * path = returnThemeResourcePath("gbaframe.bmp", 1);
	FILE* testRead = fopen (path, "rb"); //rb = read
	if(testRead)
	{
		fseek(testRead, 54, SEEK_SET); // palette is 54 bytes from start of file

		int x,y;
		u32 i,j;
		//char r,g,b;
		char col[3];
		for(y=0; y<192; y++)
		{
		 for(x=0; x<128; x++)
		 {
			fread(&col, sizeof(char), 3, testRead);	   
			i=PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			fread(&col, sizeof(char), 3, testRead);	   
			j=PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			i+=(j<<16);
			swiFastCopy(&i, (u32*)0x6800000+(((256*(191-y)+(x*2))*2)/4), 0x01000000 | (1));
			swiFastCopy(&i, (u32*)0x6820000+(((256*(191-y)+(x*2))*2)/4), 0x01000000 | (1));
		 }//x	   
		}//y
		fclose(testRead);
	}// end if testread	
	free(path);
}

inline void clearmem(u32 dest, u32 size) {
	int i=0;
	swiFastCopy(&i, (u32*)dest, 0x01000000 | (size>>2));
}
extern bool topScreenGBA;
extern bool bordersGBA;
void boot_gba(void)
{
if (Wifi_CheckInit()==0)
		PA_InitWifi();
	   PA_SetLedBlink(0,0);
//   AS_Init(
//	loadGameBootSMF();


   //switch off one of the screens
	if(topScreenGBA)
	 {
	    PA_SetScreenLight(1, 0); 
	    PA_SetScreenLight(0, 1); 
	  }
	  else
	  {
	     PA_SetScreenLight(0, 0);
	     PA_SetScreenLight(1, 1);
	  }   
/*	     PA_SetScreenLight(0, 1);
	     PA_SetScreenLight(1, 1);*/
 	//reset DMA
	clearmem(0x40000B0, 0x30);

	//clear VRAM
	REG_POWERCNT=1;
	VRAM_CR=0x80808080;
	VRAM_E_CR=0x80;
	VRAM_F_CR=0x80;
	VRAM_G_CR=0x80;
	VRAM_H_CR=0x80;
	VRAM_I_CR=0x80;
/*	  if (bordersGBA)
	  {*/
	  if (bordersGBA)
			 load_gba_frame(topScreenGBA);
		else
			blank_gba_frame(topScreenGBA);
/*	  PA_ResetBgSys();
	  PA_Init2D();
			PA_Init16bitBg(0,0);
			PA_Init16bitBg(1,0);
		  load_gba_frame(0);		  load_gba_frame(1);*/
//	}	  

	VRAM_CR=0;
	VRAM_E_CR=0;
	VRAM_F_CR=0;
	VRAM_G_CR=0;
	VRAM_H_CR=0;
	VRAM_I_CR=0;


	if(topScreenGBA)
				REG_POWERCNT=1;
			else
				REG_POWERCNT=POWER_SWAP_LCDS|1;
	while(true)
	{
	   REG_IPC_FIFO_TX=0x87654322; // send a fifo to the highjacked wifi code
	   Soul_waitForVBL();
	}   

  
}  



